// TJC implementation of procedure check_jdk_config
package tjc;
import tcl.lang.*;

public class CheckJdkConfigCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: global _tjc
            TJC.makeGlobalLinkVar(interp, "_tjc", "_tjc", 0);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$_tjc(debug)} ...
            TclObject tmp0 = getVarArray(interp, "_tjc", "debug", compiledLocals, 0);
            ExprValue tmp1 = evs0;
            TJC.exprInitValue(interp, tmp1, tmp0);
            boolean tmp2 = tmp1.getBooleanValue(interp);
            if ( tmp2 ) {
                { // Invoke: set debug 1
                    setVarScalar(interp, "debug", const1, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$debug} ...
            TclObject tmp3 = getVarScalar(interp, "debug", compiledLocals, 1);
            boolean tmp4 = TJC.getBoolean(interp, tmp3);
            if ( tmp4 ) {
                { // Invoke: puts "testing jdk tools"
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: puts
                        objv5[0] = const2;
                        // Arg 1 constant: "testing jdk tools"
                        objv5[1] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv5, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: set fname [...]
            TclObject tmp6;
            { // Invoke: jdk_tool_javac_save Test ...
                TclObject[] objv7 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: jdk_tool_javac_save
                    objv7[0] = const4;
                    // Arg 1 constant: Test
                    objv7[1] = const5;
                    // Arg 2 constant: ...
                    objv7[2] = const6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv7, 3);
                }
            } // End Invoke: jdk_tool_javac_save
            tmp6 = interp.getResult();
            setVarScalar(interp, "fname", tmp6, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set result [...]
            TclObject tmp8;
            { // Invoke: jdk_tool_javac [...]
                TclObject[] objv9 = TJC.grabObjv(interp, 2);
                TclObject tmp10;
                try {
                    // Arg 0 constant: jdk_tool_javac
                    objv9[0] = const7;
                    // Arg 1 command: [...]
                    { // Invoke: list $fname
                        TclObject tmp11 = TclList.newInstance();
                        TclObject tmp12;
                        tmp12 = getVarScalar(interp, "fname", compiledLocals, 2);
                        TclList.append(interp, tmp11, tmp12);
                        interp.setResult(tmp11);
                    } // End Invoke: list
                    tmp10 = interp.getResult();
                    tmp10.preserve();
                    objv9[1] = tmp10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv9, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp10 = objv9[1];
                    if ( tmp10 != null ) {
                        tmp10.release();
                    }
                    TJC.releaseObjv(interp, objv9, 2);
                }
            } // End Invoke: jdk_tool_javac
            tmp8 = interp.getResult();
            setVarScalar(interp, "result", tmp8, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == "ERROR"
            { // Invoke: lindex $result 0
                TclObject tmp13 = getVarScalar(interp, "result", compiledLocals, 3);
                tmp13 = TclList.index(interp, tmp13, 0);
                if ( tmp13 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp13);
                }
            } // End Invoke: lindex
            TclObject tmp14 = interp.getResult();
            boolean tmp15 = tmp14.toString().equals("ERROR");
            ExprValue tmp16 = evs0;
            tmp16.setIntValue(tmp15);
            // End Binary operator: ==
            boolean tmp17 = ( tmp16.getIntValue() != 0 );
            if ( tmp17 ) {
                { // Invoke: puts stderr ...
                    TclObject[] objv18 = TJC.grabObjv(interp, 3);
                    try {
                        // Arg 0 constant: puts
                        objv18[0] = const2;
                        // Arg 1 constant: stderr
                        objv18[1] = const8;
                        // Arg 2 constant: ...
                        objv18[2] = const9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv18, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv18, 3);
                    }
                } // End Invoke: puts
                { // Invoke: return -1
                    interp.resetResult();
                    interp.setResult(const10);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set jarname [...]
            TclObject tmp19;
            { // Invoke: jdk_tool_jar test.jar
                TclObject[] objv20 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: jdk_tool_jar
                    objv20[0] = const11;
                    // Arg 1 constant: test.jar
                    objv20[1] = const12;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv20, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv20, 2);
                }
            } // End Invoke: jdk_tool_jar
            tmp19 = interp.getResult();
            setVarScalar(interp, "jarname", tmp19, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == "ERROR"
            { // Invoke: lindex $result 0
                TclObject tmp21 = getVarScalar(interp, "result", compiledLocals, 3);
                tmp21 = TclList.index(interp, tmp21, 0);
                if ( tmp21 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp21);
                }
            } // End Invoke: lindex
            TclObject tmp22 = interp.getResult();
            boolean tmp23 = tmp22.toString().equals("ERROR");
            ExprValue tmp24 = evs0;
            tmp24.setIntValue(tmp23);
            // End Binary operator: ==
            boolean tmp25 = ( tmp24.getIntValue() != 0 );
            if ( tmp25 ) {
                { // Invoke: puts stderr ...
                    TclObject[] objv26 = TJC.grabObjv(interp, 3);
                    try {
                        // Arg 0 constant: puts
                        objv26[0] = const2;
                        // Arg 1 constant: stderr
                        objv26[1] = const8;
                        // Arg 2 constant: ...
                        objv26[2] = const13;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv26, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv26, 3);
                    }
                } // End Invoke: puts
                { // Invoke: return -1
                    interp.resetResult();
                    interp.setResult(const10);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set fname [...]
            TclObject tmp27;
            { // Invoke: jdk_tool_javac_save TestInterp ...
                TclObject[] objv28 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: jdk_tool_javac_save
                    objv28[0] = const4;
                    // Arg 1 constant: TestInterp
                    objv28[1] = const14;
                    // Arg 2 constant: ...
                    objv28[2] = const15;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv28, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv28, 3);
                }
            } // End Invoke: jdk_tool_javac_save
            tmp27 = interp.getResult();
            setVarScalar(interp, "fname", tmp27, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set result [...]
            TclObject tmp29;
            { // Invoke: jdk_tool_javac [...]
                TclObject[] objv30 = TJC.grabObjv(interp, 2);
                TclObject tmp31;
                try {
                    // Arg 0 constant: jdk_tool_javac
                    objv30[0] = const7;
                    // Arg 1 command: [...]
                    { // Invoke: list $fname
                        TclObject tmp32 = TclList.newInstance();
                        TclObject tmp33;
                        tmp33 = getVarScalar(interp, "fname", compiledLocals, 2);
                        TclList.append(interp, tmp32, tmp33);
                        interp.setResult(tmp32);
                    } // End Invoke: list
                    tmp31 = interp.getResult();
                    tmp31.preserve();
                    objv30[1] = tmp31;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv30, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp31 = objv30[1];
                    if ( tmp31 != null ) {
                        tmp31.release();
                    }
                    TJC.releaseObjv(interp, objv30, 2);
                }
            } // End Invoke: jdk_tool_javac
            tmp29 = interp.getResult();
            setVarScalar(interp, "result", tmp29, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == "ERROR"
            { // Invoke: lindex $result 0
                TclObject tmp34 = getVarScalar(interp, "result", compiledLocals, 3);
                tmp34 = TclList.index(interp, tmp34, 0);
                if ( tmp34 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp34);
                }
            } // End Invoke: lindex
            TclObject tmp35 = interp.getResult();
            boolean tmp36 = tmp35.toString().equals("ERROR");
            ExprValue tmp37 = evs0;
            tmp37.setIntValue(tmp36);
            // End Binary operator: ==
            boolean tmp38 = ( tmp37.getIntValue() != 0 );
            if ( tmp38 ) {
                { // Invoke: puts stderr ...
                    TclObject[] objv39 = TJC.grabObjv(interp, 3);
                    try {
                        // Arg 0 constant: puts
                        objv39[0] = const2;
                        // Arg 1 constant: stderr
                        objv39[1] = const8;
                        // Arg 2 constant: ...
                        objv39[2] = const16;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv39, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv39, 3);
                    }
                } // End Invoke: puts
                { // Invoke: return -1
                    interp.resetResult();
                    interp.setResult(const10);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if {$debug} ...
            TclObject tmp40 = getVarScalar(interp, "debug", compiledLocals, 1);
            boolean tmp41 = TJC.getBoolean(interp, tmp40);
            if ( tmp41 ) {
                { // Invoke: puts "jdk tools working"
                    TclObject[] objv42 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: puts
                        objv42[0] = const2;
                        // Arg 1 constant: "jdk tools working"
                        objv42[1] = const17;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv42, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv42, 2);
                    }
                } // End Invoke: puts
            }
        } // End Invoke: if
        { // Invoke: return 0
            interp.resetResult();
            interp.setResult(const0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "check_jdk_config");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(1);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("puts");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("testing jdk tools");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("jdk_tool_javac_save");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("Test");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("\npublic class Test {}\n    ");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("jdk_tool_javac");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("stderr");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("jdk tool check failed: JAVAC not working");
        const9.preserve(); const9.preserve();
        const10 = TclInteger.newInstance(-1);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("jdk_tool_jar");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("test.jar");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("jdk tool check failed: JAR not working");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("TestInterp");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("\nimport tcl.lang.Interp;\npublic class TestInterp { Interp i; }\n    ");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("jdk tool check failed: Failed to find Interp on CLASSPATH");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("jdk tools working");
        const17.preserve(); const17.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "puts";
                break;
            }
            case 2: {
                cmdName = "jdk_tool_javac_save";
                break;
            }
            case 3: {
                cmdName = "jdk_tool_javac";
                break;
            }
            case 4: {
                cmdName = "jdk_tool_jar";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "_tjc",
        "debug",
        "fname",
        "result",
        "jarname"
    };
} // end class CheckJdkConfigCmd

