// TJC implementation of procedure compileproc_can_inline_control
package tjc;
import tcl.lang.*;

public class CompileprocCanInlineControlCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 12, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: global _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 2);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! $_compileproc(...)
            TclObject tmp0 = getVarArray(interp, "_compileproc", "options,inline_controls", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            if ( tmp0.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp1, tmp0);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp1, tmp0);
            }
            // End Unary operator: !
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv3 = TJC.grabObjv(interp, 3);
                TclObject tmp4;
                try {
                    // Arg 0 constant: info
                    objv3[0] = const1;
                    // Arg 1 constant: exists
                    objv3[1] = const2;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp5 = new StringBuffer(64);
                    sbtmp5.append("_compileproc_ckeys(");
                    tmp4 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp5.append(tmp4.toString());
                    sbtmp5.append(",info_key)");
                    tmp4 = TclString.newInstance(sbtmp5);
                    tmp4.preserve();
                    objv3[2] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv3, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp4 = objv3[2];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 3);
                }
            } // End Invoke: info
            TclObject tmp6 = interp.getResult();
            ExprValue tmp7 = evs0;
            if ( tmp6.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp7, tmp6);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp7, tmp6);
            }
            // End Unary operator: !
            boolean tmp8 = ( tmp7.getIntValue() != 0 );
            if ( tmp8 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set cmdname [...]
            TclObject tmp9;
            { // Invoke: lindex $... 1
                TclObject tmp10;
                StringBuffer sbtmp11 = new StringBuffer(64);
                tmp10 = getVarScalar(interp, "key", compiledLocals, 0);
                sbtmp11.append(tmp10.toString());
                sbtmp11.append(",info_key");
                tmp10 = getVarArray(interp, "_compileproc_ckeys", sbtmp11.toString(), compiledLocals, 2);
                tmp10 = TclList.index(interp, tmp10, 1);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp9, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: $cmdname == "_UNKNOWN"
            TclObject tmp12 = getVarScalar(interp, "cmdname", compiledLocals, 3);
            boolean tmp13 = tmp12.toString().equals("_UNKNOWN");
            ExprValue tmp14 = evs0;
            tmp14.setIntValue(tmp13);
            // End Binary operator: ==
            boolean tmp15 = ( tmp14.getIntValue() != 0 );
            if ( tmp15 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: switch -exact -- $cmdname {::break} - {break} ... {::continue} - {continue} ... {::return} - {return} ... default ...
            TclObject tmp16 = getVarScalar(interp, "cmdname", compiledLocals, 3);
            String tmp17 = tmp16.toString();
            int tmp17_length = tmp17.length();
            char tmp17_first = '\n';
            if ( tmp17_length > 0 ) {
                tmp17_first = tmp17.charAt(0);
            }
            if ( ( tmp17_length == 7 && tmp17_first == ':'
                    && tmp17.compareTo("::break") == 0 ) ||
                ( tmp17_length == 5 && tmp17_first == 'b'
                    && tmp17.compareTo("break") == 0 ) ) {
                // Pattern {break}
                { // Invoke: set is_break 1
                    setVarScalar(interp, "is_break", const3, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set is_continue 0
                    setVarScalar(interp, "is_continue", const0, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set is_return 0
                    setVarScalar(interp, "is_return", const0, compiledLocals, 6);
                } // End Invoke: set
            } else if ( ( tmp17_length == 10 && tmp17_first == ':'
                    && tmp17.compareTo("::continue") == 0 ) ||
                ( tmp17_length == 8 && tmp17_first == 'c'
                    && tmp17.compareTo("continue") == 0 ) ) {
                // Pattern {continue}
                { // Invoke: set is_break 0
                    setVarScalar(interp, "is_break", const0, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set is_continue 1
                    setVarScalar(interp, "is_continue", const3, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set is_return 0
                    setVarScalar(interp, "is_return", const0, compiledLocals, 6);
                } // End Invoke: set
            } else if ( ( tmp17_length == 8 && tmp17_first == ':'
                    && tmp17.compareTo("::return") == 0 ) ||
                ( tmp17_length == 6 && tmp17_first == 'r'
                    && tmp17.compareTo("return") == 0 ) ) {
                // Pattern {return}
                { // Invoke: set is_break 0
                    setVarScalar(interp, "is_break", const0, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set is_continue 0
                    setVarScalar(interp, "is_continue", const0, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set is_return 1
                    setVarScalar(interp, "is_return", const3, compiledLocals, 6);
                } // End Invoke: set
            } else {
                // Pattern default
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        { // Invoke: set tree [...]
            TclObject tmp18;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv19 = TJC.grabObjv(interp, 3);
                TclObject tmp20;
                try {
                    // Arg 0 constant: descend_get_data
                    objv19[0] = const4;
                    // Arg 1 variable: $key
                    tmp20 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp20.preserve();
                    objv19[1] = tmp20;
                    // Arg 2 constant: tree
                    objv19[2] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv19, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp20 = objv19[1];
                    if ( tmp20 != null ) {
                        tmp20.release();
                    }
                    TJC.releaseObjv(interp, objv19, 3);
                }
            } // End Invoke: descend_get_data
            tmp18 = interp.getResult();
            setVarScalar(interp, "tree", tmp18, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp21;
            { // Invoke: llength $tree
                TclObject tmp22 = getVarScalar(interp, "tree", compiledLocals, 7);
                int tmp23 = TclList.getLength(interp, tmp22);
                interp.setResult(tmp23);
            } // End Invoke: llength
            tmp21 = interp.getResult();
            setVarScalar(interp, "num_args", tmp21, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if ... ... elseif {$is_return} ...
            // Binary operator: $is_break || $is_continue
            TclObject tmp24 = getVarScalar(interp, "is_break", compiledLocals, 4);
            ExprValue tmp25 = evs0;
            TJC.exprInitValue(interp, tmp25, tmp24);
            if (!tmp25.getBooleanValue(interp)) {
            TclObject tmp26 = getVarScalar(interp, "is_continue", compiledLocals, 5);
            ExprValue tmp27 = evs1;
            TJC.exprInitValue(interp, tmp27, tmp26);
            tmp25.setIntValue(tmp27.getBooleanValue(interp));
            } else {
            tmp25.setIntValue(1);
            } // End if: !$is_break
            // End Binary operator: ||
            boolean tmp28 = ( tmp25.getIntValue() != 0 );
            if ( tmp28 ) {
                { // Invoke: if {$num_args != 1} ...
                    // Binary operator: $num_args != 1
                    TclObject tmp29 = getVarScalar(interp, "num_args", compiledLocals, 8);
                    ExprValue tmp30 = evs0;
                    TJC.exprInitValue(interp, tmp30, tmp29);
                    ExprValue tmp31 = evs1;
                    tmp31.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp30, tmp31);
                    // End Binary operator: !=
                    boolean tmp32 = ( tmp30.getIntValue() != 0 );
                    if ( tmp32 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const0);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            } else {
                TclObject tmp33 = getVarScalar(interp, "is_return", compiledLocals, 6);
                boolean tmp34 = TJC.getBoolean(interp, tmp33);
                if ( tmp34 ) {
                    { // Invoke: if ... ...
                        // Binary operator: () && ()
                        // Binary operator: $num_args != 1
                        TclObject tmp35 = getVarScalar(interp, "num_args", compiledLocals, 8);
                        ExprValue tmp36 = evs0;
                        TJC.exprInitValue(interp, tmp36, tmp35);
                        ExprValue tmp37 = evs1;
                        tmp37.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp36, tmp37);
                        // End Binary operator: !=
                        if (tmp36.getBooleanValue(interp)) {
                        // Binary operator: $num_args != 2
                        TclObject tmp38 = getVarScalar(interp, "num_args", compiledLocals, 8);
                        ExprValue tmp39 = evs1;
                        TJC.exprInitValue(interp, tmp39, tmp38);
                        ExprValue tmp40 = evs2;
                        tmp40.setIntValue(2);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp39, tmp40);
                        // End Binary operator: !=
                        tmp36.setIntValue(tmp39.getBooleanValue(interp));
                        } else {
                        tmp36.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp41 = ( tmp36.getIntValue() != 0 );
                        if ( tmp41 ) {
                            { // Invoke: return 0
                                interp.resetResult();
                                interp.setResult(const0);
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    } // End Invoke: if
                }
            }
        } // End Invoke: if
        { // Invoke: set stack $...
            TclObject tmp42;
            tmp42 = getVarArray(interp, "_compileproc", "options,controls_stack", compiledLocals, 1);
            setVarScalar(interp, "stack", tmp42, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $stack
                TclObject tmp43 = getVarScalar(interp, "stack", compiledLocals, 9);
                int tmp44 = TclList.getLength(interp, tmp43);
                interp.setResult(tmp44);
            } // End Invoke: llength
            TclObject tmp45 = interp.getResult();
            ExprValue tmp46 = evs0;
            TJC.exprInitValue(interp, tmp46, tmp45);
            ExprValue tmp47 = evs1;
            tmp47.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp46, tmp47);
            // End Binary operator: ==
            boolean tmp48 = ( tmp46.getIntValue() != 0 );
            if ( tmp48 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set tuple [...]
            TclObject tmp49;
            { // Invoke: lindex $stack 0
                TclObject tmp50 = getVarScalar(interp, "stack", compiledLocals, 9);
                tmp50 = TclList.index(interp, tmp50, 0);
                if ( tmp50 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp50);
                }
            } // End Invoke: lindex
            tmp49 = interp.getResult();
            setVarScalar(interp, "tuple", tmp49, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: () || ()
            // Binary operator: () || ()
            // Binary operator: [...] != 7
            { // Invoke: llength $tuple
                TclObject tmp51 = getVarScalar(interp, "tuple", compiledLocals, 10);
                int tmp52 = TclList.getLength(interp, tmp51);
                interp.setResult(tmp52);
            } // End Invoke: llength
            TclObject tmp53 = interp.getResult();
            ExprValue tmp54 = evs0;
            TJC.exprInitValue(interp, tmp54, tmp53);
            ExprValue tmp55 = evs1;
            tmp55.setIntValue(7);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp54, tmp55);
            // End Binary operator: !=
            if (!tmp54.getBooleanValue(interp)) {
            // Binary operator: [...] != "break"
            { // Invoke: lindex $tuple 1
                TclObject tmp56 = getVarScalar(interp, "tuple", compiledLocals, 10);
                tmp56 = TclList.index(interp, tmp56, 1);
                if ( tmp56 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp56);
                }
            } // End Invoke: lindex
            TclObject tmp57 = interp.getResult();
            boolean tmp58 = ! tmp57.toString().equals("break");
            ExprValue tmp59 = evs1;
            tmp59.setIntValue(tmp58);
            // End Binary operator: !=
            tmp54.setIntValue(tmp59.getBooleanValue(interp));
            } else {
            tmp54.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            if (!tmp54.getBooleanValue(interp)) {
            // Binary operator: [...] != "continue"
            { // Invoke: lindex $tuple 3
                TclObject tmp60 = getVarScalar(interp, "tuple", compiledLocals, 10);
                tmp60 = TclList.index(interp, tmp60, 3);
                if ( tmp60 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp60);
                }
            } // End Invoke: lindex
            TclObject tmp61 = interp.getResult();
            boolean tmp62 = ! tmp61.toString().equals("continue");
            ExprValue tmp63 = evs1;
            tmp63.setIntValue(tmp62);
            // End Binary operator: !=
            tmp54.setIntValue(tmp63.getBooleanValue(interp));
            } else {
            tmp54.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            if (!tmp54.getBooleanValue(interp)) {
            // Binary operator: [...] != "return"
            { // Invoke: lindex $tuple 5
                TclObject tmp64 = getVarScalar(interp, "tuple", compiledLocals, 10);
                tmp64 = TclList.index(interp, tmp64, 5);
                if ( tmp64 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp64);
                }
            } // End Invoke: lindex
            TclObject tmp65 = interp.getResult();
            boolean tmp66 = ! tmp65.toString().equals("return");
            ExprValue tmp67 = evs1;
            tmp67.setIntValue(tmp66);
            // End Binary operator: !=
            tmp54.setIntValue(tmp67.getBooleanValue(interp));
            } else {
            tmp54.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp68 = ( tmp54.getIntValue() != 0 );
            if ( tmp68 ) {
                { // Invoke: error "..."
                    TclObject[] objv69 = TJC.grabObjv(interp, 2);
                    TclObject tmp70;
                    try {
                        // Arg 0 constant: error
                        objv69[0] = const6;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp71 = new StringBuffer(64);
                        sbtmp71.append("expected controls_stack top tuple {type break 0|1 continue 0|1 return 0|1} but got ");
                        sbtmp71.append("{");
                        tmp70 = getVarScalar(interp, "tuple", compiledLocals, 10);
                        sbtmp71.append(tmp70.toString());
                        sbtmp71.append("}");
                        tmp70 = TclString.newInstance(sbtmp71);
                        tmp70.preserve();
                        objv69[1] = tmp70;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv69, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp70 = objv69[1];
                        if ( tmp70 != null ) {
                            tmp70.release();
                        }
                        TJC.releaseObjv(interp, objv69, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: array set stack_map [...]
            TclObject[] objv72 = TJC.grabObjv(interp, 4);
            TclObject tmp73;
            try {
                // Arg 0 constant: array
                objv72[0] = const7;
                // Arg 1 constant: set
                objv72[1] = const8;
                // Arg 2 constant: stack_map
                objv72[2] = const9;
                // Arg 3 command: [...]
                { // Invoke: lrange $tuple 1 end
                    TclObject[] objv74 = TJC.grabObjv(interp, 4);
                    TclObject tmp75;
                    try {
                        // Arg 0 constant: lrange
                        objv74[0] = const10;
                        // Arg 1 variable: $tuple
                        tmp75 = getVarScalar(interp, "tuple", compiledLocals, 10);
                        tmp75.preserve();
                        objv74[1] = tmp75;
                        // Arg 2 constant: 1
                        objv74[2] = const3;
                        // Arg 3 constant: end
                        objv74[3] = const11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv74, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp75 = objv74[1];
                        if ( tmp75 != null ) {
                            tmp75.release();
                        }
                        TJC.releaseObjv(interp, objv74, 4);
                    }
                } // End Invoke: lrange
                tmp73 = interp.getResult();
                tmp73.preserve();
                objv72[3] = tmp73;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                    ? cmdcache5.cmd : null), objv72, 0);
                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                    updateCmdCache(interp, 5);
                }
            } finally {
                tmp73 = objv72[3];
                if ( tmp73 != null ) {
                    tmp73.release();
                }
                TJC.releaseObjv(interp, objv72, 4);
            }
        } // End Invoke: array
        { // Invoke: if ... ...
            // Binary operator: $is_break && $stack_map(...)
            TclObject tmp76 = getVarScalar(interp, "is_break", compiledLocals, 4);
            ExprValue tmp77 = evs0;
            TJC.exprInitValue(interp, tmp77, tmp76);
            if (tmp77.getBooleanValue(interp)) {
            TclObject tmp78 = getVarArray(interp, "stack_map", "break", compiledLocals, 11);
            ExprValue tmp79 = evs1;
            TJC.exprInitValue(interp, tmp79, tmp78);
            tmp77.setIntValue(tmp79.getBooleanValue(interp));
            } else {
            tmp77.setIntValue(0);
            } // End if: $is_break
            // End Binary operator: &&
            boolean tmp80 = ( tmp77.getIntValue() != 0 );
            if ( tmp80 ) {
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: $is_continue && $stack_map(...)
            TclObject tmp81 = getVarScalar(interp, "is_continue", compiledLocals, 5);
            ExprValue tmp82 = evs0;
            TJC.exprInitValue(interp, tmp82, tmp81);
            if (tmp82.getBooleanValue(interp)) {
            TclObject tmp83 = getVarArray(interp, "stack_map", "continue", compiledLocals, 11);
            ExprValue tmp84 = evs1;
            TJC.exprInitValue(interp, tmp84, tmp83);
            tmp82.setIntValue(tmp84.getBooleanValue(interp));
            } else {
            tmp82.setIntValue(0);
            } // End if: $is_continue
            // End Binary operator: &&
            boolean tmp85 = ( tmp82.getIntValue() != 0 );
            if ( tmp85 ) {
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: $is_return && $stack_map(...)
            TclObject tmp86 = getVarScalar(interp, "is_return", compiledLocals, 6);
            ExprValue tmp87 = evs0;
            TJC.exprInitValue(interp, tmp87, tmp86);
            if (tmp87.getBooleanValue(interp)) {
            TclObject tmp88 = getVarArray(interp, "stack_map", "return", compiledLocals, 11);
            ExprValue tmp89 = evs1;
            TJC.exprInitValue(interp, tmp89, tmp88);
            tmp87.setIntValue(tmp89.getBooleanValue(interp));
            } else {
            tmp87.setIntValue(0);
            } // End if: $is_return
            // End Binary operator: &&
            boolean tmp90 = ( tmp87.getIntValue() != 0 );
            if ( tmp90 ) {
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const3);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return 0
            interp.resetResult();
            interp.setResult(const0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_can_inline_control");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("info");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("exists");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_get_data");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("tree");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("error");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("array");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("set");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("stack_map");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("lrange");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("end");
        const11.preserve(); const11.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "descend_get_data";
                break;
            }
            case 3: {
                cmdName = "error";
                break;
            }
            case 4: {
                cmdName = "lrange";
                break;
            }
            case 5: {
                cmdName = "array";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "_compileproc_ckeys",
        "cmdname",
        "is_break",
        "is_continue",
        "is_return",
        "tree",
        "num_args",
        "stack",
        "tuple",
        "stack_map"
    };
} // end class CompileprocCanInlineControlCmd

