// TJC implementation of procedure compileproc_can_inline_variable_access
package tjc;
import tcl.lang.*;

public class CompileprocCanInlineVariableAccessCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        ExprValue evs3 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "key index");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "index", objv[2], compiledLocals, 1);
        { // Invoke: set tuple [...]
            TclObject tmp0;
            { // Invoke: ... $key $index
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 variable: $index
                    tmp2 = getVarScalar(interp, "index", compiledLocals, 1);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "tuple", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp3;
            { // Invoke: lindex $tuple 0
                TclObject tmp4 = getVarScalar(interp, "tuple", compiledLocals, 2);
                tmp4 = TclList.index(interp, tmp4, 0);
                if ( tmp4 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp4);
                }
            } // End Invoke: lindex
            tmp3 = interp.getResult();
            setVarScalar(interp, "type", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: switch -exact -- $type {word} ... {constant} ... {command} - {variable} - default ...
            TclObject tmp5 = getVarScalar(interp, "type", compiledLocals, 3);
            String tmp6 = tmp5.toString();
            int tmp6_length = tmp6.length();
            char tmp6_first = '\n';
            if ( tmp6_length > 0 ) {
                tmp6_first = tmp6.charAt(0);
            }
            if ( tmp6_length == 4 && tmp6_first == 'w'
                    && tmp6.compareTo("word") == 0 ) {
                // Pattern {word}
            } else if ( tmp6_length == 8 && tmp6_first == 'c'
                    && tmp6.compareTo("constant") == 0 ) {
                // Pattern {constant}
                { // Invoke: set str [...]
                    TclObject tmp7;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp8 = getVarScalar(interp, "tuple", compiledLocals, 2);
                        tmp8 = TclList.index(interp, tmp8, 1);
                        if ( tmp8 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp8);
                        }
                    } // End Invoke: lindex
                    tmp7 = interp.getResult();
                    setVarScalar(interp, "str", tmp7, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set ind [...]
                    TclObject tmp9;
                    { // Invoke: string first "(" $str
                        char tmp10 = '(';
                        TclObject tmp11 = getVarScalar(interp, "str", compiledLocals, 4);
                        String tmp12 = tmp11.toString();
                        int tmp13 = tmp12.indexOf(tmp10);
                        interp.setResult(tmp13);
                    } // End Invoke: string
                    tmp9 = interp.getResult();
                    setVarScalar(interp, "ind", tmp9, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: () && ()
                    // Binary operator: $ind != ()
                    TclObject tmp14 = getVarScalar(interp, "ind", compiledLocals, 5);
                    ExprValue tmp15 = evs0;
                    TJC.exprInitValue(interp, tmp15, tmp14);
                    // Unary operator: - 1
                    ExprValue tmp16 = evs1;
                    tmp16.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp15, tmp16);
                    // End Binary operator: !=
                    if (tmp15.getBooleanValue(interp)) {
                    // Binary operator: $ind != [...]
                    TclObject tmp17 = getVarScalar(interp, "ind", compiledLocals, 5);
                    ExprValue tmp18 = evs1;
                    TJC.exprInitValue(interp, tmp18, tmp17);
                    { // Invoke: string last "(" $str
                        String tmp19 = const1.toString();
                        TclObject tmp20 = getVarScalar(interp, "str", compiledLocals, 4);
                        String tmp21 = tmp20.toString();
                        TclObject tmp22 = TJC.stringLast(interp, tmp19, tmp21, null);
                        interp.setResult(tmp22);
                    } // End Invoke: string
                    TclObject tmp23 = interp.getResult();
                    ExprValue tmp24 = evs2;
                    TJC.exprInitValue(interp, tmp24, tmp23);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp18, tmp24);
                    // End Binary operator: !=
                    tmp15.setIntValue(tmp18.getBooleanValue(interp));
                    } else {
                    tmp15.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp25 = ( tmp15.getIntValue() != 0 );
                    if ( tmp25 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const2);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: set ind [...]
                    TclObject tmp26;
                    { // Invoke: string last ")" $str
                        String tmp27 = const3.toString();
                        TclObject tmp28 = getVarScalar(interp, "str", compiledLocals, 4);
                        String tmp29 = tmp28.toString();
                        TclObject tmp30 = TJC.stringLast(interp, tmp27, tmp29, null);
                        interp.setResult(tmp30);
                    } // End Invoke: string
                    tmp26 = interp.getResult();
                    setVarScalar(interp, "ind", tmp26, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: () && ()
                    // Binary operator: $ind != ()
                    TclObject tmp31 = getVarScalar(interp, "ind", compiledLocals, 5);
                    ExprValue tmp32 = evs0;
                    TJC.exprInitValue(interp, tmp32, tmp31);
                    // Unary operator: - 1
                    ExprValue tmp33 = evs1;
                    tmp33.setIntValue(-1);
                    // End Unary operator: -
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp32, tmp33);
                    // End Binary operator: !=
                    if (tmp32.getBooleanValue(interp)) {
                    // Binary operator: $ind != [...]
                    TclObject tmp34 = getVarScalar(interp, "ind", compiledLocals, 5);
                    ExprValue tmp35 = evs1;
                    TJC.exprInitValue(interp, tmp35, tmp34);
                    { // Invoke: string first ")" $str
                        char tmp36 = ')';
                        TclObject tmp37 = getVarScalar(interp, "str", compiledLocals, 4);
                        String tmp38 = tmp37.toString();
                        int tmp39 = tmp38.indexOf(tmp36);
                        interp.setResult(tmp39);
                    } // End Invoke: string
                    TclObject tmp40 = interp.getResult();
                    ExprValue tmp41 = evs2;
                    TJC.exprInitValue(interp, tmp41, tmp40);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp35, tmp41);
                    // End Binary operator: !=
                    tmp32.setIntValue(tmp35.getBooleanValue(interp));
                    } else {
                    tmp32.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp42 = ( tmp32.getIntValue() != 0 );
                    if ( tmp42 ) {
                        { // Invoke: return 0
                            interp.resetResult();
                            interp.setResult(const2);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const4);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: switch
        { // Invoke: set elems [...]
            TclObject tmp43;
            { // Invoke: lindex $tuple 1
                TclObject tmp44 = getVarScalar(interp, "tuple", compiledLocals, 2);
                tmp44 = TclList.index(interp, tmp44, 1);
                if ( tmp44 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp44);
                }
            } // End Invoke: lindex
            tmp43 = interp.getResult();
            setVarScalar(interp, "elems", tmp43, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set first [...]
            TclObject tmp45;
            { // Invoke: lindex $elems 0
                TclObject tmp46 = getVarScalar(interp, "elems", compiledLocals, 6);
                tmp46 = TclList.index(interp, tmp46, 0);
                if ( tmp46 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp46);
                }
            } // End Invoke: lindex
            tmp45 = interp.getResult();
            setVarScalar(interp, "first", tmp45, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set last [...]
            TclObject tmp47;
            { // Invoke: lindex $elems end
                TclObject tmp48 = null;
                TclObject tmp49;
                try {
                    tmp48 = getVarScalar(interp, "elems", compiledLocals, 6);
                    tmp48.preserve();
                    tmp49 = const5;
                    TJC.lindexNonconst(interp, tmp48, tmp49);
                } finally {
                    if ( tmp48 != null ) {
                        tmp48.release();
                    }
                }
            } // End Invoke: lindex
            tmp47 = interp.getResult();
            setVarScalar(interp, "last", tmp47, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: [...] != "text"
            { // Invoke: lindex $first 0
                TclObject tmp50 = getVarScalar(interp, "first", compiledLocals, 7);
                tmp50 = TclList.index(interp, tmp50, 0);
                if ( tmp50 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp50);
                }
            } // End Invoke: lindex
            TclObject tmp51 = interp.getResult();
            boolean tmp52 = ! tmp51.toString().equals("text");
            ExprValue tmp53 = evs0;
            tmp53.setIntValue(tmp52);
            // End Binary operator: !=
            if (!tmp53.getBooleanValue(interp)) {
            // Binary operator: [...] != "text"
            { // Invoke: lindex $last 0
                TclObject tmp54 = getVarScalar(interp, "last", compiledLocals, 8);
                tmp54 = TclList.index(interp, tmp54, 0);
                if ( tmp54 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp54);
                }
            } // End Invoke: lindex
            TclObject tmp55 = interp.getResult();
            boolean tmp56 = ! tmp55.toString().equals("text");
            ExprValue tmp57 = evs1;
            tmp57.setIntValue(tmp56);
            // End Binary operator: !=
            tmp53.setIntValue(tmp57.getBooleanValue(interp));
            } else {
            tmp53.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp58 = ( tmp53.getIntValue() != 0 );
            if ( tmp58 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set last [...]
            TclObject tmp59;
            { // Invoke: lindex $last 1
                TclObject tmp60 = getVarScalar(interp, "last", compiledLocals, 8);
                tmp60 = TclList.index(interp, tmp60, 1);
                if ( tmp60 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp60);
                }
            } // End Invoke: lindex
            tmp59 = interp.getResult();
            setVarScalar(interp, "last", tmp59, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set ind [...]
            TclObject tmp61;
            { // Invoke: string last ")" $last
                String tmp62 = const3.toString();
                TclObject tmp63 = getVarScalar(interp, "last", compiledLocals, 8);
                String tmp64 = tmp63.toString();
                TclObject tmp65 = TJC.stringLast(interp, tmp62, tmp64, null);
                interp.setResult(tmp65);
            } // End Invoke: string
            tmp61 = interp.getResult();
            setVarScalar(interp, "ind", tmp61, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: () || ()
            // Binary operator: () || ()
            // Binary operator: $ind == ()
            TclObject tmp66 = getVarScalar(interp, "ind", compiledLocals, 5);
            ExprValue tmp67 = evs0;
            TJC.exprInitValue(interp, tmp67, tmp66);
            // Unary operator: - 1
            ExprValue tmp68 = evs1;
            tmp68.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp67, tmp68);
            // End Binary operator: ==
            if (!tmp67.getBooleanValue(interp)) {
            // Binary operator: $ind != ()
            TclObject tmp69 = getVarScalar(interp, "ind", compiledLocals, 5);
            ExprValue tmp70 = evs1;
            TJC.exprInitValue(interp, tmp70, tmp69);
            // Binary operator: [...] - 1
            { // Invoke: string length $last
                TclObject tmp71 = getVarScalar(interp, "last", compiledLocals, 8);
                int tmp72 = tmp71.toString().length();
                interp.setResult(tmp72);
            } // End Invoke: string
            TclObject tmp73 = interp.getResult();
            ExprValue tmp74 = evs2;
            TJC.exprInitValue(interp, tmp74, tmp73);
            ExprValue tmp75 = evs3;
            tmp75.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp74, tmp75);
            // End Binary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp70, tmp74);
            // End Binary operator: !=
            tmp67.setIntValue(tmp70.getBooleanValue(interp));
            } else {
            tmp67.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            if (!tmp67.getBooleanValue(interp)) {
            // Binary operator: $ind != [...]
            TclObject tmp76 = getVarScalar(interp, "ind", compiledLocals, 5);
            ExprValue tmp77 = evs1;
            TJC.exprInitValue(interp, tmp77, tmp76);
            { // Invoke: string first ")" $last
                char tmp78 = ')';
                TclObject tmp79 = getVarScalar(interp, "last", compiledLocals, 8);
                String tmp80 = tmp79.toString();
                int tmp81 = tmp80.indexOf(tmp78);
                interp.setResult(tmp81);
            } // End Invoke: string
            TclObject tmp82 = interp.getResult();
            ExprValue tmp83 = evs2;
            TJC.exprInitValue(interp, tmp83, tmp82);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp77, tmp83);
            // End Binary operator: !=
            tmp67.setIntValue(tmp77.getBooleanValue(interp));
            } else {
            tmp67.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            if (!tmp67.getBooleanValue(interp)) {
            // Binary operator: () != [...]
            // Unary operator: - 1
            ExprValue tmp84 = evs1;
            tmp84.setIntValue(-1);
            // End Unary operator: -
            { // Invoke: string first "(" $last
                char tmp85 = '(';
                TclObject tmp86 = getVarScalar(interp, "last", compiledLocals, 8);
                String tmp87 = tmp86.toString();
                int tmp88 = tmp87.indexOf(tmp85);
                interp.setResult(tmp88);
            } // End Invoke: string
            TclObject tmp89 = interp.getResult();
            ExprValue tmp90 = evs2;
            TJC.exprInitValue(interp, tmp90, tmp89);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp84, tmp90);
            // End Binary operator: !=
            tmp67.setIntValue(tmp84.getBooleanValue(interp));
            } else {
            tmp67.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp91 = ( tmp67.getIntValue() != 0 );
            if ( tmp91 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set first [...]
            TclObject tmp92;
            { // Invoke: lindex $first 1
                TclObject tmp93 = getVarScalar(interp, "first", compiledLocals, 7);
                tmp93 = TclList.index(interp, tmp93, 1);
                if ( tmp93 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp93);
                }
            } // End Invoke: lindex
            tmp92 = interp.getResult();
            setVarScalar(interp, "first", tmp92, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set ind [...]
            TclObject tmp94;
            { // Invoke: string first "(" $first
                char tmp95 = '(';
                TclObject tmp96 = getVarScalar(interp, "first", compiledLocals, 7);
                String tmp97 = tmp96.toString();
                int tmp98 = tmp97.indexOf(tmp95);
                interp.setResult(tmp98);
            } // End Invoke: string
            tmp94 = interp.getResult();
            setVarScalar(interp, "ind", tmp94, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: () || ()
            // Binary operator: () || ()
            // Binary operator: $ind == ()
            TclObject tmp99 = getVarScalar(interp, "ind", compiledLocals, 5);
            ExprValue tmp100 = evs0;
            TJC.exprInitValue(interp, tmp100, tmp99);
            // Unary operator: - 1
            ExprValue tmp101 = evs1;
            tmp101.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp100, tmp101);
            // End Binary operator: ==
            if (!tmp100.getBooleanValue(interp)) {
            // Binary operator: $ind == 0
            TclObject tmp102 = getVarScalar(interp, "ind", compiledLocals, 5);
            ExprValue tmp103 = evs1;
            TJC.exprInitValue(interp, tmp103, tmp102);
            ExprValue tmp104 = evs2;
            tmp104.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp103, tmp104);
            // End Binary operator: ==
            tmp100.setIntValue(tmp103.getBooleanValue(interp));
            } else {
            tmp100.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            if (!tmp100.getBooleanValue(interp)) {
            // Binary operator: $ind != [...]
            TclObject tmp105 = getVarScalar(interp, "ind", compiledLocals, 5);
            ExprValue tmp106 = evs1;
            TJC.exprInitValue(interp, tmp106, tmp105);
            { // Invoke: string first "(" $first
                char tmp107 = '(';
                TclObject tmp108 = getVarScalar(interp, "first", compiledLocals, 7);
                String tmp109 = tmp108.toString();
                int tmp110 = tmp109.indexOf(tmp107);
                interp.setResult(tmp110);
            } // End Invoke: string
            TclObject tmp111 = interp.getResult();
            ExprValue tmp112 = evs2;
            TJC.exprInitValue(interp, tmp112, tmp111);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp106, tmp112);
            // End Binary operator: !=
            tmp100.setIntValue(tmp106.getBooleanValue(interp));
            } else {
            tmp100.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            if (!tmp100.getBooleanValue(interp)) {
            // Binary operator: () != [...]
            // Unary operator: - 1
            ExprValue tmp113 = evs1;
            tmp113.setIntValue(-1);
            // End Unary operator: -
            { // Invoke: string first ")" $first
                char tmp114 = ')';
                TclObject tmp115 = getVarScalar(interp, "first", compiledLocals, 7);
                String tmp116 = tmp115.toString();
                int tmp117 = tmp116.indexOf(tmp114);
                interp.setResult(tmp117);
            } // End Invoke: string
            TclObject tmp118 = interp.getResult();
            ExprValue tmp119 = evs2;
            TJC.exprInitValue(interp, tmp119, tmp118);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp113, tmp119);
            // End Binary operator: !=
            tmp100.setIntValue(tmp113.getBooleanValue(interp));
            } else {
            tmp100.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp120 = ( tmp100.getIntValue() != 0 );
            if ( tmp120 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const2);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: incr ind -1
            interp.resetResult();
            incrVarScalar(interp, "ind", -1, compiledLocals, 5);
        } // End Invoke: incr
        { // Invoke: set varname [...]
            TclObject tmp121;
            { // Invoke: string range $first 0 $ind
                TclObject tmp122 = getVarScalar(interp, "first", compiledLocals, 7);
                String tmp123 = tmp122.toString();
                TclObject tmp124 = const2;
                tmp124.preserve();
                TclObject tmp125 = getVarScalar(interp, "ind", compiledLocals, 5);
                TclObject tmp126 = TJC.stringRange(interp, tmp123, tmp124, tmp125);
                interp.setResult(tmp126);
            } // End Invoke: string
            tmp121 = interp.getResult();
            setVarScalar(interp, "varname", tmp121, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const4);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_can_inline_variable_access");
        } finally {
            TJC.exprReleaseValue(interp, evs3);
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("compileproc_get_argument_tuple");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("(");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance(")");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("end");
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "index",
        "tuple",
        "type",
        "str",
        "ind",
        "elems",
        "first",
        "last",
        "varname"
    };
} // end class CompileprocCanInlineVariableAccessCmd

