// TJC implementation of procedure compileproc_command_cache_lookup
package tjc;
import tcl.lang.*;

public class CompileprocCommandCacheLookupCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "dkey");
        }
        setVarScalar(interp, "dkey", objv[1], compiledLocals, 0);
        { // Invoke: global ...
            TJC.makeGlobalLinkVar(interp, "_compileproc_command_cache", "_compileproc_command_cache", 1);
        } // End Invoke: global
        { // Invoke: global _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 2);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists ...
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const0;
                    // Arg 1 constant: exists
                    objv0[1] = const1;
                    // Arg 2 constant: ...
                    objv0[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            if ( tmp1.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp2, tmp1);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp2, tmp1);
            }
            // End Unary operator: !
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
                { // Invoke: set ... 1
                    setVarArray(interp, "_compileproc_command_cache", "counter", const3, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] != "constant"
            { // Invoke: lindex $... 0
                TclObject tmp4;
                StringBuffer sbtmp5 = new StringBuffer(64);
                tmp4 = getVarScalar(interp, "dkey", compiledLocals, 0);
                sbtmp5.append(tmp4.toString());
                sbtmp5.append(",types");
                initVarScoped(interp, "::_compileproc_key_info", compiledLocals, 3);
                tmp4 = getVarArray(interp, "::_compileproc_key_info", sbtmp5.toString(), compiledLocals, 3);
                tmp4 = TclList.index(interp, tmp4, 0);
                if ( tmp4 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp4);
                }
            } // End Invoke: lindex
            TclObject tmp6 = interp.getResult();
            boolean tmp7 = ! tmp6.toString().equals("constant");
            ExprValue tmp8 = evs0;
            tmp8.setIntValue(tmp7);
            // End Binary operator: !=
            boolean tmp9 = ( tmp8.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: return
                    interp.resetResult();
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set cmdname [...]
            TclObject tmp10;
            { // Invoke: lindex $... 1
                TclObject tmp11;
                StringBuffer sbtmp12 = new StringBuffer(64);
                tmp11 = getVarScalar(interp, "dkey", compiledLocals, 0);
                sbtmp12.append(tmp11.toString());
                sbtmp12.append(",info_key");
                tmp11 = getVarArray(interp, "_compileproc_ckeys", sbtmp12.toString(), compiledLocals, 2);
                tmp11 = TclList.index(interp, tmp11, 1);
                if ( tmp11 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp11);
                }
            } // End Invoke: lindex
            tmp10 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp10, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set key "symbol,$cmdname"
            TclObject tmp13;
            StringBuffer sbtmp14 = new StringBuffer(64);
            sbtmp14.append("symbol,");
            tmp13 = getVarScalar(interp, "cmdname", compiledLocals, 4);
            sbtmp14.append(tmp13.toString());
            tmp13 = TclString.newInstance(sbtmp14);
            setVarScalar(interp, "key", tmp13, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Unary operator: ! [...]
            { // Invoke: info exists "..."
                TclObject[] objv15 = TJC.grabObjv(interp, 3);
                TclObject tmp16;
                try {
                    // Arg 0 constant: info
                    objv15[0] = const0;
                    // Arg 1 constant: exists
                    objv15[1] = const1;
                    // Arg 2 word: "..."
                    StringBuffer sbtmp17 = new StringBuffer(64);
                    sbtmp17.append("_compileproc_command_cache(");
                    tmp16 = getVarScalar(interp, "key", compiledLocals, 5);
                    sbtmp17.append(tmp16.toString());
                    sbtmp17.append(")");
                    tmp16 = TclString.newInstance(sbtmp17);
                    tmp16.preserve();
                    objv15[2] = tmp16;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv15, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp16 = objv15[2];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 3);
                }
            } // End Invoke: info
            TclObject tmp18 = interp.getResult();
            ExprValue tmp19 = evs0;
            if ( tmp18.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp19, tmp18);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp19, tmp18);
            }
            // End Unary operator: !
            boolean tmp20 = ( tmp19.getIntValue() != 0 );
            if ( tmp20 ) {
                { // Invoke: set symbol "..."
                    TclObject tmp21;
                    StringBuffer sbtmp22 = new StringBuffer(64);
                    sbtmp22.append("cmdcache");
                    tmp21 = getVarArray(interp, "_compileproc_command_cache", "counter", compiledLocals, 1);
                    sbtmp22.append(tmp21.toString());
                    tmp21 = TclString.newInstance(sbtmp22);
                    setVarScalar(interp, "symbol", tmp21, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: incr ...
                    interp.resetResult();
                    incrVarArray(interp, "_compileproc_command_cache", "counter", 1, compiledLocals, 1);
                } // End Invoke: incr
                { // Invoke: set "..." $symbol
                    TclObject tmp23;
                    tmp23 = getVarScalar(interp, "key", compiledLocals, 5);
                    String tmp24 = tmp23.toString();
                    tmp23 = getVarScalar(interp, "symbol", compiledLocals, 6);
                    tmp23 = setVarArray(interp, "_compileproc_command_cache", tmp24, tmp23, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: lappend ... $key
                    TclObject[] objv25 = TJC.grabObjv(interp, 1);
                    TclObject tmp26;
                    try {
                        // Arg 2 variable: $key
                        tmp26 = getVarScalar(interp, "key", compiledLocals, 5);
                        tmp26.preserve();
                        objv25[0] = tmp26;
                        interp.resetResult();
                        lappendVarArray(interp, "_compileproc_command_cache", "ordered_keys", objv25, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv25, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: lappend ... $cmdname
                    TclObject[] objv27 = TJC.grabObjv(interp, 1);
                    TclObject tmp28;
                    try {
                        // Arg 2 variable: $cmdname
                        tmp28 = getVarScalar(interp, "cmdname", compiledLocals, 4);
                        tmp28.preserve();
                        objv27[0] = tmp28;
                        interp.resetResult();
                        lappendVarArray(interp, "_compileproc_command_cache", "ordered_cmds", objv27, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv27, 1);
                    }
                } // End Invoke: lappend
            } else {
                { // Invoke: set symbol $...
                    TclObject tmp29;
                    tmp29 = getVarScalar(interp, "key", compiledLocals, 5);
                    tmp29 = getVarArray(interp, "_compileproc_command_cache", tmp29.toString(), compiledLocals, 1);
                    setVarScalar(interp, "symbol", tmp29, compiledLocals, 6);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return $symbol
            TclObject tmp30 = getVarScalar(interp, "symbol", compiledLocals, 6);
            interp.resetResult();
            interp.setResult(tmp30);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_command_cache_lookup");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("info");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("exists");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("_compileproc_command_cache(counter)");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "dkey",
        "_compileproc_command_cache",
        "_compileproc_ckeys",
        "::_compileproc_key_info",
        "cmdname",
        "key",
        "symbol"
    };
} // end class CompileprocCommandCacheLookupCmd

