// TJC implementation of procedure compileproc_emit_inline_command_append
package tjc;
import tcl.lang.*;

public class CompileprocEmitInlineCommandAppendCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 12, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set tmpsymbol {}
            setVarScalar(interp, "tmpsymbol", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: tree
                    objv1[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "tree", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp3;
            { // Invoke: llength $tree
                TclObject tmp4 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp5 = TclList.getLength(interp, tmp4);
                interp.setResult(tmp5);
            } // End Invoke: llength
            tmp3 = interp.getResult();
            setVarScalar(interp, "num_args", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp6;
            { // Invoke: ... $key 1
                TclObject[] objv7 = TJC.grabObjv(interp, 3);
                TclObject tmp8;
                try {
                    // Arg 0 constant: ...
                    objv7[0] = const3;
                    // Arg 1 variable: $key
                    tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    // Arg 2 constant: 1
                    objv7[2] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv7, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 3);
                }
            } // End Invoke: ...
            tmp6 = interp.getResult();
            setVarScalar(interp, "tuple", tmp6, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set type [...]
            TclObject tmp9;
            { // Invoke: lindex $tuple 0
                TclObject tmp10 = getVarScalar(interp, "tuple", compiledLocals, 5);
                tmp10 = TclList.index(interp, tmp10, 0);
                if ( tmp10 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp10);
                }
            } // End Invoke: lindex
            tmp9 = interp.getResult();
            setVarScalar(interp, "type", tmp9, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: $type == "constant"
            TclObject tmp11 = getVarScalar(interp, "type", compiledLocals, 6);
            boolean tmp12 = tmp11.toString().equals("constant");
            ExprValue tmp13 = evs0;
            tmp13.setIntValue(tmp12);
            // End Binary operator: ==
            boolean tmp14 = ( tmp13.getIntValue() != 0 );
            if ( tmp14 ) {
                { // Invoke: set varname [...]
                    TclObject tmp15;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp16 = getVarScalar(interp, "tuple", compiledLocals, 5);
                        tmp16 = TclList.index(interp, tmp16, 1);
                        if ( tmp16 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp16);
                        }
                    } // End Invoke: lindex
                    tmp15 = interp.getResult();
                    setVarScalar(interp, "varname", tmp15, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set userdata [...]
                    TclObject tmp17;
                    { // Invoke: list 1 $varname
                        TclObject tmp18 = TclList.newInstance();
                        TclObject tmp19;
                        try {
                            TclList.append(interp, tmp18, const4);
                            tmp19 = getVarScalar(interp, "varname", compiledLocals, 7);
                            TclList.append(interp, tmp18, tmp19);
                        } catch (TclException ex) {
                            tmp18.release();
                            throw ex;
                        }
                        interp.setResult(tmp18);
                    } // End Invoke: list
                    tmp17 = interp.getResult();
                    setVarScalar(interp, "userdata", tmp17, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set force_decl_tmpsymbol 1
                    setVarScalar(interp, "force_decl_tmpsymbol", const4, compiledLocals, 9);
                } // End Invoke: set
            } else {
                { // Invoke: set tmpsymbol [...]
                    TclObject tmp20;
                    { // Invoke: ...
                        TclObject[] objv21 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv21[0] = const5;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv21, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv21, 1);
                        }
                    } // End Invoke: ...
                    tmp20 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol", tmp20, compiledLocals, 2);
                } // End Invoke: set
                { // Invoke: append buffer [...]
                    TclObject[] objv22 = TJC.grabObjv(interp, 1);
                    TclObject tmp23;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_statement "..."
                            TclObject[] objv24 = TJC.grabObjv(interp, 2);
                            TclObject tmp25;
                            try {
                                // Arg 0 constant: emitter_statement
                                objv24[0] = const6;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp26 = new StringBuffer(64);
                                sbtmp26.append("TclObject ");
                                tmp25 = getVarScalar(interp, "tmpsymbol", compiledLocals, 2);
                                sbtmp26.append(tmp25.toString());
                                tmp25 = TclString.newInstance(sbtmp26);
                                tmp25.preserve();
                                objv24[1] = tmp25;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv24, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                tmp25 = objv24[1];
                                if ( tmp25 != null ) {
                                    tmp25.release();
                                }
                                TJC.releaseObjv(interp, objv24, 2);
                            }
                        } // End Invoke: emitter_statement
                        tmp23 = interp.getResult();
                        tmp23.preserve();
                        objv22[0] = tmp23;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv22, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv22, 1);
                    }
                } // End Invoke: append
                { // Invoke: set tuple [...]
                    TclObject tmp27;
                    { // Invoke: ... $key 1 $tmpsymbol
                        TclObject[] objv28 = TJC.grabObjv(interp, 4);
                        TclObject tmp29;
                        try {
                            // Arg 0 constant: ...
                            objv28[0] = const7;
                            // Arg 1 variable: $key
                            tmp29 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp29.preserve();
                            objv28[1] = tmp29;
                            // Arg 2 constant: 1
                            objv28[2] = const4;
                            // Arg 3 variable: $tmpsymbol
                            tmp29 = getVarScalar(interp, "tmpsymbol", compiledLocals, 2);
                            tmp29.preserve();
                            objv28[3] = tmp29;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv28, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp29 = objv28[1];
                            if ( tmp29 != null ) {
                                tmp29.release();
                            }
                            tmp29 = objv28[3];
                            if ( tmp29 != null ) {
                                tmp29.release();
                            }
                            TJC.releaseObjv(interp, objv28, 4);
                        }
                    } // End Invoke: ...
                    tmp27 = interp.getResult();
                    setVarScalar(interp, "tuple", tmp27, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set varname [...]
                    TclObject tmp30;
                    { // Invoke: lindex $tuple 0
                        TclObject tmp31 = getVarScalar(interp, "tuple", compiledLocals, 5);
                        tmp31 = TclList.index(interp, tmp31, 0);
                        if ( tmp31 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp31);
                        }
                    } // End Invoke: lindex
                    tmp30 = interp.getResult();
                    setVarScalar(interp, "varname", tmp30, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set keysym [...]
                    TclObject tmp32;
                    { // Invoke: lindex $tuple 1
                        TclObject tmp33 = getVarScalar(interp, "tuple", compiledLocals, 5);
                        tmp33 = TclList.index(interp, tmp33, 1);
                        if ( tmp33 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp33);
                        }
                    } // End Invoke: lindex
                    tmp32 = interp.getResult();
                    setVarScalar(interp, "keysym", tmp32, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: set word_buffer [...]
                    TclObject tmp34;
                    { // Invoke: lindex $tuple 2
                        TclObject tmp35 = getVarScalar(interp, "tuple", compiledLocals, 5);
                        tmp35 = TclList.index(interp, tmp35, 2);
                        if ( tmp35 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp35);
                        }
                    } // End Invoke: lindex
                    tmp34 = interp.getResult();
                    setVarScalar(interp, "word_buffer", tmp34, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: append buffer $word_buffer
                    TclObject[] objv36 = TJC.grabObjv(interp, 1);
                    TclObject tmp37;
                    try {
                        // Arg 2 variable: $word_buffer
                        tmp37 = getVarScalar(interp, "word_buffer", compiledLocals, 11);
                        tmp37.preserve();
                        objv36[0] = tmp37;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv36, compiledLocals, 1);
                    } finally {
                        TJC.releaseObjvElems(interp, objv36, 1);
                    }
                } // End Invoke: append
                { // Invoke: set userdata [...]
                    TclObject tmp38;
                    { // Invoke: list 0 $varname $keysym
                        TclObject tmp39 = TclList.newInstance();
                        TclObject tmp40;
                        try {
                            TclList.append(interp, tmp39, const8);
                            tmp40 = getVarScalar(interp, "varname", compiledLocals, 7);
                            TclList.append(interp, tmp39, tmp40);
                            tmp40 = getVarScalar(interp, "keysym", compiledLocals, 10);
                            TclList.append(interp, tmp39, tmp40);
                        } catch (TclException ex) {
                            tmp39.release();
                            throw ex;
                        }
                        interp.setResult(tmp39);
                    } // End Invoke: list
                    tmp38 = interp.getResult();
                    setVarScalar(interp, "userdata", tmp38, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set force_decl_tmpsymbol 0
                    setVarScalar(interp, "force_decl_tmpsymbol", const8, compiledLocals, 9);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv41 = TJC.grabObjv(interp, 1);
            TclObject tmp42;
            try {
                // Arg 2 command: [...]
                { // Invoke: ... $key 2 end $tmpsymbol $... ... $userdata
                    TclObject[] objv43 = TJC.grabObjv(interp, 8);
                    TclObject tmp44;
                    try {
                        // Arg 0 constant: ...
                        objv43[0] = const9;
                        // Arg 1 variable: $key
                        tmp44 = getVarScalar(interp, "key", compiledLocals, 0);
                        tmp44.preserve();
                        objv43[1] = tmp44;
                        // Arg 2 constant: 2
                        objv43[2] = const10;
                        // Arg 3 constant: end
                        objv43[3] = const11;
                        // Arg 4 variable: $tmpsymbol
                        tmp44 = getVarScalar(interp, "tmpsymbol", compiledLocals, 2);
                        tmp44.preserve();
                        objv43[4] = tmp44;
                        // Arg 5 variable: $...
                        tmp44 = getVarScalar(interp, "force_decl_tmpsymbol", compiledLocals, 9);
                        tmp44.preserve();
                        objv43[5] = tmp44;
                        // Arg 6 constant: ...
                        objv43[6] = const12;
                        // Arg 7 variable: $userdata
                        tmp44 = getVarScalar(interp, "userdata", compiledLocals, 8);
                        tmp44.preserve();
                        objv43[7] = tmp44;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv43, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp44 = objv43[1];
                        if ( tmp44 != null ) {
                            tmp44.release();
                        }
                        tmp44 = objv43[4];
                        if ( tmp44 != null ) {
                            tmp44.release();
                        }
                        tmp44 = objv43[5];
                        if ( tmp44 != null ) {
                            tmp44.release();
                        }
                        tmp44 = objv43[7];
                        if ( tmp44 != null ) {
                            tmp44.release();
                        }
                        TJC.releaseObjv(interp, objv43, 8);
                    }
                } // End Invoke: ...
                tmp42 = interp.getResult();
                tmp42.preserve();
                objv41[0] = tmp42;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv41, compiledLocals, 1);
            } finally {
                TJC.releaseObjvElems(interp, objv41, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp45 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp45);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_inline_command_append");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("descend_get_data");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_get_argument_tuple");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_tmpvar_next");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_statement");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_setup_nonconstant_array_variable");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(0);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_emit_objv_assignment");
        const9.preserve(); const9.preserve();
        const10 = TclInteger.newInstance(2);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("end");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_emit_append_call_impl");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "compileproc_get_argument_tuple";
                break;
            }
            case 3: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 4: {
                cmdName = "emitter_statement";
                break;
            }
            case 5: {
                cmdName = "compileproc_setup_nonconstant_array_variable";
                break;
            }
            case 6: {
                cmdName = "compileproc_emit_objv_assignment";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "buffer",
        "tmpsymbol",
        "tree",
        "num_args",
        "tuple",
        "type",
        "varname",
        "userdata",
        "force_decl_tmpsymbol",
        "keysym",
        "word_buffer"
    };
} // end class CompileprocEmitInlineCommandAppendCmd

