// TJC implementation of procedure compileproc_emit_inline_command
package tjc;
import tcl.lang.*;

public class CompileprocEmitInlineCommandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: global _compileproc_ckeys
            TJC.makeGlobalLinkVar(interp, "_compileproc_ckeys", "_compileproc_ckeys", 2);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! $_compileproc(...)
            TclObject tmp0 = getVarArray(interp, "_compileproc", "options,inline_commands", compiledLocals, 1);
            ExprValue tmp1 = evs0;
            if ( tmp0.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp1, tmp0);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp1, tmp0);
            }
            // End Unary operator: !
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: error ...
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv3[0] = const0;
                        // Arg 1 constant: ...
                        objv3[1] = const1;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv3, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set cmdname [...]
            TclObject tmp4;
            { // Invoke: lindex $... 1
                TclObject tmp5;
                StringBuffer sbtmp6 = new StringBuffer(64);
                tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                sbtmp6.append(tmp5.toString());
                sbtmp6.append(",info_key");
                tmp5 = getVarArray(interp, "_compileproc_ckeys", sbtmp6.toString(), compiledLocals, 2);
                tmp5 = TclList.index(interp, tmp5, 1);
                if ( tmp5 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp5);
                }
            } // End Invoke: lindex
            tmp4 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp4, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set cmdname [...]
            TclObject tmp7;
            { // Invoke: namespace tail $cmdname
                TclObject[] objv8 = TJC.grabObjv(interp, 3);
                TclObject tmp9;
                try {
                    // Arg 0 constant: namespace
                    objv8[0] = const2;
                    // Arg 1 constant: tail
                    objv8[1] = const3;
                    // Arg 2 variable: $cmdname
                    tmp9 = getVarScalar(interp, "cmdname", compiledLocals, 3);
                    tmp9.preserve();
                    objv8[2] = tmp9;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv8, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp9 = objv8[2];
                    if ( tmp9 != null ) {
                        tmp9.release();
                    }
                    TJC.releaseObjv(interp, objv8, 3);
                }
            } // End Invoke: namespace
            tmp7 = interp.getResult();
            setVarScalar(interp, "cmdname", tmp7, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: switch -exact -- $cmdname {append} ... {global} ... {incr} ... {lappend} ... {lindex} ... {list} ... {llength} ... {set} ... {string} ... default ...
            TclObject tmp10 = getVarScalar(interp, "cmdname", compiledLocals, 3);
            String tmp11 = tmp10.toString();
            int tmp11_length = tmp11.length();
            char tmp11_first = '\n';
            if ( tmp11_length > 0 ) {
                tmp11_first = tmp11.charAt(0);
            }
            interp.resetResult();
            if ( tmp11_length == 6 && tmp11_first == 'a'
                    && tmp11.compareTo("append") == 0 ) {
                // Pattern {append}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv12 = TJC.grabObjv(interp, 2);
                        TclObject tmp13;
                        try {
                            // Arg 0 constant: ...
                            objv12[0] = const4;
                            // Arg 1 variable: $key
                            tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp13.preserve();
                            objv12[1] = tmp13;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv12, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp13 = objv12[1];
                            if ( tmp13 != null ) {
                                tmp13.release();
                            }
                            TJC.releaseObjv(interp, objv12, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp11_length == 6 && tmp11_first == 'g'
                    && tmp11.compareTo("global") == 0 ) {
                // Pattern {global}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv14 = TJC.grabObjv(interp, 2);
                        TclObject tmp15;
                        try {
                            // Arg 0 constant: ...
                            objv14[0] = const5;
                            // Arg 1 variable: $key
                            tmp15 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp15.preserve();
                            objv14[1] = tmp15;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv14, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp15 = objv14[1];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            TJC.releaseObjv(interp, objv14, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp11_length == 4 && tmp11_first == 'i'
                    && tmp11.compareTo("incr") == 0 ) {
                // Pattern {incr}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv16 = TJC.grabObjv(interp, 2);
                        TclObject tmp17;
                        try {
                            // Arg 0 constant: ...
                            objv16[0] = const6;
                            // Arg 1 variable: $key
                            tmp17 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp17.preserve();
                            objv16[1] = tmp17;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv16, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp17 = objv16[1];
                            if ( tmp17 != null ) {
                                tmp17.release();
                            }
                            TJC.releaseObjv(interp, objv16, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp11_length == 7 && tmp11_first == 'l'
                    && tmp11.compareTo("lappend") == 0 ) {
                // Pattern {lappend}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv18 = TJC.grabObjv(interp, 2);
                        TclObject tmp19;
                        try {
                            // Arg 0 constant: ...
                            objv18[0] = const7;
                            // Arg 1 variable: $key
                            tmp19 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp19.preserve();
                            objv18[1] = tmp19;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv18, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            tmp19 = objv18[1];
                            if ( tmp19 != null ) {
                                tmp19.release();
                            }
                            TJC.releaseObjv(interp, objv18, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp11_length == 6 && tmp11_first == 'l'
                    && tmp11.compareTo("lindex") == 0 ) {
                // Pattern {lindex}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv20 = TJC.grabObjv(interp, 2);
                        TclObject tmp21;
                        try {
                            // Arg 0 constant: ...
                            objv20[0] = const8;
                            // Arg 1 variable: $key
                            tmp21 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp21.preserve();
                            objv20[1] = tmp21;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                ? cmdcache7.cmd : null), objv20, 0);
                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                updateCmdCache(interp, 7);
                            }
                        } finally {
                            tmp21 = objv20[1];
                            if ( tmp21 != null ) {
                                tmp21.release();
                            }
                            TJC.releaseObjv(interp, objv20, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp11_length == 4 && tmp11_first == 'l'
                    && tmp11.compareTo("list") == 0 ) {
                // Pattern {list}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv22 = TJC.grabObjv(interp, 2);
                        TclObject tmp23;
                        try {
                            // Arg 0 constant: ...
                            objv22[0] = const9;
                            // Arg 1 variable: $key
                            tmp23 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp23.preserve();
                            objv22[1] = tmp23;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv22, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp23 = objv22[1];
                            if ( tmp23 != null ) {
                                tmp23.release();
                            }
                            TJC.releaseObjv(interp, objv22, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp11_length == 7 && tmp11_first == 'l'
                    && tmp11.compareTo("llength") == 0 ) {
                // Pattern {llength}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv24 = TJC.grabObjv(interp, 2);
                        TclObject tmp25;
                        try {
                            // Arg 0 constant: ...
                            objv24[0] = const10;
                            // Arg 1 variable: $key
                            tmp25 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp25.preserve();
                            objv24[1] = tmp25;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                ? cmdcache9.cmd : null), objv24, 0);
                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                updateCmdCache(interp, 9);
                            }
                        } finally {
                            tmp25 = objv24[1];
                            if ( tmp25 != null ) {
                                tmp25.release();
                            }
                            TJC.releaseObjv(interp, objv24, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp11_length == 3 && tmp11_first == 's'
                    && tmp11.compareTo("set") == 0 ) {
                // Pattern {set}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv26 = TJC.grabObjv(interp, 2);
                        TclObject tmp27;
                        try {
                            // Arg 0 constant: ...
                            objv26[0] = const11;
                            // Arg 1 variable: $key
                            tmp27 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp27.preserve();
                            objv26[1] = tmp27;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                ? cmdcache10.cmd : null), objv26, 0);
                            if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                updateCmdCache(interp, 10);
                            }
                        } finally {
                            tmp27 = objv26[1];
                            if ( tmp27 != null ) {
                                tmp27.release();
                            }
                            TJC.releaseObjv(interp, objv26, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else if ( tmp11_length == 6 && tmp11_first == 's'
                    && tmp11.compareTo("string") == 0 ) {
                // Pattern {string}
                { // Invoke: return [...]
                    { // Invoke: ... $key
                        TclObject[] objv28 = TJC.grabObjv(interp, 2);
                        TclObject tmp29;
                        try {
                            // Arg 0 constant: ...
                            objv28[0] = const12;
                            // Arg 1 variable: $key
                            tmp29 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp29.preserve();
                            objv28[1] = tmp29;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache11_cmdEpoch == cmdcache11.cmdEpoch)
                                ? cmdcache11.cmd : null), objv28, 0);
                            if ( cmdcache11_cmdEpoch != cmdcache11.cmdEpoch ) {
                                updateCmdCache(interp, 11);
                            }
                        } finally {
                            tmp29 = objv28[1];
                            if ( tmp29 != null ) {
                                tmp29.release();
                            }
                            TJC.releaseObjv(interp, objv28, 2);
                        }
                    } // End Invoke: ...
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv30 = TJC.grabObjv(interp, 2);
                    TclObject tmp31;
                    try {
                        // Arg 0 constant: error
                        objv30[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp32 = new StringBuffer(64);
                        sbtmp32.append("unsupported inlined command ");
                        sbtmp32.append("\"");
                        tmp31 = getVarScalar(interp, "cmdname", compiledLocals, 3);
                        sbtmp32.append(tmp31.toString());
                        sbtmp32.append("\"");
                        tmp31 = TclString.newInstance(sbtmp32);
                        tmp31.preserve();
                        objv30[1] = tmp31;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv30, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp31 = objv30[1];
                        if ( tmp31 != null ) {
                            tmp31.release();
                        }
                        TJC.releaseObjv(interp, objv30, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_inline_command");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_emit_inline_command invoked when inline_commands option is false");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("namespace");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("tail");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_emit_inline_command_append");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_emit_inline_command_global");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("compileproc_emit_inline_command_incr");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("compileproc_emit_inline_command_lappend");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_emit_inline_command_lindex");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_emit_inline_command_list");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_emit_inline_command_llength");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("compileproc_emit_inline_command_set");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("compileproc_emit_inline_command_string");
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;
    WrappedCommand cmdcache11;
    int cmdcache11_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                cmdcache11 = TJC.INVALID_COMMAND_CACHE;
                cmdcache11_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "namespace";
                break;
            }
            case 3: {
                cmdName = "compileproc_emit_inline_command_append";
                break;
            }
            case 4: {
                cmdName = "compileproc_emit_inline_command_global";
                break;
            }
            case 5: {
                cmdName = "compileproc_emit_inline_command_incr";
                break;
            }
            case 6: {
                cmdName = "compileproc_emit_inline_command_lappend";
                break;
            }
            case 7: {
                cmdName = "compileproc_emit_inline_command_lindex";
                break;
            }
            case 8: {
                cmdName = "compileproc_emit_inline_command_list";
                break;
            }
            case 9: {
                cmdName = "compileproc_emit_inline_command_llength";
                break;
            }
            case 10: {
                cmdName = "compileproc_emit_inline_command_set";
                break;
            }
            case 11: {
                cmdName = "compileproc_emit_inline_command_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
            case 11: {
                cmdcache11 = lwcmd;
                cmdcache11_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "_compileproc_ckeys",
        "cmdname"
    };
} // end class CompileprocEmitInlineCommandCmd

