// TJC implementation of procedure compileproc_emit_inline_command_llength
package tjc;
import tcl.lang.*;

public class CompileprocEmitInlineCommandLlengthCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 1);
        } // End Invoke: global
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp0;
            { // Invoke: ... $key 1 true {}
                TclObject[] objv1 = TJC.grabObjv(interp, 5);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const1;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: 1
                    objv1[2] = const2;
                    // Arg 3 constant: true
                    objv1[3] = const3;
                    // Arg 4 constant: {}
                    objv1[4] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 5);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "tuple", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set value_type [...]
            TclObject tmp3;
            { // Invoke: lindex $tuple 0
                TclObject tmp4 = getVarScalar(interp, "tuple", compiledLocals, 3);
                tmp4 = TclList.index(interp, tmp4, 0);
                if ( tmp4 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp4);
                }
            } // End Invoke: lindex
            tmp3 = interp.getResult();
            setVarScalar(interp, "value_type", tmp3, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set value_symbol [...]
            TclObject tmp5;
            { // Invoke: lindex $tuple 1
                TclObject tmp6 = getVarScalar(interp, "tuple", compiledLocals, 3);
                tmp6 = TclList.index(interp, tmp6, 1);
                if ( tmp6 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp6);
                }
            } // End Invoke: lindex
            tmp5 = interp.getResult();
            setVarScalar(interp, "value_symbol", tmp5, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set value_buffer [...]
            TclObject tmp7;
            { // Invoke: lindex $tuple 2
                TclObject tmp8 = getVarScalar(interp, "tuple", compiledLocals, 3);
                tmp8 = TclList.index(interp, tmp8, 2);
                if ( tmp8 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp8);
                }
            } // End Invoke: lindex
            tmp7 = interp.getResult();
            setVarScalar(interp, "value_buffer", tmp7, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: append buffer $value_buffer
            TclObject[] objv9 = TJC.grabObjv(interp, 1);
            TclObject tmp10;
            try {
                // Arg 2 variable: $value_buffer
                tmp10 = getVarScalar(interp, "value_buffer", compiledLocals, 6);
                tmp10.preserve();
                objv9[0] = tmp10;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv9, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv9, 1);
            }
        } // End Invoke: append
        { // Invoke: set tmpsymbol [...]
            TclObject tmp11;
            { // Invoke: ...
                TclObject[] objv12 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: ...
                    objv12[0] = const4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv12, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv12, 1);
                }
            } // End Invoke: ...
            tmp11 = interp.getResult();
            setVarScalar(interp, "tmpsymbol", tmp11, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: append buffer [...] [...]
            TclObject[] objv13 = TJC.grabObjv(interp, 2);
            TclObject tmp14;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_statement "..."
                    TclObject[] objv15 = TJC.grabObjv(interp, 2);
                    TclObject tmp16;
                    try {
                        // Arg 0 constant: emitter_statement
                        objv15[0] = const5;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp17 = new StringBuffer(64);
                        sbtmp17.append("int ");
                        tmp16 = getVarScalar(interp, "tmpsymbol", compiledLocals, 7);
                        sbtmp17.append(tmp16.toString());
                        sbtmp17.append(" = TclList.getLength(interp, ");
                        tmp16 = getVarScalar(interp, "value_symbol", compiledLocals, 5);
                        sbtmp17.append(tmp16.toString());
                        sbtmp17.append(")");
                        tmp16 = TclString.newInstance(sbtmp17);
                        tmp16.preserve();
                        objv15[1] = tmp16;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv15, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp16 = objv15[1];
                        if ( tmp16 != null ) {
                            tmp16.release();
                        }
                        TJC.releaseObjv(interp, objv15, 2);
                    }
                } // End Invoke: emitter_statement
                tmp14 = interp.getResult();
                tmp14.preserve();
                objv13[0] = tmp14;
                // Arg 3 command: [...]
                { // Invoke: emitter_set_result $tmpsymbol false
                    TclObject[] objv18 = TJC.grabObjv(interp, 3);
                    TclObject tmp19;
                    try {
                        // Arg 0 constant: emitter_set_result
                        objv18[0] = const6;
                        // Arg 1 variable: $tmpsymbol
                        tmp19 = getVarScalar(interp, "tmpsymbol", compiledLocals, 7);
                        tmp19.preserve();
                        objv18[1] = tmp19;
                        // Arg 2 constant: false
                        objv18[2] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv18, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp19 = objv18[1];
                        if ( tmp19 != null ) {
                            tmp19.release();
                        }
                        TJC.releaseObjv(interp, objv18, 3);
                    }
                } // End Invoke: emitter_set_result
                tmp14 = interp.getResult();
                tmp14.preserve();
                objv13[1] = tmp14;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv13, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv13, 2);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp20 = getVarScalar(interp, "buffer", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp20);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_inline_command_llength");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_emit_argument");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("true");
        TclBoolean.get(interp, const3);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_tmpvar_next");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_statement");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_set_result");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("false");
        TclBoolean.get(interp, const7);
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_emit_argument";
                break;
            }
            case 2: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 3: {
                cmdName = "emitter_statement";
                break;
            }
            case 4: {
                cmdName = "emitter_set_result";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_compileproc",
        "buffer",
        "tuple",
        "value_type",
        "value_symbol",
        "value_buffer",
        "tmpsymbol"
    };
} // end class CompileprocEmitInlineCommandLlengthCmd

