// TJC implementation of procedure compileproc_emit_lappend_call_impl
package tjc;
import tcl.lang.*;

public class CompileprocEmitLappendCallImplCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 20, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 5) {
            throw new TclNumArgsException(interp, 1, objv, "key arraysym tmpsymbol userdata");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "arraysym", objv[2], compiledLocals, 1);
        setVarScalar(interp, "tmpsymbol", objv[3], compiledLocals, 2);
        setVarScalar(interp, "userdata", objv[4], compiledLocals, 3);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 4);
        } // End Invoke: global
        { // Invoke: if ... ... else ...
            TclObject tmp0 = getVarArray(interp, "_compileproc", "options,cache_variables", compiledLocals, 4);
            ExprValue tmp1 = evs0;
            TJC.exprInitValue(interp, tmp1, tmp0);
            boolean tmp2 = tmp1.getBooleanValue(interp);
            if ( tmp2 ) {
                { // Invoke: set cache_variables 1
                    setVarScalar(interp, "cache_variables", const0, compiledLocals, 5);
                } // End Invoke: set
            } else {
                { // Invoke: set cache_variables 0
                    setVarScalar(interp, "cache_variables", const1, compiledLocals, 5);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const2, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set is_static_varname [...]
            TclObject tmp3;
            { // Invoke: lindex $userdata 0
                TclObject tmp4 = getVarScalar(interp, "userdata", compiledLocals, 3);
                tmp4 = TclList.index(interp, tmp4, 0);
                if ( tmp4 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp4);
                }
            } // End Invoke: lindex
            tmp3 = interp.getResult();
            setVarScalar(interp, "is_static_varname", tmp3, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if {$is_static_varname} ... else ...
            TclObject tmp5 = getVarScalar(interp, "is_static_varname", compiledLocals, 7);
            boolean tmp6 = TJC.getBoolean(interp, tmp5);
            if ( tmp6 ) {
                { // Invoke: set varname [...]
                    TclObject tmp7;
                    { // Invoke: lindex $userdata 1
                        TclObject tmp8 = getVarScalar(interp, "userdata", compiledLocals, 3);
                        tmp8 = TclList.index(interp, tmp8, 1);
                        if ( tmp8 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp8);
                        }
                    } // End Invoke: lindex
                    tmp7 = interp.getResult();
                    setVarScalar(interp, "varname", tmp7, compiledLocals, 8);
                } // End Invoke: set
            } else {
                { // Invoke: set varname [...]
                    TclObject tmp9;
                    { // Invoke: lindex $userdata 1
                        TclObject tmp10 = getVarScalar(interp, "userdata", compiledLocals, 3);
                        tmp10 = TclList.index(interp, tmp10, 1);
                        if ( tmp10 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp10);
                        }
                    } // End Invoke: lindex
                    tmp9 = interp.getResult();
                    setVarScalar(interp, "varname", tmp9, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set keysym [...]
                    TclObject tmp11;
                    { // Invoke: lindex $userdata 2
                        TclObject tmp12 = getVarScalar(interp, "userdata", compiledLocals, 3);
                        tmp12 = TclList.index(interp, tmp12, 2);
                        if ( tmp12 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp12);
                        }
                    } // End Invoke: lindex
                    tmp11 = interp.getResult();
                    setVarScalar(interp, "keysym", tmp11, compiledLocals, 9);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: append buffer [...]
            TclObject[] objv13 = TJC.grabObjv(interp, 1);
            TclObject tmp14;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_reset_result
                    TclObject[] objv15 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_reset_result
                        objv15[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv15, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv15, 1);
                    }
                } // End Invoke: emitter_reset_result
                tmp14 = interp.getResult();
                tmp14.preserve();
                objv13[0] = tmp14;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv13, compiledLocals, 6);
            } finally {
                TJC.releaseObjvElems(interp, objv13, 1);
            }
        } // End Invoke: append
        { // Invoke: set omit_result [...]
            TclObject tmp16;
            { // Invoke: ... $key
                TclObject[] objv17 = TJC.grabObjv(interp, 2);
                TclObject tmp18;
                try {
                    // Arg 0 constant: ...
                    objv17[0] = const4;
                    // Arg 1 variable: $key
                    tmp18 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp18.preserve();
                    objv17[1] = tmp18;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv17, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp18 = objv17[1];
                    if ( tmp18 != null ) {
                        tmp18.release();
                    }
                    TJC.releaseObjv(interp, objv17, 2);
                }
            } // End Invoke: ...
            tmp16 = interp.getResult();
            setVarScalar(interp, "omit_result", tmp16, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: if {$omit_result} ... else ...
            TclObject tmp19 = getVarScalar(interp, "omit_result", compiledLocals, 10);
            boolean tmp20 = TJC.getBoolean(interp, tmp19);
            if ( tmp20 ) {
                { // Invoke: set assign ""
                    setVarScalar(interp, "assign", const2, compiledLocals, 11);
                } // End Invoke: set
            } else {
                { // Invoke: set assign "$tmpsymbol = "
                    TclObject tmp21;
                    StringBuffer sbtmp22 = new StringBuffer(64);
                    tmp21 = getVarScalar(interp, "tmpsymbol", compiledLocals, 2);
                    sbtmp22.append(tmp21.toString());
                    sbtmp22.append(" = ");
                    tmp21 = TclString.newInstance(sbtmp22);
                    setVarScalar(interp, "assign", tmp21, compiledLocals, 11);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {!$cache_variables} ... elseif {$is_static_varname} ... else ...
            // Unary operator: ! $cache_variables
            TclObject tmp23 = getVarScalar(interp, "cache_variables", compiledLocals, 5);
            ExprValue tmp24 = evs0;
            if ( tmp23.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp24, tmp23);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp24, tmp23);
            }
            // End Unary operator: !
            boolean tmp25 = ( tmp24.getIntValue() != 0 );
            if ( tmp25 ) {
                { // Invoke: set qvarname [...]
                    TclObject tmp26;
                    { // Invoke: ... $varname
                        TclObject[] objv27 = TJC.grabObjv(interp, 2);
                        TclObject tmp28;
                        try {
                            // Arg 0 constant: ...
                            objv27[0] = const5;
                            // Arg 1 variable: $varname
                            tmp28 = getVarScalar(interp, "varname", compiledLocals, 8);
                            tmp28.preserve();
                            objv27[1] = tmp28;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv27, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp28 = objv27[1];
                            if ( tmp28 != null ) {
                                tmp28.release();
                            }
                            TJC.releaseObjv(interp, objv27, 2);
                        }
                    } // End Invoke: ...
                    tmp26 = interp.getResult();
                    setVarScalar(interp, "qvarname", tmp26, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: if {$is_static_varname} ... else ...
                    TclObject tmp29 = getVarScalar(interp, "is_static_varname", compiledLocals, 7);
                    boolean tmp30 = TJC.getBoolean(interp, tmp29);
                    if ( tmp30 ) {
                        { // Invoke: append buffer [...]
                            TclObject[] objv31 = TJC.grabObjv(interp, 1);
                            TclObject tmp32;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv33 = TJC.grabObjv(interp, 2);
                                    TclObject tmp34;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv33[0] = const6;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp35 = new StringBuffer(64);
                                        tmp34 = getVarScalar(interp, "assign", compiledLocals, 11);
                                        sbtmp35.append(tmp34.toString());
                                        sbtmp35.append("TJC.lappendVar(interp, ");
                                        tmp34 = getVarScalar(interp, "qvarname", compiledLocals, 12);
                                        sbtmp35.append(tmp34.toString());
                                        sbtmp35.append(", null, ");
                                        tmp34 = getVarScalar(interp, "arraysym", compiledLocals, 1);
                                        sbtmp35.append(tmp34.toString());
                                        sbtmp35.append(")");
                                        tmp34 = TclString.newInstance(sbtmp35);
                                        tmp34.preserve();
                                        objv33[1] = tmp34;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv33, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp34 = objv33[1];
                                        if ( tmp34 != null ) {
                                            tmp34.release();
                                        }
                                        TJC.releaseObjv(interp, objv33, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp32 = interp.getResult();
                                tmp32.preserve();
                                objv31[0] = tmp32;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv31, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv31, 1);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: append buffer [...]
                            TclObject[] objv36 = TJC.grabObjv(interp, 1);
                            TclObject tmp37;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv38 = TJC.grabObjv(interp, 2);
                                    TclObject tmp39;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv38[0] = const6;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp40 = new StringBuffer(64);
                                        tmp39 = getVarScalar(interp, "assign", compiledLocals, 11);
                                        sbtmp40.append(tmp39.toString());
                                        sbtmp40.append("TJC.lappendVar(interp, ");
                                        tmp39 = getVarScalar(interp, "qvarname", compiledLocals, 12);
                                        sbtmp40.append(tmp39.toString());
                                        sbtmp40.append(", ");
                                        tmp39 = getVarScalar(interp, "keysym", compiledLocals, 9);
                                        sbtmp40.append(tmp39.toString());
                                        sbtmp40.append(", ");
                                        tmp39 = getVarScalar(interp, "arraysym", compiledLocals, 1);
                                        sbtmp40.append(tmp39.toString());
                                        sbtmp40.append(")");
                                        tmp39 = TclString.newInstance(sbtmp40);
                                        tmp39.preserve();
                                        objv38[1] = tmp39;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv38, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp39 = objv38[1];
                                        if ( tmp39 != null ) {
                                            tmp39.release();
                                        }
                                        TJC.releaseObjv(interp, objv38, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp37 = interp.getResult();
                                tmp37.preserve();
                                objv36[0] = tmp37;
                                interp.resetResult();
                                appendVarScalar(interp, "buffer", objv36, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv36, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
            } else {
                TclObject tmp41 = getVarScalar(interp, "is_static_varname", compiledLocals, 7);
                boolean tmp42 = TJC.getBoolean(interp, tmp41);
                if ( tmp42 ) {
                    { // Invoke: set vinfo [...]
                        TclObject tmp43;
                        { // Invoke: ... $varname
                            TclObject[] objv44 = TJC.grabObjv(interp, 2);
                            TclObject tmp45;
                            try {
                                // Arg 0 constant: ...
                                objv44[0] = const7;
                                // Arg 1 variable: $varname
                                tmp45 = getVarScalar(interp, "varname", compiledLocals, 8);
                                tmp45.preserve();
                                objv44[1] = tmp45;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv44, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp45 = objv44[1];
                                if ( tmp45 != null ) {
                                    tmp45.release();
                                }
                                TJC.releaseObjv(interp, objv44, 2);
                            }
                        } // End Invoke: ...
                        tmp43 = interp.getResult();
                        setVarScalar(interp, "vinfo", tmp43, compiledLocals, 13);
                    } // End Invoke: set
                    { // Invoke: if ... ... elseif ... ... else ...
                        // Binary operator: [...] == "array"
                        { // Invoke: lindex $vinfo 0
                            TclObject tmp46 = getVarScalar(interp, "vinfo", compiledLocals, 13);
                            tmp46 = TclList.index(interp, tmp46, 0);
                            if ( tmp46 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp46);
                            }
                        } // End Invoke: lindex
                        TclObject tmp47 = interp.getResult();
                        boolean tmp48 = tmp47.toString().equals("array");
                        ExprValue tmp49 = evs0;
                        tmp49.setIntValue(tmp48);
                        // End Binary operator: ==
                        boolean tmp50 = ( tmp49.getIntValue() != 0 );
                        if ( tmp50 ) {
                            { // Invoke: set p1 [...]
                                TclObject tmp51;
                                { // Invoke: lindex $vinfo 1
                                    TclObject tmp52 = getVarScalar(interp, "vinfo", compiledLocals, 13);
                                    tmp52 = TclList.index(interp, tmp52, 1);
                                    if ( tmp52 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp52);
                                    }
                                } // End Invoke: lindex
                                tmp51 = interp.getResult();
                                setVarScalar(interp, "p1", tmp51, compiledLocals, 14);
                            } // End Invoke: set
                            { // Invoke: set p2 [...]
                                TclObject tmp53;
                                { // Invoke: lindex $vinfo 2
                                    TclObject tmp54 = getVarScalar(interp, "vinfo", compiledLocals, 13);
                                    tmp54 = TclList.index(interp, tmp54, 2);
                                    if ( tmp54 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp54);
                                    }
                                } // End Invoke: lindex
                                tmp53 = interp.getResult();
                                setVarScalar(interp, "p2", tmp53, compiledLocals, 15);
                            } // End Invoke: set
                            { // Invoke: set cache_symbol [...]
                                TclObject tmp55;
                                { // Invoke: ... $p1
                                    TclObject[] objv56 = TJC.grabObjv(interp, 2);
                                    TclObject tmp57;
                                    try {
                                        // Arg 0 constant: ...
                                        objv56[0] = const8;
                                        // Arg 1 variable: $p1
                                        tmp57 = getVarScalar(interp, "p1", compiledLocals, 14);
                                        tmp57.preserve();
                                        objv56[1] = tmp57;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv56, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        tmp57 = objv56[1];
                                        if ( tmp57 != null ) {
                                            tmp57.release();
                                        }
                                        TJC.releaseObjv(interp, objv56, 2);
                                    }
                                } // End Invoke: ...
                                tmp55 = interp.getResult();
                                setVarScalar(interp, "cache_symbol", tmp55, compiledLocals, 16);
                            } // End Invoke: set
                            { // Invoke: set cacheId [...]
                                TclObject tmp58;
                                { // Invoke: ... $cache_symbol
                                    TclObject[] objv59 = TJC.grabObjv(interp, 2);
                                    TclObject tmp60;
                                    try {
                                        // Arg 0 constant: ...
                                        objv59[0] = const9;
                                        // Arg 1 variable: $cache_symbol
                                        tmp60 = getVarScalar(interp, "cache_symbol", compiledLocals, 16);
                                        tmp60.preserve();
                                        objv59[1] = tmp60;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv59, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        tmp60 = objv59[1];
                                        if ( tmp60 != null ) {
                                            tmp60.release();
                                        }
                                        TJC.releaseObjv(interp, objv59, 2);
                                    }
                                } // End Invoke: ...
                                tmp58 = interp.getResult();
                                setVarScalar(interp, "cacheId", tmp58, compiledLocals, 17);
                            } // End Invoke: set
                            { // Invoke: set qp1 [...]
                                TclObject tmp61;
                                { // Invoke: ... $p1
                                    TclObject[] objv62 = TJC.grabObjv(interp, 2);
                                    TclObject tmp63;
                                    try {
                                        // Arg 0 constant: ...
                                        objv62[0] = const5;
                                        // Arg 1 variable: $p1
                                        tmp63 = getVarScalar(interp, "p1", compiledLocals, 14);
                                        tmp63.preserve();
                                        objv62[1] = tmp63;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv62, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp63 = objv62[1];
                                        if ( tmp63 != null ) {
                                            tmp63.release();
                                        }
                                        TJC.releaseObjv(interp, objv62, 2);
                                    }
                                } // End Invoke: ...
                                tmp61 = interp.getResult();
                                setVarScalar(interp, "qp1", tmp61, compiledLocals, 18);
                            } // End Invoke: set
                            { // Invoke: set qp2 [...]
                                TclObject tmp64;
                                { // Invoke: ... $p2
                                    TclObject[] objv65 = TJC.grabObjv(interp, 2);
                                    TclObject tmp66;
                                    try {
                                        // Arg 0 constant: ...
                                        objv65[0] = const5;
                                        // Arg 1 variable: $p2
                                        tmp66 = getVarScalar(interp, "p2", compiledLocals, 15);
                                        tmp66.preserve();
                                        objv65[1] = tmp66;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv65, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp66 = objv65[1];
                                        if ( tmp66 != null ) {
                                            tmp66.release();
                                        }
                                        TJC.releaseObjv(interp, objv65, 2);
                                    }
                                } // End Invoke: ...
                                tmp64 = interp.getResult();
                                setVarScalar(interp, "qp2", tmp64, compiledLocals, 19);
                            } // End Invoke: set
                            { // Invoke: append buffer [...]
                                TclObject[] objv67 = TJC.grabObjv(interp, 1);
                                TclObject tmp68;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_statement "..."
                                        TclObject[] objv69 = TJC.grabObjv(interp, 2);
                                        TclObject tmp70;
                                        try {
                                            // Arg 0 constant: emitter_statement
                                            objv69[0] = const6;
                                            // Arg 1 word: "..."
                                            StringBuffer sbtmp71 = new StringBuffer(64);
                                            tmp70 = getVarScalar(interp, "assign", compiledLocals, 11);
                                            sbtmp71.append(tmp70.toString());
                                            sbtmp71.append("lappendVarArray(interp, ");
                                            tmp70 = getVarScalar(interp, "qp1", compiledLocals, 18);
                                            sbtmp71.append(tmp70.toString());
                                            sbtmp71.append(", ");
                                            tmp70 = getVarScalar(interp, "qp2", compiledLocals, 19);
                                            sbtmp71.append(tmp70.toString());
                                            sbtmp71.append(", ");
                                            tmp70 = getVarScalar(interp, "arraysym", compiledLocals, 1);
                                            sbtmp71.append(tmp70.toString());
                                            sbtmp71.append(", compiledLocals, ");
                                            tmp70 = getVarScalar(interp, "cacheId", compiledLocals, 17);
                                            sbtmp71.append(tmp70.toString());
                                            sbtmp71.append(")");
                                            tmp70 = TclString.newInstance(sbtmp71);
                                            tmp70.preserve();
                                            objv69[1] = tmp70;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv69, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp70 = objv69[1];
                                            if ( tmp70 != null ) {
                                                tmp70.release();
                                            }
                                            TJC.releaseObjv(interp, objv69, 2);
                                        }
                                    } // End Invoke: emitter_statement
                                    tmp68 = interp.getResult();
                                    tmp68.preserve();
                                    objv67[0] = tmp68;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv67, compiledLocals, 6);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv67, 1);
                                }
                            } // End Invoke: append
                        } else {
                            // Binary operator: [...] == "scalar"
                            { // Invoke: lindex $vinfo 0
                                TclObject tmp72 = getVarScalar(interp, "vinfo", compiledLocals, 13);
                                tmp72 = TclList.index(interp, tmp72, 0);
                                if ( tmp72 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp72);
                                }
                            } // End Invoke: lindex
                            TclObject tmp73 = interp.getResult();
                            boolean tmp74 = tmp73.toString().equals("scalar");
                            ExprValue tmp75 = evs0;
                            tmp75.setIntValue(tmp74);
                            // End Binary operator: ==
                            boolean tmp76 = ( tmp75.getIntValue() != 0 );
                            if ( tmp76 ) {
                                { // Invoke: set qvarname [...]
                                    TclObject tmp77;
                                    { // Invoke: ... $varname
                                        TclObject[] objv78 = TJC.grabObjv(interp, 2);
                                        TclObject tmp79;
                                        try {
                                            // Arg 0 constant: ...
                                            objv78[0] = const5;
                                            // Arg 1 variable: $varname
                                            tmp79 = getVarScalar(interp, "varname", compiledLocals, 8);
                                            tmp79.preserve();
                                            objv78[1] = tmp79;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv78, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            tmp79 = objv78[1];
                                            if ( tmp79 != null ) {
                                                tmp79.release();
                                            }
                                            TJC.releaseObjv(interp, objv78, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp77 = interp.getResult();
                                    setVarScalar(interp, "qvarname", tmp77, compiledLocals, 12);
                                } // End Invoke: set
                                { // Invoke: set cache_symbol [...]
                                    TclObject tmp80;
                                    { // Invoke: ... $varname
                                        TclObject[] objv81 = TJC.grabObjv(interp, 2);
                                        TclObject tmp82;
                                        try {
                                            // Arg 0 constant: ...
                                            objv81[0] = const8;
                                            // Arg 1 variable: $varname
                                            tmp82 = getVarScalar(interp, "varname", compiledLocals, 8);
                                            tmp82.preserve();
                                            objv81[1] = tmp82;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                ? cmdcache6.cmd : null), objv81, 0);
                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                updateCmdCache(interp, 6);
                                            }
                                        } finally {
                                            tmp82 = objv81[1];
                                            if ( tmp82 != null ) {
                                                tmp82.release();
                                            }
                                            TJC.releaseObjv(interp, objv81, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp80 = interp.getResult();
                                    setVarScalar(interp, "cache_symbol", tmp80, compiledLocals, 16);
                                } // End Invoke: set
                                { // Invoke: set cacheId [...]
                                    TclObject tmp83;
                                    { // Invoke: ... $cache_symbol
                                        TclObject[] objv84 = TJC.grabObjv(interp, 2);
                                        TclObject tmp85;
                                        try {
                                            // Arg 0 constant: ...
                                            objv84[0] = const9;
                                            // Arg 1 variable: $cache_symbol
                                            tmp85 = getVarScalar(interp, "cache_symbol", compiledLocals, 16);
                                            tmp85.preserve();
                                            objv84[1] = tmp85;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                ? cmdcache7.cmd : null), objv84, 0);
                                            if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                updateCmdCache(interp, 7);
                                            }
                                        } finally {
                                            tmp85 = objv84[1];
                                            if ( tmp85 != null ) {
                                                tmp85.release();
                                            }
                                            TJC.releaseObjv(interp, objv84, 2);
                                        }
                                    } // End Invoke: ...
                                    tmp83 = interp.getResult();
                                    setVarScalar(interp, "cacheId", tmp83, compiledLocals, 17);
                                } // End Invoke: set
                                { // Invoke: append buffer [...]
                                    TclObject[] objv86 = TJC.grabObjv(interp, 1);
                                    TclObject tmp87;
                                    try {
                                        // Arg 2 command: [...]
                                        { // Invoke: emitter_statement "..."
                                            TclObject[] objv88 = TJC.grabObjv(interp, 2);
                                            TclObject tmp89;
                                            try {
                                                // Arg 0 constant: emitter_statement
                                                objv88[0] = const6;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp90 = new StringBuffer(64);
                                                tmp89 = getVarScalar(interp, "assign", compiledLocals, 11);
                                                sbtmp90.append(tmp89.toString());
                                                sbtmp90.append("lappendVarScalar(interp, ");
                                                tmp89 = getVarScalar(interp, "qvarname", compiledLocals, 12);
                                                sbtmp90.append(tmp89.toString());
                                                sbtmp90.append(", ");
                                                tmp89 = getVarScalar(interp, "arraysym", compiledLocals, 1);
                                                sbtmp90.append(tmp89.toString());
                                                sbtmp90.append(", compiledLocals, ");
                                                tmp89 = getVarScalar(interp, "cacheId", compiledLocals, 17);
                                                sbtmp90.append(tmp89.toString());
                                                sbtmp90.append(")");
                                                tmp89 = TclString.newInstance(sbtmp90);
                                                tmp89.preserve();
                                                objv88[1] = tmp89;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv88, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp89 = objv88[1];
                                                if ( tmp89 != null ) {
                                                    tmp89.release();
                                                }
                                                TJC.releaseObjv(interp, objv88, 2);
                                            }
                                        } // End Invoke: emitter_statement
                                        tmp87 = interp.getResult();
                                        tmp87.preserve();
                                        objv86[0] = tmp87;
                                        interp.resetResult();
                                        appendVarScalar(interp, "buffer", objv86, compiledLocals, 6);
                                    } finally {
                                        TJC.releaseObjvElems(interp, objv86, 1);
                                    }
                                } // End Invoke: append
                            } else {
                                { // Invoke: error "..."
                                    TclObject[] objv91 = TJC.grabObjv(interp, 2);
                                    TclObject tmp92;
                                    try {
                                        // Arg 0 constant: error
                                        objv91[0] = const10;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp93 = new StringBuffer(64);
                                        sbtmp93.append("unexpected result ");
                                        sbtmp93.append("{");
                                        tmp92 = getVarScalar(interp, "vinfo", compiledLocals, 13);
                                        sbtmp93.append(tmp92.toString());
                                        sbtmp93.append("}");
                                        sbtmp93.append(" from descend_simple_variable");
                                        tmp92 = TclString.newInstance(sbtmp93);
                                        tmp92.preserve();
                                        objv91[1] = tmp92;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv91, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        tmp92 = objv91[1];
                                        if ( tmp92 != null ) {
                                            tmp92.release();
                                        }
                                        TJC.releaseObjv(interp, objv91, 2);
                                    }
                                } // End Invoke: error
                            }
                        }
                    } // End Invoke: if
                } else {
                    { // Invoke: set cache_symbol [...]
                        TclObject tmp94;
                        { // Invoke: ... $varname
                            TclObject[] objv95 = TJC.grabObjv(interp, 2);
                            TclObject tmp96;
                            try {
                                // Arg 0 constant: ...
                                objv95[0] = const8;
                                // Arg 1 variable: $varname
                                tmp96 = getVarScalar(interp, "varname", compiledLocals, 8);
                                tmp96.preserve();
                                objv95[1] = tmp96;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv95, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                tmp96 = objv95[1];
                                if ( tmp96 != null ) {
                                    tmp96.release();
                                }
                                TJC.releaseObjv(interp, objv95, 2);
                            }
                        } // End Invoke: ...
                        tmp94 = interp.getResult();
                        setVarScalar(interp, "cache_symbol", tmp94, compiledLocals, 16);
                    } // End Invoke: set
                    { // Invoke: set cacheId [...]
                        TclObject tmp97;
                        { // Invoke: ... $cache_symbol
                            TclObject[] objv98 = TJC.grabObjv(interp, 2);
                            TclObject tmp99;
                            try {
                                // Arg 0 constant: ...
                                objv98[0] = const9;
                                // Arg 1 variable: $cache_symbol
                                tmp99 = getVarScalar(interp, "cache_symbol", compiledLocals, 16);
                                tmp99.preserve();
                                objv98[1] = tmp99;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                    ? cmdcache7.cmd : null), objv98, 0);
                                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                    updateCmdCache(interp, 7);
                                }
                            } finally {
                                tmp99 = objv98[1];
                                if ( tmp99 != null ) {
                                    tmp99.release();
                                }
                                TJC.releaseObjv(interp, objv98, 2);
                            }
                        } // End Invoke: ...
                        tmp97 = interp.getResult();
                        setVarScalar(interp, "cacheId", tmp97, compiledLocals, 17);
                    } // End Invoke: set
                    { // Invoke: set qvarname [...]
                        TclObject tmp100;
                        { // Invoke: ... $varname
                            TclObject[] objv101 = TJC.grabObjv(interp, 2);
                            TclObject tmp102;
                            try {
                                // Arg 0 constant: ...
                                objv101[0] = const5;
                                // Arg 1 variable: $varname
                                tmp102 = getVarScalar(interp, "varname", compiledLocals, 8);
                                tmp102.preserve();
                                objv101[1] = tmp102;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv101, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp102 = objv101[1];
                                if ( tmp102 != null ) {
                                    tmp102.release();
                                }
                                TJC.releaseObjv(interp, objv101, 2);
                            }
                        } // End Invoke: ...
                        tmp100 = interp.getResult();
                        setVarScalar(interp, "qvarname", tmp100, compiledLocals, 12);
                    } // End Invoke: set
                    { // Invoke: append buffer [...]
                        TclObject[] objv103 = TJC.grabObjv(interp, 1);
                        TclObject tmp104;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_statement "..."
                                TclObject[] objv105 = TJC.grabObjv(interp, 2);
                                TclObject tmp106;
                                try {
                                    // Arg 0 constant: emitter_statement
                                    objv105[0] = const6;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp107 = new StringBuffer(64);
                                    tmp106 = getVarScalar(interp, "assign", compiledLocals, 11);
                                    sbtmp107.append(tmp106.toString());
                                    sbtmp107.append("lappendVarArray(interp, ");
                                    tmp106 = getVarScalar(interp, "qvarname", compiledLocals, 12);
                                    sbtmp107.append(tmp106.toString());
                                    sbtmp107.append(", ");
                                    tmp106 = getVarScalar(interp, "keysym", compiledLocals, 9);
                                    sbtmp107.append(tmp106.toString());
                                    sbtmp107.append(", ");
                                    tmp106 = getVarScalar(interp, "arraysym", compiledLocals, 1);
                                    sbtmp107.append(tmp106.toString());
                                    sbtmp107.append(", compiledLocals, ");
                                    tmp106 = getVarScalar(interp, "cacheId", compiledLocals, 17);
                                    sbtmp107.append(tmp106.toString());
                                    sbtmp107.append(")");
                                    tmp106 = TclString.newInstance(sbtmp107);
                                    tmp106.preserve();
                                    objv105[1] = tmp106;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv105, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp106 = objv105[1];
                                    if ( tmp106 != null ) {
                                        tmp106.release();
                                    }
                                    TJC.releaseObjv(interp, objv105, 2);
                                }
                            } // End Invoke: emitter_statement
                            tmp104 = interp.getResult();
                            tmp104.preserve();
                            objv103[0] = tmp104;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv103, compiledLocals, 6);
                        } finally {
                            TJC.releaseObjvElems(interp, objv103, 1);
                        }
                    } // End Invoke: append
                }
            }
        } // End Invoke: if
        { // Invoke: if {!$omit_result} ...
            // Unary operator: ! $omit_result
            TclObject tmp108 = getVarScalar(interp, "omit_result", compiledLocals, 10);
            ExprValue tmp109 = evs0;
            if ( tmp108.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp109, tmp108);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp109, tmp108);
            }
            // End Unary operator: !
            boolean tmp110 = ( tmp109.getIntValue() != 0 );
            if ( tmp110 ) {
                { // Invoke: append buffer [...]
                    TclObject[] objv111 = TJC.grabObjv(interp, 1);
                    TclObject tmp112;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_set_result $tmpsymbol false
                            TclObject[] objv113 = TJC.grabObjv(interp, 3);
                            TclObject tmp114;
                            try {
                                // Arg 0 constant: emitter_set_result
                                objv113[0] = const11;
                                // Arg 1 variable: $tmpsymbol
                                tmp114 = getVarScalar(interp, "tmpsymbol", compiledLocals, 2);
                                tmp114.preserve();
                                objv113[1] = tmp114;
                                // Arg 2 constant: false
                                objv113[2] = const12;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                    ? cmdcache9.cmd : null), objv113, 0);
                                if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                    updateCmdCache(interp, 9);
                                }
                            } finally {
                                tmp114 = objv113[1];
                                if ( tmp114 != null ) {
                                    tmp114.release();
                                }
                                TJC.releaseObjv(interp, objv113, 3);
                            }
                        } // End Invoke: emitter_set_result
                        tmp112 = interp.getResult();
                        tmp112.preserve();
                        objv111[0] = tmp112;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv111, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv111, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp115 = getVarScalar(interp, "buffer", compiledLocals, 6);
            interp.resetResult();
            interp.setResult(tmp115);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_emit_lappend_call_impl");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("emitter_reset_result");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("compileproc_omit_set_result");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_double_quote_tcl_string");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_statement");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_simple_variable");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_variable_cache_lookup");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_get_variable_cache_id_from_symbol");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("error");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("emitter_set_result");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("false");
        TclBoolean.get(interp, const12);
        const12.preserve(); const12.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_reset_result";
                break;
            }
            case 2: {
                cmdName = "compileproc_omit_set_result";
                break;
            }
            case 3: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            case 4: {
                cmdName = "emitter_statement";
                break;
            }
            case 5: {
                cmdName = "descend_simple_variable";
                break;
            }
            case 6: {
                cmdName = "compileproc_variable_cache_lookup";
                break;
            }
            case 7: {
                cmdName = "compileproc_get_variable_cache_id_from_symbol";
                break;
            }
            case 8: {
                cmdName = "error";
                break;
            }
            case 9: {
                cmdName = "emitter_set_result";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "arraysym",
        "tmpsymbol",
        "userdata",
        "_compileproc",
        "cache_variables",
        "buffer",
        "is_static_varname",
        "varname",
        "keysym",
        "omit_result",
        "assign",
        "qvarname",
        "vinfo",
        "p1",
        "p2",
        "cache_symbol",
        "cacheId",
        "qp1",
        "qp2"
    };
} // end class CompileprocEmitLappendCallImplCmd

