// TJC implementation of procedure compileproc_expr_evaluate_emit_binary_equals_operator
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateEmitBinaryEqualsOperatorCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 35, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "op left_tuple left_peek_tuple right_tuple right_peek_tuple");
        }
        setVarScalar(interp, "op", objv[1], compiledLocals, 0);
        setVarScalar(interp, "left_tuple", objv[2], compiledLocals, 1);
        setVarScalar(interp, "left_peek_tuple", objv[3], compiledLocals, 2);
        setVarScalar(interp, "right_tuple", objv[4], compiledLocals, 3);
        setVarScalar(interp, "right_peek_tuple", objv[5], compiledLocals, 4);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 5);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Binary operator: () && ()
            // Binary operator: () && ()
            // Binary operator: $op != "=="
            TclObject tmp0 = getVarScalar(interp, "op", compiledLocals, 0);
            boolean tmp1 = ! tmp0.toString().equals("==");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: !=
            if (tmp2.getBooleanValue(interp)) {
            // Binary operator: $op != "!="
            TclObject tmp3 = getVarScalar(interp, "op", compiledLocals, 0);
            boolean tmp4 = ! tmp3.toString().equals("!=");
            ExprValue tmp5 = evs1;
            tmp5.setIntValue(tmp4);
            // End Binary operator: !=
            tmp2.setIntValue(tmp5.getBooleanValue(interp));
            } else {
            tmp2.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            if (tmp2.getBooleanValue(interp)) {
            // Binary operator: $op != "eq"
            TclObject tmp6 = getVarScalar(interp, "op", compiledLocals, 0);
            boolean tmp7 = ! tmp6.toString().equals("eq");
            ExprValue tmp8 = evs1;
            tmp8.setIntValue(tmp7);
            // End Binary operator: !=
            tmp2.setIntValue(tmp8.getBooleanValue(interp));
            } else {
            tmp2.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            if (tmp2.getBooleanValue(interp)) {
            // Binary operator: $op != "ne"
            TclObject tmp9 = getVarScalar(interp, "op", compiledLocals, 0);
            boolean tmp10 = ! tmp9.toString().equals("ne");
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(tmp10);
            // End Binary operator: !=
            tmp2.setIntValue(tmp11.getBooleanValue(interp));
            } else {
            tmp2.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp12 = ( tmp2.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: error "..."
                    TclObject[] objv13 = TJC.grabObjv(interp, 2);
                    TclObject tmp14;
                    try {
                        // Arg 0 constant: error
                        objv13[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp15 = new StringBuffer(64);
                        sbtmp15.append("operator ");
                        sbtmp15.append("\"");
                        tmp14 = getVarScalar(interp, "op", compiledLocals, 0);
                        sbtmp15.append(tmp14.toString());
                        sbtmp15.append("\"");
                        sbtmp15.append(" is not an equals operator");
                        tmp14 = TclString.newInstance(sbtmp15);
                        tmp14.preserve();
                        objv13[1] = tmp14;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv13, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp14 = objv13[1];
                        if ( tmp14 != null ) {
                            tmp14.release();
                        }
                        TJC.releaseObjv(interp, objv13, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set op_buffer ""
            setVarScalar(interp, "op_buffer", const1, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set left_value_info_type [...]
            TclObject tmp16;
            { // Invoke: lindex $left_peek_tuple 0
                TclObject tmp17 = getVarScalar(interp, "left_peek_tuple", compiledLocals, 2);
                tmp17 = TclList.index(interp, tmp17, 0);
                if ( tmp17 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp17);
                }
            } // End Invoke: lindex
            tmp16 = interp.getResult();
            setVarScalar(interp, "left_value_info_type", tmp16, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp18;
            { // Invoke: lindex $left_peek_tuple 1
                TclObject tmp19 = getVarScalar(interp, "left_peek_tuple", compiledLocals, 2);
                tmp19 = TclList.index(interp, tmp19, 1);
                if ( tmp19 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp19);
                }
            } // End Invoke: lindex
            tmp18 = interp.getResult();
            setVarScalar(interp, "left_value_info_value", tmp18, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp20;
            { // Invoke: lindex $right_peek_tuple 0
                TclObject tmp21 = getVarScalar(interp, "right_peek_tuple", compiledLocals, 4);
                tmp21 = TclList.index(interp, tmp21, 0);
                if ( tmp21 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp21);
                }
            } // End Invoke: lindex
            tmp20 = interp.getResult();
            setVarScalar(interp, "right_value_info_type", tmp20, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set ... [...]
            TclObject tmp22;
            { // Invoke: lindex $right_peek_tuple 1
                TclObject tmp23 = getVarScalar(interp, "right_peek_tuple", compiledLocals, 4);
                tmp23 = TclList.index(interp, tmp23, 1);
                if ( tmp23 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp23);
                }
            } // End Invoke: lindex
            tmp22 = interp.getResult();
            setVarScalar(interp, "right_value_info_value", tmp22, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarScalar(interp, "is_tclobject_string_compare", const2, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarScalar(interp, "opt_tclobject_empty_string_compare", const2, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarScalar(interp, "opt_tclobject_string_compare", const2, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarScalar(interp, "opt_tclobject_to_tclobject_string_compare", const2, compiledLocals, 14);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarScalar(interp, "opt_tclobject_to_exprvalue_string_compare", const2, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: set ... 0
            setVarScalar(interp, "is_left_operand_tclobject", const2, compiledLocals, 16);
        } // End Invoke: set
        { // Invoke: set is_any_optimized_op 0
            setVarScalar(interp, "is_any_optimized_op", const2, compiledLocals, 17);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: () && ()
            // Binary operator: $left_value_info_type == "TclObject"
            TclObject tmp24 = getVarScalar(interp, "left_value_info_type", compiledLocals, 7);
            boolean tmp25 = tmp24.toString().equals("TclObject");
            ExprValue tmp26 = evs0;
            tmp26.setIntValue(tmp25);
            // End Binary operator: ==
            if (tmp26.getBooleanValue(interp)) {
            // Binary operator: $right_value_info_type == "String"
            TclObject tmp27 = getVarScalar(interp, "right_value_info_type", compiledLocals, 9);
            boolean tmp28 = tmp27.toString().equals("String");
            ExprValue tmp29 = evs1;
            tmp29.setIntValue(tmp28);
            // End Binary operator: ==
            tmp26.setIntValue(tmp29.getBooleanValue(interp));
            } else {
            tmp26.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            if (!tmp26.getBooleanValue(interp)) {
            // Binary operator: () && ()
            // Binary operator: $left_value_info_type == "String"
            TclObject tmp30 = getVarScalar(interp, "left_value_info_type", compiledLocals, 7);
            boolean tmp31 = tmp30.toString().equals("String");
            ExprValue tmp32 = evs1;
            tmp32.setIntValue(tmp31);
            // End Binary operator: ==
            if (tmp32.getBooleanValue(interp)) {
            // Binary operator: $right_value_info_type == "TclObject"
            TclObject tmp33 = getVarScalar(interp, "right_value_info_type", compiledLocals, 9);
            boolean tmp34 = tmp33.toString().equals("TclObject");
            ExprValue tmp35 = evs2;
            tmp35.setIntValue(tmp34);
            // End Binary operator: ==
            tmp32.setIntValue(tmp35.getBooleanValue(interp));
            } else {
            tmp32.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            tmp26.setIntValue(tmp32.getBooleanValue(interp));
            } else {
            tmp26.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp36 = ( tmp26.getIntValue() != 0 );
            if ( tmp36 ) {
                { // Invoke: set ... 1
                    setVarScalar(interp, "is_tclobject_string_compare", const3, compiledLocals, 11);
                } // End Invoke: set
                { // Invoke: set ... [...]
                    TclObject tmp37;
                    { // Invoke: expr ...
                        // Binary operator: $left_value_info_type == "TclObject"
                        TclObject tmp38 = getVarScalar(interp, "left_value_info_type", compiledLocals, 7);
                        boolean tmp39 = tmp38.toString().equals("TclObject");
                        ExprValue tmp40 = evs0;
                        tmp40.setIntValue(tmp39);
                        // End Binary operator: ==
                        interp.setResult( tmp40.getIntValue() != 0 );
                    } // End Invoke: expr
                    tmp37 = interp.getResult();
                    setVarScalar(interp, "is_left_operand_tclobject", tmp37, compiledLocals, 16);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            TclObject tmp41 = getVarScalar(interp, "is_tclobject_string_compare", compiledLocals, 11);
            boolean tmp42 = TJC.getBoolean(interp, tmp41);
            if ( tmp42 ) {
                { // Invoke: if ... ... else ...
                    TclObject tmp43 = getVarScalar(interp, "is_left_operand_tclobject", compiledLocals, 16);
                    boolean tmp44 = TJC.getBoolean(interp, tmp43);
                    if ( tmp44 ) {
                        { // Invoke: set str $...
                            TclObject tmp45;
                            tmp45 = getVarScalar(interp, "right_value_info_value", compiledLocals, 10);
                            setVarScalar(interp, "str", tmp45, compiledLocals, 18);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set str $...
                            TclObject tmp46;
                            tmp46 = getVarScalar(interp, "left_value_info_value", compiledLocals, 8);
                            setVarScalar(interp, "str", tmp46, compiledLocals, 18);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set string_literal [...]
                    TclObject tmp47;
                    { // Invoke: string range $str 1 end-1
                        TclObject tmp48 = getVarScalar(interp, "str", compiledLocals, 18);
                        String tmp49 = tmp48.toString();
                        TclObject tmp50 = const3;
                        tmp50.preserve();
                        TclObject tmp51 = const4;
                        TclObject tmp52 = TJC.stringRange(interp, tmp49, tmp50, tmp51);
                        interp.setResult(tmp52);
                    } // End Invoke: string
                    tmp47 = interp.getResult();
                    setVarScalar(interp, "string_literal", tmp47, compiledLocals, 19);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $string_literal eq ""
                    TclObject tmp53 = getVarScalar(interp, "string_literal", compiledLocals, 19);
                    ExprValue tmp54 = evs0;
                    TJC.exprEqualsEmptyString(tmp54, tmp53, false);
                    // End Binary operator: eq
                    boolean tmp55 = ( tmp54.getIntValue() != 0 );
                    if ( tmp55 ) {
                        { // Invoke: set is_any_optimized_op 1
                            setVarScalar(interp, "is_any_optimized_op", const3, compiledLocals, 17);
                        } // End Invoke: set
                        { // Invoke: set ... 1
                            setVarScalar(interp, "opt_tclobject_empty_string_compare", const3, compiledLocals, 12);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set is_any_optimized_op 1
                            setVarScalar(interp, "is_any_optimized_op", const3, compiledLocals, 17);
                        } // End Invoke: set
                        { // Invoke: set ... 1
                            setVarScalar(interp, "opt_tclobject_string_compare", const3, compiledLocals, 13);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Binary operator: () && $_compileproc(...)
            // Unary operator: ! $is_any_optimized_op
            TclObject tmp56 = getVarScalar(interp, "is_any_optimized_op", compiledLocals, 17);
            ExprValue tmp57 = evs0;
            if ( tmp56.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp57, tmp56);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp57, tmp56);
            }
            // End Unary operator: !
            if (tmp57.getBooleanValue(interp)) {
            TclObject tmp58 = getVarArray(interp, "_compileproc", "options,expr_inline_operators", compiledLocals, 5);
            ExprValue tmp59 = evs1;
            TJC.exprInitValue(interp, tmp59, tmp58);
            tmp57.setIntValue(tmp59.getBooleanValue(interp));
            } else {
            tmp57.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            if (tmp57.getBooleanValue(interp)) {
            // Binary operator: () || ()
            // Binary operator: $op == "eq"
            TclObject tmp60 = getVarScalar(interp, "op", compiledLocals, 0);
            boolean tmp61 = tmp60.toString().equals("eq");
            ExprValue tmp62 = evs1;
            tmp62.setIntValue(tmp61);
            // End Binary operator: ==
            if (!tmp62.getBooleanValue(interp)) {
            // Binary operator: $op == "ne"
            TclObject tmp63 = getVarScalar(interp, "op", compiledLocals, 0);
            boolean tmp64 = tmp63.toString().equals("ne");
            ExprValue tmp65 = evs2;
            tmp65.setIntValue(tmp64);
            // End Binary operator: ==
            tmp62.setIntValue(tmp65.getBooleanValue(interp));
            } else {
            tmp62.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            tmp57.setIntValue(tmp62.getBooleanValue(interp));
            } else {
            tmp57.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp66 = ( tmp57.getIntValue() != 0 );
            if ( tmp66 ) {
                { // Invoke: if ... ... elseif ... ... else ...
                    // Binary operator: () && ()
                    // Binary operator: $left_value_info_type == "TclObject"
                    TclObject tmp67 = getVarScalar(interp, "left_value_info_type", compiledLocals, 7);
                    boolean tmp68 = tmp67.toString().equals("TclObject");
                    ExprValue tmp69 = evs0;
                    tmp69.setIntValue(tmp68);
                    // End Binary operator: ==
                    if (tmp69.getBooleanValue(interp)) {
                    // Binary operator: $right_value_info_type == "TclObject"
                    TclObject tmp70 = getVarScalar(interp, "right_value_info_type", compiledLocals, 9);
                    boolean tmp71 = tmp70.toString().equals("TclObject");
                    ExprValue tmp72 = evs1;
                    tmp72.setIntValue(tmp71);
                    // End Binary operator: ==
                    tmp69.setIntValue(tmp72.getBooleanValue(interp));
                    } else {
                    tmp69.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp73 = ( tmp69.getIntValue() != 0 );
                    if ( tmp73 ) {
                        { // Invoke: set is_any_optimized_op 1
                            setVarScalar(interp, "is_any_optimized_op", const3, compiledLocals, 17);
                        } // End Invoke: set
                        { // Invoke: set ... 1
                            setVarScalar(interp, "opt_tclobject_to_tclobject_string_compare", const3, compiledLocals, 14);
                        } // End Invoke: set
                    } else {
                        // Binary operator: () || ()
                        // Binary operator: $left_value_info_type == "TclObject"
                        TclObject tmp74 = getVarScalar(interp, "left_value_info_type", compiledLocals, 7);
                        boolean tmp75 = tmp74.toString().equals("TclObject");
                        ExprValue tmp76 = evs0;
                        tmp76.setIntValue(tmp75);
                        // End Binary operator: ==
                        if (!tmp76.getBooleanValue(interp)) {
                        // Binary operator: $right_value_info_type == "TclObject"
                        TclObject tmp77 = getVarScalar(interp, "right_value_info_type", compiledLocals, 9);
                        boolean tmp78 = tmp77.toString().equals("TclObject");
                        ExprValue tmp79 = evs1;
                        tmp79.setIntValue(tmp78);
                        // End Binary operator: ==
                        tmp76.setIntValue(tmp79.getBooleanValue(interp));
                        } else {
                        tmp76.setIntValue(1);
                        } // End if: !()
                        // End Binary operator: ||
                        boolean tmp80 = ( tmp76.getIntValue() != 0 );
                        if ( tmp80 ) {
                            { // Invoke: set is_any_optimized_op 1
                                setVarScalar(interp, "is_any_optimized_op", const3, compiledLocals, 17);
                            } // End Invoke: set
                            { // Invoke: set ... 1
                                setVarScalar(interp, "opt_tclobject_to_exprvalue_string_compare", const3, compiledLocals, 15);
                            } // End Invoke: set
                            { // Invoke: set ... [...]
                                TclObject tmp81;
                                { // Invoke: expr ...
                                    // Binary operator: $left_value_info_type == "TclObject"
                                    TclObject tmp82 = getVarScalar(interp, "left_value_info_type", compiledLocals, 7);
                                    boolean tmp83 = tmp82.toString().equals("TclObject");
                                    ExprValue tmp84 = evs0;
                                    tmp84.setIntValue(tmp83);
                                    // End Binary operator: ==
                                    interp.setResult( tmp84.getIntValue() != 0 );
                                } // End Invoke: expr
                                tmp81 = interp.getResult();
                                setVarScalar(interp, "is_left_operand_tclobject", tmp81, compiledLocals, 16);
                            } // End Invoke: set
                        }
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            { // Invoke: info exists ...
                TclObject[] objv85 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv85[0] = const5;
                    // Arg 1 constant: exists
                    objv85[1] = const6;
                    // Arg 2 constant: ...
                    objv85[2] = const7;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv85, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv85, 3);
                }
            } // End Invoke: info
            TclObject tmp86 = interp.getResult();
            ExprValue tmp87 = evs0;
            TJC.exprInitValue(interp, tmp87, tmp86);
            boolean tmp88 = tmp87.getBooleanValue(interp);
            if ( tmp88 ) {
                { // Invoke: set ... 0
                    setVarScalar(interp, "opt_tclobject_string_compare", const2, compiledLocals, 13);
                } // End Invoke: set
                { // Invoke: set ... 0
                    setVarScalar(interp, "opt_tclobject_empty_string_compare", const2, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: set ... 0
                    setVarScalar(interp, "opt_tclobject_to_tclobject_string_compare", const2, compiledLocals, 14);
                } // End Invoke: set
                { // Invoke: set ... 0
                    setVarScalar(interp, "opt_tclobject_to_exprvalue_string_compare", const2, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: set is_any_optimized_op 0
                    setVarScalar(interp, "is_any_optimized_op", const2, compiledLocals, 17);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if ... ... elseif ... ... elseif ... ... elseif ... ... else ...
            TclObject tmp89 = getVarScalar(interp, "opt_tclobject_empty_string_compare", compiledLocals, 12);
            boolean tmp90 = TJC.getBoolean(interp, tmp89);
            if ( tmp90 ) {
                { // Invoke: if ... ... else ...
                    TclObject tmp91 = getVarScalar(interp, "is_left_operand_tclobject", compiledLocals, 16);
                    boolean tmp92 = TJC.getBoolean(interp, tmp91);
                    if ( tmp92 ) {
                        { // Invoke: set left_eval_tuple [...]
                            TclObject tmp93;
                            { // Invoke: ... $left_tuple {rtype TclObject}
                                TclObject[] objv94 = TJC.grabObjv(interp, 3);
                                TclObject tmp95;
                                try {
                                    // Arg 0 constant: ...
                                    objv94[0] = const8;
                                    // Arg 1 variable: $left_tuple
                                    tmp95 = getVarScalar(interp, "left_tuple", compiledLocals, 1);
                                    tmp95.preserve();
                                    objv94[1] = tmp95;
                                    // Arg 2 constant: {rtype TclObject}
                                    objv94[2] = const9;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv94, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp95 = objv94[1];
                                    if ( tmp95 != null ) {
                                        tmp95.release();
                                    }
                                    TJC.releaseObjv(interp, objv94, 3);
                                }
                            } // End Invoke: ...
                            tmp93 = interp.getResult();
                            setVarScalar(interp, "left_eval_tuple", tmp93, compiledLocals, 20);
                        } // End Invoke: set
                        { // Invoke: set tclobject_sym [...]
                            TclObject tmp96;
                            { // Invoke: lindex $left_eval_tuple 1
                                TclObject tmp97 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 20);
                                tmp97 = TclList.index(interp, tmp97, 1);
                                if ( tmp97 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp97);
                                }
                            } // End Invoke: lindex
                            tmp96 = interp.getResult();
                            setVarScalar(interp, "tclobject_sym", tmp96, compiledLocals, 21);
                        } // End Invoke: set
                        { // Invoke: append op_buffer [...]
                            TclObject[] objv98 = TJC.grabObjv(interp, 1);
                            TclObject tmp99;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $left_eval_tuple 2
                                    TclObject tmp100 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 20);
                                    tmp100 = TclList.index(interp, tmp100, 2);
                                    if ( tmp100 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp100);
                                    }
                                } // End Invoke: lindex
                                tmp99 = interp.getResult();
                                tmp99.preserve();
                                objv98[0] = tmp99;
                                interp.resetResult();
                                appendVarScalar(interp, "op_buffer", objv98, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv98, 1);
                            }
                        } // End Invoke: append
                    } else {
                        { // Invoke: set right_eval_tuple [...]
                            TclObject tmp101;
                            { // Invoke: ... $right_tuple {rtype TclObject}
                                TclObject[] objv102 = TJC.grabObjv(interp, 3);
                                TclObject tmp103;
                                try {
                                    // Arg 0 constant: ...
                                    objv102[0] = const8;
                                    // Arg 1 variable: $right_tuple
                                    tmp103 = getVarScalar(interp, "right_tuple", compiledLocals, 3);
                                    tmp103.preserve();
                                    objv102[1] = tmp103;
                                    // Arg 2 constant: {rtype TclObject}
                                    objv102[2] = const9;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv102, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp103 = objv102[1];
                                    if ( tmp103 != null ) {
                                        tmp103.release();
                                    }
                                    TJC.releaseObjv(interp, objv102, 3);
                                }
                            } // End Invoke: ...
                            tmp101 = interp.getResult();
                            setVarScalar(interp, "right_eval_tuple", tmp101, compiledLocals, 22);
                        } // End Invoke: set
                        { // Invoke: set tclobject_sym [...]
                            TclObject tmp104;
                            { // Invoke: lindex $right_eval_tuple 1
                                TclObject tmp105 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 22);
                                tmp105 = TclList.index(interp, tmp105, 1);
                                if ( tmp105 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp105);
                                }
                            } // End Invoke: lindex
                            tmp104 = interp.getResult();
                            setVarScalar(interp, "tclobject_sym", tmp104, compiledLocals, 21);
                        } // End Invoke: set
                        { // Invoke: append op_buffer [...]
                            TclObject[] objv106 = TJC.grabObjv(interp, 1);
                            TclObject tmp107;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $right_eval_tuple 2
                                    TclObject tmp108 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 22);
                                    tmp108 = TclList.index(interp, tmp108, 2);
                                    if ( tmp108 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp108);
                                    }
                                } // End Invoke: lindex
                                tmp107 = interp.getResult();
                                tmp107.preserve();
                                objv106[0] = tmp107;
                                interp.resetResult();
                                appendVarScalar(interp, "op_buffer", objv106, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv106, 1);
                            }
                        } // End Invoke: append
                    }
                } // End Invoke: if
                { // Invoke: set tmpsymbol [...]
                    TclObject tmp109;
                    { // Invoke: ...
                        TclObject[] objv110 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv110[0] = const10;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv110, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv110, 1);
                        }
                    } // End Invoke: ...
                    tmp109 = interp.getResult();
                    setVarScalar(interp, "tmpsymbol", tmp109, compiledLocals, 23);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: () || ()
                    // Binary operator: $op == "!="
                    TclObject tmp111 = getVarScalar(interp, "op", compiledLocals, 0);
                    boolean tmp112 = tmp111.toString().equals("!=");
                    ExprValue tmp113 = evs0;
                    tmp113.setIntValue(tmp112);
                    // End Binary operator: ==
                    if (!tmp113.getBooleanValue(interp)) {
                    // Binary operator: $op == "ne"
                    TclObject tmp114 = getVarScalar(interp, "op", compiledLocals, 0);
                    boolean tmp115 = tmp114.toString().equals("ne");
                    ExprValue tmp116 = evs1;
                    tmp116.setIntValue(tmp115);
                    // End Binary operator: ==
                    tmp113.setIntValue(tmp116.getBooleanValue(interp));
                    } else {
                    tmp113.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp117 = ( tmp113.getIntValue() != 0 );
                    if ( tmp117 ) {
                        { // Invoke: set negate true
                            setVarScalar(interp, "negate", const11, compiledLocals, 24);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set negate false
                            setVarScalar(interp, "negate", const12, compiledLocals, 24);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: append op_buffer [...] [...] ... $tmpsymbol ", " $tclobject_sym ", " $negate ")" ...
                    TclObject[] objv118 = TJC.grabObjv(interp, 10);
                    TclObject tmp119;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: ... $tmpsymbol "" ""
                            TclObject[] objv120 = TJC.grabObjv(interp, 4);
                            TclObject tmp121;
                            try {
                                // Arg 0 constant: ...
                                objv120[0] = const13;
                                // Arg 1 variable: $tmpsymbol
                                tmp121 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                                tmp121.preserve();
                                objv120[1] = tmp121;
                                // Arg 2 constant: ""
                                objv120[2] = const1;
                                // Arg 3 constant: ""
                                objv120[3] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv120, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp121 = objv120[1];
                                if ( tmp121 != null ) {
                                    tmp121.release();
                                }
                                TJC.releaseObjv(interp, objv120, 4);
                            }
                        } // End Invoke: ...
                        tmp119 = interp.getResult();
                        tmp119.preserve();
                        objv118[0] = tmp119;
                        // Arg 3 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv122 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv122[0] = const14;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                    ? cmdcache6.cmd : null), objv122, 0);
                                if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                    updateCmdCache(interp, 6);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv122, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp119 = interp.getResult();
                        tmp119.preserve();
                        objv118[1] = tmp119;
                        // Arg 4 constant: ...
                        objv118[2] = const15;
                        // Arg 5 variable: $tmpsymbol
                        tmp119 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                        tmp119.preserve();
                        objv118[3] = tmp119;
                        // Arg 6 constant: ", "
                        objv118[4] = const16;
                        // Arg 7 variable: $tclobject_sym
                        tmp119 = getVarScalar(interp, "tclobject_sym", compiledLocals, 21);
                        tmp119.preserve();
                        objv118[5] = tmp119;
                        // Arg 8 constant: ", "
                        objv118[6] = const16;
                        // Arg 9 variable: $negate
                        tmp119 = getVarScalar(interp, "negate", compiledLocals, 24);
                        tmp119.preserve();
                        objv118[7] = tmp119;
                        // Arg 10 constant: ")"
                        objv118[8] = const17;
                        // Arg 11 constant: ...
                        objv118[9] = const18;
                        interp.resetResult();
                        appendVarScalar(interp, "op_buffer", objv118, compiledLocals, 6);
                    } finally {
                        objv118[2] = null;
                        objv118[4] = null;
                        objv118[6] = null;
                        objv118[8] = null;
                        objv118[9] = null;
                        TJC.releaseObjvElems(interp, objv118, 10);
                    }
                } // End Invoke: append
                { // Invoke: set ev1 $tmpsymbol
                    TclObject tmp123;
                    tmp123 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                    setVarScalar(interp, "ev1", tmp123, compiledLocals, 25);
                } // End Invoke: set
            } else {
                TclObject tmp124 = getVarScalar(interp, "opt_tclobject_string_compare", compiledLocals, 13);
                boolean tmp125 = TJC.getBoolean(interp, tmp124);
                if ( tmp125 ) {
                    { // Invoke: set jstr "..."
                        TclObject tmp126;
                        StringBuffer sbtmp127 = new StringBuffer(64);
                        sbtmp127.append("\"");
                        tmp126 = getVarScalar(interp, "string_literal", compiledLocals, 19);
                        sbtmp127.append(tmp126.toString());
                        sbtmp127.append("\"");
                        tmp126 = TclString.newInstance(sbtmp127);
                        setVarScalar(interp, "jstr", tmp126, compiledLocals, 26);
                    } // End Invoke: set
                    { // Invoke: if ... ... else ...
                        TclObject tmp128 = getVarScalar(interp, "is_left_operand_tclobject", compiledLocals, 16);
                        boolean tmp129 = TJC.getBoolean(interp, tmp128);
                        if ( tmp129 ) {
                            { // Invoke: set left_eval_tuple [...]
                                TclObject tmp130;
                                { // Invoke: ... $left_tuple {rtype TclObject}
                                    TclObject[] objv131 = TJC.grabObjv(interp, 3);
                                    TclObject tmp132;
                                    try {
                                        // Arg 0 constant: ...
                                        objv131[0] = const8;
                                        // Arg 1 variable: $left_tuple
                                        tmp132 = getVarScalar(interp, "left_tuple", compiledLocals, 1);
                                        tmp132.preserve();
                                        objv131[1] = tmp132;
                                        // Arg 2 constant: {rtype TclObject}
                                        objv131[2] = const9;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv131, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp132 = objv131[1];
                                        if ( tmp132 != null ) {
                                            tmp132.release();
                                        }
                                        TJC.releaseObjv(interp, objv131, 3);
                                    }
                                } // End Invoke: ...
                                tmp130 = interp.getResult();
                                setVarScalar(interp, "left_eval_tuple", tmp130, compiledLocals, 20);
                            } // End Invoke: set
                            { // Invoke: set tclobject_sym [...]
                                TclObject tmp133;
                                { // Invoke: lindex $left_eval_tuple 1
                                    TclObject tmp134 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 20);
                                    tmp134 = TclList.index(interp, tmp134, 1);
                                    if ( tmp134 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp134);
                                    }
                                } // End Invoke: lindex
                                tmp133 = interp.getResult();
                                setVarScalar(interp, "tclobject_sym", tmp133, compiledLocals, 21);
                            } // End Invoke: set
                            { // Invoke: append op_buffer [...]
                                TclObject[] objv135 = TJC.grabObjv(interp, 1);
                                TclObject tmp136;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: lindex $left_eval_tuple 2
                                        TclObject tmp137 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 20);
                                        tmp137 = TclList.index(interp, tmp137, 2);
                                        if ( tmp137 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp137);
                                        }
                                    } // End Invoke: lindex
                                    tmp136 = interp.getResult();
                                    tmp136.preserve();
                                    objv135[0] = tmp136;
                                    interp.resetResult();
                                    appendVarScalar(interp, "op_buffer", objv135, compiledLocals, 6);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv135, 1);
                                }
                            } // End Invoke: append
                        } else {
                            { // Invoke: set right_eval_tuple [...]
                                TclObject tmp138;
                                { // Invoke: ... $right_tuple {rtype TclObject}
                                    TclObject[] objv139 = TJC.grabObjv(interp, 3);
                                    TclObject tmp140;
                                    try {
                                        // Arg 0 constant: ...
                                        objv139[0] = const8;
                                        // Arg 1 variable: $right_tuple
                                        tmp140 = getVarScalar(interp, "right_tuple", compiledLocals, 3);
                                        tmp140.preserve();
                                        objv139[1] = tmp140;
                                        // Arg 2 constant: {rtype TclObject}
                                        objv139[2] = const9;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                            ? cmdcache3.cmd : null), objv139, 0);
                                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                            updateCmdCache(interp, 3);
                                        }
                                    } finally {
                                        tmp140 = objv139[1];
                                        if ( tmp140 != null ) {
                                            tmp140.release();
                                        }
                                        TJC.releaseObjv(interp, objv139, 3);
                                    }
                                } // End Invoke: ...
                                tmp138 = interp.getResult();
                                setVarScalar(interp, "right_eval_tuple", tmp138, compiledLocals, 22);
                            } // End Invoke: set
                            { // Invoke: set tclobject_sym [...]
                                TclObject tmp141;
                                { // Invoke: lindex $right_eval_tuple 1
                                    TclObject tmp142 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 22);
                                    tmp142 = TclList.index(interp, tmp142, 1);
                                    if ( tmp142 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp142);
                                    }
                                } // End Invoke: lindex
                                tmp141 = interp.getResult();
                                setVarScalar(interp, "tclobject_sym", tmp141, compiledLocals, 21);
                            } // End Invoke: set
                            { // Invoke: append op_buffer [...]
                                TclObject[] objv143 = TJC.grabObjv(interp, 1);
                                TclObject tmp144;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: lindex $right_eval_tuple 2
                                        TclObject tmp145 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 22);
                                        tmp145 = TclList.index(interp, tmp145, 2);
                                        if ( tmp145 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp145);
                                        }
                                    } // End Invoke: lindex
                                    tmp144 = interp.getResult();
                                    tmp144.preserve();
                                    objv143[0] = tmp144;
                                    interp.resetResult();
                                    appendVarScalar(interp, "op_buffer", objv143, compiledLocals, 6);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv143, 1);
                                }
                            } // End Invoke: append
                        }
                    } // End Invoke: if
                    { // Invoke: set boolean_tmpsymbol [...]
                        TclObject tmp146;
                        { // Invoke: ...
                            TclObject[] objv147 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv147[0] = const10;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv147, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv147, 1);
                            }
                        } // End Invoke: ...
                        tmp146 = interp.getResult();
                        setVarScalar(interp, "boolean_tmpsymbol", tmp146, compiledLocals, 27);
                    } // End Invoke: set
                    { // Invoke: if ... ... else ...
                        // Binary operator: () || ()
                        // Binary operator: $op == "!="
                        TclObject tmp148 = getVarScalar(interp, "op", compiledLocals, 0);
                        boolean tmp149 = tmp148.toString().equals("!=");
                        ExprValue tmp150 = evs0;
                        tmp150.setIntValue(tmp149);
                        // End Binary operator: ==
                        if (!tmp150.getBooleanValue(interp)) {
                        // Binary operator: $op == "ne"
                        TclObject tmp151 = getVarScalar(interp, "op", compiledLocals, 0);
                        boolean tmp152 = tmp151.toString().equals("ne");
                        ExprValue tmp153 = evs1;
                        tmp153.setIntValue(tmp152);
                        // End Binary operator: ==
                        tmp150.setIntValue(tmp153.getBooleanValue(interp));
                        } else {
                        tmp150.setIntValue(1);
                        } // End if: !()
                        // End Binary operator: ||
                        boolean tmp154 = ( tmp150.getIntValue() != 0 );
                        if ( tmp154 ) {
                            { // Invoke: set not "! "
                                setVarScalar(interp, "not", const19, compiledLocals, 28);
                            } // End Invoke: set
                        } else {
                            { // Invoke: set not ""
                                setVarScalar(interp, "not", const1, compiledLocals, 28);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: append op_buffer [...] "boolean " $boolean_tmpsymbol " = " $not $tclobject_sym ... $jstr ...
                        TclObject[] objv155 = TJC.grabObjv(interp, 9);
                        TclObject tmp156;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv157 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv157[0] = const14;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                        ? cmdcache6.cmd : null), objv157, 0);
                                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                        updateCmdCache(interp, 6);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv157, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp156 = interp.getResult();
                            tmp156.preserve();
                            objv155[0] = tmp156;
                            // Arg 3 constant: "boolean "
                            objv155[1] = const20;
                            // Arg 4 variable: $boolean_tmpsymbol
                            tmp156 = getVarScalar(interp, "boolean_tmpsymbol", compiledLocals, 27);
                            tmp156.preserve();
                            objv155[2] = tmp156;
                            // Arg 5 constant: " = "
                            objv155[3] = const21;
                            // Arg 6 variable: $not
                            tmp156 = getVarScalar(interp, "not", compiledLocals, 28);
                            tmp156.preserve();
                            objv155[4] = tmp156;
                            // Arg 7 variable: $tclobject_sym
                            tmp156 = getVarScalar(interp, "tclobject_sym", compiledLocals, 21);
                            tmp156.preserve();
                            objv155[5] = tmp156;
                            // Arg 8 constant: ...
                            objv155[6] = const22;
                            // Arg 9 variable: $jstr
                            tmp156 = getVarScalar(interp, "jstr", compiledLocals, 26);
                            tmp156.preserve();
                            objv155[7] = tmp156;
                            // Arg 10 constant: ...
                            objv155[8] = const23;
                            interp.resetResult();
                            appendVarScalar(interp, "op_buffer", objv155, compiledLocals, 6);
                        } finally {
                            objv155[1] = null;
                            objv155[3] = null;
                            objv155[6] = null;
                            objv155[8] = null;
                            TJC.releaseObjvElems(interp, objv155, 9);
                        }
                    } // End Invoke: append
                    { // Invoke: set tmpsymbol [...]
                        TclObject tmp158;
                        { // Invoke: ...
                            TclObject[] objv159 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: ...
                                objv159[0] = const10;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                    ? cmdcache4.cmd : null), objv159, 0);
                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                    updateCmdCache(interp, 4);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv159, 1);
                            }
                        } // End Invoke: ...
                        tmp158 = interp.getResult();
                        setVarScalar(interp, "tmpsymbol", tmp158, compiledLocals, 23);
                    } // End Invoke: set
                    { // Invoke: append op_buffer [...]
                        TclObject[] objv160 = TJC.grabObjv(interp, 1);
                        TclObject tmp161;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: ... $tmpsymbol boolean $boolean_tmpsymbol
                                TclObject[] objv162 = TJC.grabObjv(interp, 4);
                                TclObject tmp163;
                                try {
                                    // Arg 0 constant: ...
                                    objv162[0] = const13;
                                    // Arg 1 variable: $tmpsymbol
                                    tmp163 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                                    tmp163.preserve();
                                    objv162[1] = tmp163;
                                    // Arg 2 constant: boolean
                                    objv162[2] = const24;
                                    // Arg 3 variable: $boolean_tmpsymbol
                                    tmp163 = getVarScalar(interp, "boolean_tmpsymbol", compiledLocals, 27);
                                    tmp163.preserve();
                                    objv162[3] = tmp163;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv162, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp163 = objv162[1];
                                    if ( tmp163 != null ) {
                                        tmp163.release();
                                    }
                                    tmp163 = objv162[3];
                                    if ( tmp163 != null ) {
                                        tmp163.release();
                                    }
                                    TJC.releaseObjv(interp, objv162, 4);
                                }
                            } // End Invoke: ...
                            tmp161 = interp.getResult();
                            tmp161.preserve();
                            objv160[0] = tmp161;
                            interp.resetResult();
                            appendVarScalar(interp, "op_buffer", objv160, compiledLocals, 6);
                        } finally {
                            TJC.releaseObjvElems(interp, objv160, 1);
                        }
                    } // End Invoke: append
                    { // Invoke: set ev1 $tmpsymbol
                        TclObject tmp164;
                        tmp164 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                        setVarScalar(interp, "ev1", tmp164, compiledLocals, 25);
                    } // End Invoke: set
                } else {
                    TclObject tmp165 = getVarScalar(interp, "opt_tclobject_to_tclobject_string_compare", compiledLocals, 14);
                    boolean tmp166 = TJC.getBoolean(interp, tmp165);
                    if ( tmp166 ) {
                        { // Invoke: set left_eval_tuple [...]
                            TclObject tmp167;
                            { // Invoke: ... $left_tuple {rtype TclObject}
                                TclObject[] objv168 = TJC.grabObjv(interp, 3);
                                TclObject tmp169;
                                try {
                                    // Arg 0 constant: ...
                                    objv168[0] = const8;
                                    // Arg 1 variable: $left_tuple
                                    tmp169 = getVarScalar(interp, "left_tuple", compiledLocals, 1);
                                    tmp169.preserve();
                                    objv168[1] = tmp169;
                                    // Arg 2 constant: {rtype TclObject}
                                    objv168[2] = const9;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv168, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp169 = objv168[1];
                                    if ( tmp169 != null ) {
                                        tmp169.release();
                                    }
                                    TJC.releaseObjv(interp, objv168, 3);
                                }
                            } // End Invoke: ...
                            tmp167 = interp.getResult();
                            setVarScalar(interp, "left_eval_tuple", tmp167, compiledLocals, 20);
                        } // End Invoke: set
                        { // Invoke: set left_tclobject_sym [...]
                            TclObject tmp170;
                            { // Invoke: lindex $left_eval_tuple 1
                                TclObject tmp171 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 20);
                                tmp171 = TclList.index(interp, tmp171, 1);
                                if ( tmp171 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp171);
                                }
                            } // End Invoke: lindex
                            tmp170 = interp.getResult();
                            setVarScalar(interp, "left_tclobject_sym", tmp170, compiledLocals, 29);
                        } // End Invoke: set
                        { // Invoke: append op_buffer [...]
                            TclObject[] objv172 = TJC.grabObjv(interp, 1);
                            TclObject tmp173;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $left_eval_tuple 2
                                    TclObject tmp174 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 20);
                                    tmp174 = TclList.index(interp, tmp174, 2);
                                    if ( tmp174 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp174);
                                    }
                                } // End Invoke: lindex
                                tmp173 = interp.getResult();
                                tmp173.preserve();
                                objv172[0] = tmp173;
                                interp.resetResult();
                                appendVarScalar(interp, "op_buffer", objv172, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv172, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set left_str_sym [...]
                            TclObject tmp175;
                            { // Invoke: ...
                                TclObject[] objv176 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv176[0] = const10;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv176, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv176, 1);
                                }
                            } // End Invoke: ...
                            tmp175 = interp.getResult();
                            setVarScalar(interp, "left_str_sym", tmp175, compiledLocals, 30);
                        } // End Invoke: set
                        { // Invoke: append op_buffer [...]
                            TclObject[] objv177 = TJC.grabObjv(interp, 1);
                            TclObject tmp178;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv179 = TJC.grabObjv(interp, 2);
                                    TclObject tmp180;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv179[0] = const25;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp181 = new StringBuffer(64);
                                        sbtmp181.append("String ");
                                        tmp180 = getVarScalar(interp, "left_str_sym", compiledLocals, 30);
                                        sbtmp181.append(tmp180.toString());
                                        sbtmp181.append(" = ");
                                        tmp180 = getVarScalar(interp, "left_tclobject_sym", compiledLocals, 29);
                                        sbtmp181.append(tmp180.toString());
                                        sbtmp181.append(".toString()");
                                        tmp180 = TclString.newInstance(sbtmp181);
                                        tmp180.preserve();
                                        objv179[1] = tmp180;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv179, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        tmp180 = objv179[1];
                                        if ( tmp180 != null ) {
                                            tmp180.release();
                                        }
                                        TJC.releaseObjv(interp, objv179, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp178 = interp.getResult();
                                tmp178.preserve();
                                objv177[0] = tmp178;
                                interp.resetResult();
                                appendVarScalar(interp, "op_buffer", objv177, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv177, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set right_eval_tuple [...]
                            TclObject tmp182;
                            { // Invoke: ... $right_tuple {rtype TclObject}
                                TclObject[] objv183 = TJC.grabObjv(interp, 3);
                                TclObject tmp184;
                                try {
                                    // Arg 0 constant: ...
                                    objv183[0] = const8;
                                    // Arg 1 variable: $right_tuple
                                    tmp184 = getVarScalar(interp, "right_tuple", compiledLocals, 3);
                                    tmp184.preserve();
                                    objv183[1] = tmp184;
                                    // Arg 2 constant: {rtype TclObject}
                                    objv183[2] = const9;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv183, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp184 = objv183[1];
                                    if ( tmp184 != null ) {
                                        tmp184.release();
                                    }
                                    TJC.releaseObjv(interp, objv183, 3);
                                }
                            } // End Invoke: ...
                            tmp182 = interp.getResult();
                            setVarScalar(interp, "right_eval_tuple", tmp182, compiledLocals, 22);
                        } // End Invoke: set
                        { // Invoke: set right_tclobject_sym [...]
                            TclObject tmp185;
                            { // Invoke: lindex $right_eval_tuple 1
                                TclObject tmp186 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 22);
                                tmp186 = TclList.index(interp, tmp186, 1);
                                if ( tmp186 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp186);
                                }
                            } // End Invoke: lindex
                            tmp185 = interp.getResult();
                            setVarScalar(interp, "right_tclobject_sym", tmp185, compiledLocals, 31);
                        } // End Invoke: set
                        { // Invoke: append op_buffer [...]
                            TclObject[] objv187 = TJC.grabObjv(interp, 1);
                            TclObject tmp188;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $right_eval_tuple 2
                                    TclObject tmp189 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 22);
                                    tmp189 = TclList.index(interp, tmp189, 2);
                                    if ( tmp189 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp189);
                                    }
                                } // End Invoke: lindex
                                tmp188 = interp.getResult();
                                tmp188.preserve();
                                objv187[0] = tmp188;
                                interp.resetResult();
                                appendVarScalar(interp, "op_buffer", objv187, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv187, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set right_str_sym [...]
                            TclObject tmp190;
                            { // Invoke: ...
                                TclObject[] objv191 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv191[0] = const10;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv191, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv191, 1);
                                }
                            } // End Invoke: ...
                            tmp190 = interp.getResult();
                            setVarScalar(interp, "right_str_sym", tmp190, compiledLocals, 32);
                        } // End Invoke: set
                        { // Invoke: append op_buffer [...]
                            TclObject[] objv192 = TJC.grabObjv(interp, 1);
                            TclObject tmp193;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_statement "..."
                                    TclObject[] objv194 = TJC.grabObjv(interp, 2);
                                    TclObject tmp195;
                                    try {
                                        // Arg 0 constant: emitter_statement
                                        objv194[0] = const25;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp196 = new StringBuffer(64);
                                        sbtmp196.append("String ");
                                        tmp195 = getVarScalar(interp, "right_str_sym", compiledLocals, 32);
                                        sbtmp196.append(tmp195.toString());
                                        sbtmp196.append(" = ");
                                        tmp195 = getVarScalar(interp, "right_tclobject_sym", compiledLocals, 31);
                                        sbtmp196.append(tmp195.toString());
                                        sbtmp196.append(".toString()");
                                        tmp195 = TclString.newInstance(sbtmp196);
                                        tmp195.preserve();
                                        objv194[1] = tmp195;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                            ? cmdcache7.cmd : null), objv194, 0);
                                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                            updateCmdCache(interp, 7);
                                        }
                                    } finally {
                                        tmp195 = objv194[1];
                                        if ( tmp195 != null ) {
                                            tmp195.release();
                                        }
                                        TJC.releaseObjv(interp, objv194, 2);
                                    }
                                } // End Invoke: emitter_statement
                                tmp193 = interp.getResult();
                                tmp193.preserve();
                                objv192[0] = tmp193;
                                interp.resetResult();
                                appendVarScalar(interp, "op_buffer", objv192, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv192, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set boolean_tmpsymbol [...]
                            TclObject tmp197;
                            { // Invoke: ...
                                TclObject[] objv198 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv198[0] = const10;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv198, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv198, 1);
                                }
                            } // End Invoke: ...
                            tmp197 = interp.getResult();
                            setVarScalar(interp, "boolean_tmpsymbol", tmp197, compiledLocals, 27);
                        } // End Invoke: set
                        { // Invoke: if {$op == "ne"} ... else ...
                            // Binary operator: $op == "ne"
                            TclObject tmp199 = getVarScalar(interp, "op", compiledLocals, 0);
                            boolean tmp200 = tmp199.toString().equals("ne");
                            ExprValue tmp201 = evs0;
                            tmp201.setIntValue(tmp200);
                            // End Binary operator: ==
                            boolean tmp202 = ( tmp201.getIntValue() != 0 );
                            if ( tmp202 ) {
                                { // Invoke: set not "! "
                                    setVarScalar(interp, "not", const19, compiledLocals, 28);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set not ""
                                    setVarScalar(interp, "not", const1, compiledLocals, 28);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                        { // Invoke: append op_buffer [...] "boolean " $boolean_tmpsymbol " = " $not $left_str_sym ".equals(" $right_str_sym ...
                            TclObject[] objv203 = TJC.grabObjv(interp, 9);
                            TclObject tmp204;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: emitter_indent
                                    TclObject[] objv205 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: emitter_indent
                                        objv205[0] = const14;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                            ? cmdcache6.cmd : null), objv205, 0);
                                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                            updateCmdCache(interp, 6);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv205, 1);
                                    }
                                } // End Invoke: emitter_indent
                                tmp204 = interp.getResult();
                                tmp204.preserve();
                                objv203[0] = tmp204;
                                // Arg 3 constant: "boolean "
                                objv203[1] = const20;
                                // Arg 4 variable: $boolean_tmpsymbol
                                tmp204 = getVarScalar(interp, "boolean_tmpsymbol", compiledLocals, 27);
                                tmp204.preserve();
                                objv203[2] = tmp204;
                                // Arg 5 constant: " = "
                                objv203[3] = const21;
                                // Arg 6 variable: $not
                                tmp204 = getVarScalar(interp, "not", compiledLocals, 28);
                                tmp204.preserve();
                                objv203[4] = tmp204;
                                // Arg 7 variable: $left_str_sym
                                tmp204 = getVarScalar(interp, "left_str_sym", compiledLocals, 30);
                                tmp204.preserve();
                                objv203[5] = tmp204;
                                // Arg 8 constant: ".equals("
                                objv203[6] = const26;
                                // Arg 9 variable: $right_str_sym
                                tmp204 = getVarScalar(interp, "right_str_sym", compiledLocals, 32);
                                tmp204.preserve();
                                objv203[7] = tmp204;
                                // Arg 10 constant: ...
                                objv203[8] = const23;
                                interp.resetResult();
                                appendVarScalar(interp, "op_buffer", objv203, compiledLocals, 6);
                            } finally {
                                objv203[1] = null;
                                objv203[3] = null;
                                objv203[6] = null;
                                objv203[8] = null;
                                TJC.releaseObjvElems(interp, objv203, 9);
                            }
                        } // End Invoke: append
                        { // Invoke: set tmpsymbol [...]
                            TclObject tmp206;
                            { // Invoke: ...
                                TclObject[] objv207 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: ...
                                    objv207[0] = const10;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv207, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv207, 1);
                                }
                            } // End Invoke: ...
                            tmp206 = interp.getResult();
                            setVarScalar(interp, "tmpsymbol", tmp206, compiledLocals, 23);
                        } // End Invoke: set
                        { // Invoke: append op_buffer [...]
                            TclObject[] objv208 = TJC.grabObjv(interp, 1);
                            TclObject tmp209;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: ... $tmpsymbol boolean $boolean_tmpsymbol
                                    TclObject[] objv210 = TJC.grabObjv(interp, 4);
                                    TclObject tmp211;
                                    try {
                                        // Arg 0 constant: ...
                                        objv210[0] = const13;
                                        // Arg 1 variable: $tmpsymbol
                                        tmp211 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                                        tmp211.preserve();
                                        objv210[1] = tmp211;
                                        // Arg 2 constant: boolean
                                        objv210[2] = const24;
                                        // Arg 3 variable: $boolean_tmpsymbol
                                        tmp211 = getVarScalar(interp, "boolean_tmpsymbol", compiledLocals, 27);
                                        tmp211.preserve();
                                        objv210[3] = tmp211;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv210, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp211 = objv210[1];
                                        if ( tmp211 != null ) {
                                            tmp211.release();
                                        }
                                        tmp211 = objv210[3];
                                        if ( tmp211 != null ) {
                                            tmp211.release();
                                        }
                                        TJC.releaseObjv(interp, objv210, 4);
                                    }
                                } // End Invoke: ...
                                tmp209 = interp.getResult();
                                tmp209.preserve();
                                objv208[0] = tmp209;
                                interp.resetResult();
                                appendVarScalar(interp, "op_buffer", objv208, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv208, 1);
                            }
                        } // End Invoke: append
                        { // Invoke: set ev1 $tmpsymbol
                            TclObject tmp212;
                            tmp212 = getVarScalar(interp, "tmpsymbol", compiledLocals, 23);
                            setVarScalar(interp, "ev1", tmp212, compiledLocals, 25);
                        } // End Invoke: set
                    } else {
                        TclObject tmp213 = getVarScalar(interp, "opt_tclobject_to_exprvalue_string_compare", compiledLocals, 15);
                        boolean tmp214 = TJC.getBoolean(interp, tmp213);
                        if ( tmp214 ) {
                            { // Invoke: if ... ... else ...
                                TclObject tmp215 = getVarScalar(interp, "is_left_operand_tclobject", compiledLocals, 16);
                                boolean tmp216 = TJC.getBoolean(interp, tmp215);
                                if ( tmp216 ) {
                                    { // Invoke: set left_eval_tuple [...]
                                        TclObject tmp217;
                                        { // Invoke: ... $left_tuple {rtype TclObject}
                                            TclObject[] objv218 = TJC.grabObjv(interp, 3);
                                            TclObject tmp219;
                                            try {
                                                // Arg 0 constant: ...
                                                objv218[0] = const8;
                                                // Arg 1 variable: $left_tuple
                                                tmp219 = getVarScalar(interp, "left_tuple", compiledLocals, 1);
                                                tmp219.preserve();
                                                objv218[1] = tmp219;
                                                // Arg 2 constant: {rtype TclObject}
                                                objv218[2] = const9;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                    ? cmdcache3.cmd : null), objv218, 0);
                                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                    updateCmdCache(interp, 3);
                                                }
                                            } finally {
                                                tmp219 = objv218[1];
                                                if ( tmp219 != null ) {
                                                    tmp219.release();
                                                }
                                                TJC.releaseObjv(interp, objv218, 3);
                                            }
                                        } // End Invoke: ...
                                        tmp217 = interp.getResult();
                                        setVarScalar(interp, "left_eval_tuple", tmp217, compiledLocals, 20);
                                    } // End Invoke: set
                                    { // Invoke: set left_tclobject_sym [...]
                                        TclObject tmp220;
                                        { // Invoke: lindex $left_eval_tuple 1
                                            TclObject tmp221 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 20);
                                            tmp221 = TclList.index(interp, tmp221, 1);
                                            if ( tmp221 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp221);
                                            }
                                        } // End Invoke: lindex
                                        tmp220 = interp.getResult();
                                        setVarScalar(interp, "left_tclobject_sym", tmp220, compiledLocals, 29);
                                    } // End Invoke: set
                                    { // Invoke: append op_buffer [...]
                                        TclObject[] objv222 = TJC.grabObjv(interp, 1);
                                        TclObject tmp223;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: lindex $left_eval_tuple 2
                                                TclObject tmp224 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 20);
                                                tmp224 = TclList.index(interp, tmp224, 2);
                                                if ( tmp224 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp224);
                                                }
                                            } // End Invoke: lindex
                                            tmp223 = interp.getResult();
                                            tmp223.preserve();
                                            objv222[0] = tmp223;
                                            interp.resetResult();
                                            appendVarScalar(interp, "op_buffer", objv222, compiledLocals, 6);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv222, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: set left_str_sym [...]
                                        TclObject tmp225;
                                        { // Invoke: ...
                                            TclObject[] objv226 = TJC.grabObjv(interp, 1);
                                            try {
                                                // Arg 0 constant: ...
                                                objv226[0] = const10;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv226, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                TJC.releaseObjv(interp, objv226, 1);
                                            }
                                        } // End Invoke: ...
                                        tmp225 = interp.getResult();
                                        setVarScalar(interp, "left_str_sym", tmp225, compiledLocals, 30);
                                    } // End Invoke: set
                                    { // Invoke: append op_buffer [...]
                                        TclObject[] objv227 = TJC.grabObjv(interp, 1);
                                        TclObject tmp228;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: emitter_statement "..."
                                                TclObject[] objv229 = TJC.grabObjv(interp, 2);
                                                TclObject tmp230;
                                                try {
                                                    // Arg 0 constant: emitter_statement
                                                    objv229[0] = const25;
                                                    // Arg 1 word: "..."
                                                    StringBuffer sbtmp231 = new StringBuffer(64);
                                                    sbtmp231.append("String ");
                                                    tmp230 = getVarScalar(interp, "left_str_sym", compiledLocals, 30);
                                                    sbtmp231.append(tmp230.toString());
                                                    sbtmp231.append(" = ");
                                                    tmp230 = getVarScalar(interp, "left_tclobject_sym", compiledLocals, 29);
                                                    sbtmp231.append(tmp230.toString());
                                                    sbtmp231.append(".toString()");
                                                    tmp230 = TclString.newInstance(sbtmp231);
                                                    tmp230.preserve();
                                                    objv229[1] = tmp230;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                                                        ? cmdcache7.cmd : null), objv229, 0);
                                                    if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                                                        updateCmdCache(interp, 7);
                                                    }
                                                } finally {
                                                    tmp230 = objv229[1];
                                                    if ( tmp230 != null ) {
                                                        tmp230.release();
                                                    }
                                                    TJC.releaseObjv(interp, objv229, 2);
                                                }
                                            } // End Invoke: emitter_statement
                                            tmp228 = interp.getResult();
                                            tmp228.preserve();
                                            objv227[0] = tmp228;
                                            interp.resetResult();
                                            appendVarScalar(interp, "op_buffer", objv227, compiledLocals, 6);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv227, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: set right_eval_tuple [...]
                                        TclObject tmp232;
                                        { // Invoke: ... $right_tuple
                                            TclObject[] objv233 = TJC.grabObjv(interp, 2);
                                            TclObject tmp234;
                                            try {
                                                // Arg 0 constant: ...
                                                objv233[0] = const8;
                                                // Arg 1 variable: $right_tuple
                                                tmp234 = getVarScalar(interp, "right_tuple", compiledLocals, 3);
                                                tmp234.preserve();
                                                objv233[1] = tmp234;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                    ? cmdcache3.cmd : null), objv233, 0);
                                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                    updateCmdCache(interp, 3);
                                                }
                                            } finally {
                                                tmp234 = objv233[1];
                                                if ( tmp234 != null ) {
                                                    tmp234.release();
                                                }
                                                TJC.releaseObjv(interp, objv233, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp232 = interp.getResult();
                                        setVarScalar(interp, "right_eval_tuple", tmp232, compiledLocals, 22);
                                    } // End Invoke: set
                                    { // Invoke: set ev2 [...]
                                        TclObject tmp235;
                                        { // Invoke: lindex $right_eval_tuple 1
                                            TclObject tmp236 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 22);
                                            tmp236 = TclList.index(interp, tmp236, 1);
                                            if ( tmp236 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp236);
                                            }
                                        } // End Invoke: lindex
                                        tmp235 = interp.getResult();
                                        setVarScalar(interp, "ev2", tmp235, compiledLocals, 33);
                                    } // End Invoke: set
                                    { // Invoke: append op_buffer [...]
                                        TclObject[] objv237 = TJC.grabObjv(interp, 1);
                                        TclObject tmp238;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: lindex $right_eval_tuple 2
                                                TclObject tmp239 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 22);
                                                tmp239 = TclList.index(interp, tmp239, 2);
                                                if ( tmp239 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp239);
                                                }
                                            } // End Invoke: lindex
                                            tmp238 = interp.getResult();
                                            tmp238.preserve();
                                            objv237[0] = tmp238;
                                            interp.resetResult();
                                            appendVarScalar(interp, "op_buffer", objv237, compiledLocals, 6);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv237, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: set right_str_sym "..."
                                        TclObject tmp240;
                                        StringBuffer sbtmp241 = new StringBuffer(64);
                                        tmp240 = getVarScalar(interp, "ev2", compiledLocals, 33);
                                        sbtmp241.append(tmp240.toString());
                                        sbtmp241.append(".getStringValue()");
                                        tmp240 = TclString.newInstance(sbtmp241);
                                        setVarScalar(interp, "right_str_sym", tmp240, compiledLocals, 32);
                                    } // End Invoke: set
                                    { // Invoke: set ev $ev2
                                        TclObject tmp242;
                                        tmp242 = getVarScalar(interp, "ev2", compiledLocals, 33);
                                        setVarScalar(interp, "ev", tmp242, compiledLocals, 34);
                                    } // End Invoke: set
                                } else {
                                    { // Invoke: set left_eval_tuple [...]
                                        TclObject tmp243;
                                        { // Invoke: ... $left_tuple
                                            TclObject[] objv244 = TJC.grabObjv(interp, 2);
                                            TclObject tmp245;
                                            try {
                                                // Arg 0 constant: ...
                                                objv244[0] = const8;
                                                // Arg 1 variable: $left_tuple
                                                tmp245 = getVarScalar(interp, "left_tuple", compiledLocals, 1);
                                                tmp245.preserve();
                                                objv244[1] = tmp245;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                    ? cmdcache3.cmd : null), objv244, 0);
                                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                    updateCmdCache(interp, 3);
                                                }
                                            } finally {
                                                tmp245 = objv244[1];
                                                if ( tmp245 != null ) {
                                                    tmp245.release();
                                                }
                                                TJC.releaseObjv(interp, objv244, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp243 = interp.getResult();
                                        setVarScalar(interp, "left_eval_tuple", tmp243, compiledLocals, 20);
                                    } // End Invoke: set
                                    { // Invoke: set ev1 [...]
                                        TclObject tmp246;
                                        { // Invoke: lindex $left_eval_tuple 1
                                            TclObject tmp247 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 20);
                                            tmp247 = TclList.index(interp, tmp247, 1);
                                            if ( tmp247 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp247);
                                            }
                                        } // End Invoke: lindex
                                        tmp246 = interp.getResult();
                                        setVarScalar(interp, "ev1", tmp246, compiledLocals, 25);
                                    } // End Invoke: set
                                    { // Invoke: append op_buffer [...]
                                        TclObject[] objv248 = TJC.grabObjv(interp, 1);
                                        TclObject tmp249;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: lindex $left_eval_tuple 2
                                                TclObject tmp250 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 20);
                                                tmp250 = TclList.index(interp, tmp250, 2);
                                                if ( tmp250 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp250);
                                                }
                                            } // End Invoke: lindex
                                            tmp249 = interp.getResult();
                                            tmp249.preserve();
                                            objv248[0] = tmp249;
                                            interp.resetResult();
                                            appendVarScalar(interp, "op_buffer", objv248, compiledLocals, 6);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv248, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: set right_eval_tuple [...]
                                        TclObject tmp251;
                                        { // Invoke: ... $right_tuple {rtype TclObject}
                                            TclObject[] objv252 = TJC.grabObjv(interp, 3);
                                            TclObject tmp253;
                                            try {
                                                // Arg 0 constant: ...
                                                objv252[0] = const8;
                                                // Arg 1 variable: $right_tuple
                                                tmp253 = getVarScalar(interp, "right_tuple", compiledLocals, 3);
                                                tmp253.preserve();
                                                objv252[1] = tmp253;
                                                // Arg 2 constant: {rtype TclObject}
                                                objv252[2] = const9;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                    ? cmdcache3.cmd : null), objv252, 0);
                                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                    updateCmdCache(interp, 3);
                                                }
                                            } finally {
                                                tmp253 = objv252[1];
                                                if ( tmp253 != null ) {
                                                    tmp253.release();
                                                }
                                                TJC.releaseObjv(interp, objv252, 3);
                                            }
                                        } // End Invoke: ...
                                        tmp251 = interp.getResult();
                                        setVarScalar(interp, "right_eval_tuple", tmp251, compiledLocals, 22);
                                    } // End Invoke: set
                                    { // Invoke: set right_tclobject_sym [...]
                                        TclObject tmp254;
                                        { // Invoke: lindex $right_eval_tuple 1
                                            TclObject tmp255 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 22);
                                            tmp255 = TclList.index(interp, tmp255, 1);
                                            if ( tmp255 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp255);
                                            }
                                        } // End Invoke: lindex
                                        tmp254 = interp.getResult();
                                        setVarScalar(interp, "right_tclobject_sym", tmp254, compiledLocals, 31);
                                    } // End Invoke: set
                                    { // Invoke: append op_buffer [...]
                                        TclObject[] objv256 = TJC.grabObjv(interp, 1);
                                        TclObject tmp257;
                                        try {
                                            // Arg 2 command: [...]
                                            { // Invoke: lindex $right_eval_tuple 2
                                                TclObject tmp258 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 22);
                                                tmp258 = TclList.index(interp, tmp258, 2);
                                                if ( tmp258 == null ) {
                                                    interp.resetResult();
                                                } else {
                                                    interp.setResult(tmp258);
                                                }
                                            } // End Invoke: lindex
                                            tmp257 = interp.getResult();
                                            tmp257.preserve();
                                            objv256[0] = tmp257;
                                            interp.resetResult();
                                            appendVarScalar(interp, "op_buffer", objv256, compiledLocals, 6);
                                        } finally {
                                            TJC.releaseObjvElems(interp, objv256, 1);
                                        }
                                    } // End Invoke: append
                                    { // Invoke: set left_str_sym "..."
                                        TclObject tmp259;
                                        StringBuffer sbtmp260 = new StringBuffer(64);
                                        tmp259 = getVarScalar(interp, "ev1", compiledLocals, 25);
                                        sbtmp260.append(tmp259.toString());
                                        sbtmp260.append(".getStringValue()");
                                        tmp259 = TclString.newInstance(sbtmp260);
                                        setVarScalar(interp, "left_str_sym", tmp259, compiledLocals, 30);
                                    } // End Invoke: set
                                    { // Invoke: set right_str_sym "..."
                                        TclObject tmp261;
                                        StringBuffer sbtmp262 = new StringBuffer(64);
                                        tmp261 = getVarScalar(interp, "right_tclobject_sym", compiledLocals, 31);
                                        sbtmp262.append(tmp261.toString());
                                        sbtmp262.append(".toString()");
                                        tmp261 = TclString.newInstance(sbtmp262);
                                        setVarScalar(interp, "right_str_sym", tmp261, compiledLocals, 32);
                                    } // End Invoke: set
                                    { // Invoke: set ev $ev1
                                        TclObject tmp263;
                                        tmp263 = getVarScalar(interp, "ev1", compiledLocals, 25);
                                        setVarScalar(interp, "ev", tmp263, compiledLocals, 34);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            { // Invoke: set boolean_tmpsymbol [...]
                                TclObject tmp264;
                                { // Invoke: ...
                                    TclObject[] objv265 = TJC.grabObjv(interp, 1);
                                    try {
                                        // Arg 0 constant: ...
                                        objv265[0] = const10;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv265, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        TJC.releaseObjv(interp, objv265, 1);
                                    }
                                } // End Invoke: ...
                                tmp264 = interp.getResult();
                                setVarScalar(interp, "boolean_tmpsymbol", tmp264, compiledLocals, 27);
                            } // End Invoke: set
                            { // Invoke: if {$op == "ne"} ... else ...
                                // Binary operator: $op == "ne"
                                TclObject tmp266 = getVarScalar(interp, "op", compiledLocals, 0);
                                boolean tmp267 = tmp266.toString().equals("ne");
                                ExprValue tmp268 = evs0;
                                tmp268.setIntValue(tmp267);
                                // End Binary operator: ==
                                boolean tmp269 = ( tmp268.getIntValue() != 0 );
                                if ( tmp269 ) {
                                    { // Invoke: set not "! "
                                        setVarScalar(interp, "not", const19, compiledLocals, 28);
                                    } // End Invoke: set
                                } else {
                                    { // Invoke: set not ""
                                        setVarScalar(interp, "not", const1, compiledLocals, 28);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            { // Invoke: append op_buffer [...] "boolean " $boolean_tmpsymbol " = " $not $left_str_sym ".equals(" $right_str_sym ...
                                TclObject[] objv270 = TJC.grabObjv(interp, 9);
                                TclObject tmp271;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv272 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv272[0] = const14;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                ? cmdcache6.cmd : null), objv272, 0);
                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                updateCmdCache(interp, 6);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv272, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp271 = interp.getResult();
                                    tmp271.preserve();
                                    objv270[0] = tmp271;
                                    // Arg 3 constant: "boolean "
                                    objv270[1] = const20;
                                    // Arg 4 variable: $boolean_tmpsymbol
                                    tmp271 = getVarScalar(interp, "boolean_tmpsymbol", compiledLocals, 27);
                                    tmp271.preserve();
                                    objv270[2] = tmp271;
                                    // Arg 5 constant: " = "
                                    objv270[3] = const21;
                                    // Arg 6 variable: $not
                                    tmp271 = getVarScalar(interp, "not", compiledLocals, 28);
                                    tmp271.preserve();
                                    objv270[4] = tmp271;
                                    // Arg 7 variable: $left_str_sym
                                    tmp271 = getVarScalar(interp, "left_str_sym", compiledLocals, 30);
                                    tmp271.preserve();
                                    objv270[5] = tmp271;
                                    // Arg 8 constant: ".equals("
                                    objv270[6] = const26;
                                    // Arg 9 variable: $right_str_sym
                                    tmp271 = getVarScalar(interp, "right_str_sym", compiledLocals, 32);
                                    tmp271.preserve();
                                    objv270[7] = tmp271;
                                    // Arg 10 constant: ...
                                    objv270[8] = const23;
                                    interp.resetResult();
                                    appendVarScalar(interp, "op_buffer", objv270, compiledLocals, 6);
                                } finally {
                                    objv270[1] = null;
                                    objv270[3] = null;
                                    objv270[6] = null;
                                    objv270[8] = null;
                                    TJC.releaseObjvElems(interp, objv270, 9);
                                }
                            } // End Invoke: append
                            { // Invoke: append op_buffer [...] $ev ".setIntValue(" $boolean_tmpsymbol ...
                                TclObject[] objv273 = TJC.grabObjv(interp, 5);
                                TclObject tmp274;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv275 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv275[0] = const14;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                                ? cmdcache6.cmd : null), objv275, 0);
                                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                                updateCmdCache(interp, 6);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv275, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp274 = interp.getResult();
                                    tmp274.preserve();
                                    objv273[0] = tmp274;
                                    // Arg 3 variable: $ev
                                    tmp274 = getVarScalar(interp, "ev", compiledLocals, 34);
                                    tmp274.preserve();
                                    objv273[1] = tmp274;
                                    // Arg 4 constant: ".setIntValue("
                                    objv273[2] = const27;
                                    // Arg 5 variable: $boolean_tmpsymbol
                                    tmp274 = getVarScalar(interp, "boolean_tmpsymbol", compiledLocals, 27);
                                    tmp274.preserve();
                                    objv273[3] = tmp274;
                                    // Arg 6 constant: ...
                                    objv273[4] = const23;
                                    interp.resetResult();
                                    appendVarScalar(interp, "op_buffer", objv273, compiledLocals, 6);
                                } finally {
                                    tmp274 = objv273[0];
                                    if ( tmp274 != null ) {
                                        tmp274.release();
                                    }
                                    tmp274 = objv273[1];
                                    if ( tmp274 != null ) {
                                        tmp274.release();
                                    }
                                    tmp274 = objv273[3];
                                    if ( tmp274 != null ) {
                                        tmp274.release();
                                    }
                                    TJC.releaseObjv(interp, objv273, 5);
                                }
                            } // End Invoke: append
                            { // Invoke: set ev1 $ev
                                TclObject tmp276;
                                tmp276 = getVarScalar(interp, "ev", compiledLocals, 34);
                                setVarScalar(interp, "ev1", tmp276, compiledLocals, 25);
                            } // End Invoke: set
                        } else {
                            { // Invoke: return {}
                                interp.resetResult();
                                interp.setResult(const1);
                                if ( true ) { return; }
                            } // End Invoke: return
                        }
                    }
                }
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $ev1 $op_buffer
                TclObject tmp277 = TclList.newInstance();
                TclObject tmp278;
                try {
                    tmp278 = getVarScalar(interp, "ev1", compiledLocals, 25);
                    TclList.append(interp, tmp277, tmp278);
                    tmp278 = getVarScalar(interp, "op_buffer", compiledLocals, 6);
                    TclList.append(interp, tmp277, tmp278);
                } catch (TclException ex) {
                    tmp277.release();
                    throw ex;
                }
                interp.setResult(tmp277);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_emit_binary_equals_operator");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("end-1");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("info");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("exists");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("_compileproc(options,expr_no_string_compare_optimizations)");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("compileproc_expr_evaluate_emit_exprvalue");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("rtype TclObject");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("compileproc_tmpvar_next");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("true");
        TclBoolean.get(interp, const11);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("false");
        TclBoolean.get(interp, const12);
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_emit_exprvalue_get");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("emitter_indent");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("TJC.exprEqualsEmptyString(");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance(", ");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance(")");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance(";\n");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("! ");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("boolean ");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance(" = ");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance(".toString().equals(");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance(");\n");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("boolean");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("emitter_statement");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance(".equals(");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance(".setIntValue(");
        const27.preserve(); const27.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "info";
                break;
            }
            case 3: {
                cmdName = "compileproc_expr_evaluate_emit_exprvalue";
                break;
            }
            case 4: {
                cmdName = "compileproc_tmpvar_next";
                break;
            }
            case 5: {
                cmdName = "compileproc_emit_exprvalue_get";
                break;
            }
            case 6: {
                cmdName = "emitter_indent";
                break;
            }
            case 7: {
                cmdName = "emitter_statement";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "op",
        "left_tuple",
        "left_peek_tuple",
        "right_tuple",
        "right_peek_tuple",
        "_compileproc",
        "op_buffer",
        "left_value_info_type",
        "left_value_info_value",
        "right_value_info_type",
        "right_value_info_value",
        "is_tclobject_string_compare",
        "opt_tclobject_empty_string_compare",
        "opt_tclobject_string_compare",
        "opt_tclobject_to_tclobject_string_compare",
        "opt_tclobject_to_exprvalue_string_compare",
        "is_left_operand_tclobject",
        "is_any_optimized_op",
        "str",
        "string_literal",
        "left_eval_tuple",
        "tclobject_sym",
        "right_eval_tuple",
        "tmpsymbol",
        "negate",
        "ev1",
        "jstr",
        "boolean_tmpsymbol",
        "not",
        "left_tclobject_sym",
        "left_str_sym",
        "right_tclobject_sym",
        "right_str_sym",
        "ev2",
        "ev"
    };
} // end class CompileprocExprEvaluateEmitBinaryEqualsOperatorCmd

