// TJC implementation of procedure compileproc_expr_evaluate_emit_binary_logic_operator
package tjc;
import tcl.lang.*;

public class CompileprocExprEvaluateEmitBinaryLogicOperatorCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 14, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "op left_tuple left_peek_tuple right_tuple right_peek_tuple");
        }
        setVarScalar(interp, "op", objv[1], compiledLocals, 0);
        setVarScalar(interp, "left_tuple", objv[2], compiledLocals, 1);
        setVarScalar(interp, "left_peek_tuple", objv[3], compiledLocals, 2);
        setVarScalar(interp, "right_tuple", objv[4], compiledLocals, 3);
        setVarScalar(interp, "right_peek_tuple", objv[5], compiledLocals, 4);
        { // Invoke: global _compileproc
            TJC.makeGlobalLinkVar(interp, "_compileproc", "_compileproc", 5);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Binary operator: () && ()
            // Binary operator: $op != "||"
            TclObject tmp0 = getVarScalar(interp, "op", compiledLocals, 0);
            boolean tmp1 = ! tmp0.toString().equals("||");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: !=
            if (tmp2.getBooleanValue(interp)) {
            // Binary operator: $op != "&&"
            TclObject tmp3 = getVarScalar(interp, "op", compiledLocals, 0);
            boolean tmp4 = ! tmp3.toString().equals("&&");
            ExprValue tmp5 = evs1;
            tmp5.setIntValue(tmp4);
            // End Binary operator: !=
            tmp2.setIntValue(tmp5.getBooleanValue(interp));
            } else {
            tmp2.setIntValue(0);
            } // End if: ()
            // End Binary operator: &&
            boolean tmp6 = ( tmp2.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: error "..."
                    TclObject[] objv7 = TJC.grabObjv(interp, 2);
                    TclObject tmp8;
                    try {
                        // Arg 0 constant: error
                        objv7[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp9 = new StringBuffer(64);
                        sbtmp9.append("operator ");
                        sbtmp9.append("\"");
                        tmp8 = getVarScalar(interp, "op", compiledLocals, 0);
                        sbtmp9.append(tmp8.toString());
                        sbtmp9.append("\"");
                        sbtmp9.append(" is not a logic operator");
                        tmp8 = TclString.newInstance(sbtmp9);
                        tmp8.preserve();
                        objv7[1] = tmp8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv7, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp8 = objv7[1];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        TJC.releaseObjv(interp, objv7, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set left_infostr [...]
            TclObject tmp10;
            { // Invoke: lindex $left_peek_tuple 3
                TclObject tmp11 = getVarScalar(interp, "left_peek_tuple", compiledLocals, 2);
                tmp11 = TclList.index(interp, tmp11, 3);
                if ( tmp11 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp11);
                }
            } // End Invoke: lindex
            tmp10 = interp.getResult();
            setVarScalar(interp, "left_infostr", tmp10, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set left_eval_tuple [...]
            TclObject tmp12;
            { // Invoke: ... $left_tuple
                TclObject[] objv13 = TJC.grabObjv(interp, 2);
                TclObject tmp14;
                try {
                    // Arg 0 constant: ...
                    objv13[0] = const1;
                    // Arg 1 variable: $left_tuple
                    tmp14 = getVarScalar(interp, "left_tuple", compiledLocals, 1);
                    tmp14.preserve();
                    objv13[1] = tmp14;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv13, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp14 = objv13[1];
                    if ( tmp14 != null ) {
                        tmp14.release();
                    }
                    TJC.releaseObjv(interp, objv13, 2);
                }
            } // End Invoke: ...
            tmp12 = interp.getResult();
            setVarScalar(interp, "left_eval_tuple", tmp12, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set right_eval_tuple [...]
            TclObject tmp15;
            { // Invoke: ... $right_tuple
                TclObject[] objv16 = TJC.grabObjv(interp, 2);
                TclObject tmp17;
                try {
                    // Arg 0 constant: ...
                    objv16[0] = const1;
                    // Arg 1 variable: $right_tuple
                    tmp17 = getVarScalar(interp, "right_tuple", compiledLocals, 3);
                    tmp17.preserve();
                    objv16[1] = tmp17;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv16, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp17 = objv16[1];
                    if ( tmp17 != null ) {
                        tmp17.release();
                    }
                    TJC.releaseObjv(interp, objv16, 2);
                }
            } // End Invoke: ...
            tmp15 = interp.getResult();
            setVarScalar(interp, "right_eval_tuple", tmp15, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set ev1 [...]
            TclObject tmp18;
            { // Invoke: lindex $left_eval_tuple 1
                TclObject tmp19 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 7);
                tmp19 = TclList.index(interp, tmp19, 1);
                if ( tmp19 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp19);
                }
            } // End Invoke: lindex
            tmp18 = interp.getResult();
            setVarScalar(interp, "ev1", tmp18, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set ev2 [...]
            TclObject tmp20;
            { // Invoke: lindex $right_eval_tuple 1
                TclObject tmp21 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 8);
                tmp21 = TclList.index(interp, tmp21, 1);
                if ( tmp21 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp21);
                }
            } // End Invoke: lindex
            tmp20 = interp.getResult();
            setVarScalar(interp, "ev2", tmp20, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: append op_buffer [...]
            TclObject[] objv22 = TJC.grabObjv(interp, 1);
            TclObject tmp23;
            try {
                // Arg 2 command: [...]
                { // Invoke: lindex $left_eval_tuple 2
                    TclObject tmp24 = getVarScalar(interp, "left_eval_tuple", compiledLocals, 7);
                    tmp24 = TclList.index(interp, tmp24, 2);
                    if ( tmp24 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp24);
                    }
                } // End Invoke: lindex
                tmp23 = interp.getResult();
                tmp23.preserve();
                objv22[0] = tmp23;
                interp.resetResult();
                appendVarScalar(interp, "op_buffer", objv22, compiledLocals, 11);
            } finally {
                TJC.releaseObjvElems(interp, objv22, 1);
            }
        } // End Invoke: append
        { // Invoke: if {$op == "&&"} ... elseif {$op == "||"} ... else ...
            // Binary operator: $op == "&&"
            TclObject tmp25 = getVarScalar(interp, "op", compiledLocals, 0);
            boolean tmp26 = tmp25.toString().equals("&&");
            ExprValue tmp27 = evs0;
            tmp27.setIntValue(tmp26);
            // End Binary operator: ==
            boolean tmp28 = ( tmp27.getIntValue() != 0 );
            if ( tmp28 ) {
                { // Invoke: set not ""
                    setVarScalar(interp, "not", const2, compiledLocals, 12);
                } // End Invoke: set
            } else {
                // Binary operator: $op == "||"
                TclObject tmp29 = getVarScalar(interp, "op", compiledLocals, 0);
                boolean tmp30 = tmp29.toString().equals("||");
                ExprValue tmp31 = evs0;
                tmp31.setIntValue(tmp30);
                // End Binary operator: ==
                boolean tmp32 = ( tmp31.getIntValue() != 0 );
                if ( tmp32 ) {
                    { // Invoke: set not "!"
                        setVarScalar(interp, "not", const3, compiledLocals, 12);
                    } // End Invoke: set
                } else {
                    { // Invoke: error "..."
                        TclObject[] objv33 = TJC.grabObjv(interp, 2);
                        TclObject tmp34;
                        try {
                            // Arg 0 constant: error
                            objv33[0] = const0;
                            // Arg 1 word: "..."
                            StringBuffer sbtmp35 = new StringBuffer(64);
                            sbtmp35.append("unmatched logic_op ");
                            sbtmp35.append("\"");
                            tmp34 = getVarScalar(interp, "op", compiledLocals, 0);
                            sbtmp35.append(tmp34.toString());
                            sbtmp35.append("\"");
                            tmp34 = TclString.newInstance(sbtmp35);
                            tmp34.preserve();
                            objv33[1] = tmp34;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv33, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp34 = objv33[1];
                            if ( tmp34 != null ) {
                                tmp34.release();
                            }
                            TJC.releaseObjv(interp, objv33, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: append op_buffer [...] "if (" $not $ev1 ... [...] [...] $ev1 ".setIntValue(" $ev2 ... [...] [...] ...
            TclObject[] objv36 = TJC.grabObjv(interp, 14);
            TclObject tmp37;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv38 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv38[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv38, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv38, 1);
                    }
                } // End Invoke: emitter_indent
                tmp37 = interp.getResult();
                tmp37.preserve();
                objv36[0] = tmp37;
                // Arg 3 constant: "if ("
                objv36[1] = const5;
                // Arg 4 variable: $not
                tmp37 = getVarScalar(interp, "not", compiledLocals, 12);
                tmp37.preserve();
                objv36[2] = tmp37;
                // Arg 5 variable: $ev1
                tmp37 = getVarScalar(interp, "ev1", compiledLocals, 9);
                tmp37.preserve();
                objv36[3] = tmp37;
                // Arg 6 constant: ...
                objv36[4] = const6;
                // Arg 7 command: [...]
                { // Invoke: lindex $right_eval_tuple 2
                    TclObject tmp39 = getVarScalar(interp, "right_eval_tuple", compiledLocals, 8);
                    tmp39 = TclList.index(interp, tmp39, 2);
                    if ( tmp39 == null ) {
                        interp.resetResult();
                    } else {
                        interp.setResult(tmp39);
                    }
                } // End Invoke: lindex
                tmp37 = interp.getResult();
                tmp37.preserve();
                objv36[5] = tmp37;
                // Arg 8 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv40 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv40[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv40, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv40, 1);
                    }
                } // End Invoke: emitter_indent
                tmp37 = interp.getResult();
                tmp37.preserve();
                objv36[6] = tmp37;
                // Arg 9 variable: $ev1
                tmp37 = getVarScalar(interp, "ev1", compiledLocals, 9);
                tmp37.preserve();
                objv36[7] = tmp37;
                // Arg 10 constant: ".setIntValue("
                objv36[8] = const7;
                // Arg 11 variable: $ev2
                tmp37 = getVarScalar(interp, "ev2", compiledLocals, 10);
                tmp37.preserve();
                objv36[9] = tmp37;
                // Arg 12 constant: ...
                objv36[10] = const8;
                // Arg 13 command: [...]
                { // Invoke: ... $ev2
                    TclObject[] objv41 = TJC.grabObjv(interp, 2);
                    TclObject tmp42;
                    try {
                        // Arg 0 constant: ...
                        objv41[0] = const9;
                        // Arg 1 variable: $ev2
                        tmp42 = getVarScalar(interp, "ev2", compiledLocals, 10);
                        tmp42.preserve();
                        objv41[1] = tmp42;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv41, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp42 = objv41[1];
                        if ( tmp42 != null ) {
                            tmp42.release();
                        }
                        TJC.releaseObjv(interp, objv41, 2);
                    }
                } // End Invoke: ...
                tmp37 = interp.getResult();
                tmp37.preserve();
                objv36[11] = tmp37;
                // Arg 14 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv43 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv43[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv43, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv43, 1);
                    }
                } // End Invoke: emitter_indent
                tmp37 = interp.getResult();
                tmp37.preserve();
                objv36[12] = tmp37;
                // Arg 15 constant: ...
                objv36[13] = const10;
                interp.resetResult();
                appendVarScalar(interp, "op_buffer", objv36, compiledLocals, 11);
            } finally {
                objv36[1] = null;
                objv36[4] = null;
                objv36[8] = null;
                objv36[10] = null;
                objv36[13] = null;
                TJC.releaseObjvElems(interp, objv36, 14);
            }
        } // End Invoke: append
        { // Invoke: set else_value [...]
            TclObject tmp44;
            { // Invoke: expr ...
                // Ternary operator: () ? 0 : 1
                // Binary operator: $not == ""
                TclObject tmp45 = getVarScalar(interp, "not", compiledLocals, 12);
                ExprValue tmp46 = evs0;
                TJC.exprEqualsEmptyString(tmp46, tmp45, false);
                // End Binary operator: ==
                if (tmp46.getBooleanValue(interp)) {
                ExprValue tmp47 = evs1;
                tmp47.setIntValue(0);
                tmp46.setValue(tmp47);
                } else {
                ExprValue tmp48 = evs1;
                tmp48.setIntValue(1);
                tmp46.setValue(tmp48);
                }
                // End Ternary operator: ?
                interp.setResult( tmp46.getIntValue() );
            } // End Invoke: expr
            tmp44 = interp.getResult();
            setVarScalar(interp, "else_value", tmp44, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: append op_buffer [...] $ev1 ".setIntValue(" $else_value ... [...] ... $not $left_infostr ...
            TclObject[] objv49 = TJC.grabObjv(interp, 10);
            TclObject tmp50;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv51 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv51[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv51, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv51, 1);
                    }
                } // End Invoke: emitter_indent
                tmp50 = interp.getResult();
                tmp50.preserve();
                objv49[0] = tmp50;
                // Arg 3 variable: $ev1
                tmp50 = getVarScalar(interp, "ev1", compiledLocals, 9);
                tmp50.preserve();
                objv49[1] = tmp50;
                // Arg 4 constant: ".setIntValue("
                objv49[2] = const7;
                // Arg 5 variable: $else_value
                tmp50 = getVarScalar(interp, "else_value", compiledLocals, 13);
                tmp50.preserve();
                objv49[3] = tmp50;
                // Arg 6 constant: ...
                objv49[4] = const11;
                // Arg 7 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv52 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv52[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv52, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv52, 1);
                    }
                } // End Invoke: emitter_indent
                tmp50 = interp.getResult();
                tmp50.preserve();
                objv49[5] = tmp50;
                // Arg 8 constant: ...
                objv49[6] = const12;
                // Arg 9 variable: $not
                tmp50 = getVarScalar(interp, "not", compiledLocals, 12);
                tmp50.preserve();
                objv49[7] = tmp50;
                // Arg 10 variable: $left_infostr
                tmp50 = getVarScalar(interp, "left_infostr", compiledLocals, 6);
                tmp50.preserve();
                objv49[8] = tmp50;
                // Arg 11 constant: ...
                objv49[9] = const13;
                interp.resetResult();
                appendVarScalar(interp, "op_buffer", objv49, compiledLocals, 11);
            } finally {
                objv49[2] = null;
                objv49[4] = null;
                objv49[6] = null;
                objv49[9] = null;
                TJC.releaseObjvElems(interp, objv49, 10);
            }
        } // End Invoke: append
        { // Invoke: return [...]
            { // Invoke: list $ev1 $op_buffer
                TclObject tmp53 = TclList.newInstance();
                TclObject tmp54;
                try {
                    tmp54 = getVarScalar(interp, "ev1", compiledLocals, 9);
                    TclList.append(interp, tmp53, tmp54);
                    tmp54 = getVarScalar(interp, "op_buffer", compiledLocals, 11);
                    TclList.append(interp, tmp53, tmp54);
                } catch (TclException ex) {
                    tmp53.release();
                    throw ex;
                }
                interp.setResult(tmp53);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_evaluate_emit_binary_logic_operator");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_expr_evaluate_emit_exprvalue");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("!");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("if (");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(".getBooleanValue(interp)) {\n");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(".setIntValue(");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(".getBooleanValue(interp));\n");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("compileproc_emit_exprvalue_release");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("} else {\n");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance(");\n");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("} // End if: ");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("\n");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "compileproc_expr_evaluate_emit_exprvalue";
                break;
            }
            case 3: {
                cmdName = "emitter_indent";
                break;
            }
            case 4: {
                cmdName = "compileproc_emit_exprvalue_release";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "op",
        "left_tuple",
        "left_peek_tuple",
        "right_tuple",
        "right_peek_tuple",
        "_compileproc",
        "left_infostr",
        "left_eval_tuple",
        "right_eval_tuple",
        "ev1",
        "ev2",
        "op_buffer",
        "not",
        "else_value"
    };
} // end class CompileprocExprEvaluateEmitBinaryLogicOperatorCmd

