// TJC implementation of procedure compileproc_expr_peek_operand
package tjc;
import tcl.lang.*;

public class CompileprocExprPeekOperandCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "tuple");
        }
        setVarScalar(interp, "tuple", objv[1], compiledLocals, 0);
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set peek_tuple [...]
            TclObject tmp0;
            { // Invoke: ... $tuple {peek 1}
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const1;
                    // Arg 1 variable: $tuple
                    tmp2 = getVarScalar(interp, "tuple", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: {peek 1}
                    objv1[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "peek_tuple", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set infostr [...]
            TclObject tmp3;
            { // Invoke: lindex $peek_tuple 0
                TclObject tmp4 = getVarScalar(interp, "peek_tuple", compiledLocals, 2);
                tmp4 = TclList.index(interp, tmp4, 0);
                if ( tmp4 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp4);
                }
            } // End Invoke: lindex
            tmp3 = interp.getResult();
            setVarScalar(interp, "infostr", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set buffer [...]
            TclObject tmp5;
            { // Invoke: lindex $peek_tuple 2
                TclObject tmp6 = getVarScalar(interp, "peek_tuple", compiledLocals, 2);
                tmp6 = TclList.index(interp, tmp6, 2);
                if ( tmp6 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp6);
                }
            } // End Invoke: lindex
            tmp5 = interp.getResult();
            setVarScalar(interp, "buffer", tmp5, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$buffer != ""} ...
            // Binary operator: $buffer != ""
            TclObject tmp7 = getVarScalar(interp, "buffer", compiledLocals, 4);
            ExprValue tmp8 = evs0;
            TJC.exprEqualsEmptyString(tmp8, tmp7, true);
            // End Binary operator: !=
            boolean tmp9 = ( tmp8.getIntValue() != 0 );
            if ( tmp9 ) {
                { // Invoke: error "..."
                    TclObject[] objv10 = TJC.grabObjv(interp, 2);
                    TclObject tmp11;
                    try {
                        // Arg 0 constant: error
                        objv10[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp12 = new StringBuffer(64);
                        sbtmp12.append("expected empty eval buffer but got : ");
                        sbtmp12.append("\"");
                        tmp11 = getVarScalar(interp, "buffer", compiledLocals, 4);
                        sbtmp12.append(tmp11.toString());
                        sbtmp12.append("\"");
                        tmp11 = TclString.newInstance(sbtmp12);
                        tmp11.preserve();
                        objv10[1] = tmp11;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv10, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp11 = objv10[1];
                        if ( tmp11 != null ) {
                            tmp11.release();
                        }
                        TJC.releaseObjv(interp, objv10, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set result_info [...]
            TclObject tmp13;
            { // Invoke: lindex $peek_tuple 3
                TclObject tmp14 = getVarScalar(interp, "peek_tuple", compiledLocals, 2);
                tmp14 = TclList.index(interp, tmp14, 3);
                if ( tmp14 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp14);
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "result_info", tmp13, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set result_tuple [...]
            TclObject tmp15;
            { // Invoke: lrange $result_info 0 2
                TclObject[] objv16 = TJC.grabObjv(interp, 4);
                TclObject tmp17;
                try {
                    // Arg 0 constant: lrange
                    objv16[0] = const4;
                    // Arg 1 variable: $result_info
                    tmp17 = getVarScalar(interp, "result_info", compiledLocals, 5);
                    tmp17.preserve();
                    objv16[1] = tmp17;
                    // Arg 2 constant: 0
                    objv16[2] = const0;
                    // Arg 3 constant: 2
                    objv16[3] = const5;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv16, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp17 = objv16[1];
                    if ( tmp17 != null ) {
                        tmp17.release();
                    }
                    TJC.releaseObjv(interp, objv16, 4);
                }
            } // End Invoke: lrange
            tmp15 = interp.getResult();
            setVarScalar(interp, "result_tuple", tmp15, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: lappend result_tuple $infostr
            TclObject[] objv18 = TJC.grabObjv(interp, 1);
            TclObject tmp19;
            try {
                // Arg 2 variable: $infostr
                tmp19 = getVarScalar(interp, "infostr", compiledLocals, 3);
                tmp19.preserve();
                objv18[0] = tmp19;
                interp.resetResult();
                lappendVarScalar(interp, "result_tuple", objv18, compiledLocals, 6);
            } finally {
                TJC.releaseObjvElems(interp, objv18, 1);
            }
        } // End Invoke: lappend
        { // Invoke: return $result_tuple
            TclObject tmp20 = getVarScalar(interp, "result_tuple", compiledLocals, 6);
            interp.resetResult();
            interp.setResult(tmp20);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_expr_peek_operand");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("compileproc_expr_evaluate_emit_exprvalue");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("peek 1");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("lrange");
        const4.preserve(); const4.preserve();
        const5 = TclInteger.newInstance(2);
        const5.preserve(); const5.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_expr_evaluate_emit_exprvalue";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "lrange";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tuple",
        "debug",
        "peek_tuple",
        "infostr",
        "buffer",
        "result_info",
        "result_tuple"
    };
} // end class CompileprocExprPeekOperandCmd

