// TJC implementation of procedure compileproc_get_set_nonconstant_array_variable
package tjc;
import tcl.lang.*;

public class CompileprocGetSetNonconstantArrayVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 12, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 5 || objv.length > 7) {
            throw new TclNumArgsException(interp, 1, objv, "key index getset tmpsymbol ?assign_tmpsymbol? ?value?");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        setVarScalar(interp, "index", objv[2], compiledLocals, 1);
        setVarScalar(interp, "getset", objv[3], compiledLocals, 2);
        setVarScalar(interp, "tmpsymbol", objv[4], compiledLocals, 3);
        setVarScalar(interp, "assign_tmpsymbol", 
            ((objv.length <= 5) ? const0 : objv[5]), compiledLocals, 4);
        setVarScalar(interp, "value", 
            ((objv.length <= 6) ? const1 : objv[6]), compiledLocals, 5);
        { // Invoke: set tuple [...]
            TclObject tmp0;
            { // Invoke: ... $key $index $tmpsymbol
                TclObject[] objv1 = TJC.grabObjv(interp, 4);
                TclObject tmp2;
                try {
                    // Arg 0 constant: ...
                    objv1[0] = const2;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 variable: $index
                    tmp2 = getVarScalar(interp, "index", compiledLocals, 1);
                    tmp2.preserve();
                    objv1[2] = tmp2;
                    // Arg 3 variable: $tmpsymbol
                    tmp2 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                    tmp2.preserve();
                    objv1[3] = tmp2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[2];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    tmp2 = objv1[3];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 4);
                }
            } // End Invoke: ...
            tmp0 = interp.getResult();
            setVarScalar(interp, "tuple", tmp0, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set varname [...]
            TclObject tmp3;
            { // Invoke: lindex $tuple 0
                TclObject tmp4 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp4 = TclList.index(interp, tmp4, 0);
                if ( tmp4 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp4);
                }
            } // End Invoke: lindex
            tmp3 = interp.getResult();
            setVarScalar(interp, "varname", tmp3, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set keysym [...]
            TclObject tmp5;
            { // Invoke: lindex $tuple 1
                TclObject tmp6 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp6 = TclList.index(interp, tmp6, 1);
                if ( tmp6 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp6);
                }
            } // End Invoke: lindex
            tmp5 = interp.getResult();
            setVarScalar(interp, "keysym", tmp5, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set word_buffer [...]
            TclObject tmp7;
            { // Invoke: lindex $tuple 2
                TclObject tmp8 = getVarScalar(interp, "tuple", compiledLocals, 6);
                tmp8 = TclList.index(interp, tmp8, 2);
                if ( tmp8 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp8);
                }
            } // End Invoke: lindex
            tmp7 = interp.getResult();
            setVarScalar(interp, "word_buffer", tmp7, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if {$getset == "get"} ... elseif {$getset == "set"} ... else ...
            // Binary operator: $getset == "get"
            TclObject tmp9 = getVarScalar(interp, "getset", compiledLocals, 2);
            boolean tmp10 = tmp9.toString().equals("get");
            ExprValue tmp11 = evs0;
            tmp11.setIntValue(tmp10);
            // End Binary operator: ==
            boolean tmp12 = ( tmp11.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: set get_set_buffer [...]
                    TclObject tmp13;
                    { // Invoke: ... $tmpsymbol $varname $keysym false
                        TclObject[] objv14 = TJC.grabObjv(interp, 5);
                        TclObject tmp15;
                        try {
                            // Arg 0 constant: ...
                            objv14[0] = const3;
                            // Arg 1 variable: $tmpsymbol
                            tmp15 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                            tmp15.preserve();
                            objv14[1] = tmp15;
                            // Arg 2 variable: $varname
                            tmp15 = getVarScalar(interp, "varname", compiledLocals, 7);
                            tmp15.preserve();
                            objv14[2] = tmp15;
                            // Arg 3 variable: $keysym
                            tmp15 = getVarScalar(interp, "keysym", compiledLocals, 8);
                            tmp15.preserve();
                            objv14[3] = tmp15;
                            // Arg 4 constant: false
                            objv14[4] = const4;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv14, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp15 = objv14[1];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            tmp15 = objv14[2];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            tmp15 = objv14[3];
                            if ( tmp15 != null ) {
                                tmp15.release();
                            }
                            TJC.releaseObjv(interp, objv14, 5);
                        }
                    } // End Invoke: ...
                    tmp13 = interp.getResult();
                    setVarScalar(interp, "get_set_buffer", tmp13, compiledLocals, 10);
                } // End Invoke: set
            } else {
                // Binary operator: $getset == "set"
                TclObject tmp16 = getVarScalar(interp, "getset", compiledLocals, 2);
                boolean tmp17 = tmp16.toString().equals("set");
                ExprValue tmp18 = evs0;
                tmp18.setIntValue(tmp17);
                // End Binary operator: ==
                boolean tmp19 = ( tmp18.getIntValue() != 0 );
                if ( tmp19 ) {
                    { // Invoke: if {$assign_tmpsymbol} ... else ...
                        TclObject tmp20 = getVarScalar(interp, "assign_tmpsymbol", compiledLocals, 4);
                        boolean tmp21 = TJC.getBoolean(interp, tmp20);
                        if ( tmp21 ) {
                            { // Invoke: set set_tmpsymbol $tmpsymbol
                                TclObject tmp22;
                                tmp22 = getVarScalar(interp, "tmpsymbol", compiledLocals, 3);
                                setVarScalar(interp, "set_tmpsymbol", tmp22, compiledLocals, 11);
                            } // End Invoke: set
                        } else {
                            { // Invoke: set set_tmpsymbol {}
                                setVarScalar(interp, "set_tmpsymbol", const1, compiledLocals, 11);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: set get_set_buffer [...]
                        TclObject tmp23;
                        { // Invoke: ... $set_tmpsymbol $varname $keysym false $value
                            TclObject[] objv24 = TJC.grabObjv(interp, 6);
                            TclObject tmp25;
                            try {
                                // Arg 0 constant: ...
                                objv24[0] = const5;
                                // Arg 1 variable: $set_tmpsymbol
                                tmp25 = getVarScalar(interp, "set_tmpsymbol", compiledLocals, 11);
                                tmp25.preserve();
                                objv24[1] = tmp25;
                                // Arg 2 variable: $varname
                                tmp25 = getVarScalar(interp, "varname", compiledLocals, 7);
                                tmp25.preserve();
                                objv24[2] = tmp25;
                                // Arg 3 variable: $keysym
                                tmp25 = getVarScalar(interp, "keysym", compiledLocals, 8);
                                tmp25.preserve();
                                objv24[3] = tmp25;
                                // Arg 4 constant: false
                                objv24[4] = const4;
                                // Arg 5 variable: $value
                                tmp25 = getVarScalar(interp, "value", compiledLocals, 5);
                                tmp25.preserve();
                                objv24[5] = tmp25;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv24, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp25 = objv24[1];
                                if ( tmp25 != null ) {
                                    tmp25.release();
                                }
                                tmp25 = objv24[2];
                                if ( tmp25 != null ) {
                                    tmp25.release();
                                }
                                tmp25 = objv24[3];
                                if ( tmp25 != null ) {
                                    tmp25.release();
                                }
                                tmp25 = objv24[5];
                                if ( tmp25 != null ) {
                                    tmp25.release();
                                }
                                TJC.releaseObjv(interp, objv24, 6);
                            }
                        } // End Invoke: ...
                        tmp23 = interp.getResult();
                        setVarScalar(interp, "get_set_buffer", tmp23, compiledLocals, 10);
                    } // End Invoke: set
                } else {
                    { // Invoke: error ...
                        TclObject[] objv26 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: error
                            objv26[0] = const6;
                            // Arg 1 constant: ...
                            objv26[1] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv26, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv26, 2);
                        }
                    } // End Invoke: error
                }
            }
        } // End Invoke: if
        { // Invoke: return [...]
            { // Invoke: list $word_buffer $get_set_buffer
                TclObject tmp27 = TclList.newInstance();
                TclObject tmp28;
                try {
                    tmp28 = getVarScalar(interp, "word_buffer", compiledLocals, 9);
                    TclList.append(interp, tmp27, tmp28);
                    tmp28 = getVarScalar(interp, "get_set_buffer", compiledLocals, 10);
                    TclList.append(interp, tmp27, tmp28);
                } catch (TclException ex) {
                    tmp27.release();
                    throw ex;
                }
                interp.setResult(tmp27);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_get_set_nonconstant_array_variable");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("true");
        TclBoolean.get(interp, const0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("compileproc_setup_nonconstant_array_variable");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("compileproc_emit_array_variable_get");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("false");
        TclBoolean.get(interp, const4);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("compileproc_emit_array_variable_set");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("error");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("bad getset argument must be \"get\" or \"set\"");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "compileproc_setup_nonconstant_array_variable";
                break;
            }
            case 2: {
                cmdName = "compileproc_emit_array_variable_get";
                break;
            }
            case 3: {
                cmdName = "compileproc_emit_array_variable_set";
                break;
            }
            case 4: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "index",
        "getset",
        "tmpsymbol",
        "assign_tmpsymbol",
        "value",
        "tuple",
        "varname",
        "keysym",
        "word_buffer",
        "get_set_buffer",
        "set_tmpsymbol"
    };
} // end class CompileprocGetSetNonconstantArrayVariableCmd

