// TJC implementation of procedure compileproc_variable_cache_count
package tjc;
import tcl.lang.*;

public class CompileprocVariableCacheCountCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 1, compiledLocalsNames);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: return [...]
            { // Invoke: llength $...
                initVarScoped(interp, "::_compileproc_variable_cache", compiledLocals, 0);
                TclObject tmp0 = getVarArray(interp, "::_compileproc_variable_cache", "ordered_keys", compiledLocals, 0);
                int tmp1 = TclList.getLength(interp, tmp0);
                interp.setResult(tmp1);
            } // End Invoke: llength
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "compileproc_variable_cache_count");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "::_compileproc_variable_cache"
    };
} // end class CompileprocVariableCacheCountCmd

