// TJC implementation of procedure _descend_commands_add
package tjc;
import tcl.lang.*;

public class DescendCommandsAddCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set l [...]
            TclObject tmp0;
            { // Invoke: lindex $... 0
                TclObject tmp1 = getVarArray(interp, "_descend", "commands_stack", compiledLocals, 1);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "l", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: lappend l $key
            TclObject[] objv2 = TJC.grabObjv(interp, 1);
            TclObject tmp3;
            try {
                // Arg 2 variable: $key
                tmp3 = getVarScalar(interp, "key", compiledLocals, 0);
                tmp3.preserve();
                objv2[0] = tmp3;
                interp.resetResult();
                lappendVarScalar(interp, "l", objv2, compiledLocals, 2);
            } finally {
                TJC.releaseObjvElems(interp, objv2, 1);
            }
        } // End Invoke: lappend
        { // Invoke: set ... [...]
            TclObject tmp4;
            { // Invoke: lreplace $... 0 0 $l
                TclObject[] objv5 = TJC.grabObjv(interp, 5);
                TclObject tmp6;
                try {
                    // Arg 0 constant: lreplace
                    objv5[0] = const0;
                    // Arg 1 variable: $...
                    tmp6 = getVarArray(interp, "_descend", "commands_stack", compiledLocals, 1);
                    tmp6.preserve();
                    objv5[1] = tmp6;
                    // Arg 2 constant: 0
                    objv5[2] = const1;
                    // Arg 3 constant: 0
                    objv5[3] = const1;
                    // Arg 4 variable: $l
                    tmp6 = getVarScalar(interp, "l", compiledLocals, 2);
                    tmp6.preserve();
                    objv5[4] = tmp6;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv5, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp6 = objv5[1];
                    if ( tmp6 != null ) {
                        tmp6.release();
                    }
                    tmp6 = objv5[4];
                    if ( tmp6 != null ) {
                        tmp6.release();
                    }
                    TJC.releaseObjv(interp, objv5, 5);
                }
            } // End Invoke: lreplace
            tmp4 = interp.getResult();
            setVarArray(interp, "_descend", "commands_stack", tmp4, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: return $l
            TclObject tmp7 = getVarScalar(interp, "l", compiledLocals, 2);
            interp.resetResult();
            interp.setResult(tmp7);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_descend_commands_add");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("lreplace");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lreplace";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "l"
    };
} // end class DescendCommandsAddCmd

