// TJC implementation of procedure descend_container_after_has_command_indexes
package tjc;
import tcl.lang.*;

public class DescendContainerAfterHasCommandIndexesCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set validated [...]
            TclObject tmp6;
            { // Invoke: descend_get_data $key validated
                TclObject[] objv7 = TJC.grabObjv(interp, 3);
                TclObject tmp8;
                try {
                    // Arg 0 constant: descend_get_data
                    objv7[0] = const0;
                    // Arg 1 variable: $key
                    tmp8 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp8.preserve();
                    objv7[1] = tmp8;
                    // Arg 2 constant: validated
                    objv7[2] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv7, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp8 = objv7[1];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 3);
                }
            } // End Invoke: descend_get_data
            tmp6 = interp.getResult();
            setVarScalar(interp, "validated", tmp6, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$validated == {}} ...
            // Binary operator: $validated == ""
            TclObject tmp9 = getVarScalar(interp, "validated", compiledLocals, 3);
            ExprValue tmp10 = evs0;
            TJC.exprEqualsEmptyString(tmp10, tmp9, false);
            // End Binary operator: ==
            boolean tmp11 = ( tmp10.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error "not validated"
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const4;
                        // Arg 1 constant: "not validated"
                        objv12[1] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set type [...]
            TclObject tmp13;
            { // Invoke: lindex $validated 0
                TclObject tmp14 = getVarScalar(interp, "validated", compiledLocals, 3);
                tmp14 = TclList.index(interp, tmp14, 0);
                if ( tmp14 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp14);
                }
            } // End Invoke: lindex
            tmp13 = interp.getResult();
            setVarScalar(interp, "type", tmp13, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            // Binary operator: () || ()
            // Binary operator: $type == "ms"
            TclObject tmp15 = getVarScalar(interp, "type", compiledLocals, 4);
            boolean tmp16 = tmp15.toString().equals("ms");
            ExprValue tmp17 = evs0;
            tmp17.setIntValue(tmp16);
            // End Binary operator: ==
            if (!tmp17.getBooleanValue(interp)) {
            // Binary operator: $type == "idle"
            TclObject tmp18 = getVarScalar(interp, "type", compiledLocals, 4);
            boolean tmp19 = tmp18.toString().equals("idle");
            ExprValue tmp20 = evs1;
            tmp20.setIntValue(tmp19);
            // End Binary operator: ==
            tmp17.setIntValue(tmp20.getBooleanValue(interp));
            } else {
            tmp17.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp21 = ( tmp17.getIntValue() != 0 );
            if ( tmp21 ) {
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const6);
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const7);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_after_has_command_indexes");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("validated");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("error");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("not validated");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(1);
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(0);
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "script",
        "tree",
        "validated",
        "type"
    };
} // end class DescendContainerAfterHasCommandIndexesCmd

