// TJC implementation of procedure descend_container_foreach_validate
package tjc;
import tcl.lang.*;

public class DescendContainerForeachValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 13, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp6;
            { // Invoke: llength $tree
                TclObject tmp7 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp8 = TclList.getLength(interp, tmp7);
                interp.setResult(tmp8);
            } // End Invoke: llength
            tmp6 = interp.getResult();
            setVarScalar(interp, "num_args", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$num_args == 4} ... elseif ... ... else ...
            // Binary operator: $num_args == 4
            TclObject tmp9 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp9);
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(4);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp10, tmp11);
            // End Binary operator: ==
            boolean tmp12 = ( tmp10.getIntValue() != 0 );
            if ( tmp12 ) {
            } else {
                // Binary operator: () && ()
                // Binary operator: $num_args > 4
                TclObject tmp13 = getVarScalar(interp, "num_args", compiledLocals, 4);
                ExprValue tmp14 = evs0;
                TJC.exprInitValue(interp, tmp14, tmp13);
                ExprValue tmp15 = evs1;
                tmp15.setIntValue(4);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp14, tmp15);
                // End Binary operator: >
                if (tmp14.getBooleanValue(interp)) {
                // Binary operator: () == 0
                // Binary operator: () % 2
                // Binary operator: $num_args - 4
                TclObject tmp16 = getVarScalar(interp, "num_args", compiledLocals, 4);
                ExprValue tmp17 = evs1;
                TJC.exprInitValue(interp, tmp17, tmp16);
                ExprValue tmp18 = evs2;
                tmp18.setIntValue(4);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp17, tmp18);
                // End Binary operator: -
                ExprValue tmp19 = evs2;
                tmp19.setIntValue(2);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp17, tmp19);
                // End Binary operator: %
                ExprValue tmp20 = evs2;
                tmp20.setIntValue(0);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp17, tmp20);
                // End Binary operator: ==
                tmp14.setIntValue(tmp17.getBooleanValue(interp));
                } else {
                tmp14.setIntValue(0);
                } // End if: ()
                // End Binary operator: &&
                boolean tmp21 = ( tmp14.getIntValue() != 0 );
                if ( tmp21 ) {
                } else {
                    { // Invoke: set _descend($key,usage) 1
                        TclObject tmp22;
                        String tmp23;
                        StringBuffer sbtmp24 = new StringBuffer(64);
                        tmp22 = getVarScalar(interp, "key", compiledLocals, 0);
                        sbtmp24.append(tmp22.toString());
                        sbtmp24.append(",usage");
                        tmp23 = sbtmp24.toString();
                        setVarArray(interp, "_descend", tmp23, const3, compiledLocals, 1);
                    } // End Invoke: set
                    { // Invoke: return [...]
                        { // Invoke: list numArgs foreach $num_args "4, 6, 8, ..."
                            TclObject tmp25 = TclList.newInstance();
                            TclObject tmp26;
                            try {
                                TclList.append(interp, tmp25, const4);
                                TclList.append(interp, tmp25, const5);
                                tmp26 = getVarScalar(interp, "num_args", compiledLocals, 4);
                                TclList.append(interp, tmp25, tmp26);
                                TclList.append(interp, tmp25, const6);
                            } catch (TclException ex) {
                                tmp25.release();
                                throw ex;
                            }
                            interp.setResult(tmp25);
                        } // End Invoke: list
                        if ( true ) { return; }
                    } // End Invoke: return
                }
            }
        } // End Invoke: if
        { // Invoke: set is_static 1
            setVarScalar(interp, "is_static", const3, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if {$num_args == 4} ... else ...
            // Binary operator: $num_args == 4
            TclObject tmp27 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp28 = evs0;
            TJC.exprInitValue(interp, tmp28, tmp27);
            ExprValue tmp29 = evs1;
            tmp29.setIntValue(4);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp28, tmp29);
            // End Binary operator: ==
            boolean tmp30 = ( tmp28.getIntValue() != 0 );
            if ( tmp30 ) {
                { // Invoke: set varlist [...]
                    TclObject tmp31;
                    { // Invoke: ... $key 1
                        TclObject[] objv32 = TJC.grabObjv(interp, 3);
                        TclObject tmp33;
                        try {
                            // Arg 0 constant: ...
                            objv32[0] = const7;
                            // Arg 1 variable: $key
                            tmp33 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp33.preserve();
                            objv32[1] = tmp33;
                            // Arg 2 constant: 1
                            objv32[2] = const3;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv32, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp33 = objv32[1];
                            if ( tmp33 != null ) {
                                tmp33.release();
                            }
                            TJC.releaseObjv(interp, objv32, 3);
                        }
                    } // End Invoke: ...
                    tmp31 = interp.getResult();
                    setVarScalar(interp, "varlist", tmp31, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: if ... ... elseif ... ... elseif ... ... else ...
                    // Binary operator: $varlist == "NOT_STATIC"
                    TclObject tmp34 = getVarScalar(interp, "varlist", compiledLocals, 6);
                    boolean tmp35 = tmp34.toString().equals("NOT_STATIC");
                    ExprValue tmp36 = evs0;
                    tmp36.setIntValue(tmp35);
                    // End Binary operator: ==
                    boolean tmp37 = ( tmp36.getIntValue() != 0 );
                    if ( tmp37 ) {
                        { // Invoke: set is_static 0
                            setVarScalar(interp, "is_static", const8, compiledLocals, 5);
                        } // End Invoke: set
                        { // Invoke: set type "unknown"
                            setVarScalar(interp, "type", const9, compiledLocals, 7);
                        } // End Invoke: set
                    } else {
                        // Binary operator: [...] == 0
                        { // Invoke: llength $varlist
                            TclObject tmp38 = getVarScalar(interp, "varlist", compiledLocals, 6);
                            int tmp39 = TclList.getLength(interp, tmp38);
                            interp.setResult(tmp39);
                        } // End Invoke: llength
                        TclObject tmp40 = interp.getResult();
                        ExprValue tmp41 = evs0;
                        TJC.exprInitValue(interp, tmp41, tmp40);
                        ExprValue tmp42 = evs1;
                        tmp42.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp41, tmp42);
                        // End Binary operator: ==
                        boolean tmp43 = ( tmp41.getIntValue() != 0 );
                        if ( tmp43 ) {
                            { // Invoke: set _descend($key,usage) 1
                                TclObject tmp44;
                                String tmp45;
                                StringBuffer sbtmp46 = new StringBuffer(64);
                                tmp44 = getVarScalar(interp, "key", compiledLocals, 0);
                                sbtmp46.append(tmp44.toString());
                                sbtmp46.append(",usage");
                                tmp45 = sbtmp46.toString();
                                setVarArray(interp, "_descend", tmp45, const3, compiledLocals, 1);
                            } // End Invoke: set
                            { // Invoke: return [...]
                                { // Invoke: list listArg foreach "empty list arg"
                                    TclObject tmp47 = TclList.newInstance();
                                    try {
                                        TclList.append(interp, tmp47, const10);
                                        TclList.append(interp, tmp47, const5);
                                        TclList.append(interp, tmp47, const11);
                                    } catch (TclException ex) {
                                        tmp47.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp47);
                                } // End Invoke: list
                                if ( true ) { return; }
                            } // End Invoke: return
                        } else {
                            // Binary operator: [...] == 1
                            { // Invoke: llength $varlist
                                TclObject tmp48 = getVarScalar(interp, "varlist", compiledLocals, 6);
                                int tmp49 = TclList.getLength(interp, tmp48);
                                interp.setResult(tmp49);
                            } // End Invoke: llength
                            TclObject tmp50 = interp.getResult();
                            ExprValue tmp51 = evs0;
                            TJC.exprInitValue(interp, tmp51, tmp50);
                            ExprValue tmp52 = evs1;
                            tmp52.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp51, tmp52);
                            // End Binary operator: ==
                            boolean tmp53 = ( tmp51.getIntValue() != 0 );
                            if ( tmp53 ) {
                                { // Invoke: set type "single"
                                    setVarScalar(interp, "type", const12, compiledLocals, 7);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set type "list"
                                    setVarScalar(interp, "type", const13, compiledLocals, 7);
                                } // End Invoke: set
                            }
                        }
                    }
                } // End Invoke: if
                { // Invoke: set "..." [...]
                    TclObject tmp54;
                    String tmp57;
                    StringBuffer sbtmp58 = new StringBuffer(64);
                    tmp54 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp58.append(tmp54.toString());
                    sbtmp58.append(",validated");
                    tmp57 = sbtmp58.toString();
                    { // Invoke: list $type {1 2} 3
                        TclObject tmp55 = TclList.newInstance();
                        TclObject tmp56;
                        try {
                            tmp56 = getVarScalar(interp, "type", compiledLocals, 7);
                            TclList.append(interp, tmp55, tmp56);
                            TclList.append(interp, tmp55, const14);
                            TclList.append(interp, tmp55, const15);
                        } catch (TclException ex) {
                            tmp55.release();
                            throw ex;
                        }
                        interp.setResult(tmp55);
                    } // End Invoke: list
                    tmp54 = interp.getResult();
                    tmp54 = setVarArray(interp, "_descend", tmp57, tmp54, compiledLocals, 1);
                } // End Invoke: set
            } else {
                { // Invoke: set ... [...]
                    TclObject tmp59;
                    { // Invoke: list
                        TclObject tmp60 = TclList.newInstance();
                        interp.setResult(tmp60);
                    } // End Invoke: list
                    tmp59 = interp.getResult();
                    setVarScalar(interp, "varname_listname_list", tmp59, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set type "multi"
                    setVarScalar(interp, "type", const16, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set last_list_index [...]
                    TclObject tmp61;
                    { // Invoke: expr {$num_args - 1 - 1}
                        // Binary operator: () - 1
                        // Binary operator: $num_args - 1
                        TclObject tmp62 = getVarScalar(interp, "num_args", compiledLocals, 4);
                        ExprValue tmp63 = evs0;
                        TJC.exprInitValue(interp, tmp63, tmp62);
                        ExprValue tmp64 = evs1;
                        tmp64.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp63, tmp64);
                        // End Binary operator: -
                        ExprValue tmp65 = evs1;
                        tmp65.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp63, tmp65);
                        // End Binary operator: -
                        TJC.exprSetResult(interp, tmp63);
                    } // End Invoke: expr
                    tmp61 = interp.getResult();
                    setVarScalar(interp, "last_list_index", tmp61, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: for {set i 1} ... {incr i 2} ...
                    { // Invoke: set i 1
                        setVarScalar(interp, "i", const3, compiledLocals, 10);
                    } // End Invoke: set
                    for ( boolean skip71 = true ; true ; ) {
                        if ( skip71 ) {
                            skip71 = false;
                        } else {
                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: incr i 2
                                interp.resetResult();
                                incrVarScalar(interp, "i", 2, compiledLocals, 10);
                            } // End Invoke: incr
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else {
                                    throw ex;
                                }
                            }
                        }

                        // Binary operator: $i < $last_list_index
                        TclObject tmp66 = getVarScalar(interp, "i", compiledLocals, 10);
                        ExprValue tmp67 = evs0;
                        TJC.exprInitValue(interp, tmp67, tmp66);
                        TclObject tmp68 = getVarScalar(interp, "last_list_index", compiledLocals, 9);
                        ExprValue tmp69 = evs1;
                        TJC.exprInitValue(interp, tmp69, tmp68);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp67, tmp69);
                        // End Binary operator: <
                        boolean tmp70 = ( tmp67.getIntValue() != 0 );
                        if ( ! tmp70 ) { break; }

                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: set var_list_index $i
                            TclObject tmp72;
                            tmp72 = getVarScalar(interp, "i", compiledLocals, 10);
                            setVarScalar(interp, "var_list_index", tmp72, compiledLocals, 11);
                        } // End Invoke: set
                        { // Invoke: set var_values_index [...]
                            TclObject tmp73;
                            { // Invoke: expr {$i + 1}
                                // Binary operator: $i + 1
                                TclObject tmp74 = getVarScalar(interp, "i", compiledLocals, 10);
                                ExprValue tmp75 = evs0;
                                TJC.exprInitValue(interp, tmp75, tmp74);
                                ExprValue tmp76 = evs1;
                                tmp76.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp75, tmp76);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp75);
                            } // End Invoke: expr
                            tmp73 = interp.getResult();
                            setVarScalar(interp, "var_values_index", tmp73, compiledLocals, 12);
                        } // End Invoke: set
                        { // Invoke: set varlist [...]
                            TclObject tmp77;
                            { // Invoke: ... $key $var_list_index
                                TclObject[] objv78 = TJC.grabObjv(interp, 3);
                                TclObject tmp79;
                                try {
                                    // Arg 0 constant: ...
                                    objv78[0] = const7;
                                    // Arg 1 variable: $key
                                    tmp79 = getVarScalar(interp, "key", compiledLocals, 0);
                                    tmp79.preserve();
                                    objv78[1] = tmp79;
                                    // Arg 2 variable: $var_list_index
                                    tmp79 = getVarScalar(interp, "var_list_index", compiledLocals, 11);
                                    tmp79.preserve();
                                    objv78[2] = tmp79;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv78, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp79 = objv78[1];
                                    if ( tmp79 != null ) {
                                        tmp79.release();
                                    }
                                    tmp79 = objv78[2];
                                    if ( tmp79 != null ) {
                                        tmp79.release();
                                    }
                                    TJC.releaseObjv(interp, objv78, 3);
                                }
                            } // End Invoke: ...
                            tmp77 = interp.getResult();
                            setVarScalar(interp, "varlist", tmp77, compiledLocals, 6);
                        } // End Invoke: set
                        { // Invoke: if ... ... elseif ... ...
                            // Binary operator: $varlist == "NOT_STATIC"
                            TclObject tmp80 = getVarScalar(interp, "varlist", compiledLocals, 6);
                            boolean tmp81 = tmp80.toString().equals("NOT_STATIC");
                            ExprValue tmp82 = evs0;
                            tmp82.setIntValue(tmp81);
                            // End Binary operator: ==
                            boolean tmp83 = ( tmp82.getIntValue() != 0 );
                            if ( tmp83 ) {
                                { // Invoke: set is_static 0
                                    setVarScalar(interp, "is_static", const8, compiledLocals, 5);
                                } // End Invoke: set
                            } else {
                                // Binary operator: [...] == 0
                                { // Invoke: llength $varlist
                                    TclObject tmp84 = getVarScalar(interp, "varlist", compiledLocals, 6);
                                    int tmp85 = TclList.getLength(interp, tmp84);
                                    interp.setResult(tmp85);
                                } // End Invoke: llength
                                TclObject tmp86 = interp.getResult();
                                ExprValue tmp87 = evs0;
                                TJC.exprInitValue(interp, tmp87, tmp86);
                                ExprValue tmp88 = evs1;
                                tmp88.setIntValue(0);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp87, tmp88);
                                // End Binary operator: ==
                                boolean tmp89 = ( tmp87.getIntValue() != 0 );
                                if ( tmp89 ) {
                                    { // Invoke: set _descend($key,usage) 1
                                        TclObject tmp90;
                                        String tmp91;
                                        StringBuffer sbtmp92 = new StringBuffer(64);
                                        tmp90 = getVarScalar(interp, "key", compiledLocals, 0);
                                        sbtmp92.append(tmp90.toString());
                                        sbtmp92.append(",usage");
                                        tmp91 = sbtmp92.toString();
                                        setVarArray(interp, "_descend", tmp91, const3, compiledLocals, 1);
                                    } // End Invoke: set
                                    { // Invoke: return [...]
                                        { // Invoke: list listArg foreach "empty list arg"
                                            TclObject tmp93 = TclList.newInstance();
                                            try {
                                                TclList.append(interp, tmp93, const10);
                                                TclList.append(interp, tmp93, const5);
                                                TclList.append(interp, tmp93, const11);
                                            } catch (TclException ex) {
                                                tmp93.release();
                                                throw ex;
                                            }
                                            interp.setResult(tmp93);
                                        } // End Invoke: list
                                        if ( true ) { return; }
                                    } // End Invoke: return
                                }
                            }
                        } // End Invoke: if
                        { // Invoke: lappend ... $var_list_index $var_values_index
                            TclObject[] objv94 = TJC.grabObjv(interp, 2);
                            TclObject tmp95;
                            try {
                                // Arg 2 variable: $var_list_index
                                tmp95 = getVarScalar(interp, "var_list_index", compiledLocals, 11);
                                tmp95.preserve();
                                objv94[0] = tmp95;
                                // Arg 3 variable: $var_values_index
                                tmp95 = getVarScalar(interp, "var_values_index", compiledLocals, 12);
                                tmp95.preserve();
                                objv94[1] = tmp95;
                                interp.resetResult();
                                lappendVarScalar(interp, "varname_listname_list", objv94, compiledLocals, 8);
                            } finally {
                                TJC.releaseObjvElems(interp, objv94, 2);
                            }
                        } // End Invoke: lappend
                        } catch (TclException ex) {
                            int type = ex.getCompletionCode();
                            if (type == TCL.BREAK) {
                                break;
                            } else if (type == TCL.CONTINUE) {
                                continue;
                            } else {
                                throw ex;
                            }
                        }
                    }
                } // End Invoke: for
                { // Invoke: set "..." [...]
                    TclObject tmp96;
                    String tmp102;
                    StringBuffer sbtmp103 = new StringBuffer(64);
                    tmp96 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp103.append(tmp96.toString());
                    sbtmp103.append(",validated");
                    tmp102 = sbtmp103.toString();
                    { // Invoke: list $type $... [...]
                        TclObject tmp97 = TclList.newInstance();
                        TclObject tmp98;
                        try {
                            tmp98 = getVarScalar(interp, "type", compiledLocals, 7);
                            TclList.append(interp, tmp97, tmp98);
                            tmp98 = getVarScalar(interp, "varname_listname_list", compiledLocals, 8);
                            TclList.append(interp, tmp97, tmp98);
                            { // Invoke: expr ...
                                // Binary operator: $last_list_index + 1
                                TclObject tmp99 = getVarScalar(interp, "last_list_index", compiledLocals, 9);
                                ExprValue tmp100 = evs0;
                                TJC.exprInitValue(interp, tmp100, tmp99);
                                ExprValue tmp101 = evs1;
                                tmp101.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp100, tmp101);
                                // End Binary operator: +
                                TJC.exprSetResult(interp, tmp100);
                            } // End Invoke: expr
                            tmp98 = interp.getResult();
                            TclList.append(interp, tmp97, tmp98);
                        } catch (TclException ex) {
                            tmp97.release();
                            throw ex;
                        }
                        interp.setResult(tmp97);
                    } // End Invoke: list
                    tmp96 = interp.getResult();
                    tmp96 = setVarArray(interp, "_descend", tmp102, tmp96, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: if {$is_static} ...
            TclObject tmp104 = getVarScalar(interp, "is_static", compiledLocals, 5);
            boolean tmp105 = TJC.getBoolean(interp, tmp104);
            if ( tmp105 ) {
                { // Invoke: if ... ...
                    // Unary operator: ! [...]
                    { // Invoke: ... $key [...]
                        TclObject[] objv106 = TJC.grabObjv(interp, 3);
                        TclObject tmp107;
                        try {
                            // Arg 0 constant: ...
                            objv106[0] = const17;
                            // Arg 1 variable: $key
                            tmp107 = getVarScalar(interp, "key", compiledLocals, 0);
                            tmp107.preserve();
                            objv106[1] = tmp107;
                            // Arg 2 command: [...]
                            { // Invoke: lindex $... end
                                TclObject tmp108 = null;
                                TclObject tmp109;
                                try {
                                    StringBuffer sbtmp110 = new StringBuffer(64);
                                    tmp108 = getVarScalar(interp, "key", compiledLocals, 0);
                                    sbtmp110.append(tmp108.toString());
                                    sbtmp110.append(",validated");
                                    tmp108 = getVarArray(interp, "_descend", sbtmp110.toString(), compiledLocals, 1);
                                    tmp108.preserve();
                                    tmp109 = const18;
                                    TJC.lindexNonconst(interp, tmp108, tmp109);
                                } finally {
                                    if ( tmp108 != null ) {
                                        tmp108.release();
                                    }
                                }
                            } // End Invoke: lindex
                            tmp107 = interp.getResult();
                            tmp107.preserve();
                            objv106[2] = tmp107;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv106, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp107 = objv106[1];
                            if ( tmp107 != null ) {
                                tmp107.release();
                            }
                            tmp107 = objv106[2];
                            if ( tmp107 != null ) {
                                tmp107.release();
                            }
                            TJC.releaseObjv(interp, objv106, 3);
                        }
                    } // End Invoke: ...
                    TclObject tmp111 = interp.getResult();
                    ExprValue tmp112 = evs0;
                    if ( tmp111.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp112, tmp111);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp112, tmp111);
                    }
                    // End Unary operator: !
                    boolean tmp113 = ( tmp112.getIntValue() != 0 );
                    if ( tmp113 ) {
                        { // Invoke: set is_static 0
                            setVarScalar(interp, "is_static", const8, compiledLocals, 5);
                        } // End Invoke: set
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: if {$is_static} ...
            TclObject tmp114 = getVarScalar(interp, "is_static", compiledLocals, 5);
            boolean tmp115 = TJC.getBoolean(interp, tmp114);
            if ( tmp115 ) {
                { // Invoke: set "..." 1
                    TclObject tmp116;
                    String tmp117;
                    StringBuffer sbtmp118 = new StringBuffer(64);
                    tmp116 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp118.append(tmp116.toString());
                    sbtmp118.append(",static_container");
                    tmp117 = sbtmp118.toString();
                    setVarArray(interp, "_descend", tmp117, const3, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return "OK"
            interp.resetResult();
            interp.setResult(const19);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_foreach_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("numArgs");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("foreach");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("4, 6, 8, ...");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_container_foreach_varlist");
        const7.preserve(); const7.preserve();
        const8 = TclInteger.newInstance(0);
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("unknown");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("listArg");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("empty list arg");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("single");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("list");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("1 2");
        const14.preserve(); const14.preserve();
        const15 = TclInteger.newInstance(3);
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("multi");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("descend_container_argument_body_is_static");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("end");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("OK");
        const19.preserve(); const19.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "descend_container_foreach_varlist";
                break;
            }
            case 3: {
                cmdName = "descend_container_argument_body_is_static";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "num_args",
        "is_static",
        "varlist",
        "type",
        "varname_listname_list",
        "last_list_index",
        "i",
        "var_list_index",
        "var_values_index"
    };
} // end class DescendContainerForeachValidateCmd

