// TJC implementation of procedure descend_container_is_static
package tjc;
import tcl.lang.*;

public class DescendContainerIsStaticCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: return $...
            TclObject tmp0;
            StringBuffer sbtmp1 = new StringBuffer(64);
            tmp0 = getVarScalar(interp, "key", compiledLocals, 0);
            sbtmp1.append(tmp0.toString());
            sbtmp1.append(",static_container");
            tmp0 = getVarArray(interp, "_descend", sbtmp1.toString(), compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_is_static");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend"
    };
} // end class DescendContainerIsStaticCmd

