// TJC implementation of procedure descend_container_lsort_validate
package tjc;
import tcl.lang.*;

public class DescendContainerLsortValidateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 11, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        ExprValue evs3 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 1);
        } // End Invoke: global
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set num_args [...]
            TclObject tmp6;
            { // Invoke: llength $tree
                TclObject tmp7 = getVarScalar(interp, "tree", compiledLocals, 3);
                int tmp8 = TclList.getLength(interp, tmp7);
                interp.setResult(tmp8);
            } // End Invoke: llength
            tmp6 = interp.getResult();
            setVarScalar(interp, "num_args", tmp6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if {$num_args < 2} ...
            // Binary operator: $num_args < 2
            TclObject tmp9 = getVarScalar(interp, "num_args", compiledLocals, 4);
            ExprValue tmp10 = evs0;
            TJC.exprInitValue(interp, tmp10, tmp9);
            ExprValue tmp11 = evs1;
            tmp11.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp10, tmp11);
            // End Binary operator: <
            boolean tmp12 = ( tmp10.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: set _descend($key,usage) 1
                    TclObject tmp13;
                    String tmp14;
                    StringBuffer sbtmp15 = new StringBuffer(64);
                    tmp13 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp15.append(tmp13.toString());
                    sbtmp15.append(",usage");
                    tmp14 = sbtmp15.toString();
                    setVarArray(interp, "_descend", tmp14, const3, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: return [...]
                    { // Invoke: list numArgs "lsort" $num_args "2 or more"
                        TclObject tmp16 = TclList.newInstance();
                        TclObject tmp17;
                        try {
                            TclList.append(interp, tmp16, const4);
                            TclList.append(interp, tmp16, const5);
                            tmp17 = getVarScalar(interp, "num_args", compiledLocals, 4);
                            TclList.append(interp, tmp16, tmp17);
                            TclList.append(interp, tmp16, const6);
                        } catch (TclException ex) {
                            tmp16.release();
                            throw ex;
                        }
                        interp.setResult(tmp16);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set found_command_index -1
            setVarScalar(interp, "found_command_index", const7, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set ... -1
            setVarScalar(interp, "command_argument_index", const7, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: for {set i 1} {$i < $num_args} {incr i} ...
            { // Invoke: set i 1
                setVarScalar(interp, "i", const3, compiledLocals, 7);
            } // End Invoke: set
            for ( boolean skip23 = true ; true ; ) {
                if ( skip23 ) {
                    skip23 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 7);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $num_args
                TclObject tmp18 = getVarScalar(interp, "i", compiledLocals, 7);
                ExprValue tmp19 = evs0;
                TJC.exprInitValue(interp, tmp19, tmp18);
                TclObject tmp20 = getVarScalar(interp, "num_args", compiledLocals, 4);
                ExprValue tmp21 = evs1;
                TJC.exprInitValue(interp, tmp21, tmp20);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp19, tmp21);
                // End Binary operator: <
                boolean tmp22 = ( tmp19.getIntValue() != 0 );
                if ( ! tmp22 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set subtree [...]
                    TclObject tmp24;
                    { // Invoke: lindex $tree $i
                        TclObject tmp25 = null;
                        TclObject tmp26;
                        try {
                            tmp25 = getVarScalar(interp, "tree", compiledLocals, 3);
                            tmp25.preserve();
                            tmp26 = getVarScalar(interp, "i", compiledLocals, 7);
                            TJC.lindexNonconst(interp, tmp25, tmp26);
                        } finally {
                            if ( tmp25 != null ) {
                                tmp25.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp24 = interp.getResult();
                    setVarScalar(interp, "subtree", tmp24, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ...
                    { // Invoke: parse_is_simple_text $subtree
                        TclObject[] objv27 = TJC.grabObjv(interp, 2);
                        TclObject tmp28;
                        try {
                            // Arg 0 constant: parse_is_simple_text
                            objv27[0] = const8;
                            // Arg 1 variable: $subtree
                            tmp28 = getVarScalar(interp, "subtree", compiledLocals, 8);
                            tmp28.preserve();
                            objv27[1] = tmp28;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv27, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp28 = objv27[1];
                            if ( tmp28 != null ) {
                                tmp28.release();
                            }
                            TJC.releaseObjv(interp, objv27, 2);
                        }
                    } // End Invoke: parse_is_simple_text
                    TclObject tmp29 = interp.getResult();
                    ExprValue tmp30 = evs0;
                    TJC.exprInitValue(interp, tmp30, tmp29);
                    boolean tmp31 = tmp30.getBooleanValue(interp);
                    if ( tmp31 ) {
                        { // Invoke: set text [...]
                            TclObject tmp32;
                            { // Invoke: ... $script $subtree text
                                TclObject[] objv33 = TJC.grabObjv(interp, 4);
                                TclObject tmp34;
                                try {
                                    // Arg 0 constant: ...
                                    objv33[0] = const9;
                                    // Arg 1 variable: $script
                                    tmp34 = getVarScalar(interp, "script", compiledLocals, 2);
                                    tmp34.preserve();
                                    objv33[1] = tmp34;
                                    // Arg 2 variable: $subtree
                                    tmp34 = getVarScalar(interp, "subtree", compiledLocals, 8);
                                    tmp34.preserve();
                                    objv33[2] = tmp34;
                                    // Arg 3 constant: text
                                    objv33[3] = const10;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv33, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    tmp34 = objv33[1];
                                    if ( tmp34 != null ) {
                                        tmp34.release();
                                    }
                                    tmp34 = objv33[2];
                                    if ( tmp34 != null ) {
                                        tmp34.release();
                                    }
                                    TJC.releaseObjv(interp, objv33, 4);
                                }
                            } // End Invoke: ...
                            tmp32 = interp.getResult();
                            setVarScalar(interp, "text", tmp32, compiledLocals, 9);
                        } // End Invoke: set
                        { // Invoke: switch -exact -- $text {-c} - {-co} - {-com} - {-comm} - {-comma} - {-comman} - {-command} ...
                            TclObject tmp35 = getVarScalar(interp, "text", compiledLocals, 9);
                            String tmp36 = tmp35.toString();
                            int tmp36_length = tmp36.length();
                            char tmp36_first = '\n';
                            if ( tmp36_length > 0 ) {
                                tmp36_first = tmp36.charAt(0);
                            }
                            if ( ( tmp36_length == 2 && tmp36_first == '-'
                                    && tmp36.compareTo("-c") == 0 ) ||
                                ( tmp36_length == 3 && tmp36_first == '-'
                                    && tmp36.compareTo("-co") == 0 ) ||
                                ( tmp36_length == 4 && tmp36_first == '-'
                                    && tmp36.compareTo("-com") == 0 ) ||
                                ( tmp36_length == 5 && tmp36_first == '-'
                                    && tmp36.compareTo("-comm") == 0 ) ||
                                ( tmp36_length == 6 && tmp36_first == '-'
                                    && tmp36.compareTo("-comma") == 0 ) ||
                                ( tmp36_length == 7 && tmp36_first == '-'
                                    && tmp36.compareTo("-comman") == 0 ) ||
                                ( tmp36_length == 8 && tmp36_first == '-'
                                    && tmp36.compareTo("-command") == 0 ) ) {
                                // Pattern {-command}
                                { // Invoke: if ... ...
                                    // Binary operator: $found_command_index != ()
                                    TclObject tmp37 = getVarScalar(interp, "found_command_index", compiledLocals, 5);
                                    ExprValue tmp38 = evs0;
                                    TJC.exprInitValue(interp, tmp38, tmp37);
                                    // Unary operator: - 1
                                    ExprValue tmp39 = evs1;
                                    tmp39.setIntValue(-1);
                                    // End Unary operator: -
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp38, tmp39);
                                    // End Binary operator: !=
                                    boolean tmp40 = ( tmp38.getIntValue() != 0 );
                                    if ( tmp40 ) {
                                        { // Invoke: set _descend($key,usage) 1
                                            TclObject tmp41;
                                            String tmp42;
                                            StringBuffer sbtmp43 = new StringBuffer(64);
                                            tmp41 = getVarScalar(interp, "key", compiledLocals, 0);
                                            sbtmp43.append(tmp41.toString());
                                            sbtmp43.append(",usage");
                                            tmp42 = sbtmp43.toString();
                                            setVarArray(interp, "_descend", tmp42, const3, compiledLocals, 1);
                                        } // End Invoke: set
                                        { // Invoke: return [...]
                                            { // Invoke: list badOption "lsort" 1 $text
                                                TclObject tmp44 = TclList.newInstance();
                                                TclObject tmp45;
                                                try {
                                                    TclList.append(interp, tmp44, const11);
                                                    TclList.append(interp, tmp44, const5);
                                                    TclList.append(interp, tmp44, const3);
                                                    tmp45 = getVarScalar(interp, "text", compiledLocals, 9);
                                                    TclList.append(interp, tmp44, tmp45);
                                                } catch (TclException ex) {
                                                    tmp44.release();
                                                    throw ex;
                                                }
                                                interp.setResult(tmp44);
                                            } // End Invoke: list
                                            if ( true ) { return; }
                                        } // End Invoke: return
                                    }
                                } // End Invoke: if
                                { // Invoke: set found_command_index $i
                                    TclObject tmp46;
                                    tmp46 = getVarScalar(interp, "i", compiledLocals, 7);
                                    setVarScalar(interp, "found_command_index", tmp46, compiledLocals, 5);
                                } // End Invoke: set
                            }
                        } // End Invoke: switch
                        { // Invoke: if ... ...
                            // Binary operator: () && ()
                            // Binary operator: $found_command_index != ()
                            TclObject tmp47 = getVarScalar(interp, "found_command_index", compiledLocals, 5);
                            ExprValue tmp48 = evs0;
                            TJC.exprInitValue(interp, tmp48, tmp47);
                            // Unary operator: - 1
                            ExprValue tmp49 = evs1;
                            tmp49.setIntValue(-1);
                            // End Unary operator: -
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp48, tmp49);
                            // End Binary operator: !=
                            if (tmp48.getBooleanValue(interp)) {
                            // Binary operator: $found_command_index == ()
                            TclObject tmp50 = getVarScalar(interp, "found_command_index", compiledLocals, 5);
                            ExprValue tmp51 = evs1;
                            TJC.exprInitValue(interp, tmp51, tmp50);
                            // Binary operator: $i - 1
                            TclObject tmp52 = getVarScalar(interp, "i", compiledLocals, 7);
                            ExprValue tmp53 = evs2;
                            TJC.exprInitValue(interp, tmp53, tmp52);
                            ExprValue tmp54 = evs3;
                            tmp54.setIntValue(1);
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp53, tmp54);
                            // End Binary operator: -
                            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp51, tmp53);
                            // End Binary operator: ==
                            tmp48.setIntValue(tmp51.getBooleanValue(interp));
                            } else {
                            tmp48.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp55 = ( tmp48.getIntValue() != 0 );
                            if ( tmp55 ) {
                                { // Invoke: set ... $i
                                    TclObject tmp56;
                                    tmp56 = getVarScalar(interp, "i", compiledLocals, 7);
                                    setVarScalar(interp, "command_argument_index", tmp56, compiledLocals, 6);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: if ... ... else ...
            // Binary operator: $command_argument_index != ()
            TclObject tmp57 = getVarScalar(interp, "command_argument_index", compiledLocals, 6);
            ExprValue tmp58 = evs0;
            TJC.exprInitValue(interp, tmp58, tmp57);
            // Unary operator: - 1
            ExprValue tmp59 = evs1;
            tmp59.setIntValue(-1);
            // End Unary operator: -
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp58, tmp59);
            // End Binary operator: !=
            boolean tmp60 = ( tmp58.getIntValue() != 0 );
            if ( tmp60 ) {
                { // Invoke: set subtree [...]
                    TclObject tmp61;
                    { // Invoke: lindex $tree $...
                        TclObject tmp62 = null;
                        TclObject tmp63;
                        try {
                            tmp62 = getVarScalar(interp, "tree", compiledLocals, 3);
                            tmp62.preserve();
                            tmp63 = getVarScalar(interp, "command_argument_index", compiledLocals, 6);
                            TJC.lindexNonconst(interp, tmp62, tmp63);
                        } finally {
                            if ( tmp62 != null ) {
                                tmp62.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp61 = interp.getResult();
                    setVarScalar(interp, "subtree", tmp61, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    { // Invoke: parse_is_simple_text $subtree
                        TclObject[] objv64 = TJC.grabObjv(interp, 2);
                        TclObject tmp65;
                        try {
                            // Arg 0 constant: parse_is_simple_text
                            objv64[0] = const8;
                            // Arg 1 variable: $subtree
                            tmp65 = getVarScalar(interp, "subtree", compiledLocals, 8);
                            tmp65.preserve();
                            objv64[1] = tmp65;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv64, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp65 = objv64[1];
                            if ( tmp65 != null ) {
                                tmp65.release();
                            }
                            TJC.releaseObjv(interp, objv64, 2);
                        }
                    } // End Invoke: parse_is_simple_text
                    TclObject tmp66 = interp.getResult();
                    ExprValue tmp67 = evs0;
                    TJC.exprInitValue(interp, tmp67, tmp66);
                    boolean tmp68 = tmp67.getBooleanValue(interp);
                    if ( tmp68 ) {
                        { // Invoke: set static 1
                            setVarScalar(interp, "static", const3, compiledLocals, 10);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set static 0
                            setVarScalar(interp, "static", const12, compiledLocals, 10);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: set "..." $static
                    TclObject tmp69;
                    String tmp70;
                    StringBuffer sbtmp71 = new StringBuffer(64);
                    tmp69 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp71.append(tmp69.toString());
                    sbtmp71.append(",static_container");
                    tmp70 = sbtmp71.toString();
                    tmp69 = getVarScalar(interp, "static", compiledLocals, 10);
                    tmp69 = setVarArray(interp, "_descend", tmp70, tmp69, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: set "..." [...]
                    TclObject tmp72;
                    String tmp75;
                    StringBuffer sbtmp76 = new StringBuffer(64);
                    tmp72 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp76.append(tmp72.toString());
                    sbtmp76.append(",validated");
                    tmp75 = sbtmp76.toString();
                    { // Invoke: list $...
                        TclObject tmp73 = TclList.newInstance();
                        TclObject tmp74;
                        tmp74 = getVarScalar(interp, "command_argument_index", compiledLocals, 6);
                        TclList.append(interp, tmp73, tmp74);
                        interp.setResult(tmp73);
                    } // End Invoke: list
                    tmp72 = interp.getResult();
                    tmp72 = setVarArray(interp, "_descend", tmp75, tmp72, compiledLocals, 1);
                } // End Invoke: set
            } else {
                { // Invoke: set "..." 0
                    TclObject tmp77;
                    String tmp78;
                    StringBuffer sbtmp79 = new StringBuffer(64);
                    tmp77 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp79.append(tmp77.toString());
                    sbtmp79.append(",static_container");
                    tmp78 = sbtmp79.toString();
                    setVarArray(interp, "_descend", tmp78, const12, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: set "..." [...]
                    TclObject tmp80;
                    String tmp82;
                    StringBuffer sbtmp83 = new StringBuffer(64);
                    tmp80 = getVarScalar(interp, "key", compiledLocals, 0);
                    sbtmp83.append(tmp80.toString());
                    sbtmp83.append(",validated");
                    tmp82 = sbtmp83.toString();
                    { // Invoke: list {}
                        TclObject tmp81 = TclList.newInstance();
                        TclList.append(interp, tmp81, const13);
                        interp.setResult(tmp81);
                    } // End Invoke: list
                    tmp80 = interp.getResult();
                    tmp80 = setVarArray(interp, "_descend", tmp82, tmp80, compiledLocals, 1);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return "OK"
            interp.resetResult();
            interp.setResult(const14);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_lsort_validate");
        } finally {
            TJC.exprReleaseValue(interp, evs3);
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(1);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("numArgs");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("lsort");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("2 or more");
        const6.preserve(); const6.preserve();
        const7 = TclInteger.newInstance(-1);
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("parse_is_simple_text");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("parse_get_simple_text");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("text");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("badOption");
        const11.preserve(); const11.preserve();
        const12 = TclInteger.newInstance(0);
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("OK");
        const14.preserve(); const14.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 3: {
                cmdName = "parse_get_simple_text";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "_descend",
        "script",
        "tree",
        "num_args",
        "found_command_index",
        "command_argument_index",
        "i",
        "subtree",
        "text",
        "static"
    };
} // end class DescendContainerLsortValidateCmd

