// TJC implementation of procedure descend_container_switch_script_recreate
package tjc;
import tcl.lang.*;

public class DescendContainerSwitchScriptRecreateCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 40, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "script range");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "range", objv[2], compiledLocals, 1);
        { // Invoke: set range_start [...]
            TclObject tmp0;
            { // Invoke: lindex $range 0
                TclObject tmp1 = getVarScalar(interp, "range", compiledLocals, 1);
                tmp1 = TclList.index(interp, tmp1, 0);
                if ( tmp1 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp1);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "range_start", tmp0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set range_len [...]
            TclObject tmp2;
            { // Invoke: lindex $range 1
                TclObject tmp3 = getVarScalar(interp, "range", compiledLocals, 1);
                tmp3 = TclList.index(interp, tmp3, 1);
                if ( tmp3 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp3);
                }
            } // End Invoke: lindex
            tmp2 = interp.getResult();
            setVarScalar(interp, "range_len", tmp2, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set braced_range [...]
            TclObject tmp4;
            { // Invoke: list [...] [...]
                TclObject tmp5 = TclList.newInstance();
                TclObject tmp6;
                try {
                    { // Invoke: expr {$range_start - 1}
                        // Binary operator: $range_start - 1
                        TclObject tmp7 = getVarScalar(interp, "range_start", compiledLocals, 2);
                        ExprValue tmp8 = evs0;
                        TJC.exprInitValue(interp, tmp8, tmp7);
                        ExprValue tmp9 = evs1;
                        tmp9.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp8, tmp9);
                        // End Binary operator: -
                        TJC.exprSetResult(interp, tmp8);
                    } // End Invoke: expr
                    tmp6 = interp.getResult();
                    TclList.append(interp, tmp5, tmp6);
                    { // Invoke: expr {$range_len + 2}
                        // Binary operator: $range_len + 2
                        TclObject tmp10 = getVarScalar(interp, "range_len", compiledLocals, 3);
                        ExprValue tmp11 = evs0;
                        TJC.exprInitValue(interp, tmp11, tmp10);
                        ExprValue tmp12 = evs1;
                        tmp12.setIntValue(2);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp11, tmp12);
                        // End Binary operator: +
                        TJC.exprSetResult(interp, tmp11);
                    } // End Invoke: expr
                    tmp6 = interp.getResult();
                    TclList.append(interp, tmp5, tmp6);
                } catch (TclException ex) {
                    tmp5.release();
                    throw ex;
                }
                interp.setResult(tmp5);
            } // End Invoke: list
            tmp4 = interp.getResult();
            setVarScalar(interp, "braced_range", tmp4, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set braced_range_string [...]
            TclObject tmp13;
            { // Invoke: parse getstring $script $braced_range
                TclObject[] objv14 = TJC.grabObjv(interp, 4);
                TclObject tmp15;
                try {
                    // Arg 0 constant: parse
                    objv14[0] = const0;
                    // Arg 1 constant: getstring
                    objv14[1] = const1;
                    // Arg 2 variable: $script
                    tmp15 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp15.preserve();
                    objv14[2] = tmp15;
                    // Arg 3 variable: $braced_range
                    tmp15 = getVarScalar(interp, "braced_range", compiledLocals, 4);
                    tmp15.preserve();
                    objv14[3] = tmp15;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv14, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp15 = objv14[2];
                    if ( tmp15 != null ) {
                        tmp15.release();
                    }
                    tmp15 = objv14[3];
                    if ( tmp15 != null ) {
                        tmp15.release();
                    }
                    TJC.releaseObjv(interp, objv14, 4);
                }
            } // End Invoke: parse
            tmp13 = interp.getResult();
            setVarScalar(interp, "braced_range_string", tmp13, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: [...] != "{"
            { // Invoke: string index $braced_range_string 0
                TclObject tmp16 = getVarScalar(interp, "braced_range_string", compiledLocals, 5);
                String tmp17 = tmp16.toString();
                TclObject tmp18 = TJC.stringIndex(interp, tmp17, const2);
                interp.setResult(tmp18);
            } // End Invoke: string
            TclObject tmp19 = interp.getResult();
            boolean tmp20 = ! tmp19.toString().equals("{");
            ExprValue tmp21 = evs0;
            tmp21.setIntValue(tmp20);
            // End Binary operator: !=
            if (!tmp21.getBooleanValue(interp)) {
            // Binary operator: [...] != "}"
            { // Invoke: string index $braced_range_string end
                TclObject tmp22 = getVarScalar(interp, "braced_range_string", compiledLocals, 5);
                String tmp23 = tmp22.toString();
                TclObject tmp24 = TJC.stringIndex(interp, tmp23, const3);
                interp.setResult(tmp24);
            } // End Invoke: string
            TclObject tmp25 = interp.getResult();
            boolean tmp26 = ! tmp25.toString().equals("}");
            ExprValue tmp27 = evs1;
            tmp27.setIntValue(tmp26);
            // End Binary operator: !=
            tmp21.setIntValue(tmp27.getBooleanValue(interp));
            } else {
            tmp21.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp28 = ( tmp21.getIntValue() != 0 );
            if ( tmp28 ) {
                { // Invoke: error "..."
                    TclObject[] objv29 = TJC.grabObjv(interp, 2);
                    TclObject tmp30;
                    try {
                        // Arg 0 constant: error
                        objv29[0] = const4;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp31 = new StringBuffer(64);
                        sbtmp31.append("range ");
                        sbtmp31.append("{");
                        tmp30 = getVarScalar(interp, "braced_range", compiledLocals, 4);
                        sbtmp31.append(tmp30.toString());
                        sbtmp31.append("}");
                        sbtmp31.append(" is not a braced string");
                        tmp30 = TclString.newInstance(sbtmp31);
                        tmp30.preserve();
                        objv29[1] = tmp30;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv29, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp30 = objv29[1];
                        if ( tmp30 != null ) {
                            tmp30.release();
                        }
                        TJC.releaseObjv(interp, objv29, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set unbraced_script [...]
            TclObject tmp32;
            { // Invoke: parse getstring $script [...]
                TclObject[] objv33 = TJC.grabObjv(interp, 4);
                TclObject tmp34;
                try {
                    // Arg 0 constant: parse
                    objv33[0] = const0;
                    // Arg 1 constant: getstring
                    objv33[1] = const1;
                    // Arg 2 variable: $script
                    tmp34 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp34.preserve();
                    objv33[2] = tmp34;
                    // Arg 3 command: [...]
                    { // Invoke: list 0 [...]
                        TclObject tmp35 = TclList.newInstance();
                        TclObject tmp36;
                        try {
                            TclList.append(interp, tmp35, const2);
                            { // Invoke: expr {$range_start - 1}
                                // Binary operator: $range_start - 1
                                TclObject tmp37 = getVarScalar(interp, "range_start", compiledLocals, 2);
                                ExprValue tmp38 = evs0;
                                TJC.exprInitValue(interp, tmp38, tmp37);
                                ExprValue tmp39 = evs1;
                                tmp39.setIntValue(1);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp38, tmp39);
                                // End Binary operator: -
                                TJC.exprSetResult(interp, tmp38);
                            } // End Invoke: expr
                            tmp36 = interp.getResult();
                            TclList.append(interp, tmp35, tmp36);
                        } catch (TclException ex) {
                            tmp35.release();
                            throw ex;
                        }
                        interp.setResult(tmp35);
                    } // End Invoke: list
                    tmp34 = interp.getResult();
                    tmp34.preserve();
                    objv33[3] = tmp34;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv33, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp34 = objv33[2];
                    if ( tmp34 != null ) {
                        tmp34.release();
                    }
                    tmp34 = objv33[3];
                    if ( tmp34 != null ) {
                        tmp34.release();
                    }
                    TJC.releaseObjv(interp, objv33, 4);
                }
            } // End Invoke: parse
            tmp32 = interp.getResult();
            setVarScalar(interp, "unbraced_script", tmp32, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set extra_space 0
            setVarScalar(interp, "extra_space", const2, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set newlines_added 0
            setVarScalar(interp, "newlines_added", const2, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set patbody_str [...]
            TclObject tmp40;
            { // Invoke: parse getstring $script $range
                TclObject[] objv41 = TJC.grabObjv(interp, 4);
                TclObject tmp42;
                try {
                    // Arg 0 constant: parse
                    objv41[0] = const0;
                    // Arg 1 constant: getstring
                    objv41[1] = const1;
                    // Arg 2 variable: $script
                    tmp42 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp42.preserve();
                    objv41[2] = tmp42;
                    // Arg 3 variable: $range
                    tmp42 = getVarScalar(interp, "range", compiledLocals, 1);
                    tmp42.preserve();
                    objv41[3] = tmp42;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv41, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp42 = objv41[2];
                    if ( tmp42 != null ) {
                        tmp42.release();
                    }
                    tmp42 = objv41[3];
                    if ( tmp42 != null ) {
                        tmp42.release();
                    }
                    TJC.releaseObjv(interp, objv41, 4);
                }
            } // End Invoke: parse
            tmp40 = interp.getResult();
            setVarScalar(interp, "patbody_str", tmp40, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set no_bs_patbody_str [...]
            TclObject tmp43;
            { // Invoke: string map ... $patbody_str
                TclObject[] objv44 = TJC.grabObjv(interp, 4);
                TclObject tmp45;
                try {
                    // Arg 0 constant: string
                    objv44[0] = const5;
                    // Arg 1 constant: map
                    objv44[1] = const6;
                    // Arg 2 constant: ...
                    objv44[2] = const7;
                    // Arg 3 variable: $patbody_str
                    tmp45 = getVarScalar(interp, "patbody_str", compiledLocals, 9);
                    tmp45.preserve();
                    objv44[3] = tmp45;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv44, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp45 = objv44[3];
                    if ( tmp45 != null ) {
                        tmp45.release();
                    }
                    TJC.releaseObjv(interp, objv44, 4);
                }
            } // End Invoke: string
            tmp43 = interp.getResult();
            setVarScalar(interp, "no_bs_patbody_str", tmp43, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] < [...]
            { // Invoke: string length $no_bs_patbody_str
                TclObject tmp46 = getVarScalar(interp, "no_bs_patbody_str", compiledLocals, 10);
                int tmp47 = tmp46.toString().length();
                interp.setResult(tmp47);
            } // End Invoke: string
            TclObject tmp48 = interp.getResult();
            ExprValue tmp49 = evs0;
            TJC.exprInitValue(interp, tmp49, tmp48);
            { // Invoke: string length $patbody_str
                TclObject tmp50 = getVarScalar(interp, "patbody_str", compiledLocals, 9);
                int tmp51 = tmp50.toString().length();
                interp.setResult(tmp51);
            } // End Invoke: string
            TclObject tmp52 = interp.getResult();
            ExprValue tmp53 = evs1;
            TJC.exprInitValue(interp, tmp53, tmp52);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp49, tmp53);
            // End Binary operator: <
            boolean tmp54 = ( tmp49.getIntValue() != 0 );
            if ( tmp54 ) {
                { // Invoke: set patbody_str $no_bs_patbody_str
                    TclObject tmp55;
                    tmp55 = getVarScalar(interp, "no_bs_patbody_str", compiledLocals, 10);
                    setVarScalar(interp, "patbody_str", tmp55, compiledLocals, 9);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set list_ranges [...]
            TclObject tmp56;
            { // Invoke: parse list $patbody_str {0 end}
                TclObject[] objv57 = TJC.grabObjv(interp, 4);
                TclObject tmp58;
                try {
                    // Arg 0 constant: parse
                    objv57[0] = const0;
                    // Arg 1 constant: list
                    objv57[1] = const8;
                    // Arg 2 variable: $patbody_str
                    tmp58 = getVarScalar(interp, "patbody_str", compiledLocals, 9);
                    tmp58.preserve();
                    objv57[2] = tmp58;
                    // Arg 3 constant: {0 end}
                    objv57[3] = const9;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv57, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp58 = objv57[2];
                    if ( tmp58 != null ) {
                        tmp58.release();
                    }
                    TJC.releaseObjv(interp, objv57, 4);
                }
            } // End Invoke: parse
            tmp56 = interp.getResult();
            setVarScalar(interp, "list_ranges", tmp56, compiledLocals, 11);
        } // End Invoke: set
        { // Invoke: set len [...]
            TclObject tmp59;
            { // Invoke: llength $patbody_str
                TclObject tmp60 = getVarScalar(interp, "patbody_str", compiledLocals, 9);
                int tmp61 = TclList.getLength(interp, tmp60);
                interp.setResult(tmp61);
            } // End Invoke: llength
            tmp59 = interp.getResult();
            setVarScalar(interp, "len", tmp59, compiledLocals, 12);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] != $len
            { // Invoke: llength $list_ranges
                TclObject tmp62 = getVarScalar(interp, "list_ranges", compiledLocals, 11);
                int tmp63 = TclList.getLength(interp, tmp62);
                interp.setResult(tmp63);
            } // End Invoke: llength
            TclObject tmp64 = interp.getResult();
            ExprValue tmp65 = evs0;
            TJC.exprInitValue(interp, tmp65, tmp64);
            TclObject tmp66 = getVarScalar(interp, "len", compiledLocals, 12);
            ExprValue tmp67 = evs1;
            TJC.exprInitValue(interp, tmp67, tmp66);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp65, tmp67);
            // End Binary operator: !=
            boolean tmp68 = ( tmp65.getIntValue() != 0 );
            if ( tmp68 ) {
                { // Invoke: error "..."
                    TclObject[] objv69 = TJC.grabObjv(interp, 2);
                    TclObject tmp70;
                    try {
                        // Arg 0 constant: error
                        objv69[0] = const4;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp71 = new StringBuffer(64);
                        sbtmp71.append("num list_ranges (");
                        { // Invoke: llength $list_ranges
                            TclObject tmp72 = getVarScalar(interp, "list_ranges", compiledLocals, 11);
                            int tmp73 = TclList.getLength(interp, tmp72);
                            interp.setResult(tmp73);
                        } // End Invoke: llength
                        tmp70 = interp.getResult();
                        sbtmp71.append(tmp70.toString());
                        sbtmp71.append("]) != list length ");
                        tmp70 = getVarScalar(interp, "len", compiledLocals, 12);
                        sbtmp71.append(tmp70.toString());
                        tmp70 = TclString.newInstance(sbtmp71);
                        tmp70.preserve();
                        objv69[1] = tmp70;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv69, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp70 = objv69[1];
                        if ( tmp70 != null ) {
                            tmp70.release();
                        }
                        TJC.releaseObjv(interp, objv69, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$len == 0} ...
            // Binary operator: $len == 0
            TclObject tmp74 = getVarScalar(interp, "len", compiledLocals, 12);
            ExprValue tmp75 = evs0;
            TJC.exprInitValue(interp, tmp75, tmp74);
            ExprValue tmp76 = evs1;
            tmp76.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp75, tmp76);
            // End Binary operator: ==
            boolean tmp77 = ( tmp75.getIntValue() != 0 );
            if ( tmp77 ) {
                { // Invoke: error ...
                    TclObject[] objv78 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv78[0] = const4;
                        // Arg 1 constant: ...
                        objv78[1] = const10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv78, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv78, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {($len % 2) != 0} ...
            // Binary operator: () != 0
            // Binary operator: $len % 2
            TclObject tmp79 = getVarScalar(interp, "len", compiledLocals, 12);
            ExprValue tmp80 = evs0;
            TJC.exprInitValue(interp, tmp80, tmp79);
            ExprValue tmp81 = evs1;
            tmp81.setIntValue(2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MOD, tmp80, tmp81);
            // End Binary operator: %
            ExprValue tmp82 = evs1;
            tmp82.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp80, tmp82);
            // End Binary operator: !=
            boolean tmp83 = ( tmp80.getIntValue() != 0 );
            if ( tmp83 ) {
                { // Invoke: error "..."
                    TclObject[] objv84 = TJC.grabObjv(interp, 2);
                    TclObject tmp85;
                    try {
                        // Arg 0 constant: error
                        objv84[0] = const4;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp86 = new StringBuffer(64);
                        sbtmp86.append("expected even length for patbody list, got ");
                        tmp85 = getVarScalar(interp, "len", compiledLocals, 12);
                        sbtmp86.append(tmp85.toString());
                        tmp85 = TclString.newInstance(sbtmp86);
                        tmp85.preserve();
                        objv84[1] = tmp85;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv84, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp85 = objv84[1];
                        if ( tmp85 != null ) {
                            tmp85.release();
                        }
                        TJC.releaseObjv(interp, objv84, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set is_pattern 1
            setVarScalar(interp, "is_pattern", const11, compiledLocals, 13);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $len} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const2, compiledLocals, 14);
            } // End Invoke: set
            for ( boolean skip92 = true ; true ; ) {
                if ( skip92 ) {
                    skip92 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 14);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $len
                TclObject tmp87 = getVarScalar(interp, "i", compiledLocals, 14);
                ExprValue tmp88 = evs0;
                TJC.exprInitValue(interp, tmp88, tmp87);
                TclObject tmp89 = getVarScalar(interp, "len", compiledLocals, 12);
                ExprValue tmp90 = evs1;
                TJC.exprInitValue(interp, tmp90, tmp89);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp88, tmp90);
                // End Binary operator: <
                boolean tmp91 = ( tmp88.getIntValue() != 0 );
                if ( ! tmp91 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set list_range [...]
                    TclObject tmp93;
                    { // Invoke: lindex $list_ranges $i
                        TclObject tmp94 = null;
                        TclObject tmp95;
                        try {
                            tmp94 = getVarScalar(interp, "list_ranges", compiledLocals, 11);
                            tmp94.preserve();
                            tmp95 = getVarScalar(interp, "i", compiledLocals, 14);
                            TJC.lindexNonconst(interp, tmp94, tmp95);
                        } finally {
                            if ( tmp94 != null ) {
                                tmp94.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp93 = interp.getResult();
                    setVarScalar(interp, "list_range", tmp93, compiledLocals, 15);
                } // End Invoke: set
                { // Invoke: set str [...]
                    TclObject tmp96;
                    { // Invoke: parse getstring $patbody_str $list_range
                        TclObject[] objv97 = TJC.grabObjv(interp, 4);
                        TclObject tmp98;
                        try {
                            // Arg 0 constant: parse
                            objv97[0] = const0;
                            // Arg 1 constant: getstring
                            objv97[1] = const1;
                            // Arg 2 variable: $patbody_str
                            tmp98 = getVarScalar(interp, "patbody_str", compiledLocals, 9);
                            tmp98.preserve();
                            objv97[2] = tmp98;
                            // Arg 3 variable: $list_range
                            tmp98 = getVarScalar(interp, "list_range", compiledLocals, 15);
                            tmp98.preserve();
                            objv97[3] = tmp98;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv97, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp98 = objv97[2];
                            if ( tmp98 != null ) {
                                tmp98.release();
                            }
                            tmp98 = objv97[3];
                            if ( tmp98 != null ) {
                                tmp98.release();
                            }
                            TJC.releaseObjv(interp, objv97, 4);
                        }
                    } // End Invoke: parse
                    tmp96 = interp.getResult();
                    setVarScalar(interp, "str", tmp96, compiledLocals, 16);
                } // End Invoke: set
                { // Invoke: set lstr [...]
                    TclObject tmp99;
                    { // Invoke: lindex $patbody_str $i
                        TclObject tmp100 = null;
                        TclObject tmp101;
                        try {
                            tmp100 = getVarScalar(interp, "patbody_str", compiledLocals, 9);
                            tmp100.preserve();
                            tmp101 = getVarScalar(interp, "i", compiledLocals, 14);
                            TJC.lindexNonconst(interp, tmp100, tmp101);
                        } finally {
                            if ( tmp100 != null ) {
                                tmp100.release();
                            }
                        }
                    } // End Invoke: lindex
                    tmp99 = interp.getResult();
                    setVarScalar(interp, "lstr", tmp99, compiledLocals, 17);
                } // End Invoke: set
                { // Invoke: set first [...]
                    TclObject tmp102;
                    { // Invoke: string index $str 0
                        TclObject tmp103 = getVarScalar(interp, "str", compiledLocals, 16);
                        String tmp104 = tmp103.toString();
                        TclObject tmp105 = TJC.stringIndex(interp, tmp104, const2);
                        interp.setResult(tmp105);
                    } // End Invoke: string
                    tmp102 = interp.getResult();
                    setVarScalar(interp, "first", tmp102, compiledLocals, 18);
                } // End Invoke: set
                { // Invoke: set last [...]
                    TclObject tmp106;
                    { // Invoke: string index $str end
                        TclObject tmp107 = getVarScalar(interp, "str", compiledLocals, 16);
                        String tmp108 = tmp107.toString();
                        TclObject tmp109 = TJC.stringIndex(interp, tmp108, const3);
                        interp.setResult(tmp109);
                    } // End Invoke: string
                    tmp106 = interp.getResult();
                    setVarScalar(interp, "last", tmp106, compiledLocals, 19);
                } // End Invoke: set
                { // Invoke: if ... ... elseif ... ... elseif ... ... else ...
                    // Binary operator: () || ()
                    // Binary operator: $is_pattern && ()
                    TclObject tmp110 = getVarScalar(interp, "is_pattern", compiledLocals, 13);
                    ExprValue tmp111 = evs0;
                    TJC.exprInitValue(interp, tmp111, tmp110);
                    if (tmp111.getBooleanValue(interp)) {
                    // Binary operator: $str == "default"
                    TclObject tmp112 = getVarScalar(interp, "str", compiledLocals, 16);
                    boolean tmp113 = tmp112.toString().equals("default");
                    ExprValue tmp114 = evs1;
                    tmp114.setIntValue(tmp113);
                    // End Binary operator: ==
                    tmp111.setIntValue(tmp114.getBooleanValue(interp));
                    } else {
                    tmp111.setIntValue(0);
                    } // End if: $is_pattern
                    // End Binary operator: &&
                    if (!tmp111.getBooleanValue(interp)) {
                    // Binary operator: () && ()
                    // Unary operator: ! $is_pattern
                    TclObject tmp115 = getVarScalar(interp, "is_pattern", compiledLocals, 13);
                    ExprValue tmp116 = evs1;
                    if ( tmp115.isIntType() ) {
                        TJC.exprUnaryNotOperatorKnownInt(tmp116, tmp115);
                    } else {
                        TJC.exprUnaryNotOperator(interp, tmp116, tmp115);
                    }
                    // End Unary operator: !
                    if (tmp116.getBooleanValue(interp)) {
                    // Binary operator: $str == "-"
                    TclObject tmp117 = getVarScalar(interp, "str", compiledLocals, 16);
                    boolean tmp118 = tmp117.toString().equals("-");
                    ExprValue tmp119 = evs2;
                    tmp119.setIntValue(tmp118);
                    // End Binary operator: ==
                    tmp116.setIntValue(tmp119.getBooleanValue(interp));
                    } else {
                    tmp116.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    tmp111.setIntValue(tmp116.getBooleanValue(interp));
                    } else {
                    tmp111.setIntValue(1);
                    } // End if: !()
                    // End Binary operator: ||
                    boolean tmp120 = ( tmp111.getIntValue() != 0 );
                    if ( tmp120 ) {
                        { // Invoke: set unquoted_str $str
                            TclObject tmp121;
                            tmp121 = getVarScalar(interp, "str", compiledLocals, 16);
                            setVarScalar(interp, "unquoted_str", tmp121, compiledLocals, 20);
                        } // End Invoke: set
                        { // Invoke: set quoted_str $str
                            TclObject tmp122;
                            tmp122 = getVarScalar(interp, "str", compiledLocals, 16);
                            setVarScalar(interp, "quoted_str", tmp122, compiledLocals, 21);
                        } // End Invoke: set
                    } else {
                        // Binary operator: () && ()
                        // Binary operator: $first == "\""
                        TclObject tmp123 = getVarScalar(interp, "first", compiledLocals, 18);
                        boolean tmp124 = tmp123.toString().equals("\"");
                        ExprValue tmp125 = evs0;
                        tmp125.setIntValue(tmp124);
                        // End Binary operator: ==
                        if (tmp125.getBooleanValue(interp)) {
                        // Binary operator: $last == "\""
                        TclObject tmp126 = getVarScalar(interp, "last", compiledLocals, 19);
                        boolean tmp127 = tmp126.toString().equals("\"");
                        ExprValue tmp128 = evs1;
                        tmp128.setIntValue(tmp127);
                        // End Binary operator: ==
                        tmp125.setIntValue(tmp128.getBooleanValue(interp));
                        } else {
                        tmp125.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp129 = ( tmp125.getIntValue() != 0 );
                        if ( tmp129 ) {
                            { // Invoke: set unquoted_str [...]
                                TclObject tmp130;
                                { // Invoke: string range $str 1 end-1
                                    TclObject tmp131 = getVarScalar(interp, "str", compiledLocals, 16);
                                    String tmp132 = tmp131.toString();
                                    TclObject tmp133 = const11;
                                    tmp133.preserve();
                                    TclObject tmp134 = const12;
                                    TclObject tmp135 = TJC.stringRange(interp, tmp132, tmp133, tmp134);
                                    interp.setResult(tmp135);
                                } // End Invoke: string
                                tmp130 = interp.getResult();
                                setVarScalar(interp, "unquoted_str", tmp130, compiledLocals, 20);
                            } // End Invoke: set
                            { // Invoke: set quoted_str $str
                                TclObject tmp136;
                                tmp136 = getVarScalar(interp, "str", compiledLocals, 16);
                                setVarScalar(interp, "quoted_str", tmp136, compiledLocals, 21);
                            } // End Invoke: set
                        } else {
                            // Binary operator: () && ()
                            // Binary operator: $first == "{"
                            TclObject tmp137 = getVarScalar(interp, "first", compiledLocals, 18);
                            boolean tmp138 = tmp137.toString().equals("{");
                            ExprValue tmp139 = evs0;
                            tmp139.setIntValue(tmp138);
                            // End Binary operator: ==
                            if (tmp139.getBooleanValue(interp)) {
                            // Binary operator: $last == "}"
                            TclObject tmp140 = getVarScalar(interp, "last", compiledLocals, 19);
                            boolean tmp141 = tmp140.toString().equals("}");
                            ExprValue tmp142 = evs1;
                            tmp142.setIntValue(tmp141);
                            // End Binary operator: ==
                            tmp139.setIntValue(tmp142.getBooleanValue(interp));
                            } else {
                            tmp139.setIntValue(0);
                            } // End if: ()
                            // End Binary operator: &&
                            boolean tmp143 = ( tmp139.getIntValue() != 0 );
                            if ( tmp143 ) {
                                { // Invoke: set unquoted_str [...]
                                    TclObject tmp144;
                                    { // Invoke: string range $str 1 end-1
                                        TclObject tmp145 = getVarScalar(interp, "str", compiledLocals, 16);
                                        String tmp146 = tmp145.toString();
                                        TclObject tmp147 = const11;
                                        tmp147.preserve();
                                        TclObject tmp148 = const12;
                                        TclObject tmp149 = TJC.stringRange(interp, tmp146, tmp147, tmp148);
                                        interp.setResult(tmp149);
                                    } // End Invoke: string
                                    tmp144 = interp.getResult();
                                    setVarScalar(interp, "unquoted_str", tmp144, compiledLocals, 20);
                                } // End Invoke: set
                                { // Invoke: set quoted_str $str
                                    TclObject tmp150;
                                    tmp150 = getVarScalar(interp, "str", compiledLocals, 16);
                                    setVarScalar(interp, "quoted_str", tmp150, compiledLocals, 21);
                                } // End Invoke: set
                            } else {
                                { // Invoke: set unquoted_str $str
                                    TclObject tmp151;
                                    tmp151 = getVarScalar(interp, "str", compiledLocals, 16);
                                    setVarScalar(interp, "unquoted_str", tmp151, compiledLocals, 20);
                                } // End Invoke: set
                                { // Invoke: set quoted_str ...
                                    TclObject tmp152;
                                    StringBuffer sbtmp153 = new StringBuffer(64);
                                    sbtmp153.append("\"");
                                    tmp152 = getVarScalar(interp, "str", compiledLocals, 16);
                                    sbtmp153.append(tmp152.toString());
                                    sbtmp153.append("\"");
                                    tmp152 = TclString.newInstance(sbtmp153);
                                    setVarScalar(interp, "quoted_str", tmp152, compiledLocals, 21);
                                } // End Invoke: set
                            }
                        }
                    }
                } // End Invoke: if
                { // Invoke: set first [...]
                    TclObject tmp154;
                    { // Invoke: string index $quoted_str 0
                        TclObject tmp155 = getVarScalar(interp, "quoted_str", compiledLocals, 21);
                        String tmp156 = tmp155.toString();
                        TclObject tmp157 = TJC.stringIndex(interp, tmp156, const2);
                        interp.setResult(tmp157);
                    } // End Invoke: string
                    tmp154 = interp.getResult();
                    setVarScalar(interp, "first", tmp154, compiledLocals, 18);
                } // End Invoke: set
                { // Invoke: set last [...]
                    TclObject tmp158;
                    { // Invoke: string index $quoted_str end
                        TclObject tmp159 = getVarScalar(interp, "quoted_str", compiledLocals, 21);
                        String tmp160 = tmp159.toString();
                        TclObject tmp161 = TJC.stringIndex(interp, tmp160, const3);
                        interp.setResult(tmp161);
                    } // End Invoke: string
                    tmp158 = interp.getResult();
                    setVarScalar(interp, "last", tmp158, compiledLocals, 19);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: () && ()
                    // Binary operator: $first == "\""
                    TclObject tmp162 = getVarScalar(interp, "first", compiledLocals, 18);
                    boolean tmp163 = tmp162.toString().equals("\"");
                    ExprValue tmp164 = evs0;
                    tmp164.setIntValue(tmp163);
                    // End Binary operator: ==
                    if (tmp164.getBooleanValue(interp)) {
                    // Binary operator: $last == "\""
                    TclObject tmp165 = getVarScalar(interp, "last", compiledLocals, 19);
                    boolean tmp166 = tmp165.toString().equals("\"");
                    ExprValue tmp167 = evs1;
                    tmp167.setIntValue(tmp166);
                    // End Binary operator: ==
                    tmp164.setIntValue(tmp167.getBooleanValue(interp));
                    } else {
                    tmp164.setIntValue(0);
                    } // End if: ()
                    // End Binary operator: &&
                    boolean tmp168 = ( tmp164.getIntValue() != 0 );
                    if ( tmp168 ) {
                        { // Invoke: set bs_subst_str [...]
                            TclObject tmp169;
                            { // Invoke: subst -nocommands -novariables $unquoted_str
                                TclObject[] objv170 = TJC.grabObjv(interp, 4);
                                TclObject tmp171;
                                try {
                                    // Arg 0 constant: subst
                                    objv170[0] = const13;
                                    // Arg 1 constant: -nocommands
                                    objv170[1] = const14;
                                    // Arg 2 constant: -novariables
                                    objv170[2] = const15;
                                    // Arg 3 variable: $unquoted_str
                                    tmp171 = getVarScalar(interp, "unquoted_str", compiledLocals, 20);
                                    tmp171.preserve();
                                    objv170[3] = tmp171;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv170, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp171 = objv170[3];
                                    if ( tmp171 != null ) {
                                        tmp171.release();
                                    }
                                    TJC.releaseObjv(interp, objv170, 4);
                                }
                            } // End Invoke: subst
                            tmp169 = interp.getResult();
                            setVarScalar(interp, "bs_subst_str", tmp169, compiledLocals, 22);
                        } // End Invoke: set
                        { // Invoke: if ... ... else ...
                            { // Invoke: string equal $unquoted_str $bs_subst_str
                                TclObject tmp172 = getVarScalar(interp, "unquoted_str", compiledLocals, 20);
                                String tmp173 = tmp172.toString();
                                TclObject tmp174 = getVarScalar(interp, "bs_subst_str", compiledLocals, 22);
                                String tmp175 = tmp174.toString();
                                boolean tmp176 = tmp173.equals(tmp175);
                                interp.setResult(tmp176);
                            } // End Invoke: string
                            TclObject tmp177 = interp.getResult();
                            ExprValue tmp178 = evs0;
                            TJC.exprInitValue(interp, tmp178, tmp177);
                            boolean tmp179 = tmp178.getBooleanValue(interp);
                            if ( tmp179 ) {
                                { // Invoke: set quoted_str ...
                                    TclObject tmp180;
                                    StringBuffer sbtmp181 = new StringBuffer(64);
                                    sbtmp181.append("{");
                                    tmp180 = getVarScalar(interp, "unquoted_str", compiledLocals, 20);
                                    sbtmp181.append(tmp180.toString());
                                    sbtmp181.append("}");
                                    tmp180 = TclString.newInstance(sbtmp181);
                                    setVarScalar(interp, "quoted_str", tmp180, compiledLocals, 21);
                                } // End Invoke: set
                            } else {
                                { // Invoke: if ... ...
                                    // Unary operator: ! [...]
                                    { // Invoke: string equal $bs_subst_str $lstr
                                        TclObject tmp182 = getVarScalar(interp, "bs_subst_str", compiledLocals, 22);
                                        String tmp183 = tmp182.toString();
                                        TclObject tmp184 = getVarScalar(interp, "lstr", compiledLocals, 17);
                                        String tmp185 = tmp184.toString();
                                        boolean tmp186 = tmp183.equals(tmp185);
                                        interp.setResult(tmp186);
                                    } // End Invoke: string
                                    TclObject tmp187 = interp.getResult();
                                    ExprValue tmp188 = evs0;
                                    if ( tmp187.isIntType() ) {
                                        TJC.exprUnaryNotOperatorKnownInt(tmp188, tmp187);
                                    } else {
                                        TJC.exprUnaryNotOperator(interp, tmp188, tmp187);
                                    }
                                    // End Unary operator: !
                                    boolean tmp189 = ( tmp188.getIntValue() != 0 );
                                    if ( tmp189 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv190 = TJC.grabObjv(interp, 2);
                                            TclObject tmp191;
                                            try {
                                                // Arg 0 constant: error
                                                objv190[0] = const4;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp192 = new StringBuffer(64);
                                                sbtmp192.append("bs_subst_str (1) ->");
                                                tmp191 = getVarScalar(interp, "bs_subst_str", compiledLocals, 22);
                                                sbtmp192.append(tmp191.toString());
                                                sbtmp192.append("<- != list index ->");
                                                tmp191 = getVarScalar(interp, "lstr", compiledLocals, 17);
                                                sbtmp192.append(tmp191.toString());
                                                sbtmp192.append("<-");
                                                tmp191 = TclString.newInstance(sbtmp192);
                                                tmp191.preserve();
                                                objv190[1] = tmp191;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                    ? cmdcache2.cmd : null), objv190, 0);
                                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                    updateCmdCache(interp, 2);
                                                }
                                            } finally {
                                                tmp191 = objv190[1];
                                                if ( tmp191 != null ) {
                                                    tmp191.release();
                                                }
                                                TJC.releaseObjv(interp, objv190, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: set bs_subst_only ""
                                    setVarScalar(interp, "bs_subst_only", const16, compiledLocals, 23);
                                } // End Invoke: set
                                { // Invoke: set last_bs 0
                                    setVarScalar(interp, "last_bs", const2, compiledLocals, 24);
                                } // End Invoke: set
                                { // Invoke: set unquoted_str_len [...]
                                    TclObject tmp193;
                                    { // Invoke: string length $unquoted_str
                                        TclObject tmp194 = getVarScalar(interp, "unquoted_str", compiledLocals, 20);
                                        int tmp195 = tmp194.toString().length();
                                        interp.setResult(tmp195);
                                    } // End Invoke: string
                                    tmp193 = interp.getResult();
                                    setVarScalar(interp, "unquoted_str_len", tmp193, compiledLocals, 25);
                                } // End Invoke: set
                                { // Invoke: for {set ind 0} ... {incr ind} ...
                                    { // Invoke: set ind 0
                                        setVarScalar(interp, "ind", const2, compiledLocals, 26);
                                    } // End Invoke: set
                                    for ( boolean skip201 = true ; true ; ) {
                                        if ( skip201 ) {
                                            skip201 = false;
                                        } else {
                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: incr ind
                                                interp.resetResult();
                                                incrVarScalar(interp, "ind", 1, compiledLocals, 26);
                                            } // End Invoke: incr
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }

                                        // Binary operator: $ind < $unquoted_str_len
                                        TclObject tmp196 = getVarScalar(interp, "ind", compiledLocals, 26);
                                        ExprValue tmp197 = evs0;
                                        TJC.exprInitValue(interp, tmp197, tmp196);
                                        TclObject tmp198 = getVarScalar(interp, "unquoted_str_len", compiledLocals, 25);
                                        ExprValue tmp199 = evs1;
                                        TJC.exprInitValue(interp, tmp199, tmp198);
                                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp197, tmp199);
                                        // End Binary operator: <
                                        boolean tmp200 = ( tmp197.getIntValue() != 0 );
                                        if ( ! tmp200 ) { break; }

                                        try {
                                        if ( false ) { throw (TclException) null; }
                                        { // Invoke: set c [...]
                                            TclObject tmp202;
                                            { // Invoke: string index $unquoted_str $ind
                                                TclObject tmp203 = getVarScalar(interp, "unquoted_str", compiledLocals, 20);
                                                String tmp204 = tmp203.toString();
                                                TclObject tmp205 = getVarScalar(interp, "ind", compiledLocals, 26);
                                                TclObject tmp206 = TJC.stringIndex(interp, tmp204, tmp205);
                                                interp.setResult(tmp206);
                                            } // End Invoke: string
                                            tmp202 = interp.getResult();
                                            setVarScalar(interp, "c", tmp202, compiledLocals, 27);
                                        } // End Invoke: set
                                        { // Invoke: switch -exact -- $c {$} - {[} - {]} ... ... ... default ...
                                            TclObject tmp207 = getVarScalar(interp, "c", compiledLocals, 27);
                                            String tmp208 = tmp207.toString();
                                            int tmp208_length = tmp208.length();
                                            char tmp208_first = '\n';
                                            if ( tmp208_length > 0 ) {
                                                tmp208_first = tmp208.charAt(0);
                                            }
                                            if ( ( tmp208_length == 1 && tmp208_first == '$' ) ||
                                                ( tmp208_length == 1 && tmp208_first == '[' ) ||
                                                ( tmp208_length == 1 && tmp208_first == ']' ) ) {
                                                // Pattern {]}
                                                { // Invoke: if {$last_bs} ... else ...
                                                    TclObject tmp209 = getVarScalar(interp, "last_bs", compiledLocals, 24);
                                                    boolean tmp210 = TJC.getBoolean(interp, tmp209);
                                                    if ( tmp210 ) {
                                                        { // Invoke: append bs_subst_only $c
                                                            TclObject[] objv211 = TJC.grabObjv(interp, 1);
                                                            TclObject tmp212;
                                                            try {
                                                                // Arg 2 variable: $c
                                                                tmp212 = getVarScalar(interp, "c", compiledLocals, 27);
                                                                tmp212.preserve();
                                                                objv211[0] = tmp212;
                                                                interp.resetResult();
                                                                appendVarScalar(interp, "bs_subst_only", objv211, compiledLocals, 23);
                                                            } finally {
                                                                TJC.releaseObjvElems(interp, objv211, 1);
                                                            }
                                                        } // End Invoke: append
                                                    } else {
                                                        { // Invoke: append bs_subst_only ... $c
                                                            TclObject[] objv213 = TJC.grabObjv(interp, 2);
                                                            TclObject tmp214;
                                                            try {
                                                                // Arg 2 constant: ...
                                                                objv213[0] = const17;
                                                                // Arg 3 variable: $c
                                                                tmp214 = getVarScalar(interp, "c", compiledLocals, 27);
                                                                tmp214.preserve();
                                                                objv213[1] = tmp214;
                                                                interp.resetResult();
                                                                appendVarScalar(interp, "bs_subst_only", objv213, compiledLocals, 23);
                                                            } finally {
                                                                tmp214 = objv213[1];
                                                                if ( tmp214 != null ) {
                                                                    tmp214.release();
                                                                }
                                                                TJC.releaseObjv(interp, objv213, 2);
                                                            }
                                                        } // End Invoke: append
                                                    }
                                                } // End Invoke: if
                                                { // Invoke: set last_bs 0
                                                    setVarScalar(interp, "last_bs", const2, compiledLocals, 24);
                                                } // End Invoke: set
                                            } else if ( tmp208_length == 1 && tmp208_first == '\\' ) {
                                                // Pattern ...
                                                { // Invoke: append bs_subst_only $c
                                                    TclObject[] objv215 = TJC.grabObjv(interp, 1);
                                                    TclObject tmp216;
                                                    try {
                                                        // Arg 2 variable: $c
                                                        tmp216 = getVarScalar(interp, "c", compiledLocals, 27);
                                                        tmp216.preserve();
                                                        objv215[0] = tmp216;
                                                        interp.resetResult();
                                                        appendVarScalar(interp, "bs_subst_only", objv215, compiledLocals, 23);
                                                    } finally {
                                                        TJC.releaseObjvElems(interp, objv215, 1);
                                                    }
                                                } // End Invoke: append
                                                { // Invoke: if {$last_bs} ... else ...
                                                    TclObject tmp217 = getVarScalar(interp, "last_bs", compiledLocals, 24);
                                                    boolean tmp218 = TJC.getBoolean(interp, tmp217);
                                                    if ( tmp218 ) {
                                                        { // Invoke: set last_bs 0
                                                            setVarScalar(interp, "last_bs", const2, compiledLocals, 24);
                                                        } // End Invoke: set
                                                    } else {
                                                        { // Invoke: set last_bs 1
                                                            setVarScalar(interp, "last_bs", const11, compiledLocals, 24);
                                                        } // End Invoke: set
                                                    }
                                                } // End Invoke: if
                                            } else {
                                                // Pattern default
                                                { // Invoke: append bs_subst_only $c
                                                    TclObject[] objv219 = TJC.grabObjv(interp, 1);
                                                    TclObject tmp220;
                                                    try {
                                                        // Arg 2 variable: $c
                                                        tmp220 = getVarScalar(interp, "c", compiledLocals, 27);
                                                        tmp220.preserve();
                                                        objv219[0] = tmp220;
                                                        interp.resetResult();
                                                        appendVarScalar(interp, "bs_subst_only", objv219, compiledLocals, 23);
                                                    } finally {
                                                        TJC.releaseObjvElems(interp, objv219, 1);
                                                    }
                                                } // End Invoke: append
                                                { // Invoke: set last_bs 0
                                                    setVarScalar(interp, "last_bs", const2, compiledLocals, 24);
                                                } // End Invoke: set
                                            }
                                        } // End Invoke: switch
                                        } catch (TclException ex) {
                                            int type = ex.getCompletionCode();
                                            if (type == TCL.BREAK) {
                                                break;
                                            } else if (type == TCL.CONTINUE) {
                                                continue;
                                            } else {
                                                throw ex;
                                            }
                                        }
                                    }
                                } // End Invoke: for
                                { // Invoke: if ... ...
                                    { // Invoke: catch ... err
                                        int code221 = TCL.OK;
                                        try {
                                        if ( false ) { throw (TclException) null; }
                                        { // Invoke: parse command ... {0 end}
                                            TclObject[] objv222 = TJC.grabObjv(interp, 4);
                                            TclObject tmp223;
                                            try {
                                                // Arg 0 constant: parse
                                                objv222[0] = const0;
                                                // Arg 1 constant: command
                                                objv222[1] = const18;
                                                // Arg 2 word: ...
                                                StringBuffer sbtmp224 = new StringBuffer(64);
                                                sbtmp224.append("\"");
                                                tmp223 = getVarScalar(interp, "bs_subst_only", compiledLocals, 23);
                                                sbtmp224.append(tmp223.toString());
                                                sbtmp224.append("\"");
                                                tmp223 = TclString.newInstance(sbtmp224);
                                                tmp223.preserve();
                                                objv222[2] = tmp223;
                                                // Arg 3 constant: {0 end}
                                                objv222[3] = const9;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                    ? cmdcache1.cmd : null), objv222, 0);
                                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                    updateCmdCache(interp, 1);
                                                }
                                            } finally {
                                                tmp223 = objv222[2];
                                                if ( tmp223 != null ) {
                                                    tmp223.release();
                                                }
                                                TJC.releaseObjv(interp, objv222, 4);
                                            }
                                        } // End Invoke: parse
                                        } catch (TclException ex) {
                                            code221 = ex.getCompletionCode();
                                        }
                                        TclObject result = interp.getResult();
                                        try {
                                            setVarScalar(interp, "err", result, compiledLocals, 28);
                                        } catch (TclException ex) {
                                            TJC.catchVarErr(interp);
                                        }
                                        interp.resetResult();
                                        interp.setResult(code221);
                                    } // End Invoke: catch
                                    TclObject tmp225 = interp.getResult();
                                    ExprValue tmp226 = evs0;
                                    TJC.exprInitValue(interp, tmp226, tmp225);
                                    boolean tmp227 = tmp226.getBooleanValue(interp);
                                    if ( tmp227 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv228 = TJC.grabObjv(interp, 2);
                                            TclObject tmp229;
                                            try {
                                                // Arg 0 constant: error
                                                objv228[0] = const4;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp230 = new StringBuffer(64);
                                                sbtmp230.append("parse error during generated word parse check : ");
                                                sbtmp230.append("\"");
                                                tmp229 = getVarScalar(interp, "bs_subst_only", compiledLocals, 23);
                                                sbtmp230.append(tmp229.toString());
                                                sbtmp230.append("\"");
                                                sbtmp230.append(" : ");
                                                tmp229 = getVarScalar(interp, "err", compiledLocals, 28);
                                                sbtmp230.append(tmp229.toString());
                                                tmp229 = TclString.newInstance(sbtmp230);
                                                tmp229.preserve();
                                                objv228[1] = tmp229;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                    ? cmdcache2.cmd : null), objv228, 0);
                                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                    updateCmdCache(interp, 2);
                                                }
                                            } finally {
                                                tmp229 = objv228[1];
                                                if ( tmp229 != null ) {
                                                    tmp229.release();
                                                }
                                                TJC.releaseObjv(interp, objv228, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: set results $err
                                    TclObject tmp231;
                                    tmp231 = getVarScalar(interp, "err", compiledLocals, 28);
                                    setVarScalar(interp, "results", tmp231, compiledLocals, 29);
                                } // End Invoke: set
                                { // Invoke: set tree [...]
                                    TclObject tmp232;
                                    { // Invoke: lindex $results 3
                                        TclObject tmp233 = getVarScalar(interp, "results", compiledLocals, 29);
                                        tmp233 = TclList.index(interp, tmp233, 3);
                                        if ( tmp233 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp233);
                                        }
                                    } // End Invoke: lindex
                                    tmp232 = interp.getResult();
                                    setVarScalar(interp, "tree", tmp232, compiledLocals, 30);
                                } // End Invoke: set
                                { // Invoke: if ... ...
                                    // Binary operator: [...] != 1
                                    { // Invoke: llength $tree
                                        TclObject tmp234 = getVarScalar(interp, "tree", compiledLocals, 30);
                                        int tmp235 = TclList.getLength(interp, tmp234);
                                        interp.setResult(tmp235);
                                    } // End Invoke: llength
                                    TclObject tmp236 = interp.getResult();
                                    ExprValue tmp237 = evs0;
                                    TJC.exprInitValue(interp, tmp237, tmp236);
                                    ExprValue tmp238 = evs1;
                                    tmp238.setIntValue(1);
                                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp237, tmp238);
                                    // End Binary operator: !=
                                    boolean tmp239 = ( tmp237.getIntValue() != 0 );
                                    if ( tmp239 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv240 = TJC.grabObjv(interp, 2);
                                            TclObject tmp241;
                                            try {
                                                // Arg 0 constant: error
                                                objv240[0] = const4;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp242 = new StringBuffer(64);
                                                sbtmp242.append("expected 1 tree element, got ");
                                                { // Invoke: llength $tree
                                                    TclObject tmp243 = getVarScalar(interp, "tree", compiledLocals, 30);
                                                    int tmp244 = TclList.getLength(interp, tmp243);
                                                    interp.setResult(tmp244);
                                                } // End Invoke: llength
                                                tmp241 = interp.getResult();
                                                sbtmp242.append(tmp241.toString());
                                                tmp241 = TclString.newInstance(sbtmp242);
                                                tmp241.preserve();
                                                objv240[1] = tmp241;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                    ? cmdcache2.cmd : null), objv240, 0);
                                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                    updateCmdCache(interp, 2);
                                                }
                                            } finally {
                                                tmp241 = objv240[1];
                                                if ( tmp241 != null ) {
                                                    tmp241.release();
                                                }
                                                TJC.releaseObjv(interp, objv240, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: set word [...]
                                    TclObject tmp245;
                                    { // Invoke: lindex $tree 0
                                        TclObject tmp246 = getVarScalar(interp, "tree", compiledLocals, 30);
                                        tmp246 = TclList.index(interp, tmp246, 0);
                                        if ( tmp246 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp246);
                                        }
                                    } // End Invoke: lindex
                                    tmp245 = interp.getResult();
                                    setVarScalar(interp, "word", tmp245, compiledLocals, 31);
                                } // End Invoke: set
                                { // Invoke: set word_elems [...]
                                    TclObject tmp247;
                                    { // Invoke: lindex $word 2
                                        TclObject tmp248 = getVarScalar(interp, "word", compiledLocals, 31);
                                        tmp248 = TclList.index(interp, tmp248, 2);
                                        if ( tmp248 == null ) {
                                            interp.resetResult();
                                        } else {
                                            interp.setResult(tmp248);
                                        }
                                    } // End Invoke: lindex
                                    tmp247 = interp.getResult();
                                    setVarScalar(interp, "word_elems", tmp247, compiledLocals, 32);
                                } // End Invoke: set
                                { // Invoke: foreach elem $word_elems ...
                                    TclObject tmp249 = null;
                                    try {
                                        tmp249 = getVarScalar(interp, "word_elems", compiledLocals, 32);
                                        tmp249.preserve();
                                        final int tmp249_length = TclList.getLength(interp, tmp249);

                                        for ( int index250 = 0 ; index250 < tmp249_length ; index250++ ) {
                                            TclObject tmp251 = TclList.index(interp, tmp249, index250);
                                            try {
                                                setVarScalar(interp, "elem", tmp251, compiledLocals, 33);
                                            } catch (TclException ex) {
                                                TJC.foreachVarErr(interp, "elem");
                                            }

                                            try {
                                            if ( false ) { throw (TclException) null; }
                                            { // Invoke: set type [...]
                                                TclObject tmp252;
                                                { // Invoke: lindex $elem 0
                                                    TclObject tmp253 = getVarScalar(interp, "elem", compiledLocals, 33);
                                                    tmp253 = TclList.index(interp, tmp253, 0);
                                                    if ( tmp253 == null ) {
                                                        interp.resetResult();
                                                    } else {
                                                        interp.setResult(tmp253);
                                                    }
                                                } // End Invoke: lindex
                                                tmp252 = interp.getResult();
                                                setVarScalar(interp, "type", tmp252, compiledLocals, 34);
                                            } // End Invoke: set
                                            { // Invoke: if ... ...
                                                // Binary operator: () && ()
                                                // Binary operator: $type != "backslash"
                                                TclObject tmp254 = getVarScalar(interp, "type", compiledLocals, 34);
                                                boolean tmp255 = ! tmp254.toString().equals("backslash");
                                                ExprValue tmp256 = evs0;
                                                tmp256.setIntValue(tmp255);
                                                // End Binary operator: !=
                                                if (tmp256.getBooleanValue(interp)) {
                                                // Binary operator: $type != "text"
                                                TclObject tmp257 = getVarScalar(interp, "type", compiledLocals, 34);
                                                boolean tmp258 = ! tmp257.toString().equals("text");
                                                ExprValue tmp259 = evs1;
                                                tmp259.setIntValue(tmp258);
                                                // End Binary operator: !=
                                                tmp256.setIntValue(tmp259.getBooleanValue(interp));
                                                } else {
                                                tmp256.setIntValue(0);
                                                } // End if: ()
                                                // End Binary operator: &&
                                                boolean tmp260 = ( tmp256.getIntValue() != 0 );
                                                if ( tmp260 ) {
                                                    { // Invoke: error "..."
                                                        TclObject[] objv261 = TJC.grabObjv(interp, 2);
                                                        TclObject tmp262;
                                                        try {
                                                            // Arg 0 constant: error
                                                            objv261[0] = const4;
                                                            // Arg 1 word: "..."
                                                            StringBuffer sbtmp263 = new StringBuffer(64);
                                                            sbtmp263.append("unexpected element type ");
                                                            sbtmp263.append("\"");
                                                            tmp262 = getVarScalar(interp, "type", compiledLocals, 34);
                                                            sbtmp263.append(tmp262.toString());
                                                            sbtmp263.append("\"");
                                                            sbtmp263.append(", word_elems was ");
                                                            sbtmp263.append("{");
                                                            tmp262 = getVarScalar(interp, "word_elems", compiledLocals, 32);
                                                            sbtmp263.append(tmp262.toString());
                                                            sbtmp263.append("}");
                                                            tmp262 = TclString.newInstance(sbtmp263);
                                                            tmp262.preserve();
                                                            objv261[1] = tmp262;
                                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                                updateCmdCache(interp, 0);
                                                            }
                                                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                                ? cmdcache2.cmd : null), objv261, 0);
                                                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                                updateCmdCache(interp, 2);
                                                            }
                                                        } finally {
                                                            tmp262 = objv261[1];
                                                            if ( tmp262 != null ) {
                                                                tmp262.release();
                                                            }
                                                            TJC.releaseObjv(interp, objv261, 2);
                                                        }
                                                    } // End Invoke: error
                                                }
                                            } // End Invoke: if
                                            } catch (TclException ex) {
                                                int type = ex.getCompletionCode();
                                                if (type == TCL.BREAK) {
                                                    break;
                                                } else if (type == TCL.CONTINUE) {
                                                    continue;
                                                } else {
                                                    throw ex;
                                                }
                                            }
                                        }
                                    } finally {
                                        if ( tmp249 != null ) {
                                            tmp249.release();
                                        }
                                    }
                                } // End Invoke: foreach
                                { // Invoke: set bs_subst_str [...]
                                    TclObject tmp264;
                                    { // Invoke: subst -nocommands -novariables $bs_subst_only
                                        TclObject[] objv265 = TJC.grabObjv(interp, 4);
                                        TclObject tmp266;
                                        try {
                                            // Arg 0 constant: subst
                                            objv265[0] = const13;
                                            // Arg 1 constant: -nocommands
                                            objv265[1] = const14;
                                            // Arg 2 constant: -novariables
                                            objv265[2] = const15;
                                            // Arg 3 variable: $bs_subst_only
                                            tmp266 = getVarScalar(interp, "bs_subst_only", compiledLocals, 23);
                                            tmp266.preserve();
                                            objv265[3] = tmp266;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                ? cmdcache4.cmd : null), objv265, 0);
                                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                updateCmdCache(interp, 4);
                                            }
                                        } finally {
                                            tmp266 = objv265[3];
                                            if ( tmp266 != null ) {
                                                tmp266.release();
                                            }
                                            TJC.releaseObjv(interp, objv265, 4);
                                        }
                                    } // End Invoke: subst
                                    tmp264 = interp.getResult();
                                    setVarScalar(interp, "bs_subst_str", tmp264, compiledLocals, 22);
                                } // End Invoke: set
                                { // Invoke: if ... ...
                                    // Unary operator: ! [...]
                                    { // Invoke: string equal $bs_subst_str $lstr
                                        TclObject tmp267 = getVarScalar(interp, "bs_subst_str", compiledLocals, 22);
                                        String tmp268 = tmp267.toString();
                                        TclObject tmp269 = getVarScalar(interp, "lstr", compiledLocals, 17);
                                        String tmp270 = tmp269.toString();
                                        boolean tmp271 = tmp268.equals(tmp270);
                                        interp.setResult(tmp271);
                                    } // End Invoke: string
                                    TclObject tmp272 = interp.getResult();
                                    ExprValue tmp273 = evs0;
                                    if ( tmp272.isIntType() ) {
                                        TJC.exprUnaryNotOperatorKnownInt(tmp273, tmp272);
                                    } else {
                                        TJC.exprUnaryNotOperator(interp, tmp273, tmp272);
                                    }
                                    // End Unary operator: !
                                    boolean tmp274 = ( tmp273.getIntValue() != 0 );
                                    if ( tmp274 ) {
                                        { // Invoke: error "..."
                                            TclObject[] objv275 = TJC.grabObjv(interp, 2);
                                            TclObject tmp276;
                                            try {
                                                // Arg 0 constant: error
                                                objv275[0] = const4;
                                                // Arg 1 word: "..."
                                                StringBuffer sbtmp277 = new StringBuffer(64);
                                                sbtmp277.append("bs_subst_str (2) ->");
                                                tmp276 = getVarScalar(interp, "bs_subst_str", compiledLocals, 22);
                                                sbtmp277.append(tmp276.toString());
                                                sbtmp277.append("<- != list index ->");
                                                tmp276 = getVarScalar(interp, "lstr", compiledLocals, 17);
                                                sbtmp277.append(tmp276.toString());
                                                sbtmp277.append("<-");
                                                tmp276 = TclString.newInstance(sbtmp277);
                                                tmp276.preserve();
                                                objv275[1] = tmp276;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                    ? cmdcache2.cmd : null), objv275, 0);
                                                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                    updateCmdCache(interp, 2);
                                                }
                                            } finally {
                                                tmp276 = objv275[1];
                                                if ( tmp276 != null ) {
                                                    tmp276.release();
                                                }
                                                TJC.releaseObjv(interp, objv275, 2);
                                            }
                                        } // End Invoke: error
                                    }
                                } // End Invoke: if
                                { // Invoke: set quoted_str ...
                                    TclObject tmp278;
                                    StringBuffer sbtmp279 = new StringBuffer(64);
                                    sbtmp279.append("\"");
                                    tmp278 = getVarScalar(interp, "bs_subst_only", compiledLocals, 23);
                                    sbtmp279.append(tmp278.toString());
                                    sbtmp279.append("\"");
                                    tmp278 = TclString.newInstance(sbtmp279);
                                    setVarScalar(interp, "quoted_str", tmp278, compiledLocals, 21);
                                } // End Invoke: set
                            }
                        } // End Invoke: if
                    }
                } // End Invoke: if
                { // Invoke: append unbraced_script $quoted_str
                    TclObject[] objv280 = TJC.grabObjv(interp, 1);
                    TclObject tmp281;
                    try {
                        // Arg 2 variable: $quoted_str
                        tmp281 = getVarScalar(interp, "quoted_str", compiledLocals, 21);
                        tmp281.preserve();
                        objv280[0] = tmp281;
                        interp.resetResult();
                        appendVarScalar(interp, "unbraced_script", objv280, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv280, 1);
                    }
                } // End Invoke: append
                { // Invoke: append unbraced_script " "
                    TclObject[] objv282 = TJC.grabObjv(interp, 1);
                    TclObject tmp283;
                    try {
                        // Arg 2 constant: " "
                        objv282[0] = const19;
                        interp.resetResult();
                        appendVarScalar(interp, "unbraced_script", objv282, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjv(interp, objv282, 1);
                    }
                } // End Invoke: append
                { // Invoke: set extra_space 1
                    setVarScalar(interp, "extra_space", const11, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set newlines [...]
                    TclObject tmp284;
                    { // Invoke: parse countnewline $str {0 end}
                        TclObject[] objv285 = TJC.grabObjv(interp, 4);
                        TclObject tmp286;
                        try {
                            // Arg 0 constant: parse
                            objv285[0] = const0;
                            // Arg 1 constant: countnewline
                            objv285[1] = const20;
                            // Arg 2 variable: $str
                            tmp286 = getVarScalar(interp, "str", compiledLocals, 16);
                            tmp286.preserve();
                            objv285[2] = tmp286;
                            // Arg 3 constant: {0 end}
                            objv285[3] = const9;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv285, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp286 = objv285[2];
                            if ( tmp286 != null ) {
                                tmp286.release();
                            }
                            TJC.releaseObjv(interp, objv285, 4);
                        }
                    } // End Invoke: parse
                    tmp284 = interp.getResult();
                    setVarScalar(interp, "newlines", tmp284, compiledLocals, 35);
                } // End Invoke: set
                { // Invoke: if {$newlines > 0} ...
                    // Binary operator: $newlines > 0
                    TclObject tmp287 = getVarScalar(interp, "newlines", compiledLocals, 35);
                    ExprValue tmp288 = evs0;
                    TJC.exprInitValue(interp, tmp288, tmp287);
                    ExprValue tmp289 = evs1;
                    tmp289.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp288, tmp289);
                    // End Binary operator: >
                    boolean tmp290 = ( tmp288.getIntValue() != 0 );
                    if ( tmp290 ) {
                        { // Invoke: incr newlines_added $newlines
                            TclObject tmp291 = getVarScalar(interp, "newlines", compiledLocals, 35);
                            int tmp292 = TclInteger.get(interp, tmp291);
                            interp.resetResult();
                            incrVarScalar(interp, "newlines_added", tmp292, compiledLocals, 8);
                        } // End Invoke: incr
                    }
                } // End Invoke: if
                { // Invoke: set is_pattern [...]
                    TclObject tmp293;
                    { // Invoke: expr {!$is_pattern}
                        // Unary operator: ! $is_pattern
                        TclObject tmp294 = getVarScalar(interp, "is_pattern", compiledLocals, 13);
                        ExprValue tmp295 = evs0;
                        if ( tmp294.isIntType() ) {
                            TJC.exprUnaryNotOperatorKnownInt(tmp295, tmp294);
                        } else {
                            TJC.exprUnaryNotOperator(interp, tmp295, tmp294);
                        }
                        // End Unary operator: !
                        interp.setResult( tmp295.getIntValue() != 0 );
                    } // End Invoke: expr
                    tmp293 = interp.getResult();
                    setVarScalar(interp, "is_pattern", tmp293, compiledLocals, 13);
                } // End Invoke: set
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: if {!$is_pattern} ...
            // Unary operator: ! $is_pattern
            TclObject tmp296 = getVarScalar(interp, "is_pattern", compiledLocals, 13);
            ExprValue tmp297 = evs0;
            if ( tmp296.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp297, tmp296);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp297, tmp296);
            }
            // End Unary operator: !
            boolean tmp298 = ( tmp297.getIntValue() != 0 );
            if ( tmp298 ) {
                { // Invoke: error ...
                    TclObject[] objv299 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv299[0] = const4;
                        // Arg 1 constant: ...
                        objv299[1] = const21;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv299, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv299, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$extra_space} ...
            TclObject tmp300 = getVarScalar(interp, "extra_space", compiledLocals, 7);
            boolean tmp301 = TJC.getBoolean(interp, tmp300);
            if ( tmp301 ) {
                { // Invoke: set unbraced_script [...]
                    TclObject tmp302;
                    { // Invoke: string range $unbraced_script 0 end-1
                        TclObject tmp303 = getVarScalar(interp, "unbraced_script", compiledLocals, 6);
                        String tmp304 = tmp303.toString();
                        TclObject tmp305 = const2;
                        tmp305.preserve();
                        TclObject tmp306 = const12;
                        TclObject tmp307 = TJC.stringRange(interp, tmp304, tmp305, tmp306);
                        interp.setResult(tmp307);
                    } // End Invoke: string
                    tmp302 = interp.getResult();
                    setVarScalar(interp, "unbraced_script", tmp302, compiledLocals, 6);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set numnewlines [...]
            TclObject tmp308;
            { // Invoke: parse countnewline $script $range
                TclObject[] objv309 = TJC.grabObjv(interp, 4);
                TclObject tmp310;
                try {
                    // Arg 0 constant: parse
                    objv309[0] = const0;
                    // Arg 1 constant: countnewline
                    objv309[1] = const20;
                    // Arg 2 variable: $script
                    tmp310 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp310.preserve();
                    objv309[2] = tmp310;
                    // Arg 3 variable: $range
                    tmp310 = getVarScalar(interp, "range", compiledLocals, 1);
                    tmp310.preserve();
                    objv309[3] = tmp310;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv309, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp310 = objv309[2];
                    if ( tmp310 != null ) {
                        tmp310.release();
                    }
                    tmp310 = objv309[3];
                    if ( tmp310 != null ) {
                        tmp310.release();
                    }
                    TJC.releaseObjv(interp, objv309, 4);
                }
            } // End Invoke: parse
            tmp308 = interp.getResult();
            setVarScalar(interp, "numnewlines", tmp308, compiledLocals, 36);
        } // End Invoke: set
        { // Invoke: set newlines_needed [...]
            TclObject tmp311;
            { // Invoke: expr ...
                // Binary operator: $numnewlines - $newlines_added
                TclObject tmp312 = getVarScalar(interp, "numnewlines", compiledLocals, 36);
                ExprValue tmp313 = evs0;
                TJC.exprInitValue(interp, tmp313, tmp312);
                TclObject tmp314 = getVarScalar(interp, "newlines_added", compiledLocals, 8);
                ExprValue tmp315 = evs1;
                TJC.exprInitValue(interp, tmp315, tmp314);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_MINUS, tmp313, tmp315);
                // End Binary operator: -
                TJC.exprSetResult(interp, tmp313);
            } // End Invoke: expr
            tmp311 = interp.getResult();
            setVarScalar(interp, "newlines_needed", tmp311, compiledLocals, 37);
        } // End Invoke: set
        { // Invoke: for {set i 0} ... {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const2, compiledLocals, 14);
            } // End Invoke: set
            for ( boolean skip321 = true ; true ; ) {
                if ( skip321 ) {
                    skip321 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 14);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $newlines_needed
                TclObject tmp316 = getVarScalar(interp, "i", compiledLocals, 14);
                ExprValue tmp317 = evs0;
                TJC.exprInitValue(interp, tmp317, tmp316);
                TclObject tmp318 = getVarScalar(interp, "newlines_needed", compiledLocals, 37);
                ExprValue tmp319 = evs1;
                TJC.exprInitValue(interp, tmp319, tmp318);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp317, tmp319);
                // End Binary operator: <
                boolean tmp320 = ( tmp317.getIntValue() != 0 );
                if ( ! tmp320 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: append unbraced_script ...
                    TclObject[] objv322 = TJC.grabObjv(interp, 1);
                    TclObject tmp323;
                    try {
                        // Arg 2 constant: ...
                        objv322[0] = const22;
                        interp.resetResult();
                        appendVarScalar(interp, "unbraced_script", objv322, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjv(interp, objv322, 1);
                    }
                } // End Invoke: append
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: set last_range [...]
            TclObject tmp324;
            { // Invoke: list [...] end
                TclObject tmp325 = TclList.newInstance();
                TclObject tmp326;
                try {
                    { // Invoke: expr ...
                        // Binary operator: () + 1
                        // Binary operator: $range_start + $range_len
                        TclObject tmp327 = getVarScalar(interp, "range_start", compiledLocals, 2);
                        ExprValue tmp328 = evs0;
                        TJC.exprInitValue(interp, tmp328, tmp327);
                        TclObject tmp329 = getVarScalar(interp, "range_len", compiledLocals, 3);
                        ExprValue tmp330 = evs1;
                        TJC.exprInitValue(interp, tmp330, tmp329);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp328, tmp330);
                        // End Binary operator: +
                        ExprValue tmp331 = evs1;
                        tmp331.setIntValue(1);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp328, tmp331);
                        // End Binary operator: +
                        TJC.exprSetResult(interp, tmp328);
                    } // End Invoke: expr
                    tmp326 = interp.getResult();
                    TclList.append(interp, tmp325, tmp326);
                    TclList.append(interp, tmp325, const3);
                } catch (TclException ex) {
                    tmp325.release();
                    throw ex;
                }
                interp.setResult(tmp325);
            } // End Invoke: list
            tmp324 = interp.getResult();
            setVarScalar(interp, "last_range", tmp324, compiledLocals, 38);
        } // End Invoke: set
        { // Invoke: set last_string [...]
            TclObject tmp332;
            { // Invoke: parse getstring $script $last_range
                TclObject[] objv333 = TJC.grabObjv(interp, 4);
                TclObject tmp334;
                try {
                    // Arg 0 constant: parse
                    objv333[0] = const0;
                    // Arg 1 constant: getstring
                    objv333[1] = const1;
                    // Arg 2 variable: $script
                    tmp334 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp334.preserve();
                    objv333[2] = tmp334;
                    // Arg 3 variable: $last_range
                    tmp334 = getVarScalar(interp, "last_range", compiledLocals, 38);
                    tmp334.preserve();
                    objv333[3] = tmp334;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv333, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp334 = objv333[2];
                    if ( tmp334 != null ) {
                        tmp334.release();
                    }
                    tmp334 = objv333[3];
                    if ( tmp334 != null ) {
                        tmp334.release();
                    }
                    TJC.releaseObjv(interp, objv333, 4);
                }
            } // End Invoke: parse
            tmp332 = interp.getResult();
            setVarScalar(interp, "last_string", tmp332, compiledLocals, 39);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] > 0
            { // Invoke: string length $last_string
                TclObject tmp335 = getVarScalar(interp, "last_string", compiledLocals, 39);
                int tmp336 = tmp335.toString().length();
                interp.setResult(tmp336);
            } // End Invoke: string
            TclObject tmp337 = interp.getResult();
            ExprValue tmp338 = evs0;
            TJC.exprInitValue(interp, tmp338, tmp337);
            ExprValue tmp339 = evs1;
            tmp339.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp338, tmp339);
            // End Binary operator: >
            boolean tmp340 = ( tmp338.getIntValue() != 0 );
            if ( tmp340 ) {
                { // Invoke: append unbraced_script $last_string
                    TclObject[] objv341 = TJC.grabObjv(interp, 1);
                    TclObject tmp342;
                    try {
                        // Arg 2 variable: $last_string
                        tmp342 = getVarScalar(interp, "last_string", compiledLocals, 39);
                        tmp342.preserve();
                        objv341[0] = tmp342;
                        interp.resetResult();
                        appendVarScalar(interp, "unbraced_script", objv341, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv341, 1);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: return $unbraced_script
            TclObject tmp343 = getVarScalar(interp, "unbraced_script", compiledLocals, 6);
            interp.resetResult();
            interp.setResult(tmp343);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_container_switch_script_recreate");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("parse");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("getstring");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(0);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("end");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("error");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("string");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("map");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("\"\\\\\\n\" \"\"");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("list");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("0 end");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("no pattern/body elements found");
        const10.preserve(); const10.preserve();
        const11 = TclInteger.newInstance(1);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("end-1");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("subst");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("-nocommands");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("-novariables");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("\\");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("command");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance(" ");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("countnewline");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("expected to process a body block last");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("\\\n");
        const22.preserve(); const22.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "parse";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "string";
                break;
            }
            case 4: {
                cmdName = "subst";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "range",
        "range_start",
        "range_len",
        "braced_range",
        "braced_range_string",
        "unbraced_script",
        "extra_space",
        "newlines_added",
        "patbody_str",
        "no_bs_patbody_str",
        "list_ranges",
        "len",
        "is_pattern",
        "i",
        "list_range",
        "str",
        "lstr",
        "first",
        "last",
        "unquoted_str",
        "quoted_str",
        "bs_subst_str",
        "bs_subst_only",
        "last_bs",
        "unquoted_str_len",
        "ind",
        "c",
        "err",
        "results",
        "tree",
        "word",
        "word_elems",
        "elem",
        "type",
        "newlines",
        "numnewlines",
        "newlines_needed",
        "last_range",
        "last_string"
    };
} // end class DescendContainerSwitchScriptRecreateCmd

