// TJC implementation of procedure descend_get_command_name
package tjc;
import tcl.lang.*;

public class DescendGetCommandNameCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "key");
        }
        setVarScalar(interp, "key", objv[1], compiledLocals, 0);
        { // Invoke: set script [...]
            TclObject tmp0;
            { // Invoke: descend_get_data $key script
                TclObject[] objv1 = TJC.grabObjv(interp, 3);
                TclObject tmp2;
                try {
                    // Arg 0 constant: descend_get_data
                    objv1[0] = const0;
                    // Arg 1 variable: $key
                    tmp2 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: script
                    objv1[2] = const1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 3);
                }
            } // End Invoke: descend_get_data
            tmp0 = interp.getResult();
            setVarScalar(interp, "script", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set tree [...]
            TclObject tmp3;
            { // Invoke: descend_get_data $key tree
                TclObject[] objv4 = TJC.grabObjv(interp, 3);
                TclObject tmp5;
                try {
                    // Arg 0 constant: descend_get_data
                    objv4[0] = const0;
                    // Arg 1 variable: $key
                    tmp5 = getVarScalar(interp, "key", compiledLocals, 0);
                    tmp5.preserve();
                    objv4[1] = tmp5;
                    // Arg 2 constant: tree
                    objv4[2] = const2;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv4, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp5 = objv4[1];
                    if ( tmp5 != null ) {
                        tmp5.release();
                    }
                    TJC.releaseObjv(interp, objv4, 3);
                }
            } // End Invoke: descend_get_data
            tmp3 = interp.getResult();
            setVarScalar(interp, "tree", tmp3, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set result [...]
            TclObject tmp6;
            { // Invoke: list
                TclObject tmp7 = TclList.newInstance();
                interp.setResult(tmp7);
            } // End Invoke: list
            tmp6 = interp.getResult();
            setVarScalar(interp, "result", tmp6, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if ... ... else ...
            { // Invoke: parse_is_simple_text [...]
                TclObject[] objv8 = TJC.grabObjv(interp, 2);
                TclObject tmp9;
                try {
                    // Arg 0 constant: parse_is_simple_text
                    objv8[0] = const3;
                    // Arg 1 command: [...]
                    { // Invoke: lindex $tree 0
                        TclObject tmp10 = getVarScalar(interp, "tree", compiledLocals, 2);
                        tmp10 = TclList.index(interp, tmp10, 0);
                        if ( tmp10 == null ) {
                            interp.resetResult();
                        } else {
                            interp.setResult(tmp10);
                        }
                    } // End Invoke: lindex
                    tmp9 = interp.getResult();
                    tmp9.preserve();
                    objv8[1] = tmp9;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv8, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp9 = objv8[1];
                    if ( tmp9 != null ) {
                        tmp9.release();
                    }
                    TJC.releaseObjv(interp, objv8, 2);
                }
            } // End Invoke: parse_is_simple_text
            TclObject tmp11 = interp.getResult();
            ExprValue tmp12 = evs0;
            TJC.exprInitValue(interp, tmp12, tmp11);
            boolean tmp13 = tmp12.getBooleanValue(interp);
            if ( tmp13 ) {
                { // Invoke: lappend result 1 [...]
                    TclObject[] objv14 = TJC.grabObjv(interp, 2);
                    TclObject tmp15;
                    try {
                        // Arg 2 constant: 1
                        objv14[0] = const4;
                        // Arg 3 command: [...]
                        { // Invoke: ... $script [...]
                            TclObject[] objv16 = TJC.grabObjv(interp, 3);
                            TclObject tmp17;
                            try {
                                // Arg 0 constant: ...
                                objv16[0] = const5;
                                // Arg 1 variable: $script
                                tmp17 = getVarScalar(interp, "script", compiledLocals, 1);
                                tmp17.preserve();
                                objv16[1] = tmp17;
                                // Arg 2 command: [...]
                                { // Invoke: lindex $tree 0
                                    TclObject tmp18 = getVarScalar(interp, "tree", compiledLocals, 2);
                                    tmp18 = TclList.index(interp, tmp18, 0);
                                    if ( tmp18 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp18);
                                    }
                                } // End Invoke: lindex
                                tmp17 = interp.getResult();
                                tmp17.preserve();
                                objv16[2] = tmp17;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                    ? cmdcache3.cmd : null), objv16, 0);
                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                    updateCmdCache(interp, 3);
                                }
                            } finally {
                                tmp17 = objv16[1];
                                if ( tmp17 != null ) {
                                    tmp17.release();
                                }
                                tmp17 = objv16[2];
                                if ( tmp17 != null ) {
                                    tmp17.release();
                                }
                                TJC.releaseObjv(interp, objv16, 3);
                            }
                        } // End Invoke: ...
                        tmp15 = interp.getResult();
                        tmp15.preserve();
                        objv14[1] = tmp15;
                        interp.resetResult();
                        lappendVarScalar(interp, "result", objv14, compiledLocals, 3);
                    } finally {
                        tmp15 = objv14[1];
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                        TJC.releaseObjv(interp, objv14, 2);
                    }
                } // End Invoke: lappend
            } else {
                { // Invoke: lappend result 0 {}
                    TclObject[] objv19 = TJC.grabObjv(interp, 2);
                    TclObject tmp20;
                    try {
                        // Arg 2 constant: 0
                        objv19[0] = const6;
                        // Arg 3 constant: {}
                        objv19[1] = const7;
                        interp.resetResult();
                        lappendVarScalar(interp, "result", objv19, compiledLocals, 3);
                    } finally {
                        TJC.releaseObjv(interp, objv19, 2);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: return $result
            TclObject tmp21 = getVarScalar(interp, "result", compiledLocals, 3);
            interp.resetResult();
            interp.setResult(tmp21);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_get_command_name");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("descend_get_data");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("script");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("tree");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("parse_is_simple_text");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("parse_get_simple_text");
        const5.preserve(); const5.preserve();
        const6 = TclInteger.newInstance(0);
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("");
        const7.preserve(); const7.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "descend_get_data";
                break;
            }
            case 2: {
                cmdName = "parse_is_simple_text";
                break;
            }
            case 3: {
                cmdName = "parse_get_simple_text";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "key",
        "script",
        "tree",
        "result"
    };
} // end class DescendGetCommandNameCmd

