// TJC implementation of procedure descend_report_usage_callback
package tjc;
import tcl.lang.*;

public class DescendReportUsageCallbackCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "cmd");
        }
        setVarScalar(interp, "cmd", objv[1], compiledLocals, 0);
        { // Invoke: global _descend_callbacks
            TJC.makeGlobalLinkVar(interp, "_descend_callbacks", "_descend_callbacks", 1);
        } // End Invoke: global
        { // Invoke: set ... $cmd
            TclObject tmp0;
            tmp0 = getVarScalar(interp, "cmd", compiledLocals, 0);
            tmp0 = setVarArray(interp, "_descend_callbacks", "report_usage", tmp0, compiledLocals, 1);
            interp.setResult(tmp0);
        } // End Invoke: set
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_report_usage_callback");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    String[] compiledLocalsNames = {
        "cmd",
        "_descend_callbacks"
    };
} // end class DescendReportUsageCallbackCmd

