// TJC implementation of procedure descend_start
package tjc;
import tcl.lang.*;

public class DescendStartCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 13, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 2 || objv.length > 7) {
            throw new TclNumArgsException(interp, 1, objv, "script ?range? ?nested? ?chknested? ?undetermined? ?outermost?");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "range", 
            ((objv.length <= 2) ? const0 : objv[2]), compiledLocals, 1);
        setVarScalar(interp, "nested", 
            ((objv.length <= 3) ? const1 : objv[3]), compiledLocals, 2);
        setVarScalar(interp, "chknested", 
            ((objv.length <= 4) ? const2 : objv[4]), compiledLocals, 3);
        setVarScalar(interp, "undetermined", 
            ((objv.length <= 5) ? const1 : objv[5]), compiledLocals, 4);
        setVarScalar(interp, "outermost", 
            ((objv.length <= 6) ? const2 : objv[6]), compiledLocals, 5);
        { // Invoke: global _descend
            TJC.makeGlobalLinkVar(interp, "_descend", "_descend", 6);
        } // End Invoke: global
        { // Invoke: set start_key_id $_descend(key)
            TclObject tmp0;
            tmp0 = getVarArray(interp, "_descend", "key", compiledLocals, 6);
            setVarScalar(interp, "start_key_id", tmp0, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if {$outermost} ...
            TclObject tmp1 = getVarScalar(interp, "outermost", compiledLocals, 5);
            boolean tmp2 = TJC.getBoolean(interp, tmp1);
            if ( tmp2 ) {
                { // Invoke: ...
                    TclObject[] objv3 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: ...
                        objv3[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv3, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv3, 1);
                    }
                } // End Invoke: ...
            }
        } // End Invoke: if
        { // Invoke: while {1} ...
            for ( ; true ; ) {
                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set key [...]
                    TclObject tmp4;
                    { // Invoke: descend_next_command $script $range $nested $undetermined
                        TclObject[] objv5 = TJC.grabObjv(interp, 5);
                        TclObject tmp6;
                        try {
                            // Arg 0 constant: descend_next_command
                            objv5[0] = const4;
                            // Arg 1 variable: $script
                            tmp6 = getVarScalar(interp, "script", compiledLocals, 0);
                            tmp6.preserve();
                            objv5[1] = tmp6;
                            // Arg 2 variable: $range
                            tmp6 = getVarScalar(interp, "range", compiledLocals, 1);
                            tmp6.preserve();
                            objv5[2] = tmp6;
                            // Arg 3 variable: $nested
                            tmp6 = getVarScalar(interp, "nested", compiledLocals, 2);
                            tmp6.preserve();
                            objv5[3] = tmp6;
                            // Arg 4 variable: $undetermined
                            tmp6 = getVarScalar(interp, "undetermined", compiledLocals, 4);
                            tmp6.preserve();
                            objv5[4] = tmp6;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv5, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            tmp6 = objv5[1];
                            if ( tmp6 != null ) {
                                tmp6.release();
                            }
                            tmp6 = objv5[2];
                            if ( tmp6 != null ) {
                                tmp6.release();
                            }
                            tmp6 = objv5[3];
                            if ( tmp6 != null ) {
                                tmp6.release();
                            }
                            tmp6 = objv5[4];
                            if ( tmp6 != null ) {
                                tmp6.release();
                            }
                            TJC.releaseObjv(interp, objv5, 5);
                        }
                    } // End Invoke: descend_next_command
                    tmp4 = interp.getResult();
                    setVarScalar(interp, "key", tmp4, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: if {$key == ""} ... elseif ... ...
                    // Binary operator: $key == ""
                    TclObject tmp7 = getVarScalar(interp, "key", compiledLocals, 8);
                    ExprValue tmp8 = evs0;
                    TJC.exprEqualsEmptyString(tmp8, tmp7, false);
                    // End Binary operator: ==
                    boolean tmp9 = ( tmp8.getIntValue() != 0 );
                    if ( tmp9 ) {
                        { // Invoke: break
                            if ( true ) { break; }
                        } // End Invoke: break
                    } else {
                        // Binary operator: () && ()
                        // Binary operator: [...] == 2
                        { // Invoke: llength $key
                            TclObject tmp10 = getVarScalar(interp, "key", compiledLocals, 8);
                            int tmp11 = TclList.getLength(interp, tmp10);
                            interp.setResult(tmp11);
                        } // End Invoke: llength
                        TclObject tmp12 = interp.getResult();
                        ExprValue tmp13 = evs0;
                        TJC.exprInitValue(interp, tmp13, tmp12);
                        ExprValue tmp14 = evs1;
                        tmp14.setIntValue(2);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp13, tmp14);
                        // End Binary operator: ==
                        if (tmp13.getBooleanValue(interp)) {
                        // Binary operator: [...] == "continue"
                        { // Invoke: lindex $key 0
                            TclObject tmp15 = getVarScalar(interp, "key", compiledLocals, 8);
                            tmp15 = TclList.index(interp, tmp15, 0);
                            if ( tmp15 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp15);
                            }
                        } // End Invoke: lindex
                        TclObject tmp16 = interp.getResult();
                        boolean tmp17 = tmp16.toString().equals("continue");
                        ExprValue tmp18 = evs1;
                        tmp18.setIntValue(tmp17);
                        // End Binary operator: ==
                        tmp13.setIntValue(tmp18.getBooleanValue(interp));
                        } else {
                        tmp13.setIntValue(0);
                        } // End if: ()
                        // End Binary operator: &&
                        boolean tmp19 = ( tmp13.getIntValue() != 0 );
                        if ( tmp19 ) {
                            { // Invoke: set range [...]
                                TclObject tmp20;
                                { // Invoke: lindex $key 1
                                    TclObject tmp21 = getVarScalar(interp, "key", compiledLocals, 8);
                                    tmp21 = TclList.index(interp, tmp21, 1);
                                    if ( tmp21 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp21);
                                    }
                                } // End Invoke: lindex
                                tmp20 = interp.getResult();
                                setVarScalar(interp, "range", tmp20, compiledLocals, 1);
                            } // End Invoke: set
                            { // Invoke: continue
                                if ( true ) { continue; }
                            } // End Invoke: continue
                        }
                    }
                } // End Invoke: if
                { // Invoke: ... $key
                    TclObject[] objv22 = TJC.grabObjv(interp, 2);
                    TclObject tmp23;
                    try {
                        // Arg 0 constant: ...
                        objv22[0] = const5;
                        // Arg 1 variable: $key
                        tmp23 = getVarScalar(interp, "key", compiledLocals, 8);
                        tmp23.preserve();
                        objv22[1] = tmp23;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv22, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        tmp23 = objv22[1];
                        if ( tmp23 != null ) {
                            tmp23.release();
                        }
                        TJC.releaseObjv(interp, objv22, 2);
                    }
                } // End Invoke: ...
                { // Invoke: ... $key
                    TclObject[] objv24 = TJC.grabObjv(interp, 2);
                    TclObject tmp25;
                    try {
                        // Arg 0 constant: ...
                        objv24[0] = const6;
                        // Arg 1 variable: $key
                        tmp25 = getVarScalar(interp, "key", compiledLocals, 8);
                        tmp25.preserve();
                        objv24[1] = tmp25;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv24, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp25 = objv24[1];
                        if ( tmp25 != null ) {
                            tmp25.release();
                        }
                        TJC.releaseObjv(interp, objv24, 2);
                    }
                } // End Invoke: ...
                { // Invoke: if {$chknested} ... else ...
                    TclObject tmp26 = getVarScalar(interp, "chknested", compiledLocals, 3);
                    boolean tmp27 = TJC.getBoolean(interp, tmp26);
                    if ( tmp27 ) {
                        { // Invoke: ... $key
                            TclObject[] objv28 = TJC.grabObjv(interp, 2);
                            TclObject tmp29;
                            try {
                                // Arg 0 constant: ...
                                objv28[0] = const7;
                                // Arg 1 variable: $key
                                tmp29 = getVarScalar(interp, "key", compiledLocals, 8);
                                tmp29.preserve();
                                objv28[1] = tmp29;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                    ? cmdcache5.cmd : null), objv28, 0);
                                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                    updateCmdCache(interp, 5);
                                }
                            } finally {
                                tmp29 = objv28[1];
                                if ( tmp29 != null ) {
                                    tmp29.release();
                                }
                                TJC.releaseObjv(interp, objv28, 2);
                            }
                        } // End Invoke: ...
                    }
                } // End Invoke: if
                { // Invoke: ... $key
                    TclObject[] objv30 = TJC.grabObjv(interp, 2);
                    TclObject tmp31;
                    try {
                        // Arg 0 constant: ...
                        objv30[0] = const8;
                        // Arg 1 variable: $key
                        tmp31 = getVarScalar(interp, "key", compiledLocals, 8);
                        tmp31.preserve();
                        objv30[1] = tmp31;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                            ? cmdcache6.cmd : null), objv30, 0);
                        if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                            updateCmdCache(interp, 6);
                        }
                    } finally {
                        tmp31 = objv30[1];
                        if ( tmp31 != null ) {
                            tmp31.release();
                        }
                        TJC.releaseObjv(interp, objv30, 2);
                    }
                } // End Invoke: ...
                { // Invoke: ... $key
                    TclObject[] objv32 = TJC.grabObjv(interp, 2);
                    TclObject tmp33;
                    try {
                        // Arg 0 constant: ...
                        objv32[0] = const9;
                        // Arg 1 variable: $key
                        tmp33 = getVarScalar(interp, "key", compiledLocals, 8);
                        tmp33.preserve();
                        objv32[1] = tmp33;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                            ? cmdcache7.cmd : null), objv32, 0);
                        if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                            updateCmdCache(interp, 7);
                        }
                    } finally {
                        tmp33 = objv32[1];
                        if ( tmp33 != null ) {
                            tmp33.release();
                        }
                        TJC.releaseObjv(interp, objv32, 2);
                    }
                } // End Invoke: ...
                { // Invoke: set range [...]
                    TclObject tmp34;
                    { // Invoke: descend_get_data $key rest
                        TclObject[] objv35 = TJC.grabObjv(interp, 3);
                        TclObject tmp36;
                        try {
                            // Arg 0 constant: descend_get_data
                            objv35[0] = const10;
                            // Arg 1 variable: $key
                            tmp36 = getVarScalar(interp, "key", compiledLocals, 8);
                            tmp36.preserve();
                            objv35[1] = tmp36;
                            // Arg 2 constant: rest
                            objv35[2] = const11;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                ? cmdcache8.cmd : null), objv35, 0);
                            if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                updateCmdCache(interp, 8);
                            }
                        } finally {
                            tmp36 = objv35[1];
                            if ( tmp36 != null ) {
                                tmp36.release();
                            }
                            TJC.releaseObjv(interp, objv35, 3);
                        }
                    } // End Invoke: descend_get_data
                    tmp34 = interp.getResult();
                    setVarScalar(interp, "range", tmp34, compiledLocals, 1);
                } // End Invoke: set
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: while
        { // Invoke: set end_key_id $_descend(key)
            TclObject tmp37;
            tmp37 = getVarArray(interp, "_descend", "key", compiledLocals, 6);
            setVarScalar(interp, "end_key_id", tmp37, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: set keys [...]
            TclObject tmp38;
            { // Invoke: list
                TclObject tmp39 = TclList.newInstance();
                interp.setResult(tmp39);
            } // End Invoke: list
            tmp38 = interp.getResult();
            setVarScalar(interp, "keys", tmp38, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: for ... ... {incr key_id} ...
            { // Invoke: set key_id $start_key_id
                TclObject tmp40;
                tmp40 = getVarScalar(interp, "start_key_id", compiledLocals, 7);
                setVarScalar(interp, "key_id", tmp40, compiledLocals, 11);
            } // End Invoke: set
            for ( boolean skip46 = true ; true ; ) {
                if ( skip46 ) {
                    skip46 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr key_id
                        interp.resetResult();
                        incrVarScalar(interp, "key_id", 1, compiledLocals, 11);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $key_id < $end_key_id
                TclObject tmp41 = getVarScalar(interp, "key_id", compiledLocals, 11);
                ExprValue tmp42 = evs0;
                TJC.exprInitValue(interp, tmp42, tmp41);
                TclObject tmp43 = getVarScalar(interp, "end_key_id", compiledLocals, 9);
                ExprValue tmp44 = evs1;
                TJC.exprInitValue(interp, tmp44, tmp43);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp42, tmp44);
                // End Binary operator: <
                boolean tmp45 = ( tmp42.getIntValue() != 0 );
                if ( ! tmp45 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: lappend keys "dkey$key_id"
                    TclObject[] objv47 = TJC.grabObjv(interp, 1);
                    TclObject tmp48;
                    try {
                        // Arg 2 word: "dkey$key_id"
                        StringBuffer sbtmp49 = new StringBuffer(64);
                        sbtmp49.append("dkey");
                        tmp48 = getVarScalar(interp, "key_id", compiledLocals, 11);
                        sbtmp49.append(tmp48.toString());
                        tmp48 = TclString.newInstance(sbtmp49);
                        tmp48.preserve();
                        objv47[0] = tmp48;
                        interp.resetResult();
                        lappendVarScalar(interp, "keys", objv47, compiledLocals, 10);
                    } finally {
                        TJC.releaseObjvElems(interp, objv47, 1);
                    }
                } // End Invoke: lappend
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: if {$outermost} ...
            TclObject tmp50 = getVarScalar(interp, "outermost", compiledLocals, 5);
            boolean tmp51 = TJC.getBoolean(interp, tmp50);
            if ( tmp51 ) {
                { // Invoke: set level_keys [...]
                    TclObject tmp52;
                    { // Invoke: ...
                        TclObject[] objv53 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: ...
                            objv53[0] = const12;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                ? cmdcache9.cmd : null), objv53, 0);
                            if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                updateCmdCache(interp, 9);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv53, 1);
                        }
                    } // End Invoke: ...
                    tmp52 = interp.getResult();
                    setVarScalar(interp, "level_keys", tmp52, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: if ... ...
                    // Binary operator: [...] != 0
                    { // Invoke: llength $...
                        TclObject tmp54 = getVarArray(interp, "_descend", "commands_stack", compiledLocals, 6);
                        int tmp55 = TclList.getLength(interp, tmp54);
                        interp.setResult(tmp55);
                    } // End Invoke: llength
                    TclObject tmp56 = interp.getResult();
                    ExprValue tmp57 = evs0;
                    TJC.exprInitValue(interp, tmp57, tmp56);
                    ExprValue tmp58 = evs1;
                    tmp58.setIntValue(0);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp57, tmp58);
                    // End Binary operator: !=
                    boolean tmp59 = ( tmp57.getIntValue() != 0 );
                    if ( tmp59 ) {
                        { // Invoke: error "..."
                            TclObject[] objv60 = TJC.grabObjv(interp, 2);
                            TclObject tmp61;
                            try {
                                // Arg 0 constant: error
                                objv60[0] = const13;
                                // Arg 1 word: "..."
                                StringBuffer sbtmp62 = new StringBuffer(64);
                                sbtmp62.append("level stack depth is ");
                                { // Invoke: llength $...
                                    TclObject tmp63 = getVarArray(interp, "_descend", "commands_stack", compiledLocals, 6);
                                    int tmp64 = TclList.getLength(interp, tmp63);
                                    interp.setResult(tmp64);
                                } // End Invoke: llength
                                tmp61 = interp.getResult();
                                sbtmp62.append(tmp61.toString());
                                sbtmp62.append(", expected depth of 0");
                                tmp61 = TclString.newInstance(sbtmp62);
                                tmp61.preserve();
                                objv60[1] = tmp61;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                    ? cmdcache10.cmd : null), objv60, 0);
                                if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                    updateCmdCache(interp, 10);
                                }
                            } finally {
                                tmp61 = objv60[1];
                                if ( tmp61 != null ) {
                                    tmp61.release();
                                }
                                TJC.releaseObjv(interp, objv60, 2);
                            }
                        } // End Invoke: error
                    }
                } // End Invoke: if
                { // Invoke: set ... $level_keys
                    TclObject tmp65;
                    tmp65 = getVarScalar(interp, "level_keys", compiledLocals, 12);
                    setVarArray(interp, "_descend", "commands,outermost", tmp65, compiledLocals, 6);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: return $keys
            TclObject tmp66 = getVarScalar(interp, "keys", compiledLocals, 10);
            interp.resetResult();
            interp.setResult(tmp66);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "descend_start");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("0 end");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(1);
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_descend_commands_push");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("descend_next_command");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("_descend_commands_add");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("descend_report_command");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("descend_check_nested_commands");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("descend_check_container_command");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("descend_report_command_finish");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("descend_get_data");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("rest");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("_descend_commands_pop");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("error");
        const13.preserve(); const13.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "_descend_commands_push";
                break;
            }
            case 2: {
                cmdName = "descend_next_command";
                break;
            }
            case 3: {
                cmdName = "_descend_commands_add";
                break;
            }
            case 4: {
                cmdName = "descend_report_command";
                break;
            }
            case 5: {
                cmdName = "descend_check_nested_commands";
                break;
            }
            case 6: {
                cmdName = "descend_check_container_command";
                break;
            }
            case 7: {
                cmdName = "descend_report_command_finish";
                break;
            }
            case 8: {
                cmdName = "descend_get_data";
                break;
            }
            case 9: {
                cmdName = "_descend_commands_pop";
                break;
            }
            case 10: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "range",
        "nested",
        "chknested",
        "undetermined",
        "outermost",
        "_descend",
        "start_key_id",
        "key",
        "end_key_id",
        "keys",
        "key_id",
        "level_keys"
    };
} // end class DescendStartCmd

