// TJC implementation of procedure emitter_container_for_try_end
package tjc;
import tcl.lang.*;

public class EmitterContainerForTryEndCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 2, compiledLocalsNames);
        try {
        if (objv.length > 2) {
            throw new TclNumArgsException(interp, 1, objv, "?do_continue?");
        }
        setVarScalar(interp, "do_continue", 
            ((objv.length <= 1) ? const0 : objv[1]), compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const1, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: append buffer [...] ...
            TclObject[] objv0 = TJC.grabObjv(interp, 2);
            TclObject tmp1;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv2 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv2[0] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 1);
                    }
                } // End Invoke: emitter_indent
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[0] = tmp1;
                // Arg 3 constant: ...
                objv0[1] = const3;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv0, compiledLocals, 1);
            } finally {
                tmp1 = objv0[0];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                TJC.releaseObjv(interp, objv0, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv3 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv3[0] = const4;
                // Arg 1 constant: +1
                objv3[1] = const5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv3, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv3, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ... ... [...] ...
            TclObject[] objv4 = TJC.grabObjv(interp, 5);
            TclObject tmp5;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv6 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv6[0] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv6, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv6, 1);
                    }
                } // End Invoke: emitter_indent
                tmp5 = interp.getResult();
                tmp5.preserve();
                objv4[0] = tmp5;
                // Arg 3 constant: ...
                objv4[1] = const6;
                // Arg 4 constant: ...
                objv4[2] = const7;
                // Arg 5 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv7 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv7[0] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv7, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv7, 1);
                    }
                } // End Invoke: emitter_indent
                tmp5 = interp.getResult();
                tmp5.preserve();
                objv4[3] = tmp5;
                // Arg 6 constant: ...
                objv4[4] = const8;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv4, compiledLocals, 1);
            } finally {
                tmp5 = objv4[0];
                if ( tmp5 != null ) {
                    tmp5.release();
                }
                tmp5 = objv4[3];
                if ( tmp5 != null ) {
                    tmp5.release();
                }
                TJC.releaseObjv(interp, objv4, 5);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv8 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv8[0] = const4;
                // Arg 1 constant: +1
                objv8[1] = const5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv8, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv8, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] "break" ...
            TclObject[] objv9 = TJC.grabObjv(interp, 3);
            TclObject tmp10;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv11 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv11[0] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv11, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv11, 1);
                    }
                } // End Invoke: emitter_indent
                tmp10 = interp.getResult();
                tmp10.preserve();
                objv9[0] = tmp10;
                // Arg 3 constant: "break"
                objv9[1] = const9;
                // Arg 4 constant: ...
                objv9[2] = const7;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv9, compiledLocals, 1);
            } finally {
                tmp10 = objv9[0];
                if ( tmp10 != null ) {
                    tmp10.release();
                }
                TJC.releaseObjv(interp, objv9, 3);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv12 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv12[0] = const4;
                // Arg 1 constant: -1
                objv12[1] = const10;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv12, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv12, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: if {$do_continue} ...
            TclObject tmp13 = getVarScalar(interp, "do_continue", compiledLocals, 0);
            boolean tmp14 = TJC.getBoolean(interp, tmp13);
            if ( tmp14 ) {
                { // Invoke: append buffer [...] ...
                    TclObject[] objv15 = TJC.grabObjv(interp, 2);
                    TclObject tmp16;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv17 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv17[0] = const2;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv17, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv17, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp16 = interp.getResult();
                        tmp16.preserve();
                        objv15[0] = tmp16;
                        // Arg 3 constant: ...
                        objv15[1] = const11;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv15, compiledLocals, 1);
                    } finally {
                        tmp16 = objv15[0];
                        if ( tmp16 != null ) {
                            tmp16.release();
                        }
                        TJC.releaseObjv(interp, objv15, 2);
                    }
                } // End Invoke: append
                { // Invoke: emitter_indent_level +1
                    TclObject[] objv18 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_indent_level
                        objv18[0] = const4;
                        // Arg 1 constant: +1
                        objv18[1] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv18, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv18, 2);
                    }
                } // End Invoke: emitter_indent_level
                { // Invoke: append buffer [...] "continue" ...
                    TclObject[] objv19 = TJC.grabObjv(interp, 3);
                    TclObject tmp20;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv21 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv21[0] = const2;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv21, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv21, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp20 = interp.getResult();
                        tmp20.preserve();
                        objv19[0] = tmp20;
                        // Arg 3 constant: "continue"
                        objv19[1] = const12;
                        // Arg 4 constant: ...
                        objv19[2] = const7;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv19, compiledLocals, 1);
                    } finally {
                        tmp20 = objv19[0];
                        if ( tmp20 != null ) {
                            tmp20.release();
                        }
                        TJC.releaseObjv(interp, objv19, 3);
                    }
                } // End Invoke: append
                { // Invoke: emitter_indent_level -1
                    TclObject[] objv22 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_indent_level
                        objv22[0] = const4;
                        // Arg 1 constant: -1
                        objv22[1] = const10;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv22, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv22, 2);
                    }
                } // End Invoke: emitter_indent_level
            }
        } // End Invoke: if
        { // Invoke: append buffer [...] ...
            TclObject[] objv23 = TJC.grabObjv(interp, 2);
            TclObject tmp24;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv25 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv25[0] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv25, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv25, 1);
                    }
                } // End Invoke: emitter_indent
                tmp24 = interp.getResult();
                tmp24.preserve();
                objv23[0] = tmp24;
                // Arg 3 constant: ...
                objv23[1] = const13;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv23, compiledLocals, 1);
            } finally {
                tmp24 = objv23[0];
                if ( tmp24 != null ) {
                    tmp24.release();
                }
                TJC.releaseObjv(interp, objv23, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv26 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv26[0] = const4;
                // Arg 1 constant: +1
                objv26[1] = const5;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv26, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv26, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] "throw ex" ...
            TclObject[] objv27 = TJC.grabObjv(interp, 3);
            TclObject tmp28;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv29 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv29[0] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv29, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv29, 1);
                    }
                } // End Invoke: emitter_indent
                tmp28 = interp.getResult();
                tmp28.preserve();
                objv27[0] = tmp28;
                // Arg 3 constant: "throw ex"
                objv27[1] = const14;
                // Arg 4 constant: ...
                objv27[2] = const7;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv27, compiledLocals, 1);
            } finally {
                tmp28 = objv27[0];
                if ( tmp28 != null ) {
                    tmp28.release();
                }
                TJC.releaseObjv(interp, objv27, 3);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv30 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv30[0] = const4;
                // Arg 1 constant: -1
                objv30[1] = const10;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv30, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv30, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv31 = TJC.grabObjv(interp, 2);
            TclObject tmp32;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv33 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv33[0] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv33, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv33, 1);
                    }
                } // End Invoke: emitter_indent
                tmp32 = interp.getResult();
                tmp32.preserve();
                objv31[0] = tmp32;
                // Arg 3 constant: ...
                objv31[1] = const15;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv31, compiledLocals, 1);
            } finally {
                tmp32 = objv31[0];
                if ( tmp32 != null ) {
                    tmp32.release();
                }
                TJC.releaseObjv(interp, objv31, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv34 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv34[0] = const4;
                // Arg 1 constant: -1
                objv34[1] = const10;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv34, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                TJC.releaseObjv(interp, objv34, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv35 = TJC.grabObjv(interp, 2);
            TclObject tmp36;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv37 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv37[0] = const2;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv37, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv37, 1);
                    }
                } // End Invoke: emitter_indent
                tmp36 = interp.getResult();
                tmp36.preserve();
                objv35[0] = tmp36;
                // Arg 3 constant: ...
                objv35[1] = const15;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv35, compiledLocals, 1);
            } finally {
                tmp36 = objv35[0];
                if ( tmp36 != null ) {
                    tmp36.release();
                }
                TJC.releaseObjv(interp, objv35, 2);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp38 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp38);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_container_for_try_end");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("emitter_indent");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("} catch (TclException ex) {\n");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent_level");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("+1");
        TclInteger.get(interp, const5);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("int type = ex.getCompletionCode()");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(";\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("if (type == TCL.BREAK) {\n");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("break");
        const9.preserve(); const9.preserve();
        const10 = TclInteger.newInstance(-1);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("} else if (type == TCL.CONTINUE) {\n");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("continue");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("} else {\n");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("throw ex");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("}\n");
        const15.preserve(); const15.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_indent_level";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "do_continue",
        "buffer"
    };
} // end class EmitterContainerForTryEndCmd

