// TJC implementation of procedure emitter_indent_level
package tjc;
import tcl.lang.*;

public class EmitterIndentLevelCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length > 2) {
            throw new TclNumArgsException(interp, 1, objv, "?change?");
        }
        setVarScalar(interp, "change", 
            ((objv.length <= 1) ? const0 : objv[1]), compiledLocals, 0);
        { // Invoke: global _emitter
            TJC.makeGlobalLinkVar(interp, "_emitter", "_emitter", 1);
        } // End Invoke: global
        { // Invoke: if ... ... elseif {$change == "zero"} ... else ...
            // Binary operator: $change == "current"
            TclObject tmp0 = getVarScalar(interp, "change", compiledLocals, 0);
            boolean tmp1 = tmp0.toString().equals("current");
            ExprValue tmp2 = evs0;
            tmp2.setIntValue(tmp1);
            // End Binary operator: ==
            boolean tmp3 = ( tmp2.getIntValue() != 0 );
            if ( tmp3 ) {
            } else {
                // Binary operator: $change == "zero"
                TclObject tmp4 = getVarScalar(interp, "change", compiledLocals, 0);
                boolean tmp5 = tmp4.toString().equals("zero");
                ExprValue tmp6 = evs0;
                tmp6.setIntValue(tmp5);
                // End Binary operator: ==
                boolean tmp7 = ( tmp6.getIntValue() != 0 );
                if ( tmp7 ) {
                    { // Invoke: set ... 0
                        setVarArray(interp, "_emitter", "indent_level", const1, compiledLocals, 1);
                    } // End Invoke: set
                } else {
                    { // Invoke: set level $...
                        TclObject tmp8;
                        tmp8 = getVarArray(interp, "_emitter", "indent_level", compiledLocals, 1);
                        setVarScalar(interp, "level", tmp8, compiledLocals, 2);
                    } // End Invoke: set
                    { // Invoke: incr level $change
                        TclObject tmp9 = getVarScalar(interp, "change", compiledLocals, 0);
                        int tmp10 = TclInteger.get(interp, tmp9);
                        interp.resetResult();
                        incrVarScalar(interp, "level", tmp10, compiledLocals, 2);
                    } // End Invoke: incr
                    { // Invoke: if {$level < 0} ...
                        // Binary operator: $level < 0
                        TclObject tmp11 = getVarScalar(interp, "level", compiledLocals, 2);
                        ExprValue tmp12 = evs0;
                        TJC.exprInitValue(interp, tmp12, tmp11);
                        ExprValue tmp13 = evs1;
                        tmp13.setIntValue(0);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp12, tmp13);
                        // End Binary operator: <
                        boolean tmp14 = ( tmp12.getIntValue() != 0 );
                        if ( tmp14 ) {
                            { // Invoke: error "..."
                                TclObject[] objv15 = TJC.grabObjv(interp, 2);
                                TclObject tmp16;
                                try {
                                    // Arg 0 constant: error
                                    objv15[0] = const2;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp17 = new StringBuffer(64);
                                    sbtmp17.append("error new indent level (");
                                    tmp16 = getVarScalar(interp, "level", compiledLocals, 2);
                                    sbtmp17.append(tmp16.toString());
                                    sbtmp17.append(") would be negative");
                                    tmp16 = TclString.newInstance(sbtmp17);
                                    tmp16.preserve();
                                    objv15[1] = tmp16;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv15, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp16 = objv15[1];
                                    if ( tmp16 != null ) {
                                        tmp16.release();
                                    }
                                    TJC.releaseObjv(interp, objv15, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: if
                    { // Invoke: set ... $level
                        TclObject tmp18;
                        tmp18 = getVarScalar(interp, "level", compiledLocals, 2);
                        setVarArray(interp, "_emitter", "indent_level", tmp18, compiledLocals, 1);
                    } // End Invoke: set
                    { // Invoke: return $level
                        TclObject tmp19 = getVarScalar(interp, "level", compiledLocals, 2);
                        interp.resetResult();
                        interp.setResult(tmp19);
                        if ( true ) { return; }
                    } // End Invoke: return
                }
            }
        } // End Invoke: if
        { // Invoke: return $...
            TclObject tmp20 = getVarArray(interp, "_emitter", "indent_level", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp20);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_indent_level");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("current");
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("error");
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "change",
        "_emitter",
        "level"
    };
} // end class EmitterIndentLevelCmd

