// TJC implementation of procedure emitter_init_cmd_check
package tjc;
import tcl.lang.*;

public class EmitterInitCmdCheckCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 3, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        try {
        if (objv.length > 2) {
            throw new TclNumArgsException(interp, 1, objv, "?cflags?");
        }
        setVarScalar(interp, "cflags", 
            ((objv.length <= 1) ? const0 : objv[1]), compiledLocals, 0);
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: if {$cflags == {}} ... else ...
            // Binary operator: $cflags == ""
            TclObject tmp0 = getVarScalar(interp, "cflags", compiledLocals, 0);
            ExprValue tmp1 = evs0;
            TJC.exprEqualsEmptyString(tmp1, tmp0, false);
            // End Binary operator: ==
            boolean tmp2 = ( tmp1.getIntValue() != 0 );
            if ( tmp2 ) {
                { // Invoke: append buffer [...] ...
                    TclObject[] objv3 = TJC.grabObjv(interp, 2);
                    TclObject tmp4;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv5 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv5[0] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv5, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv5, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp4 = interp.getResult();
                        tmp4.preserve();
                        objv3[0] = tmp4;
                        // Arg 3 constant: ...
                        objv3[1] = const2;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv3, compiledLocals, 1);
                    } finally {
                        tmp4 = objv3[0];
                        if ( tmp4 != null ) {
                            tmp4.release();
                        }
                        TJC.releaseObjv(interp, objv3, 2);
                    }
                } // End Invoke: append
            } else {
                { // Invoke: set buffer ""
                    setVarScalar(interp, "buffer", const0, compiledLocals, 1);
                } // End Invoke: set
                { // Invoke: append buffer [...] ...
                    TclObject[] objv6 = TJC.grabObjv(interp, 2);
                    TclObject tmp7;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv8 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv8[0] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv8, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv8, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp7 = interp.getResult();
                        tmp7.preserve();
                        objv6[0] = tmp7;
                        // Arg 3 constant: ...
                        objv6[1] = const3;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv6, compiledLocals, 1);
                    } finally {
                        tmp7 = objv6[0];
                        if ( tmp7 != null ) {
                            tmp7.release();
                        }
                        TJC.releaseObjv(interp, objv6, 2);
                    }
                } // End Invoke: append
                { // Invoke: emitter_indent_level +1
                    TclObject[] objv9 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_indent_level
                        objv9[0] = const4;
                        // Arg 1 constant: +1
                        objv9[1] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv9, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv9, 2);
                    }
                } // End Invoke: emitter_indent_level
                { // Invoke: foreach cflag $cflags ...
                    TclObject tmp10 = null;
                    try {
                        tmp10 = getVarScalar(interp, "cflags", compiledLocals, 0);
                        tmp10.preserve();
                        final int tmp10_length = TclList.getLength(interp, tmp10);

                        for ( int index11 = 0 ; index11 < tmp10_length ; index11++ ) {
                            TclObject tmp12 = TclList.index(interp, tmp10, index11);
                            try {
                                setVarScalar(interp, "cflag", tmp12, compiledLocals, 2);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "cflag");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: append buffer [...] $cflags " = true" ...
                                TclObject[] objv13 = TJC.grabObjv(interp, 4);
                                TclObject tmp14;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv15 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv15[0] = const1;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                                ? cmdcache1.cmd : null), objv15, 0);
                                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                                updateCmdCache(interp, 1);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv15, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp14 = interp.getResult();
                                    tmp14.preserve();
                                    objv13[0] = tmp14;
                                    // Arg 3 variable: $cflags
                                    tmp14 = getVarScalar(interp, "cflags", compiledLocals, 0);
                                    tmp14.preserve();
                                    objv13[1] = tmp14;
                                    // Arg 4 constant: " = true"
                                    objv13[2] = const6;
                                    // Arg 5 constant: ...
                                    objv13[3] = const7;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv13, compiledLocals, 1);
                                } finally {
                                    tmp14 = objv13[0];
                                    if ( tmp14 != null ) {
                                        tmp14.release();
                                    }
                                    tmp14 = objv13[1];
                                    if ( tmp14 != null ) {
                                        tmp14.release();
                                    }
                                    TJC.releaseObjv(interp, objv13, 4);
                                }
                            } // End Invoke: append
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp10 != null ) {
                            tmp10.release();
                        }
                    }
                } // End Invoke: foreach
                { // Invoke: append buffer [...] "initCmd(interp)" ...
                    TclObject[] objv16 = TJC.grabObjv(interp, 3);
                    TclObject tmp17;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv18 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv18[0] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv18, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv18, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp17 = interp.getResult();
                        tmp17.preserve();
                        objv16[0] = tmp17;
                        // Arg 3 constant: "initCmd(interp)"
                        objv16[1] = const8;
                        // Arg 4 constant: ...
                        objv16[2] = const7;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv16, compiledLocals, 1);
                    } finally {
                        tmp17 = objv16[0];
                        if ( tmp17 != null ) {
                            tmp17.release();
                        }
                        TJC.releaseObjv(interp, objv16, 3);
                    }
                } // End Invoke: append
                { // Invoke: emitter_indent_level -1
                    TclObject[] objv19 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: emitter_indent_level
                        objv19[0] = const4;
                        // Arg 1 constant: -1
                        objv19[1] = const9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv19, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv19, 2);
                    }
                } // End Invoke: emitter_indent_level
                { // Invoke: append buffer [...] ...
                    TclObject[] objv20 = TJC.grabObjv(interp, 2);
                    TclObject tmp21;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: emitter_indent
                            TclObject[] objv22 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent
                                objv22[0] = const1;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv22, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv22, 1);
                            }
                        } // End Invoke: emitter_indent
                        tmp21 = interp.getResult();
                        tmp21.preserve();
                        objv20[0] = tmp21;
                        // Arg 3 constant: ...
                        objv20[1] = const10;
                        interp.resetResult();
                        appendVarScalar(interp, "buffer", objv20, compiledLocals, 1);
                    } finally {
                        tmp21 = objv20[0];
                        if ( tmp21 != null ) {
                            tmp21.release();
                        }
                        TJC.releaseObjv(interp, objv20, 2);
                    }
                } // End Invoke: append
            }
        } // End Invoke: if
        { // Invoke: append buffer ...
            TclObject[] objv23 = TJC.grabObjv(interp, 1);
            TclObject tmp24;
            try {
                // Arg 2 constant: ...
                objv23[0] = const11;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv23, compiledLocals, 1);
            } finally {
                TJC.releaseObjv(interp, objv23, 1);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp25 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp25);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_init_cmd_check");
        } finally {
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("emitter_indent");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("if (!initCmd) { initCmd(interp); }");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("if (!initCmd) {\n");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent_level");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("+1");
        TclInteger.get(interp, const5);
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(" = true");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance(";\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("initCmd(interp)");
        const8.preserve(); const8.preserve();
        const9 = TclInteger.newInstance(-1);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("}");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("\n");
        const11.preserve(); const11.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent";
                break;
            }
            case 2: {
                cmdName = "emitter_indent_level";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "cflags",
        "buffer",
        "cflag"
    };
} // end class EmitterInitCmdCheckCmd

