// TJC implementation of procedure emitter_init_constants
package tjc;
import tcl.lang.*;

public class EmitterInitConstantsCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 10, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "tlist");
        }
        setVarScalar(interp, "tlist", objv[1], compiledLocals, 0);
        { // Invoke: if ... ...
            // Binary operator: [...] != 0
            { // Invoke: emitter_indent_level
                TclObject[] objv0 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent_level
                    objv0[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 1);
                }
            } // End Invoke: emitter_indent_level
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            TJC.exprInitValue(interp, tmp2, tmp1);
            ExprValue tmp3 = evs1;
            tmp3.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp2, tmp3);
            // End Binary operator: !=
            boolean tmp4 = ( tmp2.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("expected indent level of 0, got ");
                        { // Invoke: emitter_indent_level
                            TclObject[] objv8 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent_level
                                objv8[0] = const0;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv8, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv8, 1);
                            }
                        } // End Invoke: emitter_indent_level
                        tmp6 = interp.getResult();
                        sbtmp7.append(tmp6.toString());
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const2, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: emitter_indent_level +1
            TclObject[] objv9 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv9[0] = const0;
                // Arg 1 constant: +1
                objv9[1] = const3;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv9, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv9, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: foreach tuple $tlist ...
            TclObject tmp10 = null;
            try {
                tmp10 = getVarScalar(interp, "tlist", compiledLocals, 0);
                tmp10.preserve();
                final int tmp10_length = TclList.getLength(interp, tmp10);

                for ( int index11 = 0 ; index11 < tmp10_length ; index11++ ) {
                    TclObject tmp12 = TclList.index(interp, tmp10, index11);
                    try {
                        setVarScalar(interp, "tuple", tmp12, compiledLocals, 2);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "tuple");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set name [...]
                        TclObject tmp13;
                        { // Invoke: lindex $tuple 0
                            TclObject tmp14 = getVarScalar(interp, "tuple", compiledLocals, 2);
                            tmp14 = TclList.index(interp, tmp14, 0);
                            if ( tmp14 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp14);
                            }
                        } // End Invoke: lindex
                        tmp13 = interp.getResult();
                        setVarScalar(interp, "name", tmp13, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: append buffer [...] "TclObject " $name ...
                        TclObject[] objv15 = TJC.grabObjv(interp, 4);
                        TclObject tmp16;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv17 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv17[0] = const4;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv17, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv17, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp16 = interp.getResult();
                            tmp16.preserve();
                            objv15[0] = tmp16;
                            // Arg 3 constant: "TclObject "
                            objv15[1] = const5;
                            // Arg 4 variable: $name
                            tmp16 = getVarScalar(interp, "name", compiledLocals, 3);
                            tmp16.preserve();
                            objv15[2] = tmp16;
                            // Arg 5 constant: ...
                            objv15[3] = const6;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv15, compiledLocals, 1);
                        } finally {
                            tmp16 = objv15[0];
                            if ( tmp16 != null ) {
                                tmp16.release();
                            }
                            tmp16 = objv15[2];
                            if ( tmp16 != null ) {
                                tmp16.release();
                            }
                            TJC.releaseObjv(interp, objv15, 4);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp10 != null ) {
                    tmp10.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: append buffer ... [...] ...
            TclObject[] objv18 = TJC.grabObjv(interp, 3);
            TclObject tmp19;
            try {
                // Arg 2 constant: ...
                objv18[0] = const7;
                // Arg 3 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv20 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv20[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv20, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv20, 1);
                    }
                } // End Invoke: emitter_indent
                tmp19 = interp.getResult();
                tmp19.preserve();
                objv18[1] = tmp19;
                // Arg 4 constant: ...
                objv18[2] = const8;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv18, compiledLocals, 1);
            } finally {
                tmp19 = objv18[1];
                if ( tmp19 != null ) {
                    tmp19.release();
                }
                TJC.releaseObjv(interp, objv18, 3);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv21 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv21[0] = const0;
                // Arg 1 constant: +1
                objv21[1] = const3;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv21, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv21, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: foreach tuple $tlist ...
            TclObject tmp22 = null;
            try {
                tmp22 = getVarScalar(interp, "tlist", compiledLocals, 0);
                tmp22.preserve();
                final int tmp22_length = TclList.getLength(interp, tmp22);

                for ( int index23 = 0 ; index23 < tmp22_length ; index23++ ) {
                    TclObject tmp24 = TclList.index(interp, tmp22, index23);
                    try {
                        setVarScalar(interp, "tuple", tmp24, compiledLocals, 2);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "tuple");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set name [...]
                        TclObject tmp25;
                        { // Invoke: lindex $tuple 0
                            TclObject tmp26 = getVarScalar(interp, "tuple", compiledLocals, 2);
                            tmp26 = TclList.index(interp, tmp26, 0);
                            if ( tmp26 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp26);
                            }
                        } // End Invoke: lindex
                        tmp25 = interp.getResult();
                        setVarScalar(interp, "name", tmp25, compiledLocals, 3);
                    } // End Invoke: set
                    { // Invoke: set type [...]
                        TclObject tmp27;
                        { // Invoke: lindex $tuple 1
                            TclObject tmp28 = getVarScalar(interp, "tuple", compiledLocals, 2);
                            tmp28 = TclList.index(interp, tmp28, 1);
                            if ( tmp28 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp28);
                            }
                        } // End Invoke: lindex
                        tmp27 = interp.getResult();
                        setVarScalar(interp, "type", tmp27, compiledLocals, 4);
                    } // End Invoke: set
                    { // Invoke: set value [...]
                        TclObject tmp29;
                        { // Invoke: lindex $tuple 2
                            TclObject tmp30 = getVarScalar(interp, "tuple", compiledLocals, 2);
                            tmp30 = TclList.index(interp, tmp30, 2);
                            if ( tmp30 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp30);
                            }
                        } // End Invoke: lindex
                        tmp29 = interp.getResult();
                        setVarScalar(interp, "value", tmp29, compiledLocals, 5);
                    } // End Invoke: set
                    { // Invoke: append buffer [...] "$name = "
                        TclObject[] objv31 = TJC.grabObjv(interp, 2);
                        TclObject tmp32;
                        try {
                            // Arg 2 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv33 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv33[0] = const4;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv33, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv33, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp32 = interp.getResult();
                            tmp32.preserve();
                            objv31[0] = tmp32;
                            // Arg 3 word: "$name = "
                            StringBuffer sbtmp34 = new StringBuffer(64);
                            tmp32 = getVarScalar(interp, "name", compiledLocals, 3);
                            sbtmp34.append(tmp32.toString());
                            sbtmp34.append(" = ");
                            tmp32 = TclString.newInstance(sbtmp34);
                            tmp32.preserve();
                            objv31[1] = tmp32;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv31, compiledLocals, 1);
                        } finally {
                            TJC.releaseObjvElems(interp, objv31, 2);
                        }
                    } // End Invoke: append
                    { // Invoke: switch -exact -- $type {BOOLEAN} ... {DOUBLE} ... {INTEGER} ... {STRING} ... default ...
                        TclObject tmp35 = getVarScalar(interp, "type", compiledLocals, 4);
                        String tmp36 = tmp35.toString();
                        int tmp36_length = tmp36.length();
                        char tmp36_first = '\n';
                        if ( tmp36_length > 0 ) {
                            tmp36_first = tmp36.charAt(0);
                        }
                        if ( tmp36_length == 7 && tmp36_first == 'B'
                                && tmp36.compareTo("BOOLEAN") == 0 ) {
                            // Pattern {BOOLEAN}
                            { // Invoke: if {$value} ... else ...
                                TclObject tmp37 = getVarScalar(interp, "value", compiledLocals, 5);
                                boolean tmp38 = TJC.getBoolean(interp, tmp37);
                                if ( tmp38 ) {
                                    { // Invoke: set jval "true"
                                        setVarScalar(interp, "jval", const9, compiledLocals, 6);
                                    } // End Invoke: set
                                } else {
                                    { // Invoke: set jval "false"
                                        setVarScalar(interp, "jval", const10, compiledLocals, 6);
                                    } // End Invoke: set
                                }
                            } // End Invoke: if
                            { // Invoke: append buffer ... $jval ...
                                TclObject[] objv39 = TJC.grabObjv(interp, 3);
                                TclObject tmp40;
                                try {
                                    // Arg 2 constant: ...
                                    objv39[0] = const11;
                                    // Arg 3 variable: $jval
                                    tmp40 = getVarScalar(interp, "jval", compiledLocals, 6);
                                    tmp40.preserve();
                                    objv39[1] = tmp40;
                                    // Arg 4 constant: ...
                                    objv39[2] = const12;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv39, compiledLocals, 1);
                                } finally {
                                    tmp40 = objv39[1];
                                    if ( tmp40 != null ) {
                                        tmp40.release();
                                    }
                                    TJC.releaseObjv(interp, objv39, 3);
                                }
                            } // End Invoke: append
                            { // Invoke: append buffer [...] ... $name) ...
                                TclObject[] objv41 = TJC.grabObjv(interp, 4);
                                TclObject tmp42;
                                try {
                                    // Arg 2 command: [...]
                                    { // Invoke: emitter_indent
                                        TclObject[] objv43 = TJC.grabObjv(interp, 1);
                                        try {
                                            // Arg 0 constant: emitter_indent
                                            objv43[0] = const4;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                ? cmdcache3.cmd : null), objv43, 0);
                                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                updateCmdCache(interp, 3);
                                            }
                                        } finally {
                                            TJC.releaseObjv(interp, objv43, 1);
                                        }
                                    } // End Invoke: emitter_indent
                                    tmp42 = interp.getResult();
                                    tmp42.preserve();
                                    objv41[0] = tmp42;
                                    // Arg 3 constant: ...
                                    objv41[1] = const13;
                                    // Arg 4 word: $name)
                                    StringBuffer sbtmp44 = new StringBuffer(64);
                                    tmp42 = getVarScalar(interp, "name", compiledLocals, 3);
                                    sbtmp44.append(tmp42.toString());
                                    sbtmp44.append(")");
                                    tmp42 = TclString.newInstance(sbtmp44);
                                    tmp42.preserve();
                                    objv41[2] = tmp42;
                                    // Arg 5 constant: ...
                                    objv41[3] = const14;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv41, compiledLocals, 1);
                                } finally {
                                    tmp42 = objv41[0];
                                    if ( tmp42 != null ) {
                                        tmp42.release();
                                    }
                                    tmp42 = objv41[2];
                                    if ( tmp42 != null ) {
                                        tmp42.release();
                                    }
                                    TJC.releaseObjv(interp, objv41, 4);
                                }
                            } // End Invoke: append
                        } else if ( tmp36_length == 6 && tmp36_first == 'D'
                                && tmp36.compareTo("DOUBLE") == 0 ) {
                            // Pattern {DOUBLE}
                            { // Invoke: set parsed_double [...]
                                TclObject tmp45;
                                { // Invoke: expr {$value}
                                    TclObject tmp46 = getVarScalar(interp, "value", compiledLocals, 5);
                                    ExprValue tmp47 = evs0;
                                    TJC.exprInitValue(interp, tmp47, tmp46);
                                    TJC.exprSetResult(interp, tmp47);
                                } // End Invoke: expr
                                tmp45 = interp.getResult();
                                setVarScalar(interp, "parsed_double", tmp45, compiledLocals, 7);
                            } // End Invoke: set
                            { // Invoke: if ... ... else ...
                                // Binary operator: $parsed_double eq $value
                                TclObject tmp48 = getVarScalar(interp, "parsed_double", compiledLocals, 7);
                                String tmp49 = tmp48.toString();
                                TclObject tmp50 = getVarScalar(interp, "value", compiledLocals, 5);
                                String tmp51 = tmp50.toString();
                                boolean tmp52 = tmp49.equals(tmp51);
                                ExprValue tmp53 = evs0;
                                tmp53.setIntValue(tmp52);
                                // End Binary operator: eq
                                boolean tmp54 = ( tmp53.getIntValue() != 0 );
                                if ( tmp54 ) {
                                    { // Invoke: append buffer ... $value ...
                                        TclObject[] objv55 = TJC.grabObjv(interp, 3);
                                        TclObject tmp56;
                                        try {
                                            // Arg 2 constant: ...
                                            objv55[0] = const15;
                                            // Arg 3 variable: $value
                                            tmp56 = getVarScalar(interp, "value", compiledLocals, 5);
                                            tmp56.preserve();
                                            objv55[1] = tmp56;
                                            // Arg 4 constant: ...
                                            objv55[2] = const16;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv55, compiledLocals, 1);
                                        } finally {
                                            tmp56 = objv55[1];
                                            if ( tmp56 != null ) {
                                                tmp56.release();
                                            }
                                            TJC.releaseObjv(interp, objv55, 3);
                                        }
                                    } // End Invoke: append
                                } else {
                                    { // Invoke: set jstr [...]
                                        TclObject tmp57;
                                        { // Invoke: ... $value
                                            TclObject[] objv58 = TJC.grabObjv(interp, 2);
                                            TclObject tmp59;
                                            try {
                                                // Arg 0 constant: ...
                                                objv58[0] = const17;
                                                // Arg 1 variable: $value
                                                tmp59 = getVarScalar(interp, "value", compiledLocals, 5);
                                                tmp59.preserve();
                                                objv58[1] = tmp59;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv58, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp59 = objv58[1];
                                                if ( tmp59 != null ) {
                                                    tmp59.release();
                                                }
                                                TJC.releaseObjv(interp, objv58, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp57 = interp.getResult();
                                        setVarScalar(interp, "jstr", tmp57, compiledLocals, 8);
                                    } // End Invoke: set
                                    { // Invoke: append buffer ... $jstr ... [...] ... $name ...
                                        TclObject[] objv60 = TJC.grabObjv(interp, 7);
                                        TclObject tmp61;
                                        try {
                                            // Arg 2 constant: ...
                                            objv60[0] = const11;
                                            // Arg 3 variable: $jstr
                                            tmp61 = getVarScalar(interp, "jstr", compiledLocals, 8);
                                            tmp61.preserve();
                                            objv60[1] = tmp61;
                                            // Arg 4 constant: ...
                                            objv60[2] = const12;
                                            // Arg 5 command: [...]
                                            { // Invoke: emitter_indent
                                                TclObject[] objv62 = TJC.grabObjv(interp, 1);
                                                try {
                                                    // Arg 0 constant: emitter_indent
                                                    objv62[0] = const4;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                        ? cmdcache3.cmd : null), objv62, 0);
                                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                        updateCmdCache(interp, 3);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv62, 1);
                                                }
                                            } // End Invoke: emitter_indent
                                            tmp61 = interp.getResult();
                                            tmp61.preserve();
                                            objv60[3] = tmp61;
                                            // Arg 6 constant: ...
                                            objv60[4] = const18;
                                            // Arg 7 variable: $name
                                            tmp61 = getVarScalar(interp, "name", compiledLocals, 3);
                                            tmp61.preserve();
                                            objv60[5] = tmp61;
                                            // Arg 8 constant: ...
                                            objv60[6] = const16;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv60, compiledLocals, 1);
                                        } finally {
                                            tmp61 = objv60[1];
                                            if ( tmp61 != null ) {
                                                tmp61.release();
                                            }
                                            tmp61 = objv60[3];
                                            if ( tmp61 != null ) {
                                                tmp61.release();
                                            }
                                            tmp61 = objv60[5];
                                            if ( tmp61 != null ) {
                                                tmp61.release();
                                            }
                                            TJC.releaseObjv(interp, objv60, 7);
                                        }
                                    } // End Invoke: append
                                }
                            } // End Invoke: if
                        } else if ( tmp36_length == 7 && tmp36_first == 'I'
                                && tmp36.compareTo("INTEGER") == 0 ) {
                            // Pattern {INTEGER}
                            { // Invoke: set parsed_int [...]
                                TclObject tmp63;
                                { // Invoke: expr {$value}
                                    TclObject tmp64 = getVarScalar(interp, "value", compiledLocals, 5);
                                    ExprValue tmp65 = evs0;
                                    TJC.exprInitValue(interp, tmp65, tmp64);
                                    TJC.exprSetResult(interp, tmp65);
                                } // End Invoke: expr
                                tmp63 = interp.getResult();
                                setVarScalar(interp, "parsed_int", tmp63, compiledLocals, 9);
                            } // End Invoke: set
                            { // Invoke: if ... ... else ...
                                // Binary operator: $parsed_int eq $value
                                TclObject tmp66 = getVarScalar(interp, "parsed_int", compiledLocals, 9);
                                String tmp67 = tmp66.toString();
                                TclObject tmp68 = getVarScalar(interp, "value", compiledLocals, 5);
                                String tmp69 = tmp68.toString();
                                boolean tmp70 = tmp67.equals(tmp69);
                                ExprValue tmp71 = evs0;
                                tmp71.setIntValue(tmp70);
                                // End Binary operator: eq
                                boolean tmp72 = ( tmp71.getIntValue() != 0 );
                                if ( tmp72 ) {
                                    { // Invoke: append buffer ... $value ...
                                        TclObject[] objv73 = TJC.grabObjv(interp, 3);
                                        TclObject tmp74;
                                        try {
                                            // Arg 2 constant: ...
                                            objv73[0] = const19;
                                            // Arg 3 variable: $value
                                            tmp74 = getVarScalar(interp, "value", compiledLocals, 5);
                                            tmp74.preserve();
                                            objv73[1] = tmp74;
                                            // Arg 4 constant: ...
                                            objv73[2] = const16;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv73, compiledLocals, 1);
                                        } finally {
                                            tmp74 = objv73[1];
                                            if ( tmp74 != null ) {
                                                tmp74.release();
                                            }
                                            TJC.releaseObjv(interp, objv73, 3);
                                        }
                                    } // End Invoke: append
                                } else {
                                    { // Invoke: set jstr [...]
                                        TclObject tmp75;
                                        { // Invoke: ... $value
                                            TclObject[] objv76 = TJC.grabObjv(interp, 2);
                                            TclObject tmp77;
                                            try {
                                                // Arg 0 constant: ...
                                                objv76[0] = const17;
                                                // Arg 1 variable: $value
                                                tmp77 = getVarScalar(interp, "value", compiledLocals, 5);
                                                tmp77.preserve();
                                                objv76[1] = tmp77;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                                    ? cmdcache4.cmd : null), objv76, 0);
                                                if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                                    updateCmdCache(interp, 4);
                                                }
                                            } finally {
                                                tmp77 = objv76[1];
                                                if ( tmp77 != null ) {
                                                    tmp77.release();
                                                }
                                                TJC.releaseObjv(interp, objv76, 2);
                                            }
                                        } // End Invoke: ...
                                        tmp75 = interp.getResult();
                                        setVarScalar(interp, "jstr", tmp75, compiledLocals, 8);
                                    } // End Invoke: set
                                    { // Invoke: append buffer ... $jstr ... [...] ... $name ...
                                        TclObject[] objv78 = TJC.grabObjv(interp, 7);
                                        TclObject tmp79;
                                        try {
                                            // Arg 2 constant: ...
                                            objv78[0] = const11;
                                            // Arg 3 variable: $jstr
                                            tmp79 = getVarScalar(interp, "jstr", compiledLocals, 8);
                                            tmp79.preserve();
                                            objv78[1] = tmp79;
                                            // Arg 4 constant: ...
                                            objv78[2] = const12;
                                            // Arg 5 command: [...]
                                            { // Invoke: emitter_indent
                                                TclObject[] objv80 = TJC.grabObjv(interp, 1);
                                                try {
                                                    // Arg 0 constant: emitter_indent
                                                    objv80[0] = const4;
                                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                        updateCmdCache(interp, 0);
                                                    }
                                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                        ? cmdcache3.cmd : null), objv80, 0);
                                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                        updateCmdCache(interp, 3);
                                                    }
                                                } finally {
                                                    TJC.releaseObjv(interp, objv80, 1);
                                                }
                                            } // End Invoke: emitter_indent
                                            tmp79 = interp.getResult();
                                            tmp79.preserve();
                                            objv78[3] = tmp79;
                                            // Arg 6 constant: ...
                                            objv78[4] = const20;
                                            // Arg 7 variable: $name
                                            tmp79 = getVarScalar(interp, "name", compiledLocals, 3);
                                            tmp79.preserve();
                                            objv78[5] = tmp79;
                                            // Arg 8 constant: ...
                                            objv78[6] = const16;
                                            interp.resetResult();
                                            appendVarScalar(interp, "buffer", objv78, compiledLocals, 1);
                                        } finally {
                                            tmp79 = objv78[1];
                                            if ( tmp79 != null ) {
                                                tmp79.release();
                                            }
                                            tmp79 = objv78[3];
                                            if ( tmp79 != null ) {
                                                tmp79.release();
                                            }
                                            tmp79 = objv78[5];
                                            if ( tmp79 != null ) {
                                                tmp79.release();
                                            }
                                            TJC.releaseObjv(interp, objv78, 7);
                                        }
                                    } // End Invoke: append
                                }
                            } // End Invoke: if
                        } else if ( tmp36_length == 6 && tmp36_first == 'S'
                                && tmp36.compareTo("STRING") == 0 ) {
                            // Pattern {STRING}
                            { // Invoke: set jstr [...]
                                TclObject tmp81;
                                { // Invoke: ... $value
                                    TclObject[] objv82 = TJC.grabObjv(interp, 2);
                                    TclObject tmp83;
                                    try {
                                        // Arg 0 constant: ...
                                        objv82[0] = const17;
                                        // Arg 1 variable: $value
                                        tmp83 = getVarScalar(interp, "value", compiledLocals, 5);
                                        tmp83.preserve();
                                        objv82[1] = tmp83;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                            ? cmdcache4.cmd : null), objv82, 0);
                                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                            updateCmdCache(interp, 4);
                                        }
                                    } finally {
                                        tmp83 = objv82[1];
                                        if ( tmp83 != null ) {
                                            tmp83.release();
                                        }
                                        TJC.releaseObjv(interp, objv82, 2);
                                    }
                                } // End Invoke: ...
                                tmp81 = interp.getResult();
                                setVarScalar(interp, "jstr", tmp81, compiledLocals, 8);
                            } // End Invoke: set
                            { // Invoke: append buffer ... $jstr ...
                                TclObject[] objv84 = TJC.grabObjv(interp, 3);
                                TclObject tmp85;
                                try {
                                    // Arg 2 constant: ...
                                    objv84[0] = const11;
                                    // Arg 3 variable: $jstr
                                    tmp85 = getVarScalar(interp, "jstr", compiledLocals, 8);
                                    tmp85.preserve();
                                    objv84[1] = tmp85;
                                    // Arg 4 constant: ...
                                    objv84[2] = const21;
                                    interp.resetResult();
                                    appendVarScalar(interp, "buffer", objv84, compiledLocals, 1);
                                } finally {
                                    tmp85 = objv84[1];
                                    if ( tmp85 != null ) {
                                        tmp85.release();
                                    }
                                    TJC.releaseObjv(interp, objv84, 3);
                                }
                            } // End Invoke: append
                        } else {
                            // Pattern default
                            { // Invoke: error "..."
                                TclObject[] objv86 = TJC.grabObjv(interp, 2);
                                TclObject tmp87;
                                try {
                                    // Arg 0 constant: error
                                    objv86[0] = const1;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp88 = new StringBuffer(64);
                                    sbtmp88.append("unmatched type ");
                                    sbtmp88.append("\"");
                                    tmp87 = getVarScalar(interp, "type", compiledLocals, 4);
                                    sbtmp88.append(tmp87.toString());
                                    sbtmp88.append("\"");
                                    tmp87 = TclString.newInstance(sbtmp88);
                                    tmp87.preserve();
                                    objv86[1] = tmp87;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                        ? cmdcache2.cmd : null), objv86, 0);
                                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                        updateCmdCache(interp, 2);
                                    }
                                } finally {
                                    tmp87 = objv86[1];
                                    if ( tmp87 != null ) {
                                        tmp87.release();
                                    }
                                    TJC.releaseObjv(interp, objv86, 2);
                                }
                            } // End Invoke: error
                        }
                    } // End Invoke: switch
                    { // Invoke: append buffer ... [...]
                        TclObject[] objv89 = TJC.grabObjv(interp, 2);
                        TclObject tmp90;
                        try {
                            // Arg 2 constant: ...
                            objv89[0] = const7;
                            // Arg 3 command: [...]
                            { // Invoke: emitter_indent
                                TclObject[] objv91 = TJC.grabObjv(interp, 1);
                                try {
                                    // Arg 0 constant: emitter_indent
                                    objv91[0] = const4;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                        ? cmdcache3.cmd : null), objv91, 0);
                                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                        updateCmdCache(interp, 3);
                                    }
                                } finally {
                                    TJC.releaseObjv(interp, objv91, 1);
                                }
                            } // End Invoke: emitter_indent
                            tmp90 = interp.getResult();
                            tmp90.preserve();
                            objv89[1] = tmp90;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv89, compiledLocals, 1);
                        } finally {
                            tmp90 = objv89[1];
                            if ( tmp90 != null ) {
                                tmp90.release();
                            }
                            TJC.releaseObjv(interp, objv89, 2);
                        }
                    } // End Invoke: append
                    { // Invoke: append buffer $name ... " " $name ... ...
                        TclObject[] objv92 = TJC.grabObjv(interp, 6);
                        TclObject tmp93;
                        try {
                            // Arg 2 variable: $name
                            tmp93 = getVarScalar(interp, "name", compiledLocals, 3);
                            tmp93.preserve();
                            objv92[0] = tmp93;
                            // Arg 3 constant: ...
                            objv92[1] = const22;
                            // Arg 4 constant: " "
                            objv92[2] = const23;
                            // Arg 5 variable: $name
                            tmp93 = getVarScalar(interp, "name", compiledLocals, 3);
                            tmp93.preserve();
                            objv92[3] = tmp93;
                            // Arg 6 constant: ...
                            objv92[4] = const22;
                            // Arg 7 constant: ...
                            objv92[5] = const7;
                            interp.resetResult();
                            appendVarScalar(interp, "buffer", objv92, compiledLocals, 1);
                        } finally {
                            tmp93 = objv92[0];
                            if ( tmp93 != null ) {
                                tmp93.release();
                            }
                            tmp93 = objv92[3];
                            if ( tmp93 != null ) {
                                tmp93.release();
                            }
                            TJC.releaseObjv(interp, objv92, 6);
                        }
                    } // End Invoke: append
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp22 != null ) {
                    tmp22.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: emitter_indent_level -1
            TclObject[] objv94 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv94[0] = const0;
                // Arg 1 constant: -1
                objv94[1] = const24;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv94, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv94, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv95 = TJC.grabObjv(interp, 2);
            TclObject tmp96;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv97 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv97[0] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv97, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv97, 1);
                    }
                } // End Invoke: emitter_indent
                tmp96 = interp.getResult();
                tmp96.preserve();
                objv95[0] = tmp96;
                // Arg 3 constant: ...
                objv95[1] = const25;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv95, compiledLocals, 1);
            } finally {
                tmp96 = objv95[0];
                if ( tmp96 != null ) {
                    tmp96.release();
                }
                TJC.releaseObjv(interp, objv95, 2);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv98 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv98[0] = const0;
                // Arg 1 constant: -1
                objv98[1] = const24;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                    ? cmdcache1.cmd : null), objv98, 0);
                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                    updateCmdCache(interp, 1);
                }
            } finally {
                TJC.releaseObjv(interp, objv98, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: if ... ...
            // Binary operator: [...] != 0
            { // Invoke: emitter_indent_level
                TclObject[] objv99 = TJC.grabObjv(interp, 1);
                try {
                    // Arg 0 constant: emitter_indent_level
                    objv99[0] = const0;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv99, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv99, 1);
                }
            } // End Invoke: emitter_indent_level
            TclObject tmp100 = interp.getResult();
            ExprValue tmp101 = evs0;
            TJC.exprInitValue(interp, tmp101, tmp100);
            ExprValue tmp102 = evs1;
            tmp102.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp101, tmp102);
            // End Binary operator: !=
            boolean tmp103 = ( tmp101.getIntValue() != 0 );
            if ( tmp103 ) {
                { // Invoke: error "..."
                    TclObject[] objv104 = TJC.grabObjv(interp, 2);
                    TclObject tmp105;
                    try {
                        // Arg 0 constant: error
                        objv104[0] = const1;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp106 = new StringBuffer(64);
                        sbtmp106.append("expected exit indent level of 0, got ");
                        { // Invoke: emitter_indent_level
                            TclObject[] objv107 = TJC.grabObjv(interp, 1);
                            try {
                                // Arg 0 constant: emitter_indent_level
                                objv107[0] = const0;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv107, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv107, 1);
                            }
                        } // End Invoke: emitter_indent_level
                        tmp105 = interp.getResult();
                        sbtmp106.append(tmp105.toString());
                        tmp105 = TclString.newInstance(sbtmp106);
                        tmp105.preserve();
                        objv104[1] = tmp105;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv104, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp105 = objv104[1];
                        if ( tmp105 != null ) {
                            tmp105.release();
                        }
                        TJC.releaseObjv(interp, objv104, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: return $buffer
            TclObject tmp108 = getVarScalar(interp, "buffer", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp108);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_init_constants");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("emitter_indent_level");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("error");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("+1");
        TclInteger.get(interp, const3);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_indent");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("TclObject ");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance(";\n");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("\n");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("protected void initConstants(Interp interp) throws TclException {\n");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("true");
        TclBoolean.get(interp, const9);
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("false");
        TclBoolean.get(interp, const10);
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("TclString.newInstance(\"");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("\");\n");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("TclBoolean.get(interp, ");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance(";");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("TclDouble.newInstance(");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance(");");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("emitter_backslash_tcl_string");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("TclDouble.get(interp, ");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("TclInteger.newInstance(");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance("TclInteger.get(interp, ");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance("\");");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance(".preserve();");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance(" ");
        const23.preserve(); const23.preserve();
        const24 = TclInteger.newInstance(-1);
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("}\n");
        const25.preserve(); const25.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "emitter_indent_level";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "emitter_indent";
                break;
            }
            case 4: {
                cmdName = "emitter_backslash_tcl_string";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "tlist",
        "buffer",
        "tuple",
        "name",
        "type",
        "value",
        "jval",
        "parsed_double",
        "jstr",
        "parsed_int"
    };
} // end class EmitterInitConstantsCmd

