// TJC implementation of procedure emitter_num_args
package tjc;
import tcl.lang.*;

public class EmitterNumArgsCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 5, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "num arg_str");
        }
        setVarScalar(interp, "num", objv[1], compiledLocals, 0);
        setVarScalar(interp, "arg_str", objv[2], compiledLocals, 1);
        { // Invoke: global _emitter
            TJC.makeGlobalLinkVar(interp, "_emitter", "_emitter", 2);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: string is integer $num
                TclObject[] objv0 = TJC.grabObjv(interp, 4);
                TclObject tmp1;
                try {
                    // Arg 0 constant: string
                    objv0[0] = const0;
                    // Arg 1 constant: is
                    objv0[1] = const1;
                    // Arg 2 constant: integer
                    objv0[2] = const2;
                    // Arg 3 variable: $num
                    tmp1 = getVarScalar(interp, "num", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[3] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[3];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 4);
                }
            } // End Invoke: string
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("expected integer but got ");
                        sbtmp7.append("\"");
                        tmp6 = getVarScalar(interp, "num", compiledLocals, 0);
                        sbtmp7.append(tmp6.toString());
                        sbtmp7.append("\"");
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if {$num == 0} ...
            // Binary operator: $num == 0
            TclObject tmp8 = getVarScalar(interp, "num", compiledLocals, 0);
            ExprValue tmp9 = evs0;
            TJC.exprInitValue(interp, tmp9, tmp8);
            ExprValue tmp10 = evs1;
            tmp10.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp9, tmp10);
            // End Binary operator: ==
            boolean tmp11 = ( tmp9.getIntValue() != 0 );
            if ( tmp11 ) {
                { // Invoke: error ...
                    TclObject[] objv12 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv12[0] = const3;
                        // Arg 1 constant: ...
                        objv12[1] = const4;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv12, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv12, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set arg_str_symbol [...]
            TclObject tmp13;
            { // Invoke: ... $arg_str
                TclObject[] objv14 = TJC.grabObjv(interp, 2);
                TclObject tmp15;
                try {
                    // Arg 0 constant: ...
                    objv14[0] = const5;
                    // Arg 1 variable: $arg_str
                    tmp15 = getVarScalar(interp, "arg_str", compiledLocals, 1);
                    tmp15.preserve();
                    objv14[1] = tmp15;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv14, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp15 = objv14[1];
                    if ( tmp15 != null ) {
                        tmp15.release();
                    }
                    TJC.releaseObjv(interp, objv14, 2);
                }
            } // End Invoke: ...
            tmp13 = interp.getResult();
            setVarScalar(interp, "arg_str_symbol", tmp13, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const6, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: append buffer [...] ... [...] ...
            TclObject[] objv16 = TJC.grabObjv(interp, 4);
            TclObject tmp17;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv18 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv18[0] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv18, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv18, 1);
                    }
                } // End Invoke: emitter_indent
                tmp17 = interp.getResult();
                tmp17.preserve();
                objv16[0] = tmp17;
                // Arg 3 constant: ...
                objv16[1] = const8;
                // Arg 4 command: [...]
                { // Invoke: expr {$num + 1}
                    // Binary operator: $num + 1
                    TclObject tmp19 = getVarScalar(interp, "num", compiledLocals, 0);
                    ExprValue tmp20 = evs0;
                    TJC.exprInitValue(interp, tmp20, tmp19);
                    ExprValue tmp21 = evs1;
                    tmp21.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp20, tmp21);
                    // End Binary operator: +
                    TJC.exprSetResult(interp, tmp20);
                } // End Invoke: expr
                tmp17 = interp.getResult();
                tmp17.preserve();
                objv16[2] = tmp17;
                // Arg 5 constant: ...
                objv16[3] = const9;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv16, compiledLocals, 4);
            } finally {
                tmp17 = objv16[0];
                if ( tmp17 != null ) {
                    tmp17.release();
                }
                tmp17 = objv16[2];
                if ( tmp17 != null ) {
                    tmp17.release();
                }
                TJC.releaseObjv(interp, objv16, 4);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv22 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv22[0] = const10;
                // Arg 1 constant: +1
                objv22[1] = const11;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                    ? cmdcache5.cmd : null), objv22, 0);
                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                    updateCmdCache(interp, 5);
                }
            } finally {
                TJC.releaseObjv(interp, objv22, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ... $arg_str_symbol ...
            TclObject[] objv23 = TJC.grabObjv(interp, 4);
            TclObject tmp24;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv25 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv25[0] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv25, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv25, 1);
                    }
                } // End Invoke: emitter_indent
                tmp24 = interp.getResult();
                tmp24.preserve();
                objv23[0] = tmp24;
                // Arg 3 constant: ...
                objv23[1] = const12;
                // Arg 4 variable: $arg_str_symbol
                tmp24 = getVarScalar(interp, "arg_str_symbol", compiledLocals, 3);
                tmp24.preserve();
                objv23[2] = tmp24;
                // Arg 5 constant: ...
                objv23[3] = const13;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv23, compiledLocals, 4);
            } finally {
                tmp24 = objv23[0];
                if ( tmp24 != null ) {
                    tmp24.release();
                }
                tmp24 = objv23[2];
                if ( tmp24 != null ) {
                    tmp24.release();
                }
                TJC.releaseObjv(interp, objv23, 4);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv26 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv26[0] = const10;
                // Arg 1 constant: -1
                objv26[1] = const14;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                    ? cmdcache5.cmd : null), objv26, 0);
                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                    updateCmdCache(interp, 5);
                }
            } finally {
                TJC.releaseObjv(interp, objv26, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv27 = TJC.grabObjv(interp, 2);
            TclObject tmp28;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv29 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv29[0] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv29, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv29, 1);
                    }
                } // End Invoke: emitter_indent
                tmp28 = interp.getResult();
                tmp28.preserve();
                objv27[0] = tmp28;
                // Arg 3 constant: ...
                objv27[1] = const15;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv27, compiledLocals, 4);
            } finally {
                tmp28 = objv27[0];
                if ( tmp28 != null ) {
                    tmp28.release();
                }
                TJC.releaseObjv(interp, objv27, 2);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp30 = getVarScalar(interp, "buffer", compiledLocals, 4);
            interp.resetResult();
            interp.setResult(tmp30);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_num_args");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("is");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("integer");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("should use emitter_empty_args for zero args");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("emitter_double_quote_tcl_string");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("emitter_indent");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("if (objv.length != ");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance(") {\n");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("emitter_indent_level");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("+1");
        TclInteger.get(interp, const11);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("throw new TclNumArgsException(interp, 1, objv, ");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance(");\n");
        const13.preserve(); const13.preserve();
        const14 = TclInteger.newInstance(-1);
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("}\n");
        const15.preserve(); const15.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            case 4: {
                cmdName = "emitter_indent";
                break;
            }
            case 5: {
                cmdName = "emitter_indent_level";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "num",
        "arg_str",
        "_emitter",
        "arg_str_symbol",
        "buffer"
    };
} // end class EmitterNumArgsCmd

