// TJC implementation of procedure emitter_num_range_args
package tjc;
import tcl.lang.*;

public class EmitterNumRangeArgsCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 6, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 4) {
            throw new TclNumArgsException(interp, 1, objv, "min max arg_str");
        }
        setVarScalar(interp, "min", objv[1], compiledLocals, 0);
        setVarScalar(interp, "max", objv[2], compiledLocals, 1);
        setVarScalar(interp, "arg_str", objv[3], compiledLocals, 2);
        { // Invoke: global _emitter
            TJC.makeGlobalLinkVar(interp, "_emitter", "_emitter", 3);
        } // End Invoke: global
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: string is integer $min
                TclObject[] objv0 = TJC.grabObjv(interp, 4);
                TclObject tmp1;
                try {
                    // Arg 0 constant: string
                    objv0[0] = const0;
                    // Arg 1 constant: is
                    objv0[1] = const1;
                    // Arg 2 constant: integer
                    objv0[2] = const2;
                    // Arg 3 variable: $min
                    tmp1 = getVarScalar(interp, "min", compiledLocals, 0);
                    tmp1.preserve();
                    objv0[3] = tmp1;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp1 = objv0[3];
                    if ( tmp1 != null ) {
                        tmp1.release();
                    }
                    TJC.releaseObjv(interp, objv0, 4);
                }
            } // End Invoke: string
            TclObject tmp2 = interp.getResult();
            ExprValue tmp3 = evs0;
            if ( tmp2.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp3, tmp2);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp3, tmp2);
            }
            // End Unary operator: !
            boolean tmp4 = ( tmp3.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: error "..."
                    TclObject[] objv5 = TJC.grabObjv(interp, 2);
                    TclObject tmp6;
                    try {
                        // Arg 0 constant: error
                        objv5[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp7 = new StringBuffer(64);
                        sbtmp7.append("expected integer but got ");
                        sbtmp7.append("\"");
                        tmp6 = getVarScalar(interp, "min", compiledLocals, 0);
                        sbtmp7.append(tmp6.toString());
                        sbtmp7.append("\"");
                        tmp6 = TclString.newInstance(sbtmp7);
                        tmp6.preserve();
                        objv5[1] = tmp6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv5, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp6 = objv5[1];
                        if ( tmp6 != null ) {
                            tmp6.release();
                        }
                        TJC.releaseObjv(interp, objv5, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: string is integer $max
                TclObject[] objv8 = TJC.grabObjv(interp, 4);
                TclObject tmp9;
                try {
                    // Arg 0 constant: string
                    objv8[0] = const0;
                    // Arg 1 constant: is
                    objv8[1] = const1;
                    // Arg 2 constant: integer
                    objv8[2] = const2;
                    // Arg 3 variable: $max
                    tmp9 = getVarScalar(interp, "max", compiledLocals, 1);
                    tmp9.preserve();
                    objv8[3] = tmp9;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv8, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp9 = objv8[3];
                    if ( tmp9 != null ) {
                        tmp9.release();
                    }
                    TJC.releaseObjv(interp, objv8, 4);
                }
            } // End Invoke: string
            TclObject tmp10 = interp.getResult();
            ExprValue tmp11 = evs0;
            if ( tmp10.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp11, tmp10);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp11, tmp10);
            }
            // End Unary operator: !
            boolean tmp12 = ( tmp11.getIntValue() != 0 );
            if ( tmp12 ) {
                { // Invoke: error "..."
                    TclObject[] objv13 = TJC.grabObjv(interp, 2);
                    TclObject tmp14;
                    try {
                        // Arg 0 constant: error
                        objv13[0] = const3;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp15 = new StringBuffer(64);
                        sbtmp15.append("expected integer but got ");
                        sbtmp15.append("\"");
                        tmp14 = getVarScalar(interp, "max", compiledLocals, 1);
                        sbtmp15.append(tmp14.toString());
                        sbtmp15.append("\"");
                        tmp14 = TclString.newInstance(sbtmp15);
                        tmp14.preserve();
                        objv13[1] = tmp14;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv13, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp14 = objv13[1];
                        if ( tmp14 != null ) {
                            tmp14.release();
                        }
                        TJC.releaseObjv(interp, objv13, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set arg_str_symbol [...]
            TclObject tmp16;
            { // Invoke: ... $arg_str
                TclObject[] objv17 = TJC.grabObjv(interp, 2);
                TclObject tmp18;
                try {
                    // Arg 0 constant: ...
                    objv17[0] = const4;
                    // Arg 1 variable: $arg_str
                    tmp18 = getVarScalar(interp, "arg_str", compiledLocals, 2);
                    tmp18.preserve();
                    objv17[1] = tmp18;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                        ? cmdcache3.cmd : null), objv17, 0);
                    if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                        updateCmdCache(interp, 3);
                    }
                } finally {
                    tmp18 = objv17[1];
                    if ( tmp18 != null ) {
                        tmp18.release();
                    }
                    TJC.releaseObjv(interp, objv17, 2);
                }
            } // End Invoke: ...
            tmp16 = interp.getResult();
            setVarScalar(interp, "arg_str_symbol", tmp16, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set buffer ""
            setVarScalar(interp, "buffer", const5, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: append buffer [...] "if (objv.length < " [...] " || objv.length > " [...] ...
            TclObject[] objv19 = TJC.grabObjv(interp, 6);
            TclObject tmp20;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv21 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv21[0] = const6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv21, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv21, 1);
                    }
                } // End Invoke: emitter_indent
                tmp20 = interp.getResult();
                tmp20.preserve();
                objv19[0] = tmp20;
                // Arg 3 constant: "if (objv.length < "
                objv19[1] = const7;
                // Arg 4 command: [...]
                { // Invoke: expr {$min + 1}
                    // Binary operator: $min + 1
                    TclObject tmp22 = getVarScalar(interp, "min", compiledLocals, 0);
                    ExprValue tmp23 = evs0;
                    TJC.exprInitValue(interp, tmp23, tmp22);
                    ExprValue tmp24 = evs1;
                    tmp24.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp23, tmp24);
                    // End Binary operator: +
                    TJC.exprSetResult(interp, tmp23);
                } // End Invoke: expr
                tmp20 = interp.getResult();
                tmp20.preserve();
                objv19[2] = tmp20;
                // Arg 5 constant: " || objv.length > "
                objv19[3] = const8;
                // Arg 6 command: [...]
                { // Invoke: expr {$max + 1}
                    // Binary operator: $max + 1
                    TclObject tmp25 = getVarScalar(interp, "max", compiledLocals, 1);
                    ExprValue tmp26 = evs0;
                    TJC.exprInitValue(interp, tmp26, tmp25);
                    ExprValue tmp27 = evs1;
                    tmp27.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp26, tmp27);
                    // End Binary operator: +
                    TJC.exprSetResult(interp, tmp26);
                } // End Invoke: expr
                tmp20 = interp.getResult();
                tmp20.preserve();
                objv19[4] = tmp20;
                // Arg 7 constant: ...
                objv19[5] = const9;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv19, compiledLocals, 5);
            } finally {
                tmp20 = objv19[0];
                if ( tmp20 != null ) {
                    tmp20.release();
                }
                tmp20 = objv19[2];
                if ( tmp20 != null ) {
                    tmp20.release();
                }
                tmp20 = objv19[4];
                if ( tmp20 != null ) {
                    tmp20.release();
                }
                TJC.releaseObjv(interp, objv19, 6);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level +1
            TclObject[] objv28 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv28[0] = const10;
                // Arg 1 constant: +1
                objv28[1] = const11;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                    ? cmdcache5.cmd : null), objv28, 0);
                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                    updateCmdCache(interp, 5);
                }
            } finally {
                TJC.releaseObjv(interp, objv28, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ... $arg_str_symbol ...
            TclObject[] objv29 = TJC.grabObjv(interp, 4);
            TclObject tmp30;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv31 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv31[0] = const6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv31, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv31, 1);
                    }
                } // End Invoke: emitter_indent
                tmp30 = interp.getResult();
                tmp30.preserve();
                objv29[0] = tmp30;
                // Arg 3 constant: ...
                objv29[1] = const12;
                // Arg 4 variable: $arg_str_symbol
                tmp30 = getVarScalar(interp, "arg_str_symbol", compiledLocals, 4);
                tmp30.preserve();
                objv29[2] = tmp30;
                // Arg 5 constant: ...
                objv29[3] = const13;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv29, compiledLocals, 5);
            } finally {
                tmp30 = objv29[0];
                if ( tmp30 != null ) {
                    tmp30.release();
                }
                tmp30 = objv29[2];
                if ( tmp30 != null ) {
                    tmp30.release();
                }
                TJC.releaseObjv(interp, objv29, 4);
            }
        } // End Invoke: append
        { // Invoke: emitter_indent_level -1
            TclObject[] objv32 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: emitter_indent_level
                objv32[0] = const10;
                // Arg 1 constant: -1
                objv32[1] = const14;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                    ? cmdcache5.cmd : null), objv32, 0);
                if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                    updateCmdCache(interp, 5);
                }
            } finally {
                TJC.releaseObjv(interp, objv32, 2);
            }
        } // End Invoke: emitter_indent_level
        { // Invoke: append buffer [...] ...
            TclObject[] objv33 = TJC.grabObjv(interp, 2);
            TclObject tmp34;
            try {
                // Arg 2 command: [...]
                { // Invoke: emitter_indent
                    TclObject[] objv35 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: emitter_indent
                        objv35[0] = const6;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv35, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv35, 1);
                    }
                } // End Invoke: emitter_indent
                tmp34 = interp.getResult();
                tmp34.preserve();
                objv33[0] = tmp34;
                // Arg 3 constant: ...
                objv33[1] = const15;
                interp.resetResult();
                appendVarScalar(interp, "buffer", objv33, compiledLocals, 5);
            } finally {
                tmp34 = objv33[0];
                if ( tmp34 != null ) {
                    tmp34.release();
                }
                TJC.releaseObjv(interp, objv33, 2);
            }
        } // End Invoke: append
        { // Invoke: return $buffer
            TclObject tmp36 = getVarScalar(interp, "buffer", compiledLocals, 5);
            interp.resetResult();
            interp.setResult(tmp36);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "emitter_num_range_args");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("string");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("is");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("integer");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("error");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("emitter_double_quote_tcl_string");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("emitter_indent");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("if (objv.length < ");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance(" || objv.length > ");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance(") {\n");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("emitter_indent_level");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("+1");
        TclInteger.get(interp, const11);
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("throw new TclNumArgsException(interp, 1, objv, ");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance(");\n");
        const13.preserve(); const13.preserve();
        const14 = TclInteger.newInstance(-1);
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("}\n");
        const15.preserve(); const15.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "string";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            case 3: {
                cmdName = "emitter_double_quote_tcl_string";
                break;
            }
            case 4: {
                cmdName = "emitter_indent";
                break;
            }
            case 5: {
                cmdName = "emitter_indent_level";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "min",
        "max",
        "arg_str",
        "_emitter",
        "arg_str_symbol",
        "buffer"
    };
} // end class EmitterNumRangeArgsCmd

