// TJC implementation of procedure jdk_tool_cleanup
package tjc;
import tcl.lang.*;

public class JdkToolCleanupCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        try {
        if (objv.length != 1) {
            throw new TclNumArgsException(interp, 1, objv, "");
        }
        { // Invoke: file delete -force [...]
            TclObject[] objv0 = TJC.grabObjv(interp, 4);
            TclObject tmp1;
            try {
                // Arg 0 constant: file
                objv0[0] = const0;
                // Arg 1 constant: delete
                objv0[1] = const1;
                // Arg 2 constant: -force
                objv0[2] = const2;
                // Arg 3 command: [...]
                { // Invoke: jdk_tjc_rootdir
                    TclObject[] objv2 = TJC.grabObjv(interp, 1);
                    try {
                        // Arg 0 constant: jdk_tjc_rootdir
                        objv2[0] = const3;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 1);
                    }
                } // End Invoke: jdk_tjc_rootdir
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[3] = tmp1;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv0, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                tmp1 = objv0[3];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                TJC.releaseObjv(interp, objv0, 4);
            }
        } // End Invoke: file
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "jdk_tool_cleanup");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("file");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("delete");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("-force");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("jdk_tjc_rootdir");
        const3.preserve(); const3.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "jdk_tjc_rootdir";
                break;
            }
            case 2: {
                cmdName = "file";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }
} // end class JdkToolCleanupCmd

