// TJC implementation of procedure jdk_tool_javac
package tjc;
import tcl.lang.*;

public class JdkToolJavacCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 25, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "filenames");
        }
        setVarScalar(interp, "filenames", objv[1], compiledLocals, 0);
        { // Invoke: global _tjc
            TJC.makeGlobalLinkVar(interp, "_tjc", "_tjc", 1);
        } // End Invoke: global
        { // Invoke: set debug 0
            setVarScalar(interp, "debug", const0, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] && $_tjc(...)
            { // Invoke: info exists _tjc(debug)
                TclObject[] objv0 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv0[0] = const1;
                    // Arg 1 constant: exists
                    objv0[1] = const2;
                    // Arg 2 constant: _tjc(debug)
                    objv0[2] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv0, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv0, 3);
                }
            } // End Invoke: info
            TclObject tmp1 = interp.getResult();
            ExprValue tmp2 = evs0;
            TJC.exprInitValue(interp, tmp2, tmp1);
            if (tmp2.getBooleanValue(interp)) {
            TclObject tmp3 = getVarArray(interp, "_tjc", "debug", compiledLocals, 1);
            ExprValue tmp4 = evs1;
            TJC.exprInitValue(interp, tmp4, tmp3);
            tmp2.setIntValue(tmp4.getBooleanValue(interp));
            } else {
            tmp2.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp5 = ( tmp2.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: set debug 1
                    setVarScalar(interp, "debug", const4, compiledLocals, 2);
                } // End Invoke: set
            }
        } // End Invoke: if
        { // Invoke: set TJC [...]
            TclObject tmp6;
            { // Invoke: file join [...] [...]
                TclObject[] objv7 = TJC.grabObjv(interp, 4);
                TclObject tmp8;
                try {
                    // Arg 0 constant: file
                    objv7[0] = const5;
                    // Arg 1 constant: join
                    objv7[1] = const6;
                    // Arg 2 command: [...]
                    { // Invoke: pwd
                        TclObject[] objv9 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: pwd
                            objv9[0] = const7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                ? cmdcache2.cmd : null), objv9, 0);
                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                updateCmdCache(interp, 2);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv9, 1);
                        }
                    } // End Invoke: pwd
                    tmp8 = interp.getResult();
                    tmp8.preserve();
                    objv7[2] = tmp8;
                    // Arg 3 command: [...]
                    { // Invoke: jdk_tjc_rootdir
                        TclObject[] objv10 = TJC.grabObjv(interp, 1);
                        try {
                            // Arg 0 constant: jdk_tjc_rootdir
                            objv10[0] = const8;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv10, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv10, 1);
                        }
                    } // End Invoke: jdk_tjc_rootdir
                    tmp8 = interp.getResult();
                    tmp8.preserve();
                    objv7[3] = tmp8;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv7, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp8 = objv7[2];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    tmp8 = objv7[3];
                    if ( tmp8 != null ) {
                        tmp8.release();
                    }
                    TJC.releaseObjv(interp, objv7, 4);
                }
            } // End Invoke: file
            tmp6 = interp.getResult();
            setVarScalar(interp, "TJC", tmp6, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set TJC_source [...]
            TclObject tmp11;
            { // Invoke: file join $TJC source
                TclObject[] objv12 = TJC.grabObjv(interp, 4);
                TclObject tmp13;
                try {
                    // Arg 0 constant: file
                    objv12[0] = const5;
                    // Arg 1 constant: join
                    objv12[1] = const6;
                    // Arg 2 variable: $TJC
                    tmp13 = getVarScalar(interp, "TJC", compiledLocals, 3);
                    tmp13.preserve();
                    objv12[2] = tmp13;
                    // Arg 3 constant: source
                    objv12[3] = const9;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv12, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp13 = objv12[2];
                    if ( tmp13 != null ) {
                        tmp13.release();
                    }
                    TJC.releaseObjv(interp, objv12, 4);
                }
            } // End Invoke: file
            tmp11 = interp.getResult();
            setVarScalar(interp, "TJC_source", tmp11, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set TJC_build [...]
            TclObject tmp14;
            { // Invoke: file join $TJC build
                TclObject[] objv15 = TJC.grabObjv(interp, 4);
                TclObject tmp16;
                try {
                    // Arg 0 constant: file
                    objv15[0] = const5;
                    // Arg 1 constant: join
                    objv15[1] = const6;
                    // Arg 2 variable: $TJC
                    tmp16 = getVarScalar(interp, "TJC", compiledLocals, 3);
                    tmp16.preserve();
                    objv15[2] = tmp16;
                    // Arg 3 constant: build
                    objv15[3] = const10;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv15, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp16 = objv15[2];
                    if ( tmp16 != null ) {
                        tmp16.release();
                    }
                    TJC.releaseObjv(interp, objv15, 4);
                }
            } // End Invoke: file
            tmp14 = interp.getResult();
            setVarScalar(interp, "TJC_build", tmp14, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: [...] == 0
            { // Invoke: llength $filenames
                TclObject tmp17 = getVarScalar(interp, "filenames", compiledLocals, 0);
                int tmp18 = TclList.getLength(interp, tmp17);
                interp.setResult(tmp18);
            } // End Invoke: llength
            TclObject tmp19 = interp.getResult();
            ExprValue tmp20 = evs0;
            TJC.exprInitValue(interp, tmp20, tmp19);
            ExprValue tmp21 = evs1;
            tmp21.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp20, tmp21);
            // End Binary operator: ==
            boolean tmp22 = ( tmp20.getIntValue() != 0 );
            if ( tmp22 ) {
                { // Invoke: error ...
                    TclObject[] objv23 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv23[0] = const11;
                        // Arg 1 constant: ...
                        objv23[1] = const12;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv23, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv23, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set javac [...]
            TclObject tmp24;
            { // Invoke: jdk_config_var JAVAC
                TclObject[] objv25 = TJC.grabObjv(interp, 2);
                try {
                    // Arg 0 constant: jdk_config_var
                    objv25[0] = const13;
                    // Arg 1 constant: JAVAC
                    objv25[1] = const14;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv25, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv25, 2);
                }
            } // End Invoke: jdk_config_var
            tmp24 = interp.getResult();
            setVarScalar(interp, "javac", tmp24, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: if {$javac == ""} ...
            // Binary operator: $javac == ""
            TclObject tmp26 = getVarScalar(interp, "javac", compiledLocals, 6);
            ExprValue tmp27 = evs0;
            TJC.exprEqualsEmptyString(tmp27, tmp26, false);
            // End Binary operator: ==
            boolean tmp28 = ( tmp27.getIntValue() != 0 );
            if ( tmp28 ) {
                { // Invoke: error "JAVAC not defined"
                    TclObject[] objv29 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv29[0] = const11;
                        // Arg 1 constant: "JAVAC not defined"
                        objv29[1] = const15;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                            ? cmdcache5.cmd : null), objv29, 0);
                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                            updateCmdCache(interp, 5);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv29, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: if ... ...
            // Binary operator: [...] && ()
            { // Invoke: info exists _tjc(compiler)
                TclObject[] objv30 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv30[0] = const1;
                    // Arg 1 constant: exists
                    objv30[1] = const2;
                    // Arg 2 constant: _tjc(compiler)
                    objv30[2] = const16;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv30, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv30, 3);
                }
            } // End Invoke: info
            TclObject tmp31 = interp.getResult();
            ExprValue tmp32 = evs0;
            TJC.exprInitValue(interp, tmp32, tmp31);
            if (tmp32.getBooleanValue(interp)) {
            // Binary operator: $_tjc(...) != "javac"
            TclObject tmp33 = getVarArray(interp, "_tjc", "compiler", compiledLocals, 1);
            boolean tmp34 = ! tmp33.toString().equals("javac");
            ExprValue tmp35 = evs1;
            tmp35.setIntValue(tmp34);
            // End Binary operator: !=
            tmp32.setIntValue(tmp35.getBooleanValue(interp));
            } else {
            tmp32.setIntValue(0);
            } // End if: [...]
            // End Binary operator: &&
            boolean tmp36 = ( tmp32.getIntValue() != 0 );
            if ( tmp36 ) {
                { // Invoke: set compiler $_tjc(compiler)
                    TclObject tmp37;
                    tmp37 = getVarArray(interp, "_tjc", "compiler", compiledLocals, 1);
                    setVarScalar(interp, "compiler", tmp37, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: set jar [...]
                    TclObject tmp38;
                    { // Invoke: jdk_config_var JAR
                        TclObject[] objv39 = TJC.grabObjv(interp, 2);
                        try {
                            // Arg 0 constant: jdk_config_var
                            objv39[0] = const13;
                            // Arg 1 constant: JAR
                            objv39[1] = const17;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                                ? cmdcache6.cmd : null), objv39, 0);
                            if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                                updateCmdCache(interp, 6);
                            }
                        } finally {
                            TJC.releaseObjv(interp, objv39, 2);
                        }
                    } // End Invoke: jdk_config_var
                    tmp38 = interp.getResult();
                    setVarScalar(interp, "jar", tmp38, compiledLocals, 8);
                } // End Invoke: set
                { // Invoke: set dir [...]
                    TclObject tmp40;
                    { // Invoke: file dir $jar
                        TclObject[] objv41 = TJC.grabObjv(interp, 3);
                        TclObject tmp42;
                        try {
                            // Arg 0 constant: file
                            objv41[0] = const5;
                            // Arg 1 constant: dir
                            objv41[1] = const18;
                            // Arg 2 variable: $jar
                            tmp42 = getVarScalar(interp, "jar", compiledLocals, 8);
                            tmp42.preserve();
                            objv41[2] = tmp42;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv41, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp42 = objv41[2];
                            if ( tmp42 != null ) {
                                tmp42.release();
                            }
                            TJC.releaseObjv(interp, objv41, 3);
                        }
                    } // End Invoke: file
                    tmp40 = interp.getResult();
                    setVarScalar(interp, "dir", tmp40, compiledLocals, 9);
                } // End Invoke: set
                { // Invoke: set java [...]
                    TclObject tmp43;
                    { // Invoke: file join $dir java
                        TclObject[] objv44 = TJC.grabObjv(interp, 4);
                        TclObject tmp45;
                        try {
                            // Arg 0 constant: file
                            objv44[0] = const5;
                            // Arg 1 constant: join
                            objv44[1] = const6;
                            // Arg 2 variable: $dir
                            tmp45 = getVarScalar(interp, "dir", compiledLocals, 9);
                            tmp45.preserve();
                            objv44[2] = tmp45;
                            // Arg 3 constant: java
                            objv44[3] = const19;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                ? cmdcache4.cmd : null), objv44, 0);
                            if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                updateCmdCache(interp, 4);
                            }
                        } finally {
                            tmp45 = objv44[2];
                            if ( tmp45 != null ) {
                                tmp45.release();
                            }
                            TJC.releaseObjv(interp, objv44, 4);
                        }
                    } // End Invoke: file
                    tmp43 = interp.getResult();
                    setVarScalar(interp, "java", tmp43, compiledLocals, 10);
                } // End Invoke: set
                { // Invoke: set classpath $::env(CLASSPATH)
                    TclObject tmp46;
                    initVarScoped(interp, "::env", compiledLocals, 11);
                    tmp46 = getVarArray(interp, "::env", "CLASSPATH", compiledLocals, 11);
                    setVarScalar(interp, "classpath", tmp46, compiledLocals, 12);
                } // End Invoke: set
                { // Invoke: if ... ... else ...
                    // Binary operator: $::tcl_platform(...) == "windows"
                    initVarScoped(interp, "::tcl_platform", compiledLocals, 13);
                    TclObject tmp47 = getVarArray(interp, "::tcl_platform", "host_platform", compiledLocals, 13);
                    boolean tmp48 = tmp47.toString().equals("windows");
                    ExprValue tmp49 = evs0;
                    tmp49.setIntValue(tmp48);
                    // End Binary operator: ==
                    boolean tmp50 = ( tmp49.getIntValue() != 0 );
                    if ( tmp50 ) {
                        { // Invoke: set sep ...
                            setVarScalar(interp, "sep", const20, compiledLocals, 14);
                        } // End Invoke: set
                    } else {
                        { // Invoke: set sep :
                            setVarScalar(interp, "sep", const21, compiledLocals, 14);
                        } // End Invoke: set
                    }
                } // End Invoke: if
                { // Invoke: if ... ... elseif ... ... else ...
                    // Binary operator: $compiler == "pizza"
                    TclObject tmp51 = getVarScalar(interp, "compiler", compiledLocals, 7);
                    boolean tmp52 = tmp51.toString().equals("pizza");
                    ExprValue tmp53 = evs0;
                    tmp53.setIntValue(tmp52);
                    // End Binary operator: ==
                    boolean tmp54 = ( tmp53.getIntValue() != 0 );
                    if ( tmp54 ) {
                        { // Invoke: append classpath $sep "..."
                            TclObject[] objv55 = TJC.grabObjv(interp, 2);
                            TclObject tmp56;
                            try {
                                // Arg 2 variable: $sep
                                tmp56 = getVarScalar(interp, "sep", compiledLocals, 14);
                                tmp56.preserve();
                                objv55[0] = tmp56;
                                // Arg 3 word: "..."
                                StringBuffer sbtmp57 = new StringBuffer(64);
                                tmp56 = getVarArray(interp, "_tjc", "jardir", compiledLocals, 1);
                                sbtmp57.append(tmp56.toString());
                                sbtmp57.append("/pizza-1.1.jar");
                                tmp56 = TclString.newInstance(sbtmp57);
                                tmp56.preserve();
                                objv55[1] = tmp56;
                                interp.resetResult();
                                appendVarScalar(interp, "classpath", objv55, compiledLocals, 12);
                            } finally {
                                TJC.releaseObjvElems(interp, objv55, 2);
                            }
                        } // End Invoke: append
                        { // Invoke: set javac [...]
                            TclObject tmp58;
                            { // Invoke: list $java -classpath $classpath ...
                                TclObject tmp59 = TclList.newInstance();
                                TclObject tmp60;
                                try {
                                    tmp60 = getVarScalar(interp, "java", compiledLocals, 10);
                                    TclList.append(interp, tmp59, tmp60);
                                    TclList.append(interp, tmp59, const22);
                                    tmp60 = getVarScalar(interp, "classpath", compiledLocals, 12);
                                    TclList.append(interp, tmp59, tmp60);
                                    TclList.append(interp, tmp59, const23);
                                } catch (TclException ex) {
                                    tmp59.release();
                                    throw ex;
                                }
                                interp.setResult(tmp59);
                            } // End Invoke: list
                            tmp58 = interp.getResult();
                            setVarScalar(interp, "javac", tmp58, compiledLocals, 6);
                        } // End Invoke: set
                    } else {
                        // Binary operator: $compiler == "janino"
                        TclObject tmp61 = getVarScalar(interp, "compiler", compiledLocals, 7);
                        boolean tmp62 = tmp61.toString().equals("janino");
                        ExprValue tmp63 = evs0;
                        tmp63.setIntValue(tmp62);
                        // End Binary operator: ==
                        boolean tmp64 = ( tmp63.getIntValue() != 0 );
                        if ( tmp64 ) {
                            { // Invoke: append classpath $sep "..."
                                TclObject[] objv65 = TJC.grabObjv(interp, 2);
                                TclObject tmp66;
                                try {
                                    // Arg 2 variable: $sep
                                    tmp66 = getVarScalar(interp, "sep", compiledLocals, 14);
                                    tmp66.preserve();
                                    objv65[0] = tmp66;
                                    // Arg 3 word: "..."
                                    StringBuffer sbtmp67 = new StringBuffer(64);
                                    tmp66 = getVarArray(interp, "_tjc", "jardir", compiledLocals, 1);
                                    sbtmp67.append(tmp66.toString());
                                    sbtmp67.append("/janino.jar");
                                    tmp66 = TclString.newInstance(sbtmp67);
                                    tmp66.preserve();
                                    objv65[1] = tmp66;
                                    interp.resetResult();
                                    appendVarScalar(interp, "classpath", objv65, compiledLocals, 12);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv65, 2);
                                }
                            } // End Invoke: append
                            { // Invoke: set javac [...]
                                TclObject tmp68;
                                { // Invoke: list $java -classpath $classpath ... -classpath $classpath
                                    TclObject tmp69 = TclList.newInstance();
                                    TclObject tmp70;
                                    try {
                                        tmp70 = getVarScalar(interp, "java", compiledLocals, 10);
                                        TclList.append(interp, tmp69, tmp70);
                                        TclList.append(interp, tmp69, const22);
                                        tmp70 = getVarScalar(interp, "classpath", compiledLocals, 12);
                                        TclList.append(interp, tmp69, tmp70);
                                        TclList.append(interp, tmp69, const24);
                                        TclList.append(interp, tmp69, const22);
                                        tmp70 = getVarScalar(interp, "classpath", compiledLocals, 12);
                                        TclList.append(interp, tmp69, tmp70);
                                    } catch (TclException ex) {
                                        tmp69.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp69);
                                } // End Invoke: list
                                tmp68 = interp.getResult();
                                setVarScalar(interp, "javac", tmp68, compiledLocals, 6);
                            } // End Invoke: set
                        } else {
                            { // Invoke: error "..."
                                TclObject[] objv71 = TJC.grabObjv(interp, 2);
                                TclObject tmp72;
                                try {
                                    // Arg 0 constant: error
                                    objv71[0] = const11;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp73 = new StringBuffer(64);
                                    sbtmp73.append("unsupported compiler ");
                                    sbtmp73.append("\"");
                                    tmp72 = getVarScalar(interp, "compiler", compiledLocals, 7);
                                    sbtmp73.append(tmp72.toString());
                                    sbtmp73.append("\"");
                                    tmp72 = TclString.newInstance(sbtmp73);
                                    tmp72.preserve();
                                    objv71[1] = tmp72;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                        ? cmdcache5.cmd : null), objv71, 0);
                                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                        updateCmdCache(interp, 5);
                                    }
                                } finally {
                                    tmp72 = objv71[1];
                                    if ( tmp72 != null ) {
                                        tmp72.release();
                                    }
                                    TJC.releaseObjv(interp, objv71, 2);
                                }
                            } // End Invoke: error
                        }
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        { // Invoke: set javac_flags -g
            setVarScalar(interp, "javac_flags", const25, compiledLocals, 15);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: file exists $TJC_build
                TclObject[] objv74 = TJC.grabObjv(interp, 3);
                TclObject tmp75;
                try {
                    // Arg 0 constant: file
                    objv74[0] = const5;
                    // Arg 1 constant: exists
                    objv74[1] = const2;
                    // Arg 2 variable: $TJC_build
                    tmp75 = getVarScalar(interp, "TJC_build", compiledLocals, 5);
                    tmp75.preserve();
                    objv74[2] = tmp75;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                        ? cmdcache4.cmd : null), objv74, 0);
                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                        updateCmdCache(interp, 4);
                    }
                } finally {
                    tmp75 = objv74[2];
                    if ( tmp75 != null ) {
                        tmp75.release();
                    }
                    TJC.releaseObjv(interp, objv74, 3);
                }
            } // End Invoke: file
            TclObject tmp76 = interp.getResult();
            ExprValue tmp77 = evs0;
            if ( tmp76.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp77, tmp76);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp77, tmp76);
            }
            // End Unary operator: !
            boolean tmp78 = ( tmp77.getIntValue() != 0 );
            if ( tmp78 ) {
                { // Invoke: file mkdir $TJC_build
                    TclObject[] objv79 = TJC.grabObjv(interp, 3);
                    TclObject tmp80;
                    try {
                        // Arg 0 constant: file
                        objv79[0] = const5;
                        // Arg 1 constant: mkdir
                        objv79[1] = const26;
                        // Arg 2 variable: $TJC_build
                        tmp80 = getVarScalar(interp, "TJC_build", compiledLocals, 5);
                        tmp80.preserve();
                        objv79[2] = tmp80;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv79, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        tmp80 = objv79[2];
                        if ( tmp80 != null ) {
                            tmp80.release();
                        }
                        TJC.releaseObjv(interp, objv79, 3);
                    }
                } // End Invoke: file
            }
        } // End Invoke: if
        { // Invoke: cd $TJC
            TclObject[] objv81 = TJC.grabObjv(interp, 2);
            TclObject tmp82;
            try {
                // Arg 0 constant: cd
                objv81[0] = const27;
                // Arg 1 variable: $TJC
                tmp82 = getVarScalar(interp, "TJC", compiledLocals, 3);
                tmp82.preserve();
                objv81[1] = tmp82;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                    ? cmdcache7.cmd : null), objv81, 0);
                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                    updateCmdCache(interp, 7);
                }
            } finally {
                tmp82 = objv81[1];
                if ( tmp82 != null ) {
                    tmp82.release();
                }
                TJC.releaseObjv(interp, objv81, 2);
            }
        } // End Invoke: cd
        { // Invoke: if {$debug} ...
            TclObject tmp83 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp84 = TJC.getBoolean(interp, tmp83);
            if ( tmp84 ) {
                { // Invoke: puts "..."
                    TclObject[] objv85 = TJC.grabObjv(interp, 2);
                    TclObject tmp86;
                    try {
                        // Arg 0 constant: puts
                        objv85[0] = const28;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp87 = new StringBuffer(64);
                        sbtmp87.append("there are ");
                        { // Invoke: llength $filenames
                            TclObject tmp88 = getVarScalar(interp, "filenames", compiledLocals, 0);
                            int tmp89 = TclList.getLength(interp, tmp88);
                            interp.setResult(tmp89);
                        } // End Invoke: llength
                        tmp86 = interp.getResult();
                        sbtmp87.append(tmp86.toString());
                        sbtmp87.append(" files to be compiled with javac");
                        tmp86 = TclString.newInstance(sbtmp87);
                        tmp86.preserve();
                        objv85[1] = tmp86;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv85, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        tmp86 = objv85[1];
                        if ( tmp86 != null ) {
                            tmp86.release();
                        }
                        TJC.releaseObjv(interp, objv85, 2);
                    }
                } // End Invoke: puts
                { // Invoke: foreach filename $filenames ...
                    TclObject tmp90 = null;
                    try {
                        tmp90 = getVarScalar(interp, "filenames", compiledLocals, 0);
                        tmp90.preserve();
                        final int tmp90_length = TclList.getLength(interp, tmp90);

                        for ( int index91 = 0 ; index91 < tmp90_length ; index91++ ) {
                            TclObject tmp92 = TclList.index(interp, tmp90, index91);
                            try {
                                setVarScalar(interp, "filename", tmp92, compiledLocals, 16);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "filename");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: puts $filename
                                TclObject[] objv93 = TJC.grabObjv(interp, 2);
                                TclObject tmp94;
                                try {
                                    // Arg 0 constant: puts
                                    objv93[0] = const28;
                                    // Arg 1 variable: $filename
                                    tmp94 = getVarScalar(interp, "filename", compiledLocals, 16);
                                    tmp94.preserve();
                                    objv93[1] = tmp94;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv93, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    tmp94 = objv93[1];
                                    if ( tmp94 != null ) {
                                        tmp94.release();
                                    }
                                    TJC.releaseObjv(interp, objv93, 2);
                                }
                            } // End Invoke: puts
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp90 != null ) {
                            tmp90.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: set batch_filenames [...]
            TclObject tmp95;
            { // Invoke: list
                TclObject tmp96 = TclList.newInstance();
                interp.setResult(tmp96);
            } // End Invoke: list
            tmp95 = interp.getResult();
            setVarScalar(interp, "batch_filenames", tmp95, compiledLocals, 17);
        } // End Invoke: set
        { // Invoke: set batch [...]
            TclObject tmp97;
            { // Invoke: list
                TclObject tmp98 = TclList.newInstance();
                interp.setResult(tmp98);
            } // End Invoke: list
            tmp97 = interp.getResult();
            setVarScalar(interp, "batch", tmp97, compiledLocals, 18);
        } // End Invoke: set
        { // Invoke: set batch_size 40
            setVarScalar(interp, "batch_size", const29, compiledLocals, 19);
        } // End Invoke: set
        { // Invoke: set i 0
            setVarScalar(interp, "i", const0, compiledLocals, 20);
        } // End Invoke: set
        { // Invoke: foreach filename $filenames ...
            TclObject tmp99 = null;
            try {
                tmp99 = getVarScalar(interp, "filenames", compiledLocals, 0);
                tmp99.preserve();
                final int tmp99_length = TclList.getLength(interp, tmp99);

                for ( int index100 = 0 ; index100 < tmp99_length ; index100++ ) {
                    TclObject tmp101 = TclList.index(interp, tmp99, index100);
                    try {
                        setVarScalar(interp, "filename", tmp101, compiledLocals, 16);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "filename");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: if {$i >= $batch_size} ...
                        // Binary operator: $i >= $batch_size
                        TclObject tmp102 = getVarScalar(interp, "i", compiledLocals, 20);
                        ExprValue tmp103 = evs0;
                        TJC.exprInitValue(interp, tmp103, tmp102);
                        TclObject tmp104 = getVarScalar(interp, "batch_size", compiledLocals, 19);
                        ExprValue tmp105 = evs1;
                        TJC.exprInitValue(interp, tmp105, tmp104);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GEQ, tmp103, tmp105);
                        // End Binary operator: >=
                        boolean tmp106 = ( tmp103.getIntValue() != 0 );
                        if ( tmp106 ) {
                            { // Invoke: lappend batch_filenames $batch
                                TclObject[] objv107 = TJC.grabObjv(interp, 1);
                                TclObject tmp108;
                                try {
                                    // Arg 2 variable: $batch
                                    tmp108 = getVarScalar(interp, "batch", compiledLocals, 18);
                                    tmp108.preserve();
                                    objv107[0] = tmp108;
                                    interp.resetResult();
                                    lappendVarScalar(interp, "batch_filenames", objv107, compiledLocals, 17);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv107, 1);
                                }
                            } // End Invoke: lappend
                            { // Invoke: set batch [...]
                                TclObject tmp109;
                                { // Invoke: list
                                    TclObject tmp110 = TclList.newInstance();
                                    interp.setResult(tmp110);
                                } // End Invoke: list
                                tmp109 = interp.getResult();
                                setVarScalar(interp, "batch", tmp109, compiledLocals, 18);
                            } // End Invoke: set
                            { // Invoke: set i 0
                                setVarScalar(interp, "i", const0, compiledLocals, 20);
                            } // End Invoke: set
                        }
                    } // End Invoke: if
                    { // Invoke: lappend batch $filename
                        TclObject[] objv111 = TJC.grabObjv(interp, 1);
                        TclObject tmp112;
                        try {
                            // Arg 2 variable: $filename
                            tmp112 = getVarScalar(interp, "filename", compiledLocals, 16);
                            tmp112.preserve();
                            objv111[0] = tmp112;
                            interp.resetResult();
                            lappendVarScalar(interp, "batch", objv111, compiledLocals, 18);
                        } finally {
                            TJC.releaseObjvElems(interp, objv111, 1);
                        }
                    } // End Invoke: lappend
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 20);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp99 != null ) {
                    tmp99.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: if ... ...
            // Binary operator: [...] > 0
            { // Invoke: llength $batch
                TclObject tmp113 = getVarScalar(interp, "batch", compiledLocals, 18);
                int tmp114 = TclList.getLength(interp, tmp113);
                interp.setResult(tmp114);
            } // End Invoke: llength
            TclObject tmp115 = interp.getResult();
            ExprValue tmp116 = evs0;
            TJC.exprInitValue(interp, tmp116, tmp115);
            ExprValue tmp117 = evs1;
            tmp117.setIntValue(0);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp116, tmp117);
            // End Binary operator: >
            boolean tmp118 = ( tmp116.getIntValue() != 0 );
            if ( tmp118 ) {
                { // Invoke: lappend batch_filenames $batch
                    TclObject[] objv119 = TJC.grabObjv(interp, 1);
                    TclObject tmp120;
                    try {
                        // Arg 2 variable: $batch
                        tmp120 = getVarScalar(interp, "batch", compiledLocals, 18);
                        tmp120.preserve();
                        objv119[0] = tmp120;
                        interp.resetResult();
                        lappendVarScalar(interp, "batch_filenames", objv119, compiledLocals, 17);
                    } finally {
                        TJC.releaseObjvElems(interp, objv119, 1);
                    }
                } // End Invoke: lappend
            }
        } // End Invoke: if
        { // Invoke: if {$debug} ...
            TclObject tmp121 = getVarScalar(interp, "debug", compiledLocals, 2);
            boolean tmp122 = TJC.getBoolean(interp, tmp121);
            if ( tmp122 ) {
                { // Invoke: puts "..."
                    TclObject[] objv123 = TJC.grabObjv(interp, 2);
                    TclObject tmp124;
                    try {
                        // Arg 0 constant: puts
                        objv123[0] = const28;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp125 = new StringBuffer(64);
                        sbtmp125.append("files were broken into ");
                        { // Invoke: llength $batch_filenames
                            TclObject tmp126 = getVarScalar(interp, "batch_filenames", compiledLocals, 17);
                            int tmp127 = TclList.getLength(interp, tmp126);
                            interp.setResult(tmp127);
                        } // End Invoke: llength
                        tmp124 = interp.getResult();
                        sbtmp125.append(tmp124.toString());
                        sbtmp125.append(" batches");
                        tmp124 = TclString.newInstance(sbtmp125);
                        tmp124.preserve();
                        objv123[1] = tmp124;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                            ? cmdcache8.cmd : null), objv123, 0);
                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                            updateCmdCache(interp, 8);
                        }
                    } finally {
                        tmp124 = objv123[1];
                        if ( tmp124 != null ) {
                            tmp124.release();
                        }
                        TJC.releaseObjv(interp, objv123, 2);
                    }
                } // End Invoke: puts
                { // Invoke: set i 0
                    setVarScalar(interp, "i", const0, compiledLocals, 20);
                } // End Invoke: set
                { // Invoke: foreach batch $batch_filenames ...
                    TclObject tmp128 = null;
                    try {
                        tmp128 = getVarScalar(interp, "batch_filenames", compiledLocals, 17);
                        tmp128.preserve();
                        final int tmp128_length = TclList.getLength(interp, tmp128);

                        for ( int index129 = 0 ; index129 < tmp128_length ; index129++ ) {
                            TclObject tmp130 = TclList.index(interp, tmp128, index129);
                            try {
                                setVarScalar(interp, "batch", tmp130, compiledLocals, 18);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "batch");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: puts "batch $i:"
                                TclObject[] objv131 = TJC.grabObjv(interp, 2);
                                TclObject tmp132;
                                try {
                                    // Arg 0 constant: puts
                                    objv131[0] = const28;
                                    // Arg 1 word: "batch $i:"
                                    StringBuffer sbtmp133 = new StringBuffer(64);
                                    sbtmp133.append("batch ");
                                    tmp132 = getVarScalar(interp, "i", compiledLocals, 20);
                                    sbtmp133.append(tmp132.toString());
                                    sbtmp133.append(":");
                                    tmp132 = TclString.newInstance(sbtmp133);
                                    tmp132.preserve();
                                    objv131[1] = tmp132;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv131, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    tmp132 = objv131[1];
                                    if ( tmp132 != null ) {
                                        tmp132.release();
                                    }
                                    TJC.releaseObjv(interp, objv131, 2);
                                }
                            } // End Invoke: puts
                            { // Invoke: foreach filename $batch ...
                                TclObject tmp134 = null;
                                try {
                                    tmp134 = getVarScalar(interp, "batch", compiledLocals, 18);
                                    tmp134.preserve();
                                    final int tmp134_length = TclList.getLength(interp, tmp134);

                                    for ( int index135 = 0 ; index135 < tmp134_length ; index135++ ) {
                                        TclObject tmp136 = TclList.index(interp, tmp134, index135);
                                        try {
                                            setVarScalar(interp, "filename", tmp136, compiledLocals, 16);
                                        } catch (TclException ex) {
                                            TJC.foreachVarErr(interp, "filename");
                                        }

                                        try {
                                        if ( false ) { throw (TclException) null; }
                                        { // Invoke: puts $filename
                                            TclObject[] objv137 = TJC.grabObjv(interp, 2);
                                            TclObject tmp138;
                                            try {
                                                // Arg 0 constant: puts
                                                objv137[0] = const28;
                                                // Arg 1 variable: $filename
                                                tmp138 = getVarScalar(interp, "filename", compiledLocals, 16);
                                                tmp138.preserve();
                                                objv137[1] = tmp138;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                                    ? cmdcache8.cmd : null), objv137, 0);
                                                if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                                    updateCmdCache(interp, 8);
                                                }
                                            } finally {
                                                tmp138 = objv137[1];
                                                if ( tmp138 != null ) {
                                                    tmp138.release();
                                                }
                                                TJC.releaseObjv(interp, objv137, 2);
                                            }
                                        } // End Invoke: puts
                                        } catch (TclException ex) {
                                            int type = ex.getCompletionCode();
                                            if (type == TCL.BREAK) {
                                                break;
                                            } else if (type == TCL.CONTINUE) {
                                                continue;
                                            } else {
                                                throw ex;
                                            }
                                        }
                                    }
                                } finally {
                                    if ( tmp134 != null ) {
                                        tmp134.release();
                                    }
                                }
                            } // End Invoke: foreach
                            { // Invoke: incr i
                                interp.resetResult();
                                incrVarScalar(interp, "i", 1, compiledLocals, 20);
                            } // End Invoke: incr
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                    } finally {
                        if ( tmp128 != null ) {
                            tmp128.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        { // Invoke: set caught 0
            setVarScalar(interp, "caught", const0, compiledLocals, 21);
        } // End Invoke: set
        { // Invoke: foreach batch $batch_filenames ...
            TclObject tmp139 = null;
            try {
                tmp139 = getVarScalar(interp, "batch_filenames", compiledLocals, 17);
                tmp139.preserve();
                final int tmp139_length = TclList.getLength(interp, tmp139);

                for ( int index140 = 0 ; index140 < tmp139_length ; index140++ ) {
                    TclObject tmp141 = TclList.index(interp, tmp139, index140);
                    try {
                        setVarScalar(interp, "batch", tmp141, compiledLocals, 18);
                    } catch (TclException ex) {
                        TJC.foreachVarErr(interp, "batch");
                    }

                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: set javac_filenames $batch
                        TclObject tmp142;
                        tmp142 = getVarScalar(interp, "batch", compiledLocals, 18);
                        setVarScalar(interp, "javac_filenames", tmp142, compiledLocals, 22);
                    } // End Invoke: set
                    { // Invoke: if {$debug} ...
                        TclObject tmp143 = getVarScalar(interp, "debug", compiledLocals, 2);
                        boolean tmp144 = TJC.getBoolean(interp, tmp143);
                        if ( tmp144 ) {
                            { // Invoke: puts "..."
                                TclObject[] objv145 = TJC.grabObjv(interp, 2);
                                TclObject tmp146;
                                try {
                                    // Arg 0 constant: puts
                                    objv145[0] = const28;
                                    // Arg 1 word: "..."
                                    StringBuffer sbtmp147 = new StringBuffer(64);
                                    sbtmp147.append("JAVAC exec: ");
                                    tmp146 = getVarScalar(interp, "javac", compiledLocals, 6);
                                    sbtmp147.append(tmp146.toString());
                                    sbtmp147.append(" ");
                                    tmp146 = getVarScalar(interp, "javac_flags", compiledLocals, 15);
                                    sbtmp147.append(tmp146.toString());
                                    sbtmp147.append(" -d ");
                                    tmp146 = getVarScalar(interp, "TJC_build", compiledLocals, 5);
                                    sbtmp147.append(tmp146.toString());
                                    sbtmp147.append(" ");
                                    tmp146 = getVarScalar(interp, "javac_filenames", compiledLocals, 22);
                                    sbtmp147.append(tmp146.toString());
                                    tmp146 = TclString.newInstance(sbtmp147);
                                    tmp146.preserve();
                                    objv145[1] = tmp146;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv145, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    tmp146 = objv145[1];
                                    if ( tmp146 != null ) {
                                        tmp146.release();
                                    }
                                    TJC.releaseObjv(interp, objv145, 2);
                                }
                            } // End Invoke: puts
                        }
                    } // End Invoke: if
                    { // Invoke: if ... ...
                        { // Invoke: catch ... err
                            int code148 = TCL.OK;
                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: eval exec $javac ... $javac_filenames
                                TclObject[] objv149 = TJC.grabObjv(interp, 5);
                                TclObject tmp150;
                                try {
                                    // Arg 0 constant: eval
                                    objv149[0] = const30;
                                    // Arg 1 constant: exec
                                    objv149[1] = const31;
                                    // Arg 2 variable: $javac
                                    tmp150 = getVarScalar(interp, "javac", compiledLocals, 6);
                                    tmp150.preserve();
                                    objv149[2] = tmp150;
                                    // Arg 3 constant: ...
                                    objv149[3] = const32;
                                    // Arg 4 variable: $javac_filenames
                                    tmp150 = getVarScalar(interp, "javac_filenames", compiledLocals, 22);
                                    tmp150.preserve();
                                    objv149[4] = tmp150;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache9_cmdEpoch == cmdcache9.cmdEpoch)
                                        ? cmdcache9.cmd : null), objv149, 0);
                                    if ( cmdcache9_cmdEpoch != cmdcache9.cmdEpoch ) {
                                        updateCmdCache(interp, 9);
                                    }
                                } finally {
                                    tmp150 = objv149[2];
                                    if ( tmp150 != null ) {
                                        tmp150.release();
                                    }
                                    tmp150 = objv149[4];
                                    if ( tmp150 != null ) {
                                        tmp150.release();
                                    }
                                    TJC.releaseObjv(interp, objv149, 5);
                                }
                            } // End Invoke: eval
                            } catch (TclException ex) {
                                code148 = ex.getCompletionCode();
                            }
                            TclObject result = interp.getResult();
                            try {
                                setVarScalar(interp, "err", result, compiledLocals, 23);
                            } catch (TclException ex) {
                                TJC.catchVarErr(interp);
                            }
                            interp.resetResult();
                            interp.setResult(code148);
                        } // End Invoke: catch
                        TclObject tmp151 = interp.getResult();
                        ExprValue tmp152 = evs0;
                        TJC.exprInitValue(interp, tmp152, tmp151);
                        boolean tmp153 = tmp152.getBooleanValue(interp);
                        if ( tmp153 ) {
                            { // Invoke: puts stderr $err
                                TclObject[] objv154 = TJC.grabObjv(interp, 3);
                                TclObject tmp155;
                                try {
                                    // Arg 0 constant: puts
                                    objv154[0] = const28;
                                    // Arg 1 constant: stderr
                                    objv154[1] = const33;
                                    // Arg 2 variable: $err
                                    tmp155 = getVarScalar(interp, "err", compiledLocals, 23);
                                    tmp155.preserve();
                                    objv154[2] = tmp155;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                        ? cmdcache8.cmd : null), objv154, 0);
                                    if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                        updateCmdCache(interp, 8);
                                    }
                                } finally {
                                    tmp155 = objv154[2];
                                    if ( tmp155 != null ) {
                                        tmp155.release();
                                    }
                                    TJC.releaseObjv(interp, objv154, 3);
                                }
                            } // End Invoke: puts
                            { // Invoke: set caught 1
                                setVarScalar(interp, "caught", const4, compiledLocals, 21);
                            } // End Invoke: set
                            { // Invoke: break
                                if ( true ) { break; }
                            } // End Invoke: break
                        }
                    } // End Invoke: if
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else if (type == TCL.CONTINUE) {
                            continue;
                        } else {
                            throw ex;
                        }
                    }
                }
            } finally {
                if ( tmp139 != null ) {
                    tmp139.release();
                }
            }
        } // End Invoke: foreach
        { // Invoke: cd ..
            TclObject[] objv156 = TJC.grabObjv(interp, 2);
            try {
                // Arg 0 constant: cd
                objv156[0] = const27;
                // Arg 1 constant: ..
                objv156[1] = const34;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache7_cmdEpoch == cmdcache7.cmdEpoch)
                    ? cmdcache7.cmd : null), objv156, 0);
                if ( cmdcache7_cmdEpoch != cmdcache7.cmdEpoch ) {
                    updateCmdCache(interp, 7);
                }
            } finally {
                TJC.releaseObjv(interp, objv156, 2);
            }
        } // End Invoke: cd
        { // Invoke: if {$caught} ... else ...
            TclObject tmp157 = getVarScalar(interp, "caught", compiledLocals, 21);
            boolean tmp158 = TJC.getBoolean(interp, tmp157);
            if ( tmp158 ) {
                { // Invoke: return [...]
                    { // Invoke: list ERROR $err
                        TclObject tmp159 = TclList.newInstance();
                        TclObject tmp160;
                        try {
                            TclList.append(interp, tmp159, const35);
                            tmp160 = getVarScalar(interp, "err", compiledLocals, 23);
                            TclList.append(interp, tmp159, tmp160);
                        } catch (TclException ex) {
                            tmp159.release();
                            throw ex;
                        }
                        interp.setResult(tmp159);
                    } // End Invoke: list
                    if ( true ) { return; }
                } // End Invoke: return
            } else {
                { // Invoke: if ... ... else ...
                    // Binary operator: [...] == 1
                    { // Invoke: llength $filenames
                        TclObject tmp161 = getVarScalar(interp, "filenames", compiledLocals, 0);
                        int tmp162 = TclList.getLength(interp, tmp161);
                        interp.setResult(tmp162);
                    } // End Invoke: llength
                    TclObject tmp163 = interp.getResult();
                    ExprValue tmp164 = evs0;
                    TJC.exprInitValue(interp, tmp164, tmp163);
                    ExprValue tmp165 = evs1;
                    tmp165.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp164, tmp165);
                    // End Binary operator: ==
                    boolean tmp166 = ( tmp164.getIntValue() != 0 );
                    if ( tmp166 ) {
                        { // Invoke: set filename [...]
                            TclObject tmp167;
                            { // Invoke: lindex $filenames 0
                                TclObject tmp168 = getVarScalar(interp, "filenames", compiledLocals, 0);
                                tmp168 = TclList.index(interp, tmp168, 0);
                                if ( tmp168 == null ) {
                                    interp.resetResult();
                                } else {
                                    interp.setResult(tmp168);
                                }
                            } // End Invoke: lindex
                            tmp167 = interp.getResult();
                            setVarScalar(interp, "filename", tmp167, compiledLocals, 16);
                        } // End Invoke: set
                        { // Invoke: set classfile [...]
                            TclObject tmp169;
                            { // Invoke: ... $filename
                                TclObject[] objv170 = TJC.grabObjv(interp, 2);
                                TclObject tmp171;
                                try {
                                    // Arg 0 constant: ...
                                    objv170[0] = const36;
                                    // Arg 1 variable: $filename
                                    tmp171 = getVarScalar(interp, "filename", compiledLocals, 16);
                                    tmp171.preserve();
                                    objv170[1] = tmp171;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache10_cmdEpoch == cmdcache10.cmdEpoch)
                                        ? cmdcache10.cmd : null), objv170, 0);
                                    if ( cmdcache10_cmdEpoch != cmdcache10.cmdEpoch ) {
                                        updateCmdCache(interp, 10);
                                    }
                                } finally {
                                    tmp171 = objv170[1];
                                    if ( tmp171 != null ) {
                                        tmp171.release();
                                    }
                                    TJC.releaseObjv(interp, objv170, 2);
                                }
                            } // End Invoke: ...
                            tmp169 = interp.getResult();
                            setVarScalar(interp, "classfile", tmp169, compiledLocals, 24);
                        } // End Invoke: set
                        { // Invoke: if {$debug} ...
                            TclObject tmp172 = getVarScalar(interp, "debug", compiledLocals, 2);
                            boolean tmp173 = TJC.getBoolean(interp, tmp172);
                            if ( tmp173 ) {
                                { // Invoke: puts "..."
                                    TclObject[] objv174 = TJC.grabObjv(interp, 2);
                                    TclObject tmp175;
                                    try {
                                        // Arg 0 constant: puts
                                        objv174[0] = const28;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp176 = new StringBuffer(64);
                                        sbtmp176.append("checking for class file ");
                                        sbtmp176.append("\"");
                                        tmp175 = getVarScalar(interp, "classfile", compiledLocals, 24);
                                        sbtmp176.append(tmp175.toString());
                                        sbtmp176.append("\"");
                                        tmp175 = TclString.newInstance(sbtmp176);
                                        tmp175.preserve();
                                        objv174[1] = tmp175;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache8_cmdEpoch == cmdcache8.cmdEpoch)
                                            ? cmdcache8.cmd : null), objv174, 0);
                                        if ( cmdcache8_cmdEpoch != cmdcache8.cmdEpoch ) {
                                            updateCmdCache(interp, 8);
                                        }
                                    } finally {
                                        tmp175 = objv174[1];
                                        if ( tmp175 != null ) {
                                            tmp175.release();
                                        }
                                        TJC.releaseObjv(interp, objv174, 2);
                                    }
                                } // End Invoke: puts
                            }
                        } // End Invoke: if
                        { // Invoke: if ... ... else ...
                            { // Invoke: file exists $classfile
                                TclObject[] objv177 = TJC.grabObjv(interp, 3);
                                TclObject tmp178;
                                try {
                                    // Arg 0 constant: file
                                    objv177[0] = const5;
                                    // Arg 1 constant: exists
                                    objv177[1] = const2;
                                    // Arg 2 variable: $classfile
                                    tmp178 = getVarScalar(interp, "classfile", compiledLocals, 24);
                                    tmp178.preserve();
                                    objv177[2] = tmp178;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv177, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp178 = objv177[2];
                                    if ( tmp178 != null ) {
                                        tmp178.release();
                                    }
                                    TJC.releaseObjv(interp, objv177, 3);
                                }
                            } // End Invoke: file
                            TclObject tmp179 = interp.getResult();
                            ExprValue tmp180 = evs0;
                            TJC.exprInitValue(interp, tmp180, tmp179);
                            boolean tmp181 = tmp180.getBooleanValue(interp);
                            if ( tmp181 ) {
                                { // Invoke: return $classfile
                                    TclObject tmp182 = getVarScalar(interp, "classfile", compiledLocals, 24);
                                    interp.resetResult();
                                    interp.setResult(tmp182);
                                    if ( true ) { return; }
                                } // End Invoke: return
                            } else {
                                { // Invoke: error "..."
                                    TclObject[] objv183 = TJC.grabObjv(interp, 2);
                                    TclObject tmp184;
                                    try {
                                        // Arg 0 constant: error
                                        objv183[0] = const11;
                                        // Arg 1 word: "..."
                                        StringBuffer sbtmp185 = new StringBuffer(64);
                                        sbtmp185.append("compiled class file ");
                                        sbtmp185.append("\"");
                                        tmp184 = getVarScalar(interp, "classfile", compiledLocals, 24);
                                        sbtmp185.append(tmp184.toString());
                                        sbtmp185.append("\"");
                                        sbtmp185.append(" not found");
                                        tmp184 = TclString.newInstance(sbtmp185);
                                        tmp184.preserve();
                                        objv183[1] = tmp184;
                                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                            updateCmdCache(interp, 0);
                                        }
                                        TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                            ? cmdcache5.cmd : null), objv183, 0);
                                        if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                            updateCmdCache(interp, 5);
                                        }
                                    } finally {
                                        tmp184 = objv183[1];
                                        if ( tmp184 != null ) {
                                            tmp184.release();
                                        }
                                        TJC.releaseObjv(interp, objv183, 2);
                                    }
                                } // End Invoke: error
                            }
                        } // End Invoke: if
                    } else {
                        { // Invoke: return OK
                            interp.resetResult();
                            interp.setResult(const37);
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "jdk_tool_javac");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;
    TclObject const15;
    TclObject const16;
    TclObject const17;
    TclObject const18;
    TclObject const19;
    TclObject const20;
    TclObject const21;
    TclObject const22;
    TclObject const23;
    TclObject const24;
    TclObject const25;
    TclObject const26;
    TclObject const27;
    TclObject const28;
    TclObject const29;
    TclObject const30;
    TclObject const31;
    TclObject const32;
    TclObject const33;
    TclObject const34;
    TclObject const35;
    TclObject const36;
    TclObject const37;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("info");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("exists");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_tjc(debug)");
        const3.preserve(); const3.preserve();
        const4 = TclInteger.newInstance(1);
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("file");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("join");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("pwd");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("jdk_tjc_rootdir");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("source");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("build");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("error");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("empty filenames argument");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("jdk_config_var");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("JAVAC");
        const14.preserve(); const14.preserve();
        const15 = TclString.newInstance("JAVAC not defined");
        const15.preserve(); const15.preserve();
        const16 = TclString.newInstance("_tjc(compiler)");
        const16.preserve(); const16.preserve();
        const17 = TclString.newInstance("JAR");
        const17.preserve(); const17.preserve();
        const18 = TclString.newInstance("dir");
        const18.preserve(); const18.preserve();
        const19 = TclString.newInstance("java");
        const19.preserve(); const19.preserve();
        const20 = TclString.newInstance(";");
        const20.preserve(); const20.preserve();
        const21 = TclString.newInstance(":");
        const21.preserve(); const21.preserve();
        const22 = TclString.newInstance("-classpath");
        const22.preserve(); const22.preserve();
        const23 = TclString.newInstance("net.sf.pizzacompiler.compiler.Main");
        const23.preserve(); const23.preserve();
        const24 = TclString.newInstance("org.codehaus.janino.Compiler");
        const24.preserve(); const24.preserve();
        const25 = TclString.newInstance("-g");
        const25.preserve(); const25.preserve();
        const26 = TclString.newInstance("mkdir");
        const26.preserve(); const26.preserve();
        const27 = TclString.newInstance("cd");
        const27.preserve(); const27.preserve();
        const28 = TclString.newInstance("puts");
        const28.preserve(); const28.preserve();
        const29 = TclInteger.newInstance(40);
        const29.preserve(); const29.preserve();
        const30 = TclString.newInstance("eval");
        const30.preserve(); const30.preserve();
        const31 = TclString.newInstance("exec");
        const31.preserve(); const31.preserve();
        const32 = TclString.newInstance("$javac_flags -d $TJC_build");
        const32.preserve(); const32.preserve();
        const33 = TclString.newInstance("stderr");
        const33.preserve(); const33.preserve();
        const34 = TclString.newInstance("..");
        const34.preserve(); const34.preserve();
        const35 = TclString.newInstance("ERROR");
        const35.preserve(); const35.preserve();
        const36 = TclString.newInstance("jdk_tool_javac_classfile");
        const36.preserve(); const36.preserve();
        const37 = TclString.newInstance("OK");
        const37.preserve(); const37.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;
    WrappedCommand cmdcache7;
    int cmdcache7_cmdEpoch;
    WrappedCommand cmdcache8;
    int cmdcache8_cmdEpoch;
    WrappedCommand cmdcache9;
    int cmdcache9_cmdEpoch;
    WrappedCommand cmdcache10;
    int cmdcache10_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                cmdcache7 = TJC.INVALID_COMMAND_CACHE;
                cmdcache7_cmdEpoch = 0;
                cmdcache8 = TJC.INVALID_COMMAND_CACHE;
                cmdcache8_cmdEpoch = 0;
                cmdcache9 = TJC.INVALID_COMMAND_CACHE;
                cmdcache9_cmdEpoch = 0;
                cmdcache10 = TJC.INVALID_COMMAND_CACHE;
                cmdcache10_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "info";
                break;
            }
            case 2: {
                cmdName = "pwd";
                break;
            }
            case 3: {
                cmdName = "jdk_tjc_rootdir";
                break;
            }
            case 4: {
                cmdName = "file";
                break;
            }
            case 5: {
                cmdName = "error";
                break;
            }
            case 6: {
                cmdName = "jdk_config_var";
                break;
            }
            case 7: {
                cmdName = "cd";
                break;
            }
            case 8: {
                cmdName = "puts";
                break;
            }
            case 9: {
                cmdName = "eval";
                break;
            }
            case 10: {
                cmdName = "jdk_tool_javac_classfile";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
            case 7: {
                cmdcache7 = lwcmd;
                cmdcache7_cmdEpoch = cmdEpoch;
                break;
            }
            case 8: {
                cmdcache8 = lwcmd;
                cmdcache8_cmdEpoch = cmdEpoch;
                break;
            }
            case 9: {
                cmdcache9 = lwcmd;
                cmdcache9_cmdEpoch = cmdEpoch;
                break;
            }
            case 10: {
                cmdcache10 = lwcmd;
                cmdcache10_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "filenames",
        "_tjc",
        "debug",
        "TJC",
        "TJC_source",
        "TJC_build",
        "javac",
        "compiler",
        "jar",
        "dir",
        "java",
        "::env",
        "classpath",
        "::tcl_platform",
        "sep",
        "javac_flags",
        "filename",
        "batch_filenames",
        "batch",
        "batch_size",
        "i",
        "caught",
        "javac_filenames",
        "err",
        "classfile"
    };
} // end class JdkToolJavacCmd

