// TJC implementation of procedure module_option_value
package tjc;
import tcl.lang.*;

public class ModuleOptionValueCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 7, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length < 2 || objv.length > 3) {
            throw new TclNumArgsException(interp, 1, objv, "option ?proc?");
        }
        setVarScalar(interp, "option", objv[1], compiledLocals, 0);
        setVarScalar(interp, "proc", 
            ((objv.length <= 2) ? const0 : objv[2]), compiledLocals, 1);
        { // Invoke: array set options [...]
            TclObject[] objv0 = TJC.grabObjv(interp, 4);
            TclObject tmp1;
            try {
                // Arg 0 constant: array
                objv0[0] = const1;
                // Arg 1 constant: set
                objv0[1] = const2;
                // Arg 2 constant: options
                objv0[2] = const3;
                // Arg 3 command: [...]
                { // Invoke: module_query OPTIONS
                    TclObject[] objv2 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: module_query
                        objv2[0] = const4;
                        // Arg 1 constant: OPTIONS
                        objv2[1] = const5;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv2, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv2, 2);
                    }
                } // End Invoke: module_query
                tmp1 = interp.getResult();
                tmp1.preserve();
                objv0[3] = tmp1;
                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                    updateCmdCache(interp, 0);
                }
                TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                    ? cmdcache2.cmd : null), objv0, 0);
                if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                    updateCmdCache(interp, 2);
                }
            } finally {
                tmp1 = objv0[3];
                if ( tmp1 != null ) {
                    tmp1.release();
                }
                TJC.releaseObjv(interp, objv0, 4);
            }
        } // End Invoke: array
        { // Invoke: if {$proc == {}} ... else ...
            // Binary operator: $proc == ""
            TclObject tmp3 = getVarScalar(interp, "proc", compiledLocals, 1);
            ExprValue tmp4 = evs0;
            TJC.exprEqualsEmptyString(tmp4, tmp3, false);
            // End Binary operator: ==
            boolean tmp5 = ( tmp4.getIntValue() != 0 );
            if ( tmp5 ) {
                { // Invoke: if ... ... else ...
                    { // Invoke: info exists options($option)
                        TclObject[] objv6 = TJC.grabObjv(interp, 3);
                        TclObject tmp7;
                        try {
                            // Arg 0 constant: info
                            objv6[0] = const6;
                            // Arg 1 constant: exists
                            objv6[1] = const7;
                            // Arg 2 word: options($option)
                            StringBuffer sbtmp8 = new StringBuffer(64);
                            sbtmp8.append("options(");
                            tmp7 = getVarScalar(interp, "option", compiledLocals, 0);
                            sbtmp8.append(tmp7.toString());
                            sbtmp8.append(")");
                            tmp7 = TclString.newInstance(sbtmp8);
                            tmp7.preserve();
                            objv6[2] = tmp7;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                ? cmdcache3.cmd : null), objv6, 0);
                            if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                updateCmdCache(interp, 3);
                            }
                        } finally {
                            tmp7 = objv6[2];
                            if ( tmp7 != null ) {
                                tmp7.release();
                            }
                            TJC.releaseObjv(interp, objv6, 3);
                        }
                    } // End Invoke: info
                    TclObject tmp9 = interp.getResult();
                    ExprValue tmp10 = evs0;
                    TJC.exprInitValue(interp, tmp10, tmp9);
                    boolean tmp11 = tmp10.getBooleanValue(interp);
                    if ( tmp11 ) {
                        { // Invoke: return $options($option)
                            TclObject tmp12 = getVarScalar(interp, "option", compiledLocals, 0);
                            tmp12 = getVarArray(interp, "options", tmp12.toString(), compiledLocals, 2);
                            interp.resetResult();
                            interp.setResult(tmp12);
                            if ( true ) { return; }
                        } // End Invoke: return
                    } else {
                        { // Invoke: return [...]
                            { // Invoke: ... $option
                                TclObject[] objv13 = TJC.grabObjv(interp, 2);
                                TclObject tmp14;
                                try {
                                    // Arg 0 constant: ...
                                    objv13[0] = const8;
                                    // Arg 1 variable: $option
                                    tmp14 = getVarScalar(interp, "option", compiledLocals, 0);
                                    tmp14.preserve();
                                    objv13[1] = tmp14;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                                        ? cmdcache4.cmd : null), objv13, 0);
                                    if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                                        updateCmdCache(interp, 4);
                                    }
                                } finally {
                                    tmp14 = objv13[1];
                                    if ( tmp14 != null ) {
                                        tmp14.release();
                                    }
                                    TJC.releaseObjv(interp, objv13, 2);
                                }
                            } // End Invoke: ...
                            if ( true ) { return; }
                        } // End Invoke: return
                    }
                } // End Invoke: if
            } else {
                { // Invoke: foreach pair [...] ...
                    TclObject tmp15 = null;
                    try {
                        { // Invoke: module_query PROC_OPTIONS
                            TclObject[] objv16 = TJC.grabObjv(interp, 2);
                            try {
                                // Arg 0 constant: module_query
                                objv16[0] = const4;
                                // Arg 1 constant: PROC_OPTIONS
                                objv16[1] = const9;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv16, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                TJC.releaseObjv(interp, objv16, 2);
                            }
                        } // End Invoke: module_query
                        tmp15 = interp.getResult();
                        tmp15.preserve();
                        final int tmp15_length = TclList.getLength(interp, tmp15);

                        for ( int index17 = 0 ; index17 < tmp15_length ; index17++ ) {
                            TclObject tmp18 = TclList.index(interp, tmp15, index17);
                            try {
                                setVarScalar(interp, "pair", tmp18, compiledLocals, 3);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "pair");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: set p_name [...]
                                TclObject tmp19;
                                { // Invoke: lindex $pair 0
                                    TclObject tmp20 = getVarScalar(interp, "pair", compiledLocals, 3);
                                    tmp20 = TclList.index(interp, tmp20, 0);
                                    if ( tmp20 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp20);
                                    }
                                } // End Invoke: lindex
                                tmp19 = interp.getResult();
                                setVarScalar(interp, "p_name", tmp19, compiledLocals, 4);
                            } // End Invoke: set
                            { // Invoke: set p_options [...]
                                TclObject tmp21;
                                { // Invoke: lindex $pair 1
                                    TclObject tmp22 = getVarScalar(interp, "pair", compiledLocals, 3);
                                    tmp22 = TclList.index(interp, tmp22, 1);
                                    if ( tmp22 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp22);
                                    }
                                } // End Invoke: lindex
                                tmp21 = interp.getResult();
                                setVarScalar(interp, "p_options", tmp21, compiledLocals, 5);
                            } // End Invoke: set
                            { // Invoke: if {$proc == $p_name} ...
                                // Binary operator: $proc == $p_name
                                TclObject tmp23 = getVarScalar(interp, "proc", compiledLocals, 1);
                                ExprValue tmp24 = evs0;
                                TJC.exprInitValue(interp, tmp24, tmp23);
                                TclObject tmp25 = getVarScalar(interp, "p_name", compiledLocals, 4);
                                ExprValue tmp26 = evs1;
                                TJC.exprInitValue(interp, tmp26, tmp25);
                                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp24, tmp26);
                                // End Binary operator: ==
                                boolean tmp27 = ( tmp24.getIntValue() != 0 );
                                if ( tmp27 ) {
                                    { // Invoke: array set proc_options $p_options
                                        TclObject[] objv28 = TJC.grabObjv(interp, 4);
                                        TclObject tmp29;
                                        try {
                                            // Arg 0 constant: array
                                            objv28[0] = const1;
                                            // Arg 1 constant: set
                                            objv28[1] = const2;
                                            // Arg 2 constant: proc_options
                                            objv28[2] = const10;
                                            // Arg 3 variable: $p_options
                                            tmp29 = getVarScalar(interp, "p_options", compiledLocals, 5);
                                            tmp29.preserve();
                                            objv28[3] = tmp29;
                                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                updateCmdCache(interp, 0);
                                            }
                                            TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                                                ? cmdcache2.cmd : null), objv28, 0);
                                            if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                                                updateCmdCache(interp, 2);
                                            }
                                        } finally {
                                            tmp29 = objv28[3];
                                            if ( tmp29 != null ) {
                                                tmp29.release();
                                            }
                                            TJC.releaseObjv(interp, objv28, 4);
                                        }
                                    } // End Invoke: array
                                    { // Invoke: if ... ... else ...
                                        { // Invoke: info exists "..."
                                            TclObject[] objv30 = TJC.grabObjv(interp, 3);
                                            TclObject tmp31;
                                            try {
                                                // Arg 0 constant: info
                                                objv30[0] = const6;
                                                // Arg 1 constant: exists
                                                objv30[1] = const7;
                                                // Arg 2 word: "..."
                                                StringBuffer sbtmp32 = new StringBuffer(64);
                                                sbtmp32.append("proc_options(");
                                                tmp31 = getVarScalar(interp, "option", compiledLocals, 0);
                                                sbtmp32.append(tmp31.toString());
                                                sbtmp32.append(")");
                                                tmp31 = TclString.newInstance(sbtmp32);
                                                tmp31.preserve();
                                                objv30[2] = tmp31;
                                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                                    updateCmdCache(interp, 0);
                                                }
                                                TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                                                    ? cmdcache3.cmd : null), objv30, 0);
                                                if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                                                    updateCmdCache(interp, 3);
                                                }
                                            } finally {
                                                tmp31 = objv30[2];
                                                if ( tmp31 != null ) {
                                                    tmp31.release();
                                                }
                                                TJC.releaseObjv(interp, objv30, 3);
                                            }
                                        } // End Invoke: info
                                        TclObject tmp33 = interp.getResult();
                                        ExprValue tmp34 = evs0;
                                        TJC.exprInitValue(interp, tmp34, tmp33);
                                        boolean tmp35 = tmp34.getBooleanValue(interp);
                                        if ( tmp35 ) {
                                            { // Invoke: return $...
                                                TclObject tmp36 = getVarScalar(interp, "option", compiledLocals, 0);
                                                tmp36 = getVarArray(interp, "proc_options", tmp36.toString(), compiledLocals, 6);
                                                interp.resetResult();
                                                interp.setResult(tmp36);
                                                if ( true ) { return; }
                                            } // End Invoke: return
                                        } else {
                                            { // Invoke: return
                                                interp.resetResult();
                                                if ( true ) { return; }
                                            } // End Invoke: return
                                        }
                                    } // End Invoke: if
                                }
                            } // End Invoke: if
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                        interp.resetResult();
                    } finally {
                        if ( tmp15 != null ) {
                            tmp15.release();
                        }
                    }
                } // End Invoke: foreach
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "module_option_value");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("array");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("set");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("options");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("module_query");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("OPTIONS");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("info");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("exists");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("module_option_default");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("PROC_OPTIONS");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("proc_options");
        const10.preserve(); const10.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "module_query";
                break;
            }
            case 2: {
                cmdName = "array";
                break;
            }
            case 3: {
                cmdName = "info";
                break;
            }
            case 4: {
                cmdName = "module_option_default";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "option",
        "proc",
        "options",
        "pair",
        "p_name",
        "p_options",
        "proc_options"
    };
} // end class ModuleOptionValueCmd

