// TJC implementation of procedure _parse_get_variable_list_callback
package tjc;
import tcl.lang.*;

public class ParseGetVariableListCallbackCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 6) {
            throw new TclNumArgsException(interp, 1, objv, "script stree type values ranges");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "type", objv[3], compiledLocals, 2);
        setVarScalar(interp, "values", objv[4], compiledLocals, 3);
        setVarScalar(interp, "ranges", objv[5], compiledLocals, 4);
        { // Invoke: global _parse
            TJC.makeGlobalLinkVar(interp, "_parse", "_parse", 5);
        } // End Invoke: global
        { // Invoke: set result [...]
            TclObject tmp0;
            { // Invoke: list "variable"
                TclObject tmp1 = TclList.newInstance();
                TclList.append(interp, tmp1, const0);
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarScalar(interp, "result", tmp0, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: switch -exact -- $type {scalar} ... {array text} ... {array scalar} ... {array command} ... {array word} ... {word begin} ... {word end} ... {word text} ... {word scalar} ... {word command} ... {word array text} ... {word array scalar} ... {word array command} ... {word array word} ... default ...
            TclObject tmp2 = getVarScalar(interp, "type", compiledLocals, 2);
            String tmp3 = tmp2.toString();
            int tmp3_length = tmp3.length();
            char tmp3_first = '\n';
            if ( tmp3_length > 0 ) {
                tmp3_first = tmp3.charAt(0);
            }
            if ( tmp3_length == 6 && tmp3_first == 's'
                    && tmp3.compareTo("scalar") == 0 ) {
                // Pattern {scalar}
                { // Invoke: lappend result [...]
                    TclObject[] objv4 = TJC.grabObjv(interp, 1);
                    TclObject tmp5;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: lindex $values 0
                            TclObject tmp6 = getVarScalar(interp, "values", compiledLocals, 3);
                            tmp6 = TclList.index(interp, tmp6, 0);
                            if ( tmp6 == null ) {
                                interp.resetResult();
                            } else {
                                interp.setResult(tmp6);
                            }
                        } // End Invoke: lindex
                        tmp5 = interp.getResult();
                        tmp5.preserve();
                        objv4[0] = tmp5;
                        interp.resetResult();
                        lappendVarScalar(interp, "result", objv4, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv4, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 10 && tmp3_first == 'a'
                    && tmp3.compareTo("array text") == 0 ) {
                // Pattern {array text}
                { // Invoke: lappend result $values
                    TclObject[] objv7 = TJC.grabObjv(interp, 1);
                    TclObject tmp8;
                    try {
                        // Arg 2 variable: $values
                        tmp8 = getVarScalar(interp, "values", compiledLocals, 3);
                        tmp8.preserve();
                        objv7[0] = tmp8;
                        interp.resetResult();
                        lappendVarScalar(interp, "result", objv7, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv7, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 12 && tmp3_first == 'a'
                    && tmp3.compareTo("array scalar") == 0 ) {
                // Pattern {array scalar}
                { // Invoke: lappend result [...]
                    TclObject[] objv9 = TJC.grabObjv(interp, 1);
                    TclObject tmp10;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list [...] [...]
                            TclObject tmp11 = TclList.newInstance();
                            TclObject tmp12;
                            try {
                                { // Invoke: lindex $values 0
                                    TclObject tmp13 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp13 = TclList.index(interp, tmp13, 0);
                                    if ( tmp13 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp13);
                                    }
                                } // End Invoke: lindex
                                tmp12 = interp.getResult();
                                TclList.append(interp, tmp11, tmp12);
                                { // Invoke: list "variable" [...]
                                    TclObject tmp14 = TclList.newInstance();
                                    TclObject tmp15;
                                    try {
                                        TclList.append(interp, tmp14, const0);
                                        { // Invoke: lindex $values 1
                                            TclObject tmp16 = getVarScalar(interp, "values", compiledLocals, 3);
                                            tmp16 = TclList.index(interp, tmp16, 1);
                                            if ( tmp16 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp16);
                                            }
                                        } // End Invoke: lindex
                                        tmp15 = interp.getResult();
                                        TclList.append(interp, tmp14, tmp15);
                                    } catch (TclException ex) {
                                        tmp14.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp14);
                                } // End Invoke: list
                                tmp12 = interp.getResult();
                                TclList.append(interp, tmp11, tmp12);
                            } catch (TclException ex) {
                                tmp11.release();
                                throw ex;
                            }
                            interp.setResult(tmp11);
                        } // End Invoke: list
                        tmp10 = interp.getResult();
                        tmp10.preserve();
                        objv9[0] = tmp10;
                        interp.resetResult();
                        lappendVarScalar(interp, "result", objv9, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv9, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 13 && tmp3_first == 'a'
                    && tmp3.compareTo("array command") == 0 ) {
                // Pattern {array command}
                { // Invoke: lappend result [...]
                    TclObject[] objv17 = TJC.grabObjv(interp, 1);
                    TclObject tmp18;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list [...] [...]
                            TclObject tmp19 = TclList.newInstance();
                            TclObject tmp20;
                            try {
                                { // Invoke: lindex $values 0
                                    TclObject tmp21 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp21 = TclList.index(interp, tmp21, 0);
                                    if ( tmp21 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp21);
                                    }
                                } // End Invoke: lindex
                                tmp20 = interp.getResult();
                                TclList.append(interp, tmp19, tmp20);
                                { // Invoke: list "command" [...]
                                    TclObject tmp22 = TclList.newInstance();
                                    TclObject tmp23;
                                    try {
                                        TclList.append(interp, tmp22, const1);
                                        { // Invoke: lindex $values 1
                                            TclObject tmp24 = getVarScalar(interp, "values", compiledLocals, 3);
                                            tmp24 = TclList.index(interp, tmp24, 1);
                                            if ( tmp24 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp24);
                                            }
                                        } // End Invoke: lindex
                                        tmp23 = interp.getResult();
                                        TclList.append(interp, tmp22, tmp23);
                                    } catch (TclException ex) {
                                        tmp22.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp22);
                                } // End Invoke: list
                                tmp20 = interp.getResult();
                                TclList.append(interp, tmp19, tmp20);
                            } catch (TclException ex) {
                                tmp19.release();
                                throw ex;
                            }
                            interp.setResult(tmp19);
                        } // End Invoke: list
                        tmp18 = interp.getResult();
                        tmp18.preserve();
                        objv17[0] = tmp18;
                        interp.resetResult();
                        lappendVarScalar(interp, "result", objv17, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv17, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 10 && tmp3_first == 'a'
                    && tmp3.compareTo("array word") == 0 ) {
                // Pattern {array word}
                { // Invoke: lappend result [...]
                    TclObject[] objv25 = TJC.grabObjv(interp, 1);
                    TclObject tmp26;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: concat [...] $...
                            TclObject[] objv27 = TJC.grabObjv(interp, 3);
                            TclObject tmp28;
                            try {
                                // Arg 0 constant: concat
                                objv27[0] = const2;
                                // Arg 1 command: [...]
                                { // Invoke: lindex $values 0
                                    TclObject tmp29 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp29 = TclList.index(interp, tmp29, 0);
                                    if ( tmp29 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp29);
                                    }
                                } // End Invoke: lindex
                                tmp28 = interp.getResult();
                                tmp28.preserve();
                                objv27[1] = tmp28;
                                // Arg 2 variable: $...
                                tmp28 = getVarArray(interp, "_parse", "get_variable_list_word", compiledLocals, 5);
                                tmp28.preserve();
                                objv27[2] = tmp28;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv27, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp28 = objv27[1];
                                if ( tmp28 != null ) {
                                    tmp28.release();
                                }
                                tmp28 = objv27[2];
                                if ( tmp28 != null ) {
                                    tmp28.release();
                                }
                                TJC.releaseObjv(interp, objv27, 3);
                            }
                        } // End Invoke: concat
                        tmp26 = interp.getResult();
                        tmp26.preserve();
                        objv25[0] = tmp26;
                        interp.resetResult();
                        lappendVarScalar(interp, "result", objv25, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv25, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 10 && tmp3_first == 'w'
                    && tmp3.compareTo("word begin") == 0 ) {
                // Pattern {word begin}
                { // Invoke: set ... [...]
                    TclObject tmp30;
                    { // Invoke: list
                        TclObject tmp31 = TclList.newInstance();
                        interp.setResult(tmp31);
                    } // End Invoke: list
                    tmp30 = interp.getResult();
                    setVarArray(interp, "_parse", "get_variable_list_word", tmp30, compiledLocals, 5);
                } // End Invoke: set
            } else if ( tmp3_length == 8 && tmp3_first == 'w'
                    && tmp3.compareTo("word end") == 0 ) {
                // Pattern {word end}
            } else if ( tmp3_length == 9 && tmp3_first == 'w'
                    && tmp3.compareTo("word text") == 0 ) {
                // Pattern {word text}
                { // Invoke: lappend ... [...]
                    TclObject[] objv32 = TJC.grabObjv(interp, 1);
                    TclObject tmp33;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list "text" [...]
                            TclObject tmp34 = TclList.newInstance();
                            TclObject tmp35;
                            try {
                                TclList.append(interp, tmp34, const3);
                                { // Invoke: lindex $values 0
                                    TclObject tmp36 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp36 = TclList.index(interp, tmp36, 0);
                                    if ( tmp36 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp36);
                                    }
                                } // End Invoke: lindex
                                tmp35 = interp.getResult();
                                TclList.append(interp, tmp34, tmp35);
                            } catch (TclException ex) {
                                tmp34.release();
                                throw ex;
                            }
                            interp.setResult(tmp34);
                        } // End Invoke: list
                        tmp33 = interp.getResult();
                        tmp33.preserve();
                        objv32[0] = tmp33;
                        interp.resetResult();
                        lappendVarArray(interp, "_parse", "get_variable_list_word", objv32, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv32, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 11 && tmp3_first == 'w'
                    && tmp3.compareTo("word scalar") == 0 ) {
                // Pattern {word scalar}
                { // Invoke: lappend ... [...]
                    TclObject[] objv37 = TJC.grabObjv(interp, 1);
                    TclObject tmp38;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list "variable" [...]
                            TclObject tmp39 = TclList.newInstance();
                            TclObject tmp40;
                            try {
                                TclList.append(interp, tmp39, const0);
                                { // Invoke: lindex $values 0
                                    TclObject tmp41 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp41 = TclList.index(interp, tmp41, 0);
                                    if ( tmp41 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp41);
                                    }
                                } // End Invoke: lindex
                                tmp40 = interp.getResult();
                                TclList.append(interp, tmp39, tmp40);
                            } catch (TclException ex) {
                                tmp39.release();
                                throw ex;
                            }
                            interp.setResult(tmp39);
                        } // End Invoke: list
                        tmp38 = interp.getResult();
                        tmp38.preserve();
                        objv37[0] = tmp38;
                        interp.resetResult();
                        lappendVarArray(interp, "_parse", "get_variable_list_word", objv37, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv37, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 12 && tmp3_first == 'w'
                    && tmp3.compareTo("word command") == 0 ) {
                // Pattern {word command}
                { // Invoke: lappend ... [...]
                    TclObject[] objv42 = TJC.grabObjv(interp, 1);
                    TclObject tmp43;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list "command" [...]
                            TclObject tmp44 = TclList.newInstance();
                            TclObject tmp45;
                            try {
                                TclList.append(interp, tmp44, const1);
                                { // Invoke: lindex $values 0
                                    TclObject tmp46 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp46 = TclList.index(interp, tmp46, 0);
                                    if ( tmp46 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp46);
                                    }
                                } // End Invoke: lindex
                                tmp45 = interp.getResult();
                                TclList.append(interp, tmp44, tmp45);
                            } catch (TclException ex) {
                                tmp44.release();
                                throw ex;
                            }
                            interp.setResult(tmp44);
                        } // End Invoke: list
                        tmp43 = interp.getResult();
                        tmp43.preserve();
                        objv42[0] = tmp43;
                        interp.resetResult();
                        lappendVarArray(interp, "_parse", "get_variable_list_word", objv42, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv42, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 15 && tmp3_first == 'w'
                    && tmp3.compareTo("word array text") == 0 ) {
                // Pattern {word array text}
                { // Invoke: lappend ... [...]
                    TclObject[] objv47 = TJC.grabObjv(interp, 1);
                    TclObject tmp48;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list "variable" $values
                            TclObject tmp49 = TclList.newInstance();
                            TclObject tmp50;
                            try {
                                TclList.append(interp, tmp49, const0);
                                tmp50 = getVarScalar(interp, "values", compiledLocals, 3);
                                TclList.append(interp, tmp49, tmp50);
                            } catch (TclException ex) {
                                tmp49.release();
                                throw ex;
                            }
                            interp.setResult(tmp49);
                        } // End Invoke: list
                        tmp48 = interp.getResult();
                        tmp48.preserve();
                        objv47[0] = tmp48;
                        interp.resetResult();
                        lappendVarArray(interp, "_parse", "get_variable_list_word", objv47, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv47, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 17 && tmp3_first == 'w'
                    && tmp3.compareTo("word array scalar") == 0 ) {
                // Pattern {word array scalar}
                { // Invoke: lappend ... [...]
                    TclObject[] objv51 = TJC.grabObjv(interp, 1);
                    TclObject tmp52;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list "variable" [...] [...]
                            TclObject tmp53 = TclList.newInstance();
                            TclObject tmp54;
                            try {
                                TclList.append(interp, tmp53, const0);
                                { // Invoke: lindex $values 0
                                    TclObject tmp55 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp55 = TclList.index(interp, tmp55, 0);
                                    if ( tmp55 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp55);
                                    }
                                } // End Invoke: lindex
                                tmp54 = interp.getResult();
                                TclList.append(interp, tmp53, tmp54);
                                { // Invoke: list "variable" [...]
                                    TclObject tmp56 = TclList.newInstance();
                                    TclObject tmp57;
                                    try {
                                        TclList.append(interp, tmp56, const0);
                                        { // Invoke: lindex $values 1
                                            TclObject tmp58 = getVarScalar(interp, "values", compiledLocals, 3);
                                            tmp58 = TclList.index(interp, tmp58, 1);
                                            if ( tmp58 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp58);
                                            }
                                        } // End Invoke: lindex
                                        tmp57 = interp.getResult();
                                        TclList.append(interp, tmp56, tmp57);
                                    } catch (TclException ex) {
                                        tmp56.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp56);
                                } // End Invoke: list
                                tmp54 = interp.getResult();
                                TclList.append(interp, tmp53, tmp54);
                            } catch (TclException ex) {
                                tmp53.release();
                                throw ex;
                            }
                            interp.setResult(tmp53);
                        } // End Invoke: list
                        tmp52 = interp.getResult();
                        tmp52.preserve();
                        objv51[0] = tmp52;
                        interp.resetResult();
                        lappendVarArray(interp, "_parse", "get_variable_list_word", objv51, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv51, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 18 && tmp3_first == 'w'
                    && tmp3.compareTo("word array command") == 0 ) {
                // Pattern {word array command}
                { // Invoke: lappend ... [...]
                    TclObject[] objv59 = TJC.grabObjv(interp, 1);
                    TclObject tmp60;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: list "variable" [...] [...]
                            TclObject tmp61 = TclList.newInstance();
                            TclObject tmp62;
                            try {
                                TclList.append(interp, tmp61, const0);
                                { // Invoke: lindex $values 0
                                    TclObject tmp63 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp63 = TclList.index(interp, tmp63, 0);
                                    if ( tmp63 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp63);
                                    }
                                } // End Invoke: lindex
                                tmp62 = interp.getResult();
                                TclList.append(interp, tmp61, tmp62);
                                { // Invoke: list "command" [...]
                                    TclObject tmp64 = TclList.newInstance();
                                    TclObject tmp65;
                                    try {
                                        TclList.append(interp, tmp64, const1);
                                        { // Invoke: lindex $values 1
                                            TclObject tmp66 = getVarScalar(interp, "values", compiledLocals, 3);
                                            tmp66 = TclList.index(interp, tmp66, 1);
                                            if ( tmp66 == null ) {
                                                interp.resetResult();
                                            } else {
                                                interp.setResult(tmp66);
                                            }
                                        } // End Invoke: lindex
                                        tmp65 = interp.getResult();
                                        TclList.append(interp, tmp64, tmp65);
                                    } catch (TclException ex) {
                                        tmp64.release();
                                        throw ex;
                                    }
                                    interp.setResult(tmp64);
                                } // End Invoke: list
                                tmp62 = interp.getResult();
                                TclList.append(interp, tmp61, tmp62);
                            } catch (TclException ex) {
                                tmp61.release();
                                throw ex;
                            }
                            interp.setResult(tmp61);
                        } // End Invoke: list
                        tmp60 = interp.getResult();
                        tmp60.preserve();
                        objv59[0] = tmp60;
                        interp.resetResult();
                        lappendVarArray(interp, "_parse", "get_variable_list_word", objv59, compiledLocals, 5);
                    } finally {
                        TJC.releaseObjvElems(interp, objv59, 1);
                    }
                } // End Invoke: lappend
            } else if ( tmp3_length == 15 && tmp3_first == 'w'
                    && tmp3.compareTo("word array word") == 0 ) {
                // Pattern {word array word}
                { // Invoke: lappend result [...]
                    TclObject[] objv67 = TJC.grabObjv(interp, 1);
                    TclObject tmp68;
                    try {
                        // Arg 2 command: [...]
                        { // Invoke: concat [...] $...
                            TclObject[] objv69 = TJC.grabObjv(interp, 3);
                            TclObject tmp70;
                            try {
                                // Arg 0 constant: concat
                                objv69[0] = const2;
                                // Arg 1 command: [...]
                                { // Invoke: lindex $values 0
                                    TclObject tmp71 = getVarScalar(interp, "values", compiledLocals, 3);
                                    tmp71 = TclList.index(interp, tmp71, 0);
                                    if ( tmp71 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp71);
                                    }
                                } // End Invoke: lindex
                                tmp70 = interp.getResult();
                                tmp70.preserve();
                                objv69[1] = tmp70;
                                // Arg 2 variable: $...
                                tmp70 = getVarArray(interp, "_parse", "get_variable_list_word", compiledLocals, 5);
                                tmp70.preserve();
                                objv69[2] = tmp70;
                                if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                    updateCmdCache(interp, 0);
                                }
                                TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                    ? cmdcache1.cmd : null), objv69, 0);
                                if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                    updateCmdCache(interp, 1);
                                }
                            } finally {
                                tmp70 = objv69[1];
                                if ( tmp70 != null ) {
                                    tmp70.release();
                                }
                                tmp70 = objv69[2];
                                if ( tmp70 != null ) {
                                    tmp70.release();
                                }
                                TJC.releaseObjv(interp, objv69, 3);
                            }
                        } // End Invoke: concat
                        tmp68 = interp.getResult();
                        tmp68.preserve();
                        objv67[0] = tmp68;
                        interp.resetResult();
                        lappendVarScalar(interp, "result", objv67, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv67, 1);
                    }
                } // End Invoke: lappend
            } else {
                // Pattern default
                { // Invoke: error "..."
                    TclObject[] objv72 = TJC.grabObjv(interp, 2);
                    TclObject tmp73;
                    try {
                        // Arg 0 constant: error
                        objv72[0] = const4;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp74 = new StringBuffer(64);
                        sbtmp74.append("unknown type ");
                        sbtmp74.append("{");
                        tmp73 = getVarScalar(interp, "type", compiledLocals, 2);
                        sbtmp74.append(tmp73.toString());
                        sbtmp74.append("}");
                        tmp73 = TclString.newInstance(sbtmp74);
                        tmp73.preserve();
                        objv72[1] = tmp73;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                            ? cmdcache2.cmd : null), objv72, 0);
                        if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                            updateCmdCache(interp, 2);
                        }
                    } finally {
                        tmp73 = objv72[1];
                        if ( tmp73 != null ) {
                            tmp73.release();
                        }
                        TJC.releaseObjv(interp, objv72, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: switch
        { // Invoke: if ... ...
            // Binary operator: [...] > 1
            { // Invoke: llength $result
                TclObject tmp75 = getVarScalar(interp, "result", compiledLocals, 6);
                int tmp76 = TclList.getLength(interp, tmp75);
                interp.setResult(tmp76);
            } // End Invoke: llength
            TclObject tmp77 = interp.getResult();
            ExprValue tmp78 = evs0;
            TJC.exprInitValue(interp, tmp78, tmp77);
            ExprValue tmp79 = evs1;
            tmp79.setIntValue(1);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp78, tmp79);
            // End Binary operator: >
            boolean tmp80 = ( tmp78.getIntValue() != 0 );
            if ( tmp80 ) {
                { // Invoke: foreach elem $result ...
                    TclObject tmp81 = null;
                    try {
                        tmp81 = getVarScalar(interp, "result", compiledLocals, 6);
                        tmp81.preserve();
                        final int tmp81_length = TclList.getLength(interp, tmp81);

                        for ( int index82 = 0 ; index82 < tmp81_length ; index82++ ) {
                            TclObject tmp83 = TclList.index(interp, tmp81, index82);
                            try {
                                setVarScalar(interp, "elem", tmp83, compiledLocals, 7);
                            } catch (TclException ex) {
                                TJC.foreachVarErr(interp, "elem");
                            }

                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: lappend ... $elem
                                TclObject[] objv84 = TJC.grabObjv(interp, 1);
                                TclObject tmp85;
                                try {
                                    // Arg 2 variable: $elem
                                    tmp85 = getVarScalar(interp, "elem", compiledLocals, 7);
                                    tmp85.preserve();
                                    objv84[0] = tmp85;
                                    interp.resetResult();
                                    lappendVarArray(interp, "_parse", "get_variable_list_results", objv84, compiledLocals, 5);
                                } finally {
                                    TJC.releaseObjvElems(interp, objv84, 1);
                                }
                            } // End Invoke: lappend
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else if (type == TCL.CONTINUE) {
                                    continue;
                                } else {
                                    throw ex;
                                }
                            }
                        }
                        interp.resetResult();
                    } finally {
                        if ( tmp81 != null ) {
                            tmp81.release();
                        }
                    }
                } // End Invoke: foreach
            } else {
                interp.resetResult();
            }
        } // End Invoke: if
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_parse_get_variable_list_callback");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("variable");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("command");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("concat");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("text");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("error");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "concat";
                break;
            }
            case 2: {
                cmdName = "error";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "type",
        "values",
        "ranges",
        "_parse",
        "result",
        "elem"
    };
} // end class ParseGetVariableListCallbackCmd

