// TJC implementation of procedure parse_get_word_variable
package tjc;
import tcl.lang.*;

public class ParseGetWordVariableCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 4, compiledLocalsNames);
        try {
        if (objv.length < 3 || objv.length > 4) {
            throw new TclNumArgsException(interp, 1, objv, "script stree ?rtype?");
        }
        setVarScalar(interp, "script", objv[1], compiledLocals, 0);
        setVarScalar(interp, "stree", objv[2], compiledLocals, 1);
        setVarScalar(interp, "rtype", 
            ((objv.length <= 3) ? const0 : objv[3]), compiledLocals, 2);
        { // Invoke: set variable_subtree [...]
            TclObject tmp0;
            { // Invoke: lindex $stree 2 0
                TclObject[] objv1 = TJC.grabObjv(interp, 4);
                TclObject tmp2;
                try {
                    // Arg 0 constant: lindex
                    objv1[0] = const1;
                    // Arg 1 variable: $stree
                    tmp2 = getVarScalar(interp, "stree", compiledLocals, 1);
                    tmp2.preserve();
                    objv1[1] = tmp2;
                    // Arg 2 constant: 2
                    objv1[2] = const2;
                    // Arg 3 constant: 0
                    objv1[3] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                        ? cmdcache1.cmd : null), objv1, 0);
                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                        updateCmdCache(interp, 1);
                    }
                } finally {
                    tmp2 = objv1[1];
                    if ( tmp2 != null ) {
                        tmp2.release();
                    }
                    TJC.releaseObjv(interp, objv1, 4);
                }
            } // End Invoke: lindex
            tmp0 = interp.getResult();
            setVarScalar(interp, "variable_subtree", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: parse_get_variable $script $variable_subtree $rtype
                TclObject[] objv3 = TJC.grabObjv(interp, 4);
                TclObject tmp4;
                try {
                    // Arg 0 constant: parse_get_variable
                    objv3[0] = const4;
                    // Arg 1 variable: $script
                    tmp4 = getVarScalar(interp, "script", compiledLocals, 0);
                    tmp4.preserve();
                    objv3[1] = tmp4;
                    // Arg 2 variable: $variable_subtree
                    tmp4 = getVarScalar(interp, "variable_subtree", compiledLocals, 3);
                    tmp4.preserve();
                    objv3[2] = tmp4;
                    // Arg 3 variable: $rtype
                    tmp4 = getVarScalar(interp, "rtype", compiledLocals, 2);
                    tmp4.preserve();
                    objv3[3] = tmp4;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv3, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    tmp4 = objv3[1];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    tmp4 = objv3[2];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    tmp4 = objv3[3];
                    if ( tmp4 != null ) {
                        tmp4.release();
                    }
                    TJC.releaseObjv(interp, objv3, 4);
                }
            } // End Invoke: parse_get_variable
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_get_word_variable");
        } finally {
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("variable");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("lindex");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(2);
        const2.preserve(); const2.preserve();
        const3 = TclInteger.newInstance(0);
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("parse_get_variable");
        const4.preserve(); const4.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lindex";
                break;
            }
            case 2: {
                cmdName = "parse_get_variable";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "script",
        "stree",
        "rtype",
        "variable_subtree"
    };
} // end class ParseGetWordVariableCmd

