// TJC implementation of procedure parse_is_subrange
package tjc;
import tcl.lang.*;

public class ParseIsSubrangeCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 8, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        ExprValue evs2 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "outer inner");
        }
        setVarScalar(interp, "outer", objv[1], compiledLocals, 0);
        setVarScalar(interp, "inner", objv[2], compiledLocals, 1);
        { // Invoke: if {$outer == $inner} ...
            // Binary operator: $outer == $inner
            TclObject tmp0 = getVarScalar(interp, "outer", compiledLocals, 0);
            ExprValue tmp1 = evs0;
            TJC.exprInitValue(interp, tmp1, tmp0);
            TclObject tmp2 = getVarScalar(interp, "inner", compiledLocals, 1);
            ExprValue tmp3 = evs1;
            TJC.exprInitValue(interp, tmp3, tmp2);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp1, tmp3);
            // End Binary operator: ==
            boolean tmp4 = ( tmp1.getIntValue() != 0 );
            if ( tmp4 ) {
                { // Invoke: return 1
                    interp.resetResult();
                    interp.setResult(const0);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: set outer_start [...]
            TclObject tmp5;
            { // Invoke: lindex $outer 0
                TclObject tmp6 = getVarScalar(interp, "outer", compiledLocals, 0);
                tmp6 = TclList.index(interp, tmp6, 0);
                if ( tmp6 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp6);
                }
            } // End Invoke: lindex
            tmp5 = interp.getResult();
            setVarScalar(interp, "outer_start", tmp5, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: set outer_len [...]
            TclObject tmp7;
            { // Invoke: lindex $outer 1
                TclObject tmp8 = getVarScalar(interp, "outer", compiledLocals, 0);
                tmp8 = TclList.index(interp, tmp8, 1);
                if ( tmp8 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp8);
                }
            } // End Invoke: lindex
            tmp7 = interp.getResult();
            setVarScalar(interp, "outer_len", tmp7, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: set outer_end [...]
            TclObject tmp9;
            { // Invoke: expr ...
                // Binary operator: $outer_start + $outer_len
                TclObject tmp10 = getVarScalar(interp, "outer_start", compiledLocals, 2);
                ExprValue tmp11 = evs0;
                TJC.exprInitValue(interp, tmp11, tmp10);
                TclObject tmp12 = getVarScalar(interp, "outer_len", compiledLocals, 3);
                ExprValue tmp13 = evs1;
                TJC.exprInitValue(interp, tmp13, tmp12);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp11, tmp13);
                // End Binary operator: +
                TJC.exprSetResult(interp, tmp11);
            } // End Invoke: expr
            tmp9 = interp.getResult();
            setVarScalar(interp, "outer_end", tmp9, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: set inner_start [...]
            TclObject tmp14;
            { // Invoke: lindex $inner 0
                TclObject tmp15 = getVarScalar(interp, "inner", compiledLocals, 1);
                tmp15 = TclList.index(interp, tmp15, 0);
                if ( tmp15 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp15);
                }
            } // End Invoke: lindex
            tmp14 = interp.getResult();
            setVarScalar(interp, "inner_start", tmp14, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set inner_len [...]
            TclObject tmp16;
            { // Invoke: lindex $inner 1
                TclObject tmp17 = getVarScalar(interp, "inner", compiledLocals, 1);
                tmp17 = TclList.index(interp, tmp17, 1);
                if ( tmp17 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp17);
                }
            } // End Invoke: lindex
            tmp16 = interp.getResult();
            setVarScalar(interp, "inner_len", tmp16, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set inner_end [...]
            TclObject tmp18;
            { // Invoke: expr ...
                // Binary operator: $inner_start + $inner_len
                TclObject tmp19 = getVarScalar(interp, "inner_start", compiledLocals, 5);
                ExprValue tmp20 = evs0;
                TJC.exprInitValue(interp, tmp20, tmp19);
                TclObject tmp21 = getVarScalar(interp, "inner_len", compiledLocals, 6);
                ExprValue tmp22 = evs1;
                TJC.exprInitValue(interp, tmp22, tmp21);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_PLUS, tmp20, tmp22);
                // End Binary operator: +
                TJC.exprSetResult(interp, tmp20);
            } // End Invoke: expr
            tmp18 = interp.getResult();
            setVarScalar(interp, "inner_end", tmp18, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Binary operator: () || ()
            // Binary operator: $inner_start < $outer_start
            TclObject tmp23 = getVarScalar(interp, "inner_start", compiledLocals, 5);
            ExprValue tmp24 = evs0;
            TJC.exprInitValue(interp, tmp24, tmp23);
            TclObject tmp25 = getVarScalar(interp, "outer_start", compiledLocals, 2);
            ExprValue tmp26 = evs1;
            TJC.exprInitValue(interp, tmp26, tmp25);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp24, tmp26);
            // End Binary operator: <
            if (!tmp24.getBooleanValue(interp)) {
            // Binary operator: $inner_end > $outer_end
            TclObject tmp27 = getVarScalar(interp, "inner_end", compiledLocals, 7);
            ExprValue tmp28 = evs1;
            TJC.exprInitValue(interp, tmp28, tmp27);
            TclObject tmp29 = getVarScalar(interp, "outer_end", compiledLocals, 4);
            ExprValue tmp30 = evs2;
            TJC.exprInitValue(interp, tmp30, tmp29);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_GREATER, tmp28, tmp30);
            // End Binary operator: >
            tmp24.setIntValue(tmp28.getBooleanValue(interp));
            } else {
            tmp24.setIntValue(1);
            } // End if: !()
            // End Binary operator: ||
            boolean tmp31 = ( tmp24.getIntValue() != 0 );
            if ( tmp31 ) {
                { // Invoke: return 0
                    interp.resetResult();
                    interp.setResult(const1);
                    if ( true ) { return; }
                } // End Invoke: return
            }
        } // End Invoke: if
        { // Invoke: return 1
            interp.resetResult();
            interp.setResult(const0);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "parse_is_subrange");
        } finally {
            TJC.exprReleaseValue(interp, evs2);
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(1);
        const0.preserve(); const0.preserve();
        const1 = TclInteger.newInstance(0);
        const1.preserve(); const1.preserve();
    }

    String[] compiledLocalsNames = {
        "outer",
        "inner",
        "outer_start",
        "outer_len",
        "outer_end",
        "inner_start",
        "inner_len",
        "inner_end"
    };
} // end class ParseIsSubrangeCmd

