// TJC implementation of procedure _parse_variable_subtree_types
package tjc;
import tcl.lang.*;

public class ParseVariableSubtreeTypesCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 9, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 2) {
            throw new TclNumArgsException(interp, 1, objv, "stree");
        }
        setVarScalar(interp, "stree", objv[1], compiledLocals, 0);
        { // Invoke: set inner_type_list [...]
            TclObject tmp0;
            { // Invoke: list
                TclObject tmp1 = TclList.newInstance();
                interp.setResult(tmp1);
            } // End Invoke: list
            tmp0 = interp.getResult();
            setVarScalar(interp, "inner_type_list", tmp0, compiledLocals, 1);
        } // End Invoke: set
        { // Invoke: set len [...]
            TclObject tmp2;
            { // Invoke: llength $stree
                TclObject tmp3 = getVarScalar(interp, "stree", compiledLocals, 0);
                int tmp4 = TclList.getLength(interp, tmp3);
                interp.setResult(tmp4);
            } // End Invoke: llength
            tmp2 = interp.getResult();
            setVarScalar(interp, "len", tmp2, compiledLocals, 2);
        } // End Invoke: set
        { // Invoke: for {set i 0} {$i < $len} {incr i} ...
            { // Invoke: set i 0
                setVarScalar(interp, "i", const0, compiledLocals, 3);
            } // End Invoke: set
            for ( boolean skip10 = true ; true ; ) {
                if ( skip10 ) {
                    skip10 = false;
                } else {
                    try {
                    if ( false ) { throw (TclException) null; }
                    { // Invoke: incr i
                        interp.resetResult();
                        incrVarScalar(interp, "i", 1, compiledLocals, 3);
                    } // End Invoke: incr
                    } catch (TclException ex) {
                        int type = ex.getCompletionCode();
                        if (type == TCL.BREAK) {
                            break;
                        } else {
                            throw ex;
                        }
                    }
                }

                // Binary operator: $i < $len
                TclObject tmp5 = getVarScalar(interp, "i", compiledLocals, 3);
                ExprValue tmp6 = evs0;
                TJC.exprInitValue(interp, tmp6, tmp5);
                TclObject tmp7 = getVarScalar(interp, "len", compiledLocals, 2);
                ExprValue tmp8 = evs1;
                TJC.exprInitValue(interp, tmp8, tmp7);
                TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp6, tmp8);
                // End Binary operator: <
                boolean tmp9 = ( tmp6.getIntValue() != 0 );
                if ( ! tmp9 ) { break; }

                try {
                if ( false ) { throw (TclException) null; }
                { // Invoke: set inner_type [...]
                    TclObject tmp11;
                    { // Invoke: lindex $stree $i 0
                        TclObject[] objv12 = TJC.grabObjv(interp, 4);
                        TclObject tmp13;
                        try {
                            // Arg 0 constant: lindex
                            objv12[0] = const1;
                            // Arg 1 variable: $stree
                            tmp13 = getVarScalar(interp, "stree", compiledLocals, 0);
                            tmp13.preserve();
                            objv12[1] = tmp13;
                            // Arg 2 variable: $i
                            tmp13 = getVarScalar(interp, "i", compiledLocals, 3);
                            tmp13.preserve();
                            objv12[2] = tmp13;
                            // Arg 3 constant: 0
                            objv12[3] = const0;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv12, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp13 = objv12[1];
                            if ( tmp13 != null ) {
                                tmp13.release();
                            }
                            tmp13 = objv12[2];
                            if ( tmp13 != null ) {
                                tmp13.release();
                            }
                            TJC.releaseObjv(interp, objv12, 4);
                        }
                    } // End Invoke: lindex
                    tmp11 = interp.getResult();
                    setVarScalar(interp, "inner_type", tmp11, compiledLocals, 4);
                } // End Invoke: set
                { // Invoke: set inner_stree [...]
                    TclObject tmp14;
                    { // Invoke: lindex $stree $i 2
                        TclObject[] objv15 = TJC.grabObjv(interp, 4);
                        TclObject tmp16;
                        try {
                            // Arg 0 constant: lindex
                            objv15[0] = const1;
                            // Arg 1 variable: $stree
                            tmp16 = getVarScalar(interp, "stree", compiledLocals, 0);
                            tmp16.preserve();
                            objv15[1] = tmp16;
                            // Arg 2 variable: $i
                            tmp16 = getVarScalar(interp, "i", compiledLocals, 3);
                            tmp16.preserve();
                            objv15[2] = tmp16;
                            // Arg 3 constant: 2
                            objv15[3] = const2;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                ? cmdcache1.cmd : null), objv15, 0);
                            if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                updateCmdCache(interp, 1);
                            }
                        } finally {
                            tmp16 = objv15[1];
                            if ( tmp16 != null ) {
                                tmp16.release();
                            }
                            tmp16 = objv15[2];
                            if ( tmp16 != null ) {
                                tmp16.release();
                            }
                            TJC.releaseObjv(interp, objv15, 4);
                        }
                    } // End Invoke: lindex
                    tmp14 = interp.getResult();
                    setVarScalar(interp, "inner_stree", tmp14, compiledLocals, 5);
                } // End Invoke: set
                { // Invoke: set entry [...]
                    TclObject tmp17;
                    { // Invoke: list
                        TclObject tmp18 = TclList.newInstance();
                        interp.setResult(tmp18);
                    } // End Invoke: list
                    tmp17 = interp.getResult();
                    setVarScalar(interp, "entry", tmp17, compiledLocals, 6);
                } // End Invoke: set
                { // Invoke: lappend entry $inner_type
                    TclObject[] objv19 = TJC.grabObjv(interp, 1);
                    TclObject tmp20;
                    try {
                        // Arg 2 variable: $inner_type
                        tmp20 = getVarScalar(interp, "inner_type", compiledLocals, 4);
                        tmp20.preserve();
                        objv19[0] = tmp20;
                        interp.resetResult();
                        lappendVarScalar(interp, "entry", objv19, compiledLocals, 6);
                    } finally {
                        TJC.releaseObjvElems(interp, objv19, 1);
                    }
                } // End Invoke: lappend
                { // Invoke: set inner_len [...]
                    TclObject tmp21;
                    { // Invoke: llength $inner_stree
                        TclObject tmp22 = getVarScalar(interp, "inner_stree", compiledLocals, 5);
                        int tmp23 = TclList.getLength(interp, tmp22);
                        interp.setResult(tmp23);
                    } // End Invoke: llength
                    tmp21 = interp.getResult();
                    setVarScalar(interp, "inner_len", tmp21, compiledLocals, 7);
                } // End Invoke: set
                { // Invoke: for {set j 0} {$j < $inner_len} {incr j} ...
                    { // Invoke: set j 0
                        setVarScalar(interp, "j", const0, compiledLocals, 8);
                    } // End Invoke: set
                    for ( boolean skip29 = true ; true ; ) {
                        if ( skip29 ) {
                            skip29 = false;
                        } else {
                            try {
                            if ( false ) { throw (TclException) null; }
                            { // Invoke: incr j
                                interp.resetResult();
                                incrVarScalar(interp, "j", 1, compiledLocals, 8);
                            } // End Invoke: incr
                            } catch (TclException ex) {
                                int type = ex.getCompletionCode();
                                if (type == TCL.BREAK) {
                                    break;
                                } else {
                                    throw ex;
                                }
                            }
                        }

                        // Binary operator: $j < $inner_len
                        TclObject tmp24 = getVarScalar(interp, "j", compiledLocals, 8);
                        ExprValue tmp25 = evs0;
                        TJC.exprInitValue(interp, tmp25, tmp24);
                        TclObject tmp26 = getVarScalar(interp, "inner_len", compiledLocals, 7);
                        ExprValue tmp27 = evs1;
                        TJC.exprInitValue(interp, tmp27, tmp26);
                        TJC.exprBinaryOperator(interp, TJC.EXPR_OP_LESS, tmp25, tmp27);
                        // End Binary operator: <
                        boolean tmp28 = ( tmp25.getIntValue() != 0 );
                        if ( ! tmp28 ) { break; }

                        try {
                        if ( false ) { throw (TclException) null; }
                        { // Invoke: set inner_type [...]
                            TclObject tmp30;
                            { // Invoke: lindex $inner_stree $j 0
                                TclObject[] objv31 = TJC.grabObjv(interp, 4);
                                TclObject tmp32;
                                try {
                                    // Arg 0 constant: lindex
                                    objv31[0] = const1;
                                    // Arg 1 variable: $inner_stree
                                    tmp32 = getVarScalar(interp, "inner_stree", compiledLocals, 5);
                                    tmp32.preserve();
                                    objv31[1] = tmp32;
                                    // Arg 2 variable: $j
                                    tmp32 = getVarScalar(interp, "j", compiledLocals, 8);
                                    tmp32.preserve();
                                    objv31[2] = tmp32;
                                    // Arg 3 constant: 0
                                    objv31[3] = const0;
                                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                        updateCmdCache(interp, 0);
                                    }
                                    TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                                        ? cmdcache1.cmd : null), objv31, 0);
                                    if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                                        updateCmdCache(interp, 1);
                                    }
                                } finally {
                                    tmp32 = objv31[1];
                                    if ( tmp32 != null ) {
                                        tmp32.release();
                                    }
                                    tmp32 = objv31[2];
                                    if ( tmp32 != null ) {
                                        tmp32.release();
                                    }
                                    TJC.releaseObjv(interp, objv31, 4);
                                }
                            } // End Invoke: lindex
                            tmp30 = interp.getResult();
                            setVarScalar(interp, "inner_type", tmp30, compiledLocals, 4);
                        } // End Invoke: set
                        { // Invoke: lappend entry $inner_type
                            TclObject[] objv33 = TJC.grabObjv(interp, 1);
                            TclObject tmp34;
                            try {
                                // Arg 2 variable: $inner_type
                                tmp34 = getVarScalar(interp, "inner_type", compiledLocals, 4);
                                tmp34.preserve();
                                objv33[0] = tmp34;
                                interp.resetResult();
                                lappendVarScalar(interp, "entry", objv33, compiledLocals, 6);
                            } finally {
                                TJC.releaseObjvElems(interp, objv33, 1);
                            }
                        } // End Invoke: lappend
                        } catch (TclException ex) {
                            int type = ex.getCompletionCode();
                            if (type == TCL.BREAK) {
                                break;
                            } else if (type == TCL.CONTINUE) {
                                continue;
                            } else {
                                throw ex;
                            }
                        }
                    }
                } // End Invoke: for
                { // Invoke: if ... ... else ...
                    // Binary operator: [...] == 1
                    { // Invoke: llength $entry
                        TclObject tmp35 = getVarScalar(interp, "entry", compiledLocals, 6);
                        int tmp36 = TclList.getLength(interp, tmp35);
                        interp.setResult(tmp36);
                    } // End Invoke: llength
                    TclObject tmp37 = interp.getResult();
                    ExprValue tmp38 = evs0;
                    TJC.exprInitValue(interp, tmp38, tmp37);
                    ExprValue tmp39 = evs1;
                    tmp39.setIntValue(1);
                    TJC.exprBinaryOperator(interp, TJC.EXPR_OP_EQUAL, tmp38, tmp39);
                    // End Binary operator: ==
                    boolean tmp40 = ( tmp38.getIntValue() != 0 );
                    if ( tmp40 ) {
                        { // Invoke: lappend inner_type_list [...]
                            TclObject[] objv41 = TJC.grabObjv(interp, 1);
                            TclObject tmp42;
                            try {
                                // Arg 2 command: [...]
                                { // Invoke: lindex $entry 0
                                    TclObject tmp43 = getVarScalar(interp, "entry", compiledLocals, 6);
                                    tmp43 = TclList.index(interp, tmp43, 0);
                                    if ( tmp43 == null ) {
                                        interp.resetResult();
                                    } else {
                                        interp.setResult(tmp43);
                                    }
                                } // End Invoke: lindex
                                tmp42 = interp.getResult();
                                tmp42.preserve();
                                objv41[0] = tmp42;
                                interp.resetResult();
                                lappendVarScalar(interp, "inner_type_list", objv41, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv41, 1);
                            }
                        } // End Invoke: lappend
                    } else {
                        { // Invoke: lappend inner_type_list $entry
                            TclObject[] objv44 = TJC.grabObjv(interp, 1);
                            TclObject tmp45;
                            try {
                                // Arg 2 variable: $entry
                                tmp45 = getVarScalar(interp, "entry", compiledLocals, 6);
                                tmp45.preserve();
                                objv44[0] = tmp45;
                                interp.resetResult();
                                lappendVarScalar(interp, "inner_type_list", objv44, compiledLocals, 1);
                            } finally {
                                TJC.releaseObjvElems(interp, objv44, 1);
                            }
                        } // End Invoke: lappend
                    }
                } // End Invoke: if
                } catch (TclException ex) {
                    int type = ex.getCompletionCode();
                    if (type == TCL.BREAK) {
                        break;
                    } else if (type == TCL.CONTINUE) {
                        continue;
                    } else {
                        throw ex;
                    }
                }
            }
        } // End Invoke: for
        { // Invoke: return $inner_type_list
            TclObject tmp46 = getVarScalar(interp, "inner_type_list", compiledLocals, 1);
            interp.resetResult();
            interp.setResult(tmp46);
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "_parse_variable_subtree_types");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclInteger.newInstance(0);
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("lindex");
        const1.preserve(); const1.preserve();
        const2 = TclInteger.newInstance(2);
        const2.preserve(); const2.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "lindex";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "stree",
        "inner_type_list",
        "len",
        "i",
        "inner_type",
        "inner_stree",
        "entry",
        "inner_len",
        "j"
    };
} // end class ParseVariableSubtreeTypesCmd

