// TJC implementation of procedure processTclSource
package tjc;
import tcl.lang.*;

public class ProcessTclSourceCmd extends TJC.CompiledCommand {
    public void cmdProc(
        Interp interp,
        TclObject[] objv)
            throws TclException
    {
        if (!initCmd) {
            inlineCmds = true;
            initCmd(interp);
        }
        CallFrame callFrame = TJC.pushLocalCallFrame(interp, wcmd.ns);
        Var[] compiledLocals =
            TJC.initCompiledLocals(callFrame, 11, compiledLocalsNames);
        ExprValue evs0 = TJC.exprGetValue(interp);
        ExprValue evs1 = TJC.exprGetValue(interp);
        try {
        if (objv.length != 3) {
            throw new TclNumArgsException(interp, 1, objv, "java_filename proc_source");
        }
        setVarScalar(interp, "java_filename", objv[1], compiledLocals, 0);
        setVarScalar(interp, "proc_source", objv[2], compiledLocals, 1);
        { // Invoke: global _tjc
            TJC.makeGlobalLinkVar(interp, "_tjc", "_tjc", 2);
        } // End Invoke: global
        { // Invoke: set len [...]
            TclObject tmp0;
            { // Invoke: llength $proc_source
                TclObject tmp1 = getVarScalar(interp, "proc_source", compiledLocals, 1);
                int tmp2 = TclList.getLength(interp, tmp1);
                interp.setResult(tmp2);
            } // End Invoke: llength
            tmp0 = interp.getResult();
            setVarScalar(interp, "len", tmp0, compiledLocals, 3);
        } // End Invoke: set
        { // Invoke: if {$len != 4} ...
            // Binary operator: $len != 4
            TclObject tmp3 = getVarScalar(interp, "len", compiledLocals, 3);
            ExprValue tmp4 = evs0;
            TJC.exprInitValue(interp, tmp4, tmp3);
            ExprValue tmp5 = evs1;
            tmp5.setIntValue(4);
            TJC.exprBinaryOperator(interp, TJC.EXPR_OP_NEQ, tmp4, tmp5);
            // End Binary operator: !=
            boolean tmp6 = ( tmp4.getIntValue() != 0 );
            if ( tmp6 ) {
                { // Invoke: error "..."
                    TclObject[] objv7 = TJC.grabObjv(interp, 2);
                    TclObject tmp8;
                    try {
                        // Arg 0 constant: error
                        objv7[0] = const0;
                        // Arg 1 word: "..."
                        StringBuffer sbtmp9 = new StringBuffer(64);
                        sbtmp9.append("Tcl proc decl should have 4 arguments: got ");
                        sbtmp9.append("{");
                        tmp8 = getVarScalar(interp, "proc_source", compiledLocals, 1);
                        sbtmp9.append(tmp8.toString());
                        sbtmp9.append("}");
                        tmp8 = TclString.newInstance(sbtmp9);
                        tmp8.preserve();
                        objv7[1] = tmp8;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv7, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        tmp8 = objv7[1];
                        if ( tmp8 != null ) {
                            tmp8.release();
                        }
                        TJC.releaseObjv(interp, objv7, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set proc_name [...]
            TclObject tmp10;
            { // Invoke: lindex $proc_source 1
                TclObject tmp11 = getVarScalar(interp, "proc_source", compiledLocals, 1);
                tmp11 = TclList.index(interp, tmp11, 1);
                if ( tmp11 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp11);
                }
            } // End Invoke: lindex
            tmp10 = interp.getResult();
            setVarScalar(interp, "proc_name", tmp10, compiledLocals, 4);
        } // End Invoke: set
        { // Invoke: if ... ...
            // Unary operator: ! [...]
            { // Invoke: info exists _tjc(embedded)
                TclObject[] objv12 = TJC.grabObjv(interp, 3);
                try {
                    // Arg 0 constant: info
                    objv12[0] = const1;
                    // Arg 1 constant: exists
                    objv12[1] = const2;
                    // Arg 2 constant: _tjc(embedded)
                    objv12[2] = const3;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache2_cmdEpoch == cmdcache2.cmdEpoch)
                        ? cmdcache2.cmd : null), objv12, 0);
                    if ( cmdcache2_cmdEpoch != cmdcache2.cmdEpoch ) {
                        updateCmdCache(interp, 2);
                    }
                } finally {
                    TJC.releaseObjv(interp, objv12, 3);
                }
            } // End Invoke: info
            TclObject tmp13 = interp.getResult();
            ExprValue tmp14 = evs0;
            if ( tmp13.isIntType() ) {
                TJC.exprUnaryNotOperatorKnownInt(tmp14, tmp13);
            } else {
                TJC.exprUnaryNotOperator(interp, tmp14, tmp13);
            }
            // End Unary operator: !
            boolean tmp15 = ( tmp14.getIntValue() != 0 );
            if ( tmp15 ) {
                { // Invoke: namespace eval :: ...
                    TclObject[] objv16 = TJC.grabObjv(interp, 4);
                    try {
                        // Arg 0 constant: namespace
                        objv16[0] = const4;
                        // Arg 1 constant: eval
                        objv16[1] = const5;
                        // Arg 2 constant: ::
                        objv16[2] = const6;
                        // Arg 3 constant: ...
                        objv16[3] = const7;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache3_cmdEpoch == cmdcache3.cmdEpoch)
                            ? cmdcache3.cmd : null), objv16, 0);
                        if ( cmdcache3_cmdEpoch != cmdcache3.cmdEpoch ) {
                            updateCmdCache(interp, 3);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv16, 4);
                    }
                } // End Invoke: namespace
                { // Invoke: module_parse ...
                    TclObject[] objv17 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: module_parse
                        objv17[0] = const8;
                        // Arg 1 constant: ...
                        objv17[1] = const9;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache4_cmdEpoch == cmdcache4.cmdEpoch)
                            ? cmdcache4.cmd : null), objv17, 0);
                        if ( cmdcache4_cmdEpoch != cmdcache4.cmdEpoch ) {
                            updateCmdCache(interp, 4);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv17, 2);
                    }
                } // End Invoke: module_parse
            }
        } // End Invoke: if
        { // Invoke: set proc_filename $java_filename
            TclObject tmp18;
            tmp18 = getVarScalar(interp, "java_filename", compiledLocals, 0);
            setVarScalar(interp, "proc_filename", tmp18, compiledLocals, 5);
        } // End Invoke: set
        { // Invoke: set cname [...]
            TclObject tmp19;
            { // Invoke: file root [...]
                TclObject[] objv20 = TJC.grabObjv(interp, 3);
                TclObject tmp21;
                try {
                    // Arg 0 constant: file
                    objv20[0] = const10;
                    // Arg 1 constant: root
                    objv20[1] = const11;
                    // Arg 2 command: [...]
                    { // Invoke: file tail $java_filename
                        TclObject[] objv22 = TJC.grabObjv(interp, 3);
                        TclObject tmp23;
                        try {
                            // Arg 0 constant: file
                            objv22[0] = const10;
                            // Arg 1 constant: tail
                            objv22[1] = const12;
                            // Arg 2 variable: $java_filename
                            tmp23 = getVarScalar(interp, "java_filename", compiledLocals, 0);
                            tmp23.preserve();
                            objv22[2] = tmp23;
                            if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                                updateCmdCache(interp, 0);
                            }
                            TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                                ? cmdcache5.cmd : null), objv22, 0);
                            if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                                updateCmdCache(interp, 5);
                            }
                        } finally {
                            tmp23 = objv22[2];
                            if ( tmp23 != null ) {
                                tmp23.release();
                            }
                            TJC.releaseObjv(interp, objv22, 3);
                        }
                    } // End Invoke: file
                    tmp21 = interp.getResult();
                    tmp21.preserve();
                    objv20[2] = tmp21;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache5_cmdEpoch == cmdcache5.cmdEpoch)
                        ? cmdcache5.cmd : null), objv20, 0);
                    if ( cmdcache5_cmdEpoch != cmdcache5.cmdEpoch ) {
                        updateCmdCache(interp, 5);
                    }
                } finally {
                    tmp21 = objv20[2];
                    if ( tmp21 != null ) {
                        tmp21.release();
                    }
                    TJC.releaseObjv(interp, objv20, 3);
                }
            } // End Invoke: file
            tmp19 = interp.getResult();
            setVarScalar(interp, "cname", tmp19, compiledLocals, 6);
        } // End Invoke: set
        { // Invoke: set proc_decl_tuple $proc_source
            TclObject tmp24;
            tmp24 = getVarScalar(interp, "proc_source", compiledLocals, 1);
            setVarScalar(interp, "proc_decl_tuple", tmp24, compiledLocals, 7);
        } // End Invoke: set
        { // Invoke: set proc_tuple [...]
            TclObject tmp25;
            { // Invoke: list $proc_name $cname $proc_decl_tuple
                TclObject tmp26 = TclList.newInstance();
                TclObject tmp27;
                try {
                    tmp27 = getVarScalar(interp, "proc_name", compiledLocals, 4);
                    TclList.append(interp, tmp26, tmp27);
                    tmp27 = getVarScalar(interp, "cname", compiledLocals, 6);
                    TclList.append(interp, tmp26, tmp27);
                    tmp27 = getVarScalar(interp, "proc_decl_tuple", compiledLocals, 7);
                    TclList.append(interp, tmp26, tmp27);
                } catch (TclException ex) {
                    tmp26.release();
                    throw ex;
                }
                interp.setResult(tmp26);
            } // End Invoke: list
            tmp25 = interp.getResult();
            setVarScalar(interp, "proc_tuple", tmp25, compiledLocals, 8);
        } // End Invoke: set
        { // Invoke: set tuple [...]
            TclObject tmp28;
            { // Invoke: ... $proc_filename $proc_tuple
                TclObject[] objv29 = TJC.grabObjv(interp, 3);
                TclObject tmp30;
                try {
                    // Arg 0 constant: ...
                    objv29[0] = const13;
                    // Arg 1 variable: $proc_filename
                    tmp30 = getVarScalar(interp, "proc_filename", compiledLocals, 5);
                    tmp30.preserve();
                    objv29[1] = tmp30;
                    // Arg 2 variable: $proc_tuple
                    tmp30 = getVarScalar(interp, "proc_tuple", compiledLocals, 8);
                    tmp30.preserve();
                    objv29[2] = tmp30;
                    if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                        updateCmdCache(interp, 0);
                    }
                    TJC.invoke(interp, ((cmdcache6_cmdEpoch == cmdcache6.cmdEpoch)
                        ? cmdcache6.cmd : null), objv29, 0);
                    if ( cmdcache6_cmdEpoch != cmdcache6.cmdEpoch ) {
                        updateCmdCache(interp, 6);
                    }
                } finally {
                    tmp30 = objv29[1];
                    if ( tmp30 != null ) {
                        tmp30.release();
                    }
                    tmp30 = objv29[2];
                    if ( tmp30 != null ) {
                        tmp30.release();
                    }
                    TJC.releaseObjv(interp, objv29, 3);
                }
            } // End Invoke: ...
            tmp28 = interp.getResult();
            setVarScalar(interp, "tuple", tmp28, compiledLocals, 9);
        } // End Invoke: set
        { // Invoke: if {$tuple == "ERROR"} ...
            // Binary operator: $tuple == "ERROR"
            TclObject tmp31 = getVarScalar(interp, "tuple", compiledLocals, 9);
            boolean tmp32 = tmp31.toString().equals("ERROR");
            ExprValue tmp33 = evs0;
            tmp33.setIntValue(tmp32);
            // End Binary operator: ==
            boolean tmp34 = ( tmp33.getIntValue() != 0 );
            if ( tmp34 ) {
                { // Invoke: error ...
                    TclObject[] objv35 = TJC.grabObjv(interp, 2);
                    try {
                        // Arg 0 constant: error
                        objv35[0] = const0;
                        // Arg 1 constant: ...
                        objv35[1] = const14;
                        if ( wcmd_cmdEpoch != wcmd.cmdEpoch ) {
                            updateCmdCache(interp, 0);
                        }
                        TJC.invoke(interp, ((cmdcache1_cmdEpoch == cmdcache1.cmdEpoch)
                            ? cmdcache1.cmd : null), objv35, 0);
                        if ( cmdcache1_cmdEpoch != cmdcache1.cmdEpoch ) {
                            updateCmdCache(interp, 1);
                        }
                    } finally {
                        TJC.releaseObjv(interp, objv35, 2);
                    }
                } // End Invoke: error
            }
        } // End Invoke: if
        { // Invoke: set java_source [...]
            TclObject tmp36;
            { // Invoke: lindex $tuple 3
                TclObject tmp37 = getVarScalar(interp, "tuple", compiledLocals, 9);
                tmp37 = TclList.index(interp, tmp37, 3);
                if ( tmp37 == null ) {
                    interp.resetResult();
                } else {
                    interp.setResult(tmp37);
                }
            } // End Invoke: lindex
            tmp36 = interp.getResult();
            setVarScalar(interp, "java_source", tmp36, compiledLocals, 10);
        } // End Invoke: set
        { // Invoke: return [...]
            { // Invoke: list $proc_name $java_source
                TclObject tmp38 = TclList.newInstance();
                TclObject tmp39;
                try {
                    tmp39 = getVarScalar(interp, "proc_name", compiledLocals, 4);
                    TclList.append(interp, tmp38, tmp39);
                    tmp39 = getVarScalar(interp, "java_source", compiledLocals, 10);
                    TclList.append(interp, tmp38, tmp39);
                } catch (TclException ex) {
                    tmp38.release();
                    throw ex;
                }
                interp.setResult(tmp38);
            } // End Invoke: list
            if ( true ) { return; }
        } // End Invoke: return
        } catch (TclException te) {
            TJC.checkTclException(interp, te, "processTclSource");
        } finally {
            TJC.exprReleaseValue(interp, evs1);
            TJC.exprReleaseValue(interp, evs0);
            TJC.popLocalCallFrame(interp, callFrame);
        }
    }

    TclObject const0;
    TclObject const1;
    TclObject const2;
    TclObject const3;
    TclObject const4;
    TclObject const5;
    TclObject const6;
    TclObject const7;
    TclObject const8;
    TclObject const9;
    TclObject const10;
    TclObject const11;
    TclObject const12;
    TclObject const13;
    TclObject const14;

    protected void initConstants(Interp interp) throws TclException {
        const0 = TclString.newInstance("error");
        const0.preserve(); const0.preserve();
        const1 = TclString.newInstance("info");
        const1.preserve(); const1.preserve();
        const2 = TclString.newInstance("exists");
        const2.preserve(); const2.preserve();
        const3 = TclString.newInstance("_tjc(embedded)");
        const3.preserve(); const3.preserve();
        const4 = TclString.newInstance("namespace");
        const4.preserve(); const4.preserve();
        const5 = TclString.newInstance("eval");
        const5.preserve(); const5.preserve();
        const6 = TclString.newInstance("::");
        const6.preserve(); const6.preserve();
        const7 = TclString.newInstance("\n           package require parser\n           set _tjc(embedded) 1\n           source resource:/tjc/library/reload.tcl\n        ");
        const7.preserve(); const7.preserve();
        const8 = TclString.newInstance("module_parse");
        const8.preserve(); const8.preserve();
        const9 = TclString.newInstance("\nPACKAGE tjcthread\nOPTIONS +O\n        ");
        const9.preserve(); const9.preserve();
        const10 = TclString.newInstance("file");
        const10.preserve(); const10.preserve();
        const11 = TclString.newInstance("root");
        const11.preserve(); const11.preserve();
        const12 = TclString.newInstance("tail");
        const12.preserve(); const12.preserve();
        const13 = TclString.newInstance("compileproc_entry_point");
        const13.preserve(); const13.preserve();
        const14 = TclString.newInstance("compileproc_entry_point error");
        const14.preserve(); const14.preserve();
    }

    int wcmd_cmdEpoch = 0;
    WrappedCommand cmdcache1;
    int cmdcache1_cmdEpoch;
    WrappedCommand cmdcache2;
    int cmdcache2_cmdEpoch;
    WrappedCommand cmdcache3;
    int cmdcache3_cmdEpoch;
    WrappedCommand cmdcache4;
    int cmdcache4_cmdEpoch;
    WrappedCommand cmdcache5;
    int cmdcache5_cmdEpoch;
    WrappedCommand cmdcache6;
    int cmdcache6_cmdEpoch;

    void updateCmdCache(Interp interp, int cacheId) throws TclException {
        String cmdName;
        switch ( cacheId ) {
            case 0: {
                cmdcache1 = TJC.INVALID_COMMAND_CACHE;
                cmdcache1_cmdEpoch = 0;
                cmdcache2 = TJC.INVALID_COMMAND_CACHE;
                cmdcache2_cmdEpoch = 0;
                cmdcache3 = TJC.INVALID_COMMAND_CACHE;
                cmdcache3_cmdEpoch = 0;
                cmdcache4 = TJC.INVALID_COMMAND_CACHE;
                cmdcache4_cmdEpoch = 0;
                cmdcache5 = TJC.INVALID_COMMAND_CACHE;
                cmdcache5_cmdEpoch = 0;
                cmdcache6 = TJC.INVALID_COMMAND_CACHE;
                cmdcache6_cmdEpoch = 0;
                wcmd_cmdEpoch = wcmd.cmdEpoch;
                return;
            }
            case 1: {
                cmdName = "error";
                break;
            }
            case 2: {
                cmdName = "info";
                break;
            }
            case 3: {
                cmdName = "namespace";
                break;
            }
            case 4: {
                cmdName = "module_parse";
                break;
            }
            case 5: {
                cmdName = "file";
                break;
            }
            case 6: {
                cmdName = "compileproc_entry_point";
                break;
            }
            default: {
                throw new TclRuntimeError("default: cacheId " + cacheId);
            }
        }
        WrappedCommand lwcmd = TJC.resolveCmd(interp, cmdName);
        int cmdEpoch;
        if ( lwcmd == null ) {
            lwcmd = TJC.INVALID_COMMAND_CACHE;
            cmdEpoch = 0;
        } else {
            cmdEpoch = lwcmd.cmdEpoch;
        }
        switch ( cacheId ) {
            case 1: {
                cmdcache1 = lwcmd;
                cmdcache1_cmdEpoch = cmdEpoch;
                break;
            }
            case 2: {
                cmdcache2 = lwcmd;
                cmdcache2_cmdEpoch = cmdEpoch;
                break;
            }
            case 3: {
                cmdcache3 = lwcmd;
                cmdcache3_cmdEpoch = cmdEpoch;
                break;
            }
            case 4: {
                cmdcache4 = lwcmd;
                cmdcache4_cmdEpoch = cmdEpoch;
                break;
            }
            case 5: {
                cmdcache5 = lwcmd;
                cmdcache5_cmdEpoch = cmdEpoch;
                break;
            }
            case 6: {
                cmdcache6 = lwcmd;
                cmdcache6_cmdEpoch = cmdEpoch;
                break;
            }
        }
    }

    String[] compiledLocalsNames = {
        "java_filename",
        "proc_source",
        "_tjc",
        "len",
        "proc_name",
        "proc_filename",
        "cname",
        "proc_decl_tuple",
        "proc_tuple",
        "tuple",
        "java_source"
    };
} // end class ProcessTclSourceCmd

