
library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_AND is
	port(z : out std_logic; a, b : in std_logic );
end;

architecture rtl of FVP_PRIM_AND is
begin
	z <= a and b;
end;


library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_NAND is
	port(z : out std_logic; a, b : in std_logic );
end;

architecture rtl of FVP_PRIM_NAND is
begin
	z <= not (a and b);
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_OR is
	port(z : out std_logic; a, b : in std_logic );
end;

architecture rtl of FVP_PRIM_OR is
begin
	z <= a or b;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_NOR is
	port(z : out std_logic; a, b : in std_logic );
end;

architecture rtl of FVP_PRIM_NOR is
begin
	z <= not (a or b);
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_XOR is
	port(z : out std_logic; a, b : in std_logic );
end;

architecture rtl of FVP_PRIM_XOR is
begin
	z <= a xor b;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_XNOR is
	port(z : out std_logic; a, b : in std_logic );
end;

architecture rtl of FVP_PRIM_XNOR is
begin
	z <= not (a xor b);
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_BUF is
	port(z : out std_logic; a : in std_logic );
end;

architecture rtl of FVP_PRIM_BUF is
begin
	z <= a;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_BUFIF0 is
	port(z : out std_logic; d, s : in std_logic );
end;

architecture rtl of FVP_PRIM_BUFIF0 is
begin
	z <= 'Z' when s='1' else d;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_BUFIF1 is
	port(z : out std_logic; d, s : in std_logic );
end;

architecture rtl of FVP_PRIM_BUFIF1 is
begin
	z <= 'Z' when s='0' else d;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_NOT is
	port(z : out std_logic; a : in std_logic );
end;

architecture rtl of FVP_PRIM_NOT is
begin
	z <= not a ;
end;

library ieee;
use ieee.std_logic_1164.all;
entity FVP_PRIM_NOTIF0 is
	port(z : out std_logic; d, s : in std_logic );
end;

architecture rtl of FVP_PRIM_NOTIF0 is
begin
	process( s, d )
	begin
		if ( s ='1' ) then
			z <= 'Z' ;
		else
			z <= not d;
		end if;
	end process;
end;

library ieee;
use ieee.std_logic_1164.all;
entity FVP_PRIM_NOTIF1 is
	port(z : out std_logic; d, s : in std_logic );
end;

architecture rtl of FVP_PRIM_NOTIF1 is
begin
	z <= 'Z' when s='0' else ( not d );
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_PULLDOWN is
	port(z : out std_logic; a : in std_logic );
end;

architecture rtl of FVP_PRIM_PULLDOWN is
begin
	z <= a ;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_PULLUP is
	port(z : out std_logic; a : in std_logic );
end;

architecture rtl of FVP_PRIM_PULLUP is
begin
	z <= a ;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_NMOS is
	port(z : out std_logic; d, s : in std_logic );
end;

architecture rtl of FVP_PRIM_NMOS is
begin
	z <= 'Z' when s='0' else d;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_RNMOS is
	port(z : out std_logic; d, s : in std_logic );
end;

architecture rtl of FVP_PRIM_RNMOS is
begin
	z <= 'Z' when s='0' else d;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_PMOS is
	port(z : out std_logic; d, s : in std_logic );
end;

architecture rtl of FVP_PRIM_PMOS is
begin
	z <= 'Z' when s='1' else d;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_RPMOS is
	port(z : out std_logic; d, s : in std_logic );
end;

architecture rtl of FVP_PRIM_RPMOS is
begin
	z <= 'Z' when s='1' else d;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_CMOS is
	port(z : out std_logic; d, nctrl, pctrl : in std_logic );
end;

architecture rtl of FVP_PRIM_CMOS is
begin
	process( nctrl, pctrl, d )
	begin
		if ( '0' = nctrl ) then
			if ( pctrl = '1' ) then
				z <= 'Z';
			elsif ( '0' = pctrl) then
				z <= d;
			else
				z <= 'X';
		    end if;
		elsif ( '1' = nctrl) then
			z <= d;
		else
			if ( pctrl = '0' ) then
				z <= d;
			else
				z <= 'X';
		    end if;
		end if;
	end process;
end;

library ieee;
use ieee.std_logic_1164.all;

entity FVP_PRIM_RCMOS is
	port(z : out std_logic; d, nctrl, pctrl : in std_logic );
end;

architecture rtl of FVP_PRIM_RCMOS is
begin
	process( nctrl, pctrl, d )
	begin
		if ( '0' = nctrl ) then
			if ( pctrl = '1' ) then
				z <= 'Z';
			elsif ( '0' = pctrl) then
				z <= d;
			else
				z <= 'X';
		    end if;
		elsif ( '1' = nctrl) then
			z <= d;
		else
			if ( pctrl = '0' ) then
				z <= d;
			else
				z <= 'X';
		    end if;
		end if;
	end process;
end;

-- The following instances are yet to be implemented
--
--	FVP_PRIM_TRAN,
--	FVP_PRIM_RTRAN,
--	FVP_PRIM_TRANIF0,
--	FVP_PRIM_RTRANIF0,
--	FVP_PRIM_TRANIF1,
--	FVP_PRIM_RTRANIF1,

